VIF - VIntage Fortran compiler
------------------------------

Copyright 2020-2025 J. Marcel van der Veer <algol68g@xs4all.nl>.

VIF is an 'early FORTRAN' dialect, encompassing a large subset of 
FORTRAN II/IV and FORTRAN 66/77.

VIF is a front end using a gcc compatible C99 compiler as back end. 
VIF uses gcc extensions to C, and also gcc's libquadmath.
Intermediate C code is written to file, that doubles as listing file.

A design goal for VIF was to make high precision data types available. 
It implements REAL*32 and COMPLEX*64, which VIF implements through 
HPAlib (which VIF totes).

Important differences between VIF and early FORTRAN are described below.

* Independent compilation.

  VIF is not designed for large projects, though it can compile libraries.
  Preferably all source files in a project are compiled together and linked 
  into one executable, so gcc can optimize globally. VIF can declare most 
  C objects 'static' and many equivalenced objects as 'const' pointers 
  which improves optimisation by backend gcc. 

* Formatting of source text and reserved words.
  
  VIF is fixed format like early FORTRAN but symbols cannot span records.
  Record length is 500 (formerly maximum length of a C source line) 
  compared to 80 characters in early FORTRAN. VIF is case insensitive,
  except in character strings.

  Early FORTRAN knows no reserved words - context determines meaning.
  VIF knows reserved words and requires reserved words to be separated 
  from variable names by whitespace. Reserved words can mostly be used 
  as variable names though.

  Early FORTRAN limits the length of variable and subprogram names to 6 
  characters. VIF limits this to the record length. Also a name may contain
  underscores, but cannot start with one.

* Types and internal representation of data.
 
  VIF depends on 'gcc' and 'libquadmath' that comes with it.
  VIF generates code for the 'gcc' hardware representation as follows:

    INTEGER*2  -> int16_t        -> int_2
    INTEGER*4  -> int            -> int_4
    INTEGER*8  -> int64_t        -> int_8
    LOGICAL*4  -> unsigned       -> logical_4
    REAL*4     -> float          -> real_4
    REAL*8     -> double         -> real_8
    REAL*16    -> __float128     -> real_16
    COMPLEX*8  -> complex        -> complex_8
    COMPLEX*16 -> double complex -> complex_16
    COMPLEX*32 -> __complex128   -> complex_32
    REAL*32    ->                -> real_32    // Software implementation, HPALIB
    COMPLEX*64 ->                -> complex_64 // Software implementation, HPALIB

  VIF implements any CHARACTER*n length as a C string.
  CHARACTER strings are null-terminated as in C, not padded with spaces.
  A single CHARACTER is a string of two bytes.

* 'Jurassic' features obsoleted in modern Fortran and VIF.

  * Alternate ENTRY and alternate RETURN are F77 constructs that were never
  considered good programming practice. VIF does not implement them.
  Like EQUIVALENCE, ENTRY was a tool to minimize storage footprint. 
  That was important in the 1950's, but nowadays, nobody cares. 

* Not implemented (yet, and probably never).

  * Namelist IO.

  * List-directed niceties and sugar as for example repetition counts for
  input items. You can however read free-format with e.g. READ (*, *) I, Z.
  A repetition count for DATA items is implemented.

* Deviations from early FORTRAN.

  * VIF allows recursion, which is not supported by early FORTRAN.
    IO statements are not re-entrant however.

  * Early FORTRAN does not allow two adjacent operator symbols with 
    exceptions for practical combinations as .AND..NOT. etcetera.
    Hence in early FORTRAN, I--1 must be strictly written as I-(-1).
    VIF does not pose this restriction. 

  * Subprograms can declare variables in (named) COMMON blocks,
    and VIF merges all declarations to form the COMMON blocks after
    compilation. Hence there is no need to specify in every subprogram
    all variables per block in the correct order.

  * VIF constant lists in DATA statements are circular, like format
    lists. Hence after INTEGER ROW(100) you can initialize the array
    with DATA ROW /0/ in VIF while in early FORTRAN this only initializes 
    the first element.

  * VIF has a DO REPEAT ... END DO construct where 'UNTIL (condition)'
    terminates it when TRUE. There can be multiple UNTIL statements.

  * In the intermediate language (C), labels in principle have function 
    scope. VIF has the same feature. Hence next snippet would be 
    invalid early FORTRAN, but is accepted by VIF:

    IF (condition) THEN
      ...
      GOTO 1
      ...
    ELSE
      ...
  1   ...
      ...
    ENDIF

    Needless to say that this is not a recommended coding style.

  * VIF allows Fortran 90 statements 'EXIT' and 'CYCLE'.

  * Vintage operators like .EQ. and .NE. can be denoted as '==', '!=', etcetera.
    Also .AND. can be denoted as '&', .OR. as '|', .XOR. as '^' and .NOT. as '!'.

  * VIF allows CRAY-1 FORTRAN two-branch arithmetic if-statements and 
    indirect logical-if statements.

#pragma -xO
      program tstfft
c
c     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c                       version 4  april 1985
c
c                         a test driver for
c          a package of fortran subprograms for the fast fourier
c           transform of periodic and other symmetric sequences
c
c                              by
c
c                       paul n swarztrauber
c
c       national center for atmospheric research  boulder,colorado 80307
c
c        which is sponsored by the national science foundation
c
c     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
c
c
c             this program tests the package of fast fourier
c     transforms for both complex and real periodic sequences and
c     certian other symmetric sequences that are listed below.
c
c     1.   rffti     initialize  rfftf and rfftb
c     2.   rfftf     forward transform of a real periodic sequence
c     3.   rfftb     backward transform of a real coefficient array
c
c     4.   ezffti    initialize ezfftf and ezfftb
c     5.   ezfftf    a simplified real periodic forward transform
c     6.   ezfftb    a simplified real periodic backward transform
c
c     7.   sinti     initialize sint
c     8.   sint      sine transform of a real odd sequence
c
c     9.   costi     initialize cost
c     10.  cost      cosine transform of a real even sequence
c
c     11.  sinqi     initialize sinqf and sinqb
c     12.  sinqf     forward sine transform with odd wave numbers
c     13.  sinqb     unnormalized inverse of sinqf
c
c     14.  cosqi     initialize cosqf and cosqb
c     15.  cosqf     forward cosine transform with odd wave numbers
c     16.  cosqb     unnormalized inverse of cosqf
c
c     17.  cffti     initialize cfftf and cfftb
c     18.  cfftf     forward transform of a complex periodic sequence
c     19.  cfftb     unnormalized inverse of cfftf

c     *** hacked by hcp for the double prec. version novemember 1999


c
      implicit double precision (a-h,o-z)
      dimension       nd(10)     ,x(200)     ,y(200)     ,w(2000)    ,
     1                a(100)     ,b(100)     ,ah(100)    ,bh(100)    ,
     2                xh(200)    ,cx(200)    ,cy(200)
      double complex         cx         ,cy
      data nd(1),nd(2),nd(3),nd(4),nd(5),nd(6),nd(7)/120,54,49,32,4,3,2/
      sqrt2 = sqrt(2.0d0)
      nns = 7
      do 157 nz=1,nns
         n = nd(nz)
         modn = mod(n,2)
         fn = float(n)
         tfn = fn+fn
         np1 = n+1
         nm1 = n-1
         do 101 j=1,np1
            x(j) = sin(float(j)*sqrt2)
            y(j) = x(j)
            xh(j) = x(j)
  101    continue
c
c     test subroutines rffti,rfftf and rfftb
c
         call dffti (n,w)
         pi = 3.14159265358979323846d0
         dt = (pi+pi)/fn
         ns2 = (n+1)/2
         if (ns2 .lt. 2) go to 104
         do 103 k=2,ns2
            sum1 = 0.0d0
            sum2 = 0.0d0
            arg = float(k-1)*dt
            do 102 i=1,n
               arg1 = float(i-1)*arg
               sum1 = sum1+x(i)*cos(arg1)
               sum2 = sum2+x(i)*sin(arg1)
  102       continue
            y(2*k-2) = sum1
            y(2*k-1) = -sum2
  103    continue
  104    sum1 = 0.0d0
         sum2 = 0.0d0
         do 105 i=1,nm1,2
            sum1 = sum1+x(i)
            sum2 = sum2+x(i+1)
  105    continue
         if (modn .eq. 1) sum1 = sum1+x(n)
         y(1) = sum1+sum2
         if (modn .eq. 0) y(n) = sum1-sum2
         call dfftf (n,x,w)
         rftf = 0.0d0
         do 106 i=1,n
            rftf = dmax1(rftf,abs(x(i)-y(i)))
            x(i) = xh(i)
  106    continue
         rftf = rftf/fn
         do 109 i=1,n
            sum = 0.5d0*x(1)
            arg = float(i-1)*dt
            if (ns2 .lt. 2) go to 108
            do 107 k=2,ns2
               arg1 = float(k-1)*arg
               sum = sum+x(2*k-2)*cos(arg1)-x(2*k-1)*sin(arg1)
  107       continue
  108       if (modn .eq. 0) sum = sum+.5*float((-1)**(i-1))*x(n)
            y(i) = sum+sum
  109    continue
         call dfftb (n,x,w)
         rftb = 0.0d0
         do 110 i=1,n
            rftb = dmax1(rftb,abs(x(i)-y(i)))
            x(i) = xh(i)
            y(i) = xh(i)
  110    continue
         call dfftb (n,y,w)
         call dfftf (n,y,w)
         cf = 1.0d0/fn
         rftfb = 0.
         do 111 i=1,n
            rftfb = dmax1(rftfb,abs(cf*y(i)-x(i)))
  111    continue
c
c     test subroutines dsinti and dsint
c
         dt = pi/fn
         do 112 i=1,nm1
            x(i) = xh(i)
  112    continue
         do 114 i=1,nm1
            y(i) = 0.0d0
            arg1 = float(i)*dt
            do 113 k=1,nm1
               y(i) = y(i)+x(k)*sin(float(k)*arg1)
  113       continue
            y(i) = y(i)+y(i)
  114    continue
         call dsinti (nm1,w)
         call dsint (nm1,x,w)
         cf = 0.5d0/fn
         sintt = 0.0d0
         do 115 i=1,nm1
            sintt = dmax1(sintt,abs(x(i)-y(i)))
            x(i) = xh(i)
            y(i) = x(i)
  115    continue
         sintt = cf*sintt
         call dsint (nm1,x,w)
         call dsint (nm1,x,w)
         sintfb = 0.0d0
         do 116 i=1,nm1
            sintfb = dmax1(sintfb,abs(cf*x(i)-y(i)))
  116    continue
c
c     test subroutines costi and cost
c
         do 117 i=1,np1
            x(i) = xh(i)
  117    continue
         do 119 i=1,np1
            y(i) = 0.5d0*(x(1)+float((-1)**(i+1))*x(n+1))
            arg = float(i-1)*dt
            do 118 k=2,n
               y(i) = y(i)+x(k)*cos(float(k-1)*arg)
  118       continue
            y(i) = y(i)+y(i)
  119    continue
         call dcosti (np1,w)
         call dcost (np1,x,w)
         costt = 0.0d0
         do 120 i=1,np1
            costt = dmax1(costt,abs(x(i)-y(i)))
            x(i) = xh(i)
            y(i) = xh(i)
  120    continue
         costt = cf*costt
         call dcost (np1,x,w)
         call dcost (np1,x,w)
         costfb = 0.0d0
         do 121 i=1,np1
            costfb = dmax1(costfb,abs(cf*x(i)-y(i)))
  121    continue
c
c     test subroutines sinqi,sinqf and sinqb
c
         cf = 0.25d0/fn
         do 122 i=1,n
            y(i) = xh(i)
  122    continue
         dt = pi/(fn+fn)
         do 124 i=1,n
            x(i) = 0.0d0
            arg = dt*float(i)
            do 123 k=1,n
               x(i) = x(i)+y(k)*sin(float(k+k-1)*arg)
  123       continue
            x(i) = 4.0d0*x(i)
  124    continue
         call dsinqi (n,w)
         call dsinqb (n,y,w)
         sinqbt = 0.0d0
         do 125 i=1,n
            sinqbt = dmax1(sinqbt,abs(y(i)-x(i)))
            x(i) = xh(i)
  125    continue
         sinqbt = cf*sinqbt
         do 127 i=1,n
            arg = float(i+i-1)*dt
            y(i) = 0.5d0*float((-1)**(i+1))*x(n)
            do 126 k=1,nm1
               y(i) = y(i)+x(k)*sin(float(k)*arg)
  126       continue
            y(i) = y(i)+y(i)
  127    continue
         call dsinqf (n,x,w)
         sinqft = 0.0d0
         do 128 i=1,n
            sinqft = dmax1(sinqft,abs(x(i)-y(i)))
            y(i) = xh(i)
            x(i) = xh(i)
  128    continue
         call dsinqf (n,y,w)
         call dsinqb (n,y,w)
         sinqfb = 0.0d0
         do 129 i=1,n
            sinqfb = dmax1(sinqfb,abs(cf*y(i)-x(i)))
  129    continue
c
c     test subroutines cosqi,cosqf and cosqb
c
         do 130 i=1,n
            y(i) = xh(i)
  130    continue
         do 132 i=1,n
            x(i) = 0.0d0
            arg = float(i-1)*dt
            do 131 k=1,n
               x(i) = x(i)+y(k)*cos(float(k+k-1)*arg)
  131       continue
            x(i) = 4.0d0*x(i)
  132    continue
         call dcosqi (n,w)
         call dcosqb (n,y,w)
         cosqbt = 0.0d0
         do 133 i=1,n
            cosqbt = dmax1(cosqbt,abs(x(i)-y(i)))
            x(i) = xh(i)
  133    continue
         cosqbt = cf*cosqbt
         do 135 i=1,n
            y(i) = 0.5d0*x(1)
            arg = float(i+i-1)*dt
            do 134 k=2,n
               y(i) = y(i)+x(k)*cos(float(k-1)*arg)
  134       continue
            y(i) = y(i)+y(i)
  135    continue
         call dcosqf (n,x,w)
         cosqft = 0.0d0
         do 136 i=1,n
            cosqft = dmax1(cosqft,abs(y(i)-x(i)))
            x(i) = xh(i)
            y(i) = xh(i)
  136    continue
         cosqft = cf*cosqft
         call dcosqb (n,x,w)
         call dcosqf (n,x,w)
         cosqfb = 0.0d0
         do 137 i=1,n
            cosqfb = dmax1(cosqfb,abs(cf*x(i)-y(i)))
  137    continue
c
c     test programs ezffti,ezfftf,ezfftb
c
         call dzffti(n,w)
         do 138 i=1,n
            x(i) = xh(i)
  138    continue
         tpi = 8.0d0*atan(1.0d0)
         dt = tpi/float(n)
         ns2 = (n+1)/2
         cf = 2.0d0/float(n)
         ns2m = ns2-1
         if (ns2m .le. 0) go to 141
         do 140 k=1,ns2m
            sum1 = 0.0d0
            sum2 = 0.0d0
            arg = float(k)*dt
            do 139 i=1,n
               arg1 = float(i-1)*arg
               sum1 = sum1+x(i)*cos(arg1)
               sum2 = sum2+x(i)*sin(arg1)
  139       continue
            a(k) = cf*sum1
            b(k) = cf*sum2
  140    continue
  141    nm1 = n-1
         sum1 = 0.0d0
         sum2 = 0.0d0
         do 142 i=1,nm1,2
            sum1 = sum1+x(i)
            sum2 = sum2+x(i+1)
  142    continue
         if (modn .eq. 1) sum1 = sum1+x(n)
         azero = 0.5d0*cf*(sum1+sum2)
         if (modn .eq. 0) a(ns2) = 0.5d0*cf*(sum1-sum2)
         call dzfftf (n,x,azeroh,ah,bh,w)
         dezf1 = abs(azeroh-azero)
         if (modn .eq. 0) dezf1 = dmax1(dezf1,abs(a(ns2)-ah(ns2)))
         if (ns2m .le. 0) go to 144
         do 143 i=1,ns2m
            dezf1 = dmax1(dezf1,abs(ah(i)-a(i)),abs(bh(i)-b(i)))
  143    continue
  144    ns2 = n/2
         if (modn .eq. 0) b(ns2) = 0.0d0
         do 146 i=1,n
            sum = azero
            arg1 = float(i-1)*dt
            do 145 k=1,ns2
               arg2 = float(k)*arg1
               sum = sum+a(k)*cos(arg2)+b(k)*sin(arg2)
  145       continue
            x(i) = sum
  146    continue
         call dzfftb (n,y,azero,a,b,w)
         dezb1 = 0.0d0
         do 147 i=1,n
            dezb1 = dmax1(dezb1,abs(x(i)-y(i)))
            x(i) = xh(i)
  147    continue
         call dzfftf (n,x,azero,a,b,w)
         call dzfftb (n,y,azero,a,b,w)
         dezfb = 0.0d0
         do 148 i=1,n
            dezfb = dmax1(dezfb,abs(x(i)-y(i)))
  148    continue
c
c     test  cffti,cfftf,cfftb
c
         do 149 i=1,n
            cx(i) = dcmplx(cos(sqrt2*float(i)),sin(sqrt2*float(i*i)))
  149    continue
         dt = (pi+pi)/fn
         do 151 i=1,n
            arg1 = -float(i-1)*dt
            cy(i) = (0.0d0,0.0d0)
            do 150 k=1,n
               arg2 = float(k-1)*arg1
               cy(i) = cy(i)+dcmplx(cos(arg2),sin(arg2))*cx(k)
  150       continue
  151    continue
         call zffti (n,w)
         call zfftf (n,cx,w)
         dcfftf = 0.0d0
         do 152 i=1,n
            dcfftf = dmax1(dcfftf,abs(cx(i)-cy(i)))
            cx(i) = cx(i)/fn
  152    continue
         dcfftf = dcfftf/fn
         do 154 i=1,n
            arg1 = float(i-1)*dt
            cy(i) = (0.0d0,0.0d0)
            do 153 k=1,n
               arg2 = float(k-1)*arg1
               cy(i) = cy(i)+dcmplx(cos(arg2),sin(arg2))*cx(k)
  153       continue
  154    continue
         call zfftb (n,cx,w)
         dcfftb = 0.0d0
         do 155 i=1,n
            dcfftb = dmax1(dcfftb,abs(cx(i)-cy(i)))
            cx(i) = cy(i)
  155    continue
         cf = 1.0d0/fn
         call zfftf (n,cx,w)
         call zfftb (n,cx,w)
         dcfb = 0.0d0
         do 156 i=1,n
            dcfb = dmax1(dcfb,abs(cf*cx(i)-cy(i)))
  156    continue
         write (6,1001) n,rftf,rftb,rftfb,sintt,sintfb,costt,costfb,
     1                  sinqft,sinqbt,sinqfb,cosqft,cosqbt,cosqfb,dezf1,
     2                  dezb1,dezfb,dcfftf,dcfftb,dcfb
  157 continue
c
c
c
 1001 format (2h0n,i5,8h rfftf  ,e10.3,8h rfftb  ,e10.3,8h rfftfb ,
     1        e10.3,8h sint   ,e10.3,8h sintfb ,e10.3,8h cost   ,e10.3/
     2        7x,8h costfb ,e10.3,8h sinqf  ,e10.3,8h sinqb  ,e10.3,
     3        8h sinqfb ,e10.3,8h cosqf  ,e10.3,8h cosqb  ,e10.3/7x,
     4        8h cosqfb ,e10.3,8h dezf   ,e10.3,8h dezb   ,e10.3,
     5        8h dezfb  ,e10.3,8h cfftf  ,e10.3,8h cfftb  ,e10.3/
     6        7x,8h cfftfb ,e10.3)
c
      end

#pragma -xO
      program mltest
      implicit real*8 (a-h, o-z)
      parameter (n = 20, m = 40)
      dimension a(n, m), conval(n), w(m)
      call pi8(pi)
      do j = 1, n
        do k = 1, m
          x = pi * (k - 0.5d0) / m - pi / 2.0
          signal = nint(j / 2.0d0) * cos(x)
          call rand48(s1, s2, rnd)
          dnoise = (2 * rnd - 1) / 10
          a(j, k) = signal + dnoise
        end do
      end do
      call mlwmatrix('Training set', a, n, m)
      do j = 1, n
        conval(j) = nint(j / 2.0d0)
      end do
      call mlwcolvec('Constituent values', conval, n)
c
      end

#pragma -xO
      program whets

      implicit real*32 (a-h, o-z)
c
      common t, t1, t2, e1(4), j, k, l
      integer time0, time1
c
      time0 = 0
      call cputyd(time0)
c
      t = 0.499975
      t1 = 0.50025
      t2 = 2.0
c
c     with iweigh=10, one million whetstone instructions
c     will be executed in each major loop.a major loop is executed
c     'ii' times to increase wall-clock timing accuracy.
c
      iweigh = 10
      ii   = 10
c
      do 500 jj=1, ii
      n1 = 0
      n2 = 12 * iweigh
      n3 = 14 * iweigh
      n4 = 345 * iweigh
      n5 = 0
      n6 = 210 * iweigh
      n7 = 32 * iweigh
      n8 = 899 * iweigh
      n9 = 616 * iweigh
      n10 = 0
      n11 = 93 * iweigh
c
c     module 1: simple identifiers
c
      x1 = 1.0
      x2 = -1.0
      x3 = -1.0
      x4 = -1.0
c
      do 30 i=1, n1
        x1 = (x1 + x2 + x3 - x4)*t
        x2 = (x1 + x2 - x3 + x4)*t
        x3 = (x1 - x2 + x3 + x4)*t
        x4 = (-x1 + x2 + x3 + x4)*t
   30 continue
c
      if (jj .eq. ii) call pout(n1, n1, n1, x1, x2, x3, x4)
c
c     module 2: array elements
c
      e1(1) = 1.0
      e1(2) = -1.0
      e1(3) = -1.0
      e1(4) = -1.0
c
      do 40 i=1, n2
         e1(1) = (e1(1) + e1(2) + e1(3) - e1(4))*t
         e1(2) = (e1(1) + e1(2) - e1(3) + e1(4))*t
         e1(3) = (e1(1) - e1(2) + e1(3) + e1(4))*t
         e1(4) = (-e1(1) + e1(2) + e1(3) + e1(4))*t
   40 continue
c
      if (jj .eq. ii) call pout(n2, n3, n2, e1(1), e1(2), e1(3), e1(4))
c
c     module 3: array as parameter
c
      do 50 i=1, n3
        call pa(e1)
   50 continue
c
      if (jj .eq. ii) call pout(n3, n2, n2, e1(1), e1(2), e1(3), e1(4))
c
c     module 4: conditional jumps
c
      j = 1
      do 60 i=1, n4
         if (j .eq. 1) go to 51
         j = 3
         go to 52
51       j = 2
52       if (j .gt. 2) go to 53
         j = 1
         go to 54
53       j = 0
54       if (j .lt. 1) go to 55
         j = 0
         go to 60
55       j = 1
   60 continue
c
      if (jj .eq. ii) call pout(n4, j, j, x1, x2, x3, x4)
c
c     module 5: omitted
c     module 6: integer arithmetic
c        
      j = 1
      k = 2
      l = 3
c
      do 70 i=1, n6
         j = j * (k-j) * (l-k)
         k = l * k - (l-j) * k
         l = (l - k) * (k + j)
         e1(l-1) = j + k + l
         e1(k-1) = j * k * l
   70 continue
c
      if (jj .eq. ii) call pout(n6, j, k, e1(1), e1(2), e1(3), e1(4))
c
c     module 7: trigonometric functions
c
      x = 0.5
      y = 0.5
c
      do 80 i=1, n7
        x = t * atan(t2 * sin(x) * cos(x) / 
     .      (cos(x + y) + cos(x - y) - 1.0x0))
        y = t * atan(t2 * sin(y) * cos(y) /
     .      (cos(x + y) + cos(x - y) - 1.0x0))
   80 continue
c
      if (jj .eq. ii) call pout(n7, j, k, x, x, y, y)
c
c    module 8: procedure calls
c
      x = 1.0
      y = 1.0
      z = 1.0
c
      do 90 i=1, n8
         call p3(x, y, z)
   90 continue
c
      if (jj .eq. ii) call pout(n8, j, k, x, y, z, z)
c
c     module 9: array references
c
      j = 1
      k = 2
      l = 3
      e1(1) = 1.0
      e1(2) = 2.0
      e1(3) = 3.0
c
      do 100 i=1, n9
         call p0
  100 continue
c
      if (jj .eq. ii) call pout(n9, j, k, e1(1), e1(2), e1(3), e1(4))
c
c     module 10: integer arithmetic
c
      j = 2
      k = 3
c
      do 110 i=1, n10
         j = j + k
         k = j + k
         j = k - j
         k = k - j - j
  110 continue
c
      if (jj .eq. ii) call pout(n10, j, k, x1, x2, x3, x4)
c
c     module 11: standard functions
c
      x = 0.75
c
      do 120 i=1, n11
         x = sqrt(exp(log(x)/t1))
  120 continue
c
      if (jj .eq. ii) call pout(n11, j, k, x, x, x, x)
c
500   continue
c
      call cputyd (time1)
      write (6, 1) 10000 * (iweigh / 10 * ii) / dble (time1-time0)
    1 format (x, f9.1, ' mwhets')
      end
c
      subroutine pa(e)
      implicit real*32 (a-h, o-z)
      dimension e(4)
      common t, t1, t2, e1(4), j, k, l
      j1 = 0
   10 e(1) = (e(1) + e(2) + e(3) - e(4)) * t
      e(2) = (e(1) + e(2) - e(3) + e(4)) * t  
      e(3) = (e(1) - e(2) + e(3) + e(4)) * t
      e(4) = (-e(1) + e(2) + e(3) + e(4)) / t2
      j1 = j1 + 1
      if (j1 - 6) 10, 20, 20
   20 return
      end
c
      subroutine p0
      implicit real*32 (a-h, o-z)
      common t, t1, t2, e1(4), j, k, l
      e1(j) = e1(k)
      e1(k) = e1(l)
      e1(l) = e1(j)
      return
      end
c
      subroutine p3(x, y, z)
      implicit real*32 (a-h, o-z)
      common t, t1, t2, e1(4), j, k, l
      x1 = x
      y1 = y
      x1 = t * (x1 + y1)
      y1 = t * (x1 + y1)
      z = (x1 + y1) / t2
      return
      end
c
      subroutine pout(n, j, k, x1, x2, x3, x4)
      implicit real*32 (a-h, o-z)
      write (6, 10) n, j, k, x1, x2, x3, x4
   10 format (3(x, i7), 4(x, e12.4))
      return
      end

#pragma -xO
      character*1 line(80)
      real*8 pi, pi8
      parameter (max = 30)
      call pi8 (pi)
      do 1 i = 1, max
      x = 2 * (i - 0.5) / max * pi
      y = 39 * (sin (x) + 1)
      do 2 j = 1, 80
    2 line(j) = ' '
      line(1 + int (y + 0.5)) = '*' 
    1 write (*, *) line
      end

#pragma -xO
      PARAMETER (NS=3)
      CHARACTER*16 LINE(NS) 
      DATA LINE(1) / '   1   1' / 
      DATA LINE(2) / '   2   2' / 
      DATA LINE(3) / '   3   3' / 
      READ (LINE, FMT='(2I4)', REC=2) M, N 
      PRINT *, M, N 
      READ (LINE, FMT='(2I4)') M, N 
      PRINT *, M, N 
      DECODE (15, 10, LINE) M, N 
   10 FORMAT (2I4)
      PRINT *, M, N 
      END 

#pragma -xO
      subroutine hanoi (n, m, p, q, r)
      implicit integer (a-z)
      integer*8 m
      if (n .eq. 1) then
        m = m + 1
      else
        call hanoi (n - 1, m, p, r, q)
        call hanoi (1, m, p, q, r)
        call hanoi (n - 1, m, q, p, r)
      endif
      end

      program main
      integer*8 m
      do 1 k = 2, 24
      m = 0
      call hanoi (k, m, 1, 2, 3)
    1 write (*, *) k, ' disks require ', m, ' moves'
      end

#pragma -xO
c 'E' or 'e',   DLAMCH := eps
c 'S' or 's ,   DLAMCH := sfmin
c 'B' or 'b',   DLAMCH := base
c 'P' or 'p',   DLAMCH := eps*base
c 'N' or 'n',   DLAMCH := t
c 'R' or 'r',   DLAMCH := rnd
c 'M' or 'm',   DLAMCH := emin
c 'U' or 'u',   DLAMCH := rmin
c 'L' or 'l',   DLAMCH := emax
c 'O' or 'o',   DLAMCH := rmax
      real*8 dlamch
      write (*, *) dlamch('e')
      write (*, *) dlamch('s')
      write (*, *) dlamch('b')
      write (*, *) dlamch('p')
      write (*, *) dlamch('n')
      write (*, *) dlamch('r')
      write (*, *) dlamch('m')
      write (*, *) dlamch('u')
      write (*, *) dlamch('l')
      write (*, *) dlamch('o')
      end

#pragma -xO
!     real*4 function amod(a, b)
!     implicit real*8 (a-z)
!     amod = a - int(a / b) * b
!     return
!     end

!     integer*4 function ifix(a)
!     implicit real*8 (a-z)
!     ifix = int(a)
!     return
!     end

!     integer*4 function idint(a)
!     implicit real*8 (a-z)
!     idint = int(a)
!     return
!     end

!     subroutine caxpy(n,ca,cx,incx,cy,incy)
!     complex cx(1),cy(1),ca
!     canorm = abs(real(ca)) + abs(aimag(ca))
!     if(n.le.0.or.canorm.eq.0.e0) return
!     if(incx.eq.incy.and.incx.gt.0) go to 20
!     kx = 1
!     ky = 1
!     if(incx.lt.0) kx = 1+(1-n)*incx
!     if(incy.lt.0) ky = 1+(1-n)*incy
!         do 10 i = 1,n
!         cy(ky) = cy(ky) + ca*cx(kx)
!         kx = kx + incx
!         ky = ky + incy
!  10 continue
!     return
!  20 continue
!     ns = n*incx
!         do 30 i=1,ns,incx
!         cy(i) = ca*cx(i) + cy(i)
!  30     continue
!     return
!     end

!     subroutine ccopy(n,cx,incx,cy,incy)
!     complex cx(1),cy(1)
!     if(n .le. 0)return
!     if(incx.eq.incy.and.incx.gt.0) go to 20
!     kx = 1
!     ky = 1
!     if(incx.lt.0) kx = 1+(1-n)*incx
!     if(incy.lt.0) ky = 1+(1-n)*incy
!         do 10 i = 1,n
!         cy(ky) = cx(kx)
!         kx = kx + incx
!         ky = ky + incy
!  10 continue
!     return
!  20 continue
!     ns = n*incx
!         do 30 i=1,ns,incx
!         cy(i) = cx(i)
!  30     continue
!     return
!     end

!     complex function cdotc(n,cx,incx,cy,incy)
!     complex cx(1),cy(1)
!     cdotc = (0.,0.)
!     if(n .le. 0)return
!     if(incx.eq.incy.and.incx.gt.0) go to 20
!     kx = 1
!     ky = 1
!     if(incx.lt.0) kx = 1+(1-n)*incx
!     if(incy.lt.0) ky = 1+(1-n)*incy
!         do 10 i = 1,n
!         cdotc = cdotc + conjg(cx(kx))*cy(ky)
!         kx = kx + incx
!         ky = ky + incy
!  10     continue
!     return
!  20 continue
!     ns = n*incx
!         do 30 i=1,ns,incx
!         cdotc = conjg(cx(i))*cy(i) + cdotc
!  30     continue
!     return
!     end

!     complex function cdotu(n,cx,incx,cy,incy)
!     complex cx(1),cy(1)
!     cdotu = (0.,0.)
!     if(n .le. 0)return
!     if(incx.eq.incy.and.incx.gt.0) go to 20
!     kx = 1
!     ky = 1
!     if(incx.lt.0) kx = 1+(1-n)*incx
!     if(incy.lt.0) ky = 1+(1-n)*incy
!         do 10 i = 1,n
!         cdotu = cdotu + cx(kx)*cy(ky)
!         kx = kx + incx
!         ky = ky + incy
!  10     continue
!     return
!  20 continue
!     ns = n*incx
!         do 30 i=1,ns,incx
!         cdotu = cdotu + cx(i)*cy(i)
!  30     continue
!     return
!     end

!     subroutine crotg(ca,cb,c,s)
!     complex ca,cb,s
!     real c
!     real norm,scale
!     complex alpha
!     if (cabs(ca) .ne. 0.) go to 10
!        c = 0.
!        s = (1.,0.)
!        ca = cb
!        go to 20
!  10 continue
!        scale = cabs(ca) + cabs(cb)
!        norm = scale * sqrt((cabs(ca/scale))**2 + (cabs(cb/scale))**2)
!        alpha = ca /cabs(ca)
!        c = cabs(ca) / norm
!        s = alpha * conjg(cb) / norm
!        ca = alpha * norm
!  20 continue
!     return
!     end

!     subroutine cscal(n,ca,cx,incx)
!     complex ca,cx(1)
!     if(n .le. 0) return
!     ns = n*incx
!         do 10 i = 1,ns,incx
!         cx(i) = ca*cx(i)
!  10     continue
!     return
!     end

!     subroutine csscal(n,sa,cx,incx)
!     complex cx(1)
!     real    sa
!     if(n .le. 0) return
!     ns = n*incx
!         do 10 i = 1,ns,incx
!         cx(i) = sa*cx(i)
!  10     continue
!     return
!     end

!     subroutine cswap(n,cx,incx,cy,incy)
!     complex cx(1),cy(1),ctemp
!     if(n .le. 0)return
!     if(incx.eq.incy.and.incx.gt.0) go to 20
!     kx = 1
!     ky = 1
!     if(incx.lt.0) kx = 1+(1-n)*incx
!     if(incy.lt.0) ky = 1+(1-n)*incy
!         do 10 i = 1,n
!         ctemp = cx(kx)
!         cx(kx) = cy(ky)
!         cy(ky) = ctemp
!         kx = kx + incx
!         ky = ky + incy
!  10 continue
!     return
!  20 continue
!     ns = n*incx
!         do 30 i=1,ns,incx
!         ctemp = cx(i)
!         cx(i) = cy(i)
!         cy(i) = ctemp
!  30     continue
!     return
!     end

!     double precision function dasum(n,dx,incx)
!     double precision dx(1)
!     dasum = 0.d0
!     if(n.le.0)return
!     if(incx.eq.1)goto 20
!     ns = n*incx
!         do 10 i=1,ns,incx
!         dasum = dasum + dabs(dx(i))
!  10     continue
!     return
!  20 m = mod(n,6)
!     if( m .eq. 0 ) go to 40
!     do 30 i = 1,m
!        dasum = dasum + dabs(dx(i))
!  30 continue
!     if( n .lt. 6 ) return
!  40 mp1 = m + 1
!     do 50 i = mp1,n,6
!        dasum = dasum + dabs(dx(i)) + dabs(dx(i+1)) + dabs(dx(i+2))
!    1   + dabs(dx(i+3)) + dabs(dx(i+4)) + dabs(dx(i+5))
!  50 continue
!     return
!     end

!     subroutine daxpy(n,da,dx,incx,dy,incy)
!     double precision dx(1),dy(1),da
!     if(n.le.0.or.da.eq.0.d0) return
!     if(incx.eq.incy) if(incx-1) 5,20,60
!   5 continue
!     ix = 1
!     iy = 1
!     if(incx.lt.0)ix = (-n+1)*incx + 1
!     if(incy.lt.0)iy = (-n+1)*incy + 1
!     do 10 i = 1,n
!       dy(iy) = dy(iy) + da*dx(ix)
!       ix = ix + incx
!       iy = iy + incy
!  10 continue
!     return
!  20 m = mod(n,4)
!     if( m .eq. 0 ) go to 40
!     do 30 i = 1,m
!       dy(i) = dy(i) + da*dx(i)
!  30 continue
!     if( n .lt. 4 ) return
!  40 mp1 = m + 1
!     do 50 i = mp1,n,4
!       dy(i) = dy(i) + da*dx(i)
!       dy(i + 1) = dy(i + 1) + da*dx(i + 1)
!       dy(i + 2) = dy(i + 2) + da*dx(i + 2)
!       dy(i + 3) = dy(i + 3) + da*dx(i + 3)
!  50 continue
!     return
!  60 continue
!     ns = n*incx
!         do 70 i=1,ns,incx
!         dy(i) = da*dx(i) + dy(i)
!  70     continue
!     return
!     end

!     subroutine dcopy(n,dx,incx,dy,incy)
!     double precision dx(1),dy(1)
!     if(n.le.0)return
!     if(incx.eq.incy) if(incx-1) 5,20,60
!   5 continue
!     ix = 1
!     iy = 1
!     if(incx.lt.0)ix = (-n+1)*incx + 1
!     if(incy.lt.0)iy = (-n+1)*incy + 1
!     do 10 i = 1,n
!       dy(iy) = dx(ix)
!       ix = ix + incx
!       iy = iy + incy
!  10 continue
!     return
!  20 m = mod(n,7)
!     if( m .eq. 0 ) go to 40
!     do 30 i = 1,m
!       dy(i) = dx(i)
!  30 continue
!     if( n .lt. 7 ) return
!  40 mp1 = m + 1
!     do 50 i = mp1,n,7
!       dy(i) = dx(i)
!       dy(i + 1) = dx(i + 1)
!       dy(i + 2) = dx(i + 2)
!       dy(i + 3) = dx(i + 3)
!       dy(i + 4) = dx(i + 4)
!       dy(i + 5) = dx(i + 5)
!       dy(i + 6) = dx(i + 6)
!  50 continue
!     return
!  60 continue
!     ns=n*incx
!         do 70 i=1,ns,incx
!         dy(i) = dx(i)
!  70     continue
!     return
!     end

!     double precision function ddot(n,dx,incx,dy,incy)
!     double precision dx(1),dy(1)
!     ddot = 0.d0
!     if(n.le.0)return
!     if(incx.eq.incy) if(incx-1) 5,20,60
!   5 continue
!     ix = 1
!     iy = 1
!     if(incx.lt.0)ix = (-n+1)*incx + 1
!     if(incy.lt.0)iy = (-n+1)*incy + 1
!     do 10 i = 1,n
!        ddot = ddot + dx(ix)*dy(iy)
!       ix = ix + incx
!       iy = iy + incy
!  10 continue
!     return
!  20 m = mod(n,5)
!     if( m .eq. 0 ) go to 40
!     do 30 i = 1,m
!        ddot = ddot + dx(i)*dy(i)
!  30 continue
!     if( n .lt. 5 ) return
!  40 mp1 = m + 1
!     do 50 i = mp1,n,5
!        ddot = ddot + dx(i)*dy(i) + dx(i+1)*dy(i+1) +
!    1   dx(i + 2)*dy(i + 2) + dx(i + 3)*dy(i + 3) + dx(i + 4)*dy(i + 4)
!  50 continue
!     return
!  60 continue
!     ns = n*incx
!         do 70 i=1,ns,incx
!         ddot = ddot + dx(i)*dy(i)
!  70     continue
!     return
!     end

!     double precision function dnrm2 ( n, dx, incx)
!     integer          next
!     double precision   dx(1), cutlo, cuthi, hitest, sum, xmax,zero,one
!     data   zero, one /0.0d0, 1.0d0/
!     data cutlo, cuthi / 8.232d-11,  1.304d19 /
!     if(n .gt. 0) go to 10
!        dnrm2  = zero
!        go to 300
!  10 assign 30 to next
!     sum = zero
!     nn = n * incx
!     i = 1
!  20    go to next,(30, 50, 70, 110)
!  30 if( dabs(dx(i)) .gt. cutlo) go to 85
!     assign 50 to next
!     xmax = zero
!  50 if( dx(i) .eq. zero) go to 200
!     if( dabs(dx(i)) .gt. cutlo) go to 85
!     assign 70 to next
!     go to 105
! 100 i = j
!     assign 110 to next
!     sum = (sum / dx(i)) / dx(i)
! 105 xmax = dabs(dx(i))
!     go to 115
!  70 if( dabs(dx(i)) .gt. cutlo ) go to 75
! 110 if( dabs(dx(i)) .le. xmax ) go to 115
!        sum = one + sum * (xmax / dx(i))**2
!        xmax = dabs(dx(i))
!        go to 200
! 115 sum = sum + (dx(i)/xmax)**2
!     go to 200
!  75 sum = (sum * xmax) * xmax
!  85 hitest = cuthi/float( n )
!     do 95 j =i,nn,incx
!     if(dabs(dx(j)) .ge. hitest) go to 100
!  95    sum = sum + dx(j)**2
!     dnrm2 = dsqrt( sum )
!     go to 300
! 200 continue
!     i = i + incx
!     if ( i .le. nn ) go to 20
!     dnrm2 = xmax * dsqrt(sum)
! 300 continue
!     return
!     end

!     subroutine drot(n,dx,incx,dy,incy,dc,ds)
!     double precision dx,dy,dc,ds,zero,one,w,z
!     dimension dx(1),dy(1)
!     data zero,one/0.d0,1.d0/
!     if(n .le. 0 .or. (ds .eq. zero .and. dc .eq. one)) go to 40
!     if(.not. (incx .eq. incy .and. incx .gt. 0)) go to 20
!          nsteps=incx*n
!          do 10 i=1,nsteps,incx
!               w=dx(i)
!               z=dy(i)
!               dx(i)=dc*w+ds*z
!               dy(i)=-ds*w+dc*z
!  10           continue
!          go to 40
!  20 continue
!          kx=1
!          ky=1
!          if(incx .lt. 0) kx=1-(n-1)*incx
!          if(incy .lt. 0) ky=1-(n-1)*incy
!          do 30 i=1,n
!               w=dx(kx)
!               z=dy(ky)
!               dx(kx)=dc*w+ds*z
!               dy(ky)=-ds*w+dc*z
!               kx=kx+incx
!               ky=ky+incy
!  30           continue
!  40 continue
!     return
!     end

!     subroutine drotg(da,db,dc,ds)
!     double precision  da, db, dc, ds, u, v, r
!     if (dabs(da) .le. dabs(db)) go to 10
!     u = da + da
!     v = db / u
!     r = dsqrt(.25d0 + v**2) * u
!     dc = da / r
!     ds = v * (dc + dc)
!     db = ds
!     da = r
!     return
!  10 if (db .eq. 0.d0) go to 20
!     u = db + db
!     v = da / u
!     da = dsqrt(.25d0 + v**2) * u
!     ds = db / da
!     dc = v * (ds + ds)
!     if (dc .eq. 0.d0) go to 15
!     db = 1.d0 / dc
!     return
!  15 db = 1.d0
!     return
!  20 dc = 1.d0
!     ds = 0.d0
!     return
!     end

!     subroutine drotm (n,dx,incx,dy,incy,dparam)
!     double precision dflag,dh12,dh22,dx,two,z,dh11,dh21,
!    1 dparam,dy,w,zero
!     dimension dx(1),dy(1),dparam(5)
!     data zero,two/0.d0,2.d0/
!     dflag=dparam(1)
!     if(n .le. 0 .or.(dflag+two.eq.zero)) go to 140
!         if(.not.(incx.eq.incy.and. incx .gt.0)) go to 70
!              nsteps=n*incx
!              if(dflag) 50,10,30
!  10          continue
!              dh12=dparam(4)
!              dh21=dparam(3)
!                   do 20 i=1,nsteps,incx
!                   w=dx(i)
!                   z=dy(i)
!                   dx(i)=w+z*dh12
!                   dy(i)=w*dh21+z
!  20               continue
!              go to 140
!  30          continue
!              dh11=dparam(2)
!              dh22=dparam(5)
!                   do 40 i=1,nsteps,incx
!                   w=dx(i)
!                   z=dy(i)
!                   dx(i)=w*dh11+z
!                   dy(i)=-w+dh22*z
!  40               continue
!              go to 140
!  50          continue
!              dh11=dparam(2)
!              dh12=dparam(4)
!              dh21=dparam(3)
!              dh22=dparam(5)
!                   do 60 i=1,nsteps,incx
!                   w=dx(i)
!                   z=dy(i)
!                   dx(i)=w*dh11+z*dh12
!                   dy(i)=w*dh21+z*dh22
!  60               continue
!              go to 140
!  70     continue
!         kx=1
!         ky=1
!         if(incx .lt. 0) kx=1+(1-n)*incx
!         if(incy .lt. 0) ky=1+(1-n)*incy
!         if(dflag)120,80,100
!  80     continue
!         dh12=dparam(4)
!         dh21=dparam(3)
!              do 90 i=1,n
!              w=dx(kx)
!              z=dy(ky)
!              dx(kx)=w+z*dh12
!              dy(ky)=w*dh21+z
!              kx=kx+incx
!              ky=ky+incy
!  90          continue
!         go to 140
! 100     continue
!         dh11=dparam(2)
!         dh22=dparam(5)
!              do 110 i=1,n
!              w=dx(kx)
!              z=dy(ky)
!              dx(kx)=w*dh11+z
!              dy(ky)=-w+dh22*z
!              kx=kx+incx
!              ky=ky+incy
! 110          continue
!         go to 140
! 120     continue
!         dh11=dparam(2)
!         dh12=dparam(4)
!         dh21=dparam(3)
!         dh22=dparam(5)
!              do 130 i=1,n
!              w=dx(kx)
!              z=dy(ky)
!              dx(kx)=w*dh11+z*dh12
!              dy(ky)=w*dh21+z*dh22
!              kx=kx+incx
!              ky=ky+incy
! 130          continue
! 140     continue
!         return
!         end

!     subroutine drotmg (dd1,dd2,dx1,dy1,dparam)
!     double precision gam,one,rgamsq,dd2,dh11,dh21,dparam,dp2,
!    1 dq2,du,dy1,zero,gamsq,dd1,dflag,dh12,dh22,dp1,dq1,
!    2 dtemp,dx1,two
!     dimension dparam(5)
!     data zero,one,two /0.d0,1.d0,2.d0/
!     data gam,gamsq,rgamsq/4096.d0,16777216.d0,5.9604645d-8/
!     if(.not. dd1 .lt. zero) go to 10
!         go to 60
!  10 continue
!     dp2=dd2*dy1
!     if(.not. dp2 .eq. zero) go to 20
!         dflag=-two
!         go to 260
!  20 continue
!     dp1=dd1*dx1
!     dq2=dp2*dy1
!     dq1=dp1*dx1
!     if(.not. dabs(dq1) .gt. dabs(dq2)) go to 40
!         dh21=-dy1/dx1
!         dh12=dp2/dp1
!         du=one-dh12*dh21
!         if(.not. du .le. zero) go to 30
!              go to 60
!  30     continue
!              dflag=zero
!              dd1=dd1/du
!              dd2=dd2/du
!              dx1=dx1*du
!              go to 100
!  40 continue
!         if(.not. dq2 .lt. zero) go to 50
!              go to 60
!  50     continue
!              dflag=one
!              dh11=dp1/dp2
!              dh22=dx1/dy1
!              du=one+dh11*dh22
!              dtemp=dd2/du
!              dd2=dd1/du
!              dd1=dtemp
!              dx1=dy1*du
!              go to 100
!  60 continue
!         dflag=-one
!         dh11=zero
!         dh12=zero
!         dh21=zero
!         dh22=zero
!         dd1=zero
!         dd2=zero
!         dx1=zero
!         go to 220
!  70 continue
!     if(.not. dflag .ge. zero) go to 90
!         if(.not. dflag .eq. zero) go to 80
!         dh11=one
!         dh22=one
!         dflag=-one
!         go to 90
!  80     continue
!         dh21=-one
!         dh12=one
!         dflag=-one
!  90 continue
!     go to igo,(120,150,180,210)
! 100 continue
! 110     continue
!         if(.not. dd1 .le. rgamsq) go to 130
!              if(dd1 .eq. zero) go to 160
!              assign 120 to igo
!              go to 70
! 120          continue
!              dd1=dd1*gam**2
!              dx1=dx1/gam
!              dh11=dh11/gam
!              dh12=dh12/gam
!         go to 110
! 130 continue
! 140     continue
!         if(.not. dd1 .ge. gamsq) go to 160
!              assign 150 to igo
!              go to 70
! 150          continue
!              dd1=dd1/gam**2
!              dx1=dx1*gam
!              dh11=dh11*gam
!              dh12=dh12*gam
!         go to 140
! 160 continue
! 170     continue
!         if(.not. dabs(dd2) .le. rgamsq) go to 190
!              if(dd2 .eq. zero) go to 220
!              assign 180 to igo
!              go to 70
! 180          continue
!              dd2=dd2*gam**2
!              dh21=dh21/gam
!              dh22=dh22/gam
!         go to 170
! 190 continue
! 200     continue
!         if(.not. dabs(dd2) .ge. gamsq) go to 220
!              assign 210 to igo
!              go to 70
! 210          continue
!              dd2=dd2/gam**2
!              dh21=dh21*gam
!              dh22=dh22*gam
!         go to 200
! 220 continue
!         if(dflag)250,230,240
! 230     continue
!              dparam(3)=dh21
!              dparam(4)=dh12
!              go to 260
! 240     continue
!              dparam(2)=dh11
!              dparam(5)=dh22
!              go to 260
! 250     continue
!              dparam(2)=dh11
!              dparam(3)=dh21
!              dparam(4)=dh12
!              dparam(5)=dh22
! 260 continue
!         dparam(1)=dflag
!         return
!     end

!     subroutine dscal(n,da,dx,incx)
!     double precision da,dx(1)
!     if(n.le.0)return
!     if(incx.eq.1)goto 20
!     ns = n*incx
!         do 10 i = 1,ns,incx
!         dx(i) = da*dx(i)
!  10     continue
!     return
!  20 m = mod(n,5)
!     if( m .eq. 0 ) go to 40
!     do 30 i = 1,m
!       dx(i) = da*dx(i)
!  30 continue
!     if( n .lt. 5 ) return
!  40 mp1 = m + 1
!     do 50 i = mp1,n,5
!       dx(i) = da*dx(i)
!       dx(i + 1) = da*dx(i + 1)
!       dx(i + 2) = da*dx(i + 2)
!       dx(i + 3) = da*dx(i + 3)
!       dx(i + 4) = da*dx(i + 4)
!  50 continue
!     return
!     end

!     double precision function dsdot(n,sx,incx,sy,incy)
!     real sx(1),sy(1)
!     dsdot = 0.d0
!     if(n .le. 0)return
!     if(incx.eq.incy.and.incx.gt.0) go to 20
!     kx = 1
!     ky = 1
!     if(incx.lt.0) kx = 1+(1-n)*incx
!     if(incy.lt.0) ky = 1+(1-n)*incy
!         do 10 i = 1,n
!         dsdot = dsdot + dble(sx(kx))*dble(sy(ky))
!         kx = kx + incx
!         ky = ky + incy
!  10 continue
!     return
!  20 continue
!     ns = n*incx
!         do 30 i=1,ns,incx
!         dsdot = dsdot + dble(sx(i))*dble(sy(i))
!  30     continue
!     return
!     end

!     subroutine dswap(n,dx,incx,dy,incy)
!     double precision dx(1),dy(1),dtemp1,dtemp2,dtemp3
!     if(n.le.0)return
!     if(incx.eq.incy) if(incx-1) 5,20,60
!   5 continue
!     ix = 1
!     iy = 1
!     if(incx.lt.0)ix = (-n+1)*incx + 1
!     if(incy.lt.0)iy = (-n+1)*incy + 1
!     do 10 i = 1,n
!       dtemp1 = dx(ix)
!       dx(ix) = dy(iy)
!       dy(iy) = dtemp1
!       ix = ix + incx
!       iy = iy + incy
!  10 continue
!     return
!  20 m = mod(n,3)
!     if( m .eq. 0 ) go to 40
!     do 30 i = 1,m
!       dtemp1 = dx(i)
!       dx(i) = dy(i)
!       dy(i) = dtemp1
!  30 continue
!     if( n .lt. 3 ) return
!  40 mp1 = m + 1
!     do 50 i = mp1,n,3
!       dtemp1 = dx(i)
!       dtemp2 = dx(i+1)
!       dtemp3 = dx(i+2)
!       dx(i) = dy(i)
!       dx(i+1) = dy(i+1)
!       dx(i+2) = dy(i+2)
!       dy(i) = dtemp1
!       dy(i+1) = dtemp2
!       dy(i+2) = dtemp3
!  50 continue
!     return
!  60 continue
!     ns = n*incx
!       do 70 i=1,ns,incx
!       dtemp1 = dx(i)
!       dx(i) = dy(i)
!       dy(i) = dtemp1
!  70   continue
!     return
!     end

!     integer function icamax(n,cx,incx)
!     complex cx(1)
!     icamax = 0
!     if(n.le.0) return
!     icamax = 1
!     if(n .le. 1) return
!     ns = n*incx
!     ii = 1
!     summax = abs(real(cx(1))) + abs(aimag(cx(1)))
!         do 20 i=1,ns,incx
!         sumri = abs(real(cx(i))) + abs(aimag(cx(i)))
!         if(summax.ge.sumri) go to 10
!         summax = sumri
!         icamax = ii
!  10     ii = ii + 1
!  20     continue
!     return
!     end

!     integer function idamax(n,dx,incx)
!     double precision dx(1),dmax,xmag
!     idamax = 0
!     if(n.le.0) return
!     idamax = 1
!     if(n.le.1)return
!     if(incx.eq.1)goto 20
!     dmax = dabs(dx(1))
!     ns = n*incx
!     ii = 1
!         do 10 i = 1,ns,incx
!         xmag = dabs(dx(i))
!         if(xmag.le.dmax) go to 5
!         idamax = ii
!         dmax = xmag
!   5     ii = ii + 1
!  10     continue
!     return
!  20 dmax = dabs(dx(1))
!     do 30 i = 2,n
!         xmag = dabs(dx(i))
!         if(xmag.le.dmax) go to 30
!         idamax = i
!         dmax = xmag
!  30 continue
!     return
!     end

!     integer function isamax(n,sx,incx)
!     real sx(1),smax,xmag
!     isamax = 0
!     if(n.le.0) return
!     isamax = 1
!     if(n.le.1)return
!     if(incx.eq.1)goto 20
!     smax = abs(sx(1))
!     ns = n*incx
!     ii = 1
!         do 10 i=1,ns,incx
!         xmag = abs(sx(i))
!         if(xmag.le.smax) go to 5
!         isamax = ii
!         smax = xmag
!   5     ii = ii + 1
!  10     continue
!     return
!  20 smax = abs(sx(1))
!     do 30 i = 2,n
!        xmag = abs(sx(i))
!        if(xmag.le.smax) go to 30
!        isamax = i
!        smax = xmag
!  30 continue
!     return
!     end

!     real function sasum(n,sx,incx)
!     real sx(1)
!     sasum = 0.0e0
!     if(n.le.0)return
!     if(incx.eq.1)goto 20
!     ns = n*incx
!         do 10 i=1,ns,incx
!         sasum = sasum + abs(sx(i))
!  10     continue
!     return
!  20 m = mod(n,6)
!     if( m .eq. 0 ) go to 40
!     do 30 i = 1,m
!       sasum = sasum + abs(sx(i))
!  30 continue
!     if( n .lt. 6 ) return
!  40 mp1 = m + 1
!     do 50 i = mp1,n,6
!       sasum = sasum + abs(sx(i)) + abs(sx(i + 1)) + abs(sx(i + 2))
!    1  + abs(sx(i + 3)) + abs(sx(i + 4)) + abs(sx(i + 5))
!  50 continue
!     return
!     end

!     subroutine saxpy(n,sa,sx,incx,sy,incy)
!     real sx(1),sy(1),sa
!     if(n.le.0.or.sa.eq.0.e0) return
!     if(incx.eq.incy) if(incx-1) 5,20,60
!   5 continue
!     ix = 1
!     iy = 1
!     if(incx.lt.0)ix = (-n+1)*incx + 1
!     if(incy.lt.0)iy = (-n+1)*incy + 1
!     do 10 i = 1,n
!       sy(iy) = sy(iy) + sa*sx(ix)
!       ix = ix + incx
!       iy = iy + incy
!  10 continue
!     return
!  20 m = mod(n,4)
!     if( m .eq. 0 ) go to 40
!     do 30 i = 1,m
!       sy(i) = sy(i) + sa*sx(i)
!  30 continue
!     if( n .lt. 4 ) return
!  40 mp1 = m + 1
!     do 50 i = mp1,n,4
!       sy(i) = sy(i) + sa*sx(i)
!       sy(i + 1) = sy(i + 1) + sa*sx(i + 1)
!       sy(i + 2) = sy(i + 2) + sa*sx(i + 2)
!       sy(i + 3) = sy(i + 3) + sa*sx(i + 3)
!  50 continue
!     return
!  60 continue
!     ns = n*incx
!         do 70 i=1,ns,incx
!         sy(i) = sa*sx(i) + sy(i)
!  70     continue
!     return
!     end

!     function scasum(n,cx,incx)
!     complex cx(1)
!     scasum=0.
!     if(n .le. 0) return
!     ns = n*incx
!         do 10 i=1,ns,incx
!         scasum = scasum + abs(real(cx(i))) + abs(aimag(cx(i)))
!  10     continue
!     return
!     end

!     real function scnrm2( n, cx, incx)
!     logical imag, scale
!     integer          next
!     real         cutlo, cuthi, hitest, sum, xmax, absx, zero, one
!     complex      cx(1)
!     data         zero, one /0.0e0, 1.0e0/
!     data cutlo, cuthi / 4.441e-16,  1.304e19 /
!     if(n .gt. 0) go to 10
!        scnrm2  = zero
!        go to 300
!  10 assign 30 to next
!     sum = zero
!     nn = n * incx
!     do 210 i=1,nn,incx
!        absx = abs(real(cx(i)))
!        imag = .false.
!        go to next,(30, 50, 70, 90, 110)
!  30 if( absx .gt. cutlo) go to 85
!     assign 50 to next
!     scale = .false.
!  50 if( absx .eq. zero) go to 200
!     if( absx .gt. cutlo) go to 85
!     assign 70 to next
!     go to 105
! 100 assign 110 to next
!     sum = (sum / absx) / absx
! 105 scale = .true.
!     xmax = absx
!     go to 115
!  70 if( absx .gt. cutlo ) go to 75
! 110 if( absx .le. xmax ) go to 115
!        sum = one + sum * (xmax / absx)**2
!        xmax = absx
!        go to 200
! 115 sum = sum + (absx/xmax)**2
!     go to 200
!  75 sum = (sum * xmax) * xmax
!  85 assign 90 to next
!     scale = .false.
!     hitest = cuthi/float( n )
!  90 if(absx .ge. hitest) go to 100
!        sum = sum + absx**2
! 200 continue
!     if(imag) go to 210
!        absx = abs(aimag(cx(i)))
!        imag = .true.
!     go to next,(  50, 70, 90, 110 )
! 210 continue
!     scnrm2 = sqrt(sum)
!     if(scale) scnrm2 = scnrm2 * xmax
! 300 continue
!     return
!     end

!     subroutine scopy(n,sx,incx,sy,incy)
!     real sx(1),sy(1)
!     if(n.le.0)return
!     if(incx.eq.incy) if(incx-1) 5,20,60
!   5 continue
!     ix = 1
!     iy = 1
!     if(incx.lt.0)ix = (-n+1)*incx + 1
!     if(incy.lt.0)iy = (-n+1)*incy + 1
!     do 10 i = 1,n
!       sy(iy) = sx(ix)
!       ix = ix + incx
!       iy = iy + incy
!  10 continue
!     return
!  20 m = mod(n,7)
!     if( m .eq. 0 ) go to 40
!     do 30 i = 1,m
!       sy(i) = sx(i)
!  30 continue
!     if( n .lt. 7 ) return
!  40 mp1 = m + 1
!     do 50 i = mp1,n,7
!       sy(i) = sx(i)
!       sy(i + 1) = sx(i + 1)
!       sy(i + 2) = sx(i + 2)
!       sy(i + 3) = sx(i + 3)
!       sy(i + 4) = sx(i + 4)
!       sy(i + 5) = sx(i + 5)
!       sy(i + 6) = sx(i + 6)
!  50 continue
!     return
!  60 continue
!     ns = n*incx
!         do 70 i=1,ns,incx
!         sy(i) = sx(i)
!  70     continue
!     return
!     end

!     real function sdot(n,sx,incx,sy,incy)
!     real sx(1),sy(1)
!     sdot = 0.0e0
!     if(n.le.0)return
!     if(incx.eq.incy) if(incx-1)5,20,60
!   5 continue
!     ix = 1
!     iy = 1
!     if(incx.lt.0)ix = (-n+1)*incx + 1
!     if(incy.lt.0)iy = (-n+1)*incy + 1
!     do 10 i = 1,n
!       sdot = sdot + sx(ix)*sy(iy)
!       ix = ix + incx
!       iy = iy + incy
!  10 continue
!     return
!  20 m = mod(n,5)
!     if( m .eq. 0 ) go to 40
!     do 30 i = 1,m
!       sdot = sdot + sx(i)*sy(i)
!  30 continue
!     if( n .lt. 5 ) return
!  40 mp1 = m + 1
!     do 50 i = mp1,n,5
!       sdot = sdot + sx(i)*sy(i) + sx(i + 1)*sy(i + 1) +
!    1   sx(i + 2)*sy(i + 2) + sx(i + 3)*sy(i + 3) + sx(i + 4)*sy(i + 4)
!  50 continue
!     return
!  60 continue
!     ns=n*incx
!     do 70 i=1,ns,incx
!       sdot = sdot + sx(i)*sy(i)
!  70   continue
!     return
!     end

!     real function sdsdot(n,sb,sx,incx,sy,incy)
!     real              sx(1),sy(1),sb
!     double precision dsdot
!     dsdot = dble(sb)
!     if(n .le. 0) go to 30
!     if(incx.eq.incy.and.incx.gt.0) go to 40
!     kx = 1
!     ky = 1
!     if(incx.lt.0) kx = 1+(1-n)*incx
!     if(incy.lt.0) ky = 1+(1-n)*incy
!         do 10 i = 1,n
!         dsdot = dsdot + dble(sx(kx))*dble(sy(ky))
!         kx = kx + incx
!         ky = ky + incy
!  10     continue
!  30 sdsdot = sngl(dsdot)
!     return
!  40 continue
!     ns = n*incx
!         do 50 i=1,ns,incx
!         dsdot = dsdot + dble(sx(i))*dble(sy(i))
!  50     continue
!     sdsdot = sngl(dsdot)
!     return
!     end

!     real function snrm2 ( n, sx, incx)
!     integer          next
!     real   sx(1),  cutlo, cuthi, hitest, sum, xmax, zero, one
!     data   zero, one /0.0e0, 1.0e0/
!     data cutlo, cuthi / 4.441e-16,  1.304e19 /
!     if(n .gt. 0) go to 10
!        snrm2  = zero
!        go to 300
!  10 assign 30 to next
!     sum = zero
!     nn = n * incx
!     i = 1
!  20    go to next,(30, 50, 70, 110)
!  30 if( abs(sx(i)) .gt. cutlo) go to 85
!     assign 50 to next
!     xmax = zero
!  50 if( sx(i) .eq. zero) go to 200
!     if( abs(sx(i)) .gt. cutlo) go to 85
!     assign 70 to next
!     go to 105
! 100 i = j
!     assign 110 to next
!     sum = (sum / sx(i)) / sx(i)
! 105 xmax = abs(sx(i))
!     go to 115
!  70 if( abs(sx(i)) .gt. cutlo ) go to 75
! 110 if( abs(sx(i)) .le. xmax ) go to 115
!        sum = one + sum * (xmax / sx(i))**2
!        xmax = abs(sx(i))
!        go to 200
! 115 sum = sum + (sx(i)/xmax)**2
!     go to 200
!  75 sum = (sum * xmax) * xmax
!  85 hitest = cuthi/float( n )
!     do 95 j =i,nn,incx
!     if(abs(sx(j)) .ge. hitest) go to 100
!  95    sum = sum + sx(j)**2
!     snrm2 = sqrt( sum )
!     go to 300
! 200 continue
!     i = i + incx
!     if ( i .le. nn ) go to 20
!     snrm2 = xmax * sqrt(sum)
! 300 continue
!     return
!     end

!     subroutine srot(n,sx,incx,sy,incy,sc,ss)
!     real             sx,sy,sc,ss,zero,one,w,z
!     dimension sx(1),sy(1)
!     data zero,one/0.e0,1.e0/
!     if(n .le. 0 .or. (ss .eq. zero .and. sc .eq. one)) go to 40
!     if(.not. (incx .eq. incy .and. incx .gt. 0)) go to 20
!          nsteps=incx*n
!          do 10 i=1,nsteps,incx
!               w=sx(i)
!               z=sy(i)
!               sx(i)=sc*w+ss*z
!               sy(i)=-ss*w+sc*z
!  10           continue
!          go to 40
!  20 continue
!          kx=1
!          ky=1
!          if(incx .lt. 0) kx=1-(n-1)*incx
!          if(incy .lt. 0) ky=1-(n-1)*incy
!          do 30 i=1,n
!               w=sx(kx)
!               z=sy(ky)
!               sx(kx)=sc*w+ss*z
!               sy(ky)=-ss*w+sc*z
!               kx=kx+incx
!               ky=ky+incy
!  30           continue
!  40 continue
!     return
!     end

!     subroutine srotg(sa,sb,sc,ss)
!     if (abs(sa) .le. abs(sb)) go to 10
!     u = sa + sa
!     v = sb / u
!     r = sqrt(.25 + v**2) * u
!     sc = sa / r
!     ss = v * (sc + sc)
!     sb = ss
!     sa = r
!     return
!  10 if (sb .eq. 0.) go to 20
!     u = sb + sb
!     v = sa / u
!     sa = sqrt(.25 + v**2) * u
!     ss = sb / sa
!     sc = v * (ss + ss)
!     if (sc .eq. 0.) go to 15
!     sb = 1. / sc
!     return
!  15 sb = 1.
!     return
!  20 sc = 1.
!     ss = 0.
!     return
!     end

!     subroutine srotm (n,sx,incx,sy,incy,sparam)
!     dimension sx(1),sy(1),sparam(5)
!     data zero,two/0.e0,2.e0/
!     sflag=sparam(1)
!     if(n .le. 0 .or.(sflag+two.eq.zero)) go to 140
!         if(.not.(incx.eq.incy.and. incx .gt.0)) go to 70
!              nsteps=n*incx
!              if(sflag) 50,10,30
!  10          continue
!              sh12=sparam(4)
!              sh21=sparam(3)
!                   do 20 i=1,nsteps,incx
!                   w=sx(i)
!                   z=sy(i)
!                   sx(i)=w+z*sh12
!                   sy(i)=w*sh21+z
!  20               continue
!              go to 140
!  30          continue
!              sh11=sparam(2)
!              sh22=sparam(5)
!                   do 40 i=1,nsteps,incx
!                   w=sx(i)
!                   z=sy(i)
!                   sx(i)=w*sh11+z
!                   sy(i)=-w+sh22*z
!  40               continue
!              go to 140
!  50          continue
!              sh11=sparam(2)
!              sh12=sparam(4)
!              sh21=sparam(3)
!              sh22=sparam(5)
!                   do 60 i=1,nsteps,incx
!                   w=sx(i)
!                   z=sy(i)
!                   sx(i)=w*sh11+z*sh12
!                   sy(i)=w*sh21+z*sh22
!  60               continue
!              go to 140
!  70     continue
!         kx=1
!         ky=1
!         if(incx .lt. 0) kx=1+(1-n)*incx
!         if(incy .lt. 0) ky=1+(1-n)*incy
!         if(sflag)120,80,100
!  80     continue
!         sh12=sparam(4)
!         sh21=sparam(3)
!              do 90 i=1,n
!              w=sx(kx)
!              z=sy(ky)
!              sx(kx)=w+z*sh12
!              sy(ky)=w*sh21+z
!              kx=kx+incx
!              ky=ky+incy
!  90          continue
!         go to 140
! 100     continue
!         sh11=sparam(2)
!         sh22=sparam(5)
!              do 110 i=1,n
!              w=sx(kx)
!              z=sy(ky)
!              sx(kx)=w*sh11+z
!              sy(ky)=-w+sh22*z
!              kx=kx+incx
!              ky=ky+incy
! 110          continue
!         go to 140
! 120     continue
!         sh11=sparam(2)
!         sh12=sparam(4)
!         sh21=sparam(3)
!         sh22=sparam(5)
!              do 130 i=1,n
!              w=sx(kx)
!              z=sy(ky)
!              sx(kx)=w*sh11+z*sh12
!              sy(ky)=w*sh21+z*sh22
!              kx=kx+incx
!              ky=ky+incy
! 130          continue
! 140     continue
!         return
!         end

!     subroutine srotmg (sd1,sd2,sx1,sy1,sparam)
!     dimension sparam(5)
!     data zero,one,two /0.e0,1.e0,2.e0/
!     data gam,gamsq,rgamsq/4096.e0,1.67772e7,5.96046e-8/
!     if(.not. sd1 .lt. zero) go to 10
!         go to 60
!  10 continue
!     sp2=sd2*sy1
!     if(.not. sp2 .eq. zero) go to 20
!         sflag=-two
!         go to 260
!  20 continue
!     sp1=sd1*sx1
!     sq2=sp2*sy1
!     sq1=sp1*sx1
!     if(.not. abs(sq1) .gt. abs(sq2)) go to 40
!         sh21=-sy1/sx1
!         sh12=sp2/sp1
!         su=one-sh12*sh21
!         if(.not. su .le. zero) go to 30
!              go to 60
!  30     continue
!              sflag=zero
!              sd1=sd1/su
!              sd2=sd2/su
!              sx1=sx1*su
!              go to 100
!  40 continue
!         if(.not. sq2 .lt. zero) go to 50
!              go to 60
!  50     continue
!              sflag=one
!              sh11=sp1/sp2
!              sh22=sx1/sy1
!              su=one+sh11*sh22
!              stemp=sd2/su
!              sd2=sd1/su
!              sd1=stemp
!              sx1=sy1*su
!              go to 100
!  60 continue
!         sflag=-one
!         sh11=zero
!         sh12=zero
!         sh21=zero
!         sh22=zero
!         sd1=zero
!         sd2=zero
!         sx1=zero
!         go to 220
!  70 continue
!     if(.not. sflag .ge. zero) go to 90
!         if(.not. sflag .eq. zero) go to 80
!         sh11=one
!         sh22=one
!         sflag=-one
!         go to 90
!  80     continue
!         sh21=-one
!         sh12=one
!         sflag=-one
!  90 continue
!     go to igo,(120,150,180,210)
! 100 continue
! 110     continue
!         if(.not. sd1 .le. rgamsq) go to 130
!              if(sd1 .eq. zero) go to 160
!              assign 120 to igo
!              go to 70
! 120          continue
!              sd1=sd1*gam**2
!              sx1=sx1/gam
!              sh11=sh11/gam
!              sh12=sh12/gam
!         go to 110
! 130 continue
! 140     continue
!         if(.not. sd1 .ge. gamsq) go to 160
!              assign 150 to igo
!              go to 70
! 150          continue
!              sd1=sd1/gam**2
!              sx1=sx1*gam
!              sh11=sh11*gam
!              sh12=sh12*gam
!         go to 140
! 160 continue
! 170     continue
!         if(.not. abs(sd2) .le. rgamsq) go to 190
!              if(sd2 .eq. zero) go to 220
!              assign 180 to igo
!              go to 70
! 180          continue
!              sd2=sd2*gam**2
!              sh21=sh21/gam
!              sh22=sh22/gam
!         go to 170
! 190 continue
! 200     continue
!         if(.not. abs(sd2) .ge. gamsq) go to 220
!              assign 210 to igo
!              go to 70
! 210          continue
!              sd2=sd2/gam**2
!              sh21=sh21*gam
!              sh22=sh22*gam
!         go to 200
! 220 continue
!         if(sflag)250,230,240
! 230     continue
!              sparam(3)=sh21
!              sparam(4)=sh12
!              go to 260
! 240     continue
!              sparam(2)=sh11
!              sparam(5)=sh22
!              go to 260
! 250     continue
!              sparam(2)=sh11
!              sparam(3)=sh21
!              sparam(4)=sh12
!              sparam(5)=sh22
! 260 continue
!         sparam(1)=sflag
!         return
!     end

!     subroutine sscal(n,sa,sx,incx)
!     real sa,sx(1)
!     if(n.le.0)return
!     if(incx.eq.1)goto 20
!     ns = n*incx
!         do 10 i = 1,ns,incx
!         sx(i) = sa*sx(i)
!  10     continue
!     return
!  20 m = mod(n,5)
!     if( m .eq. 0 ) go to 40
!     do 30 i = 1,m
!       sx(i) = sa*sx(i)
!  30 continue
!     if( n .lt. 5 ) return
!  40 mp1 = m + 1
!     do 50 i = mp1,n,5
!       sx(i) = sa*sx(i)
!       sx(i + 1) = sa*sx(i + 1)
!       sx(i + 2) = sa*sx(i + 2)
!       sx(i + 3) = sa*sx(i + 3)
!       sx(i + 4) = sa*sx(i + 4)
!  50 continue
!     return
!     end

!     subroutine sswap (n,sx,incx,sy,incy)
!     real sx(1),sy(1),stemp1,stemp2,stemp3
!     if(n.le.0)return
!     if(incx.eq.incy) if(incx-1) 5,20,60
!   5 continue
!     ix = 1
!     iy = 1
!     if(incx.lt.0)ix = (-n+1)*incx + 1
!     if(incy.lt.0)iy = (-n+1)*incy + 1
!     do 10 i = 1,n
!       stemp1 = sx(ix)
!       sx(ix) = sy(iy)
!       sy(iy) = stemp1
!       ix = ix + incx
!       iy = iy + incy
!  10 continue
!     return
!  20 m = mod(n,3)
!     if( m .eq. 0 ) go to 40
!     do 30 i = 1,m
!       stemp1 = sx(i)
!       sx(i) = sy(i)
!       sy(i) = stemp1
!  30 continue
!     if( n .lt. 3 ) return
!  40 mp1 = m + 1
!     do 50 i = mp1,n,3
!       stemp1 = sx(i)
!       stemp2 = sx(i+1)
!       stemp3 = sx(i+2)
!       sx(i) = sy(i)
!       sx(i+1) = sy(i+1)
!       sx(i+2) = sy(i+2)
!       sy(i) = stemp1
!       sy(i+1) = stemp2
!       sy(i+2) = stemp3
!  50 continue
!     return
!  60 continue
!     ns = n*incx
!       do 70 i=1,ns,incx
!       stemp1 = sx(i)
!       sx(i) = sy(i)
!       sy(i) = stemp1
!  70   continue
!     return
!     end

!     subroutine vexopy (nn,v,x,y,icode)
!     real    v(1), x(1), y(1)
!     n = nn
!     if(icode.eq.2) go to 20
!     do 15 i = 1,n
!        v(i) = x(i) + y(i)
!15   continue
!     return
!20   do 25 i = 1,n
!        v(i) = x(i) - y(i)
!25   continue
!     return
!     end

!     subroutine vfill (n,v,val)
!     real    v(n)
!     if (n .le. 0) return
!     nr=mod(n,4)
!     is=1
!     goto(1,2,3,4), nr+1
!   4   is=4
!       v(1)=val
!       v(2)=val
!       v(3)=val
!       goto 1
!   3   is=3
!       v(1)=val
!       v(2)=val
!       goto 1
!   2   is=2
!       v(1)=val
!   1 do 10 i=is,n,4
!       v(i)  =val
!       v(i+1)=val
!       v(i+2)=val
!       v(i+3)=val
!10   continue
!     return
!     end

!     subroutine saxpyx (nn,saa,sx,incxx,sy,incyy)
!     real               sy(1), sx(1), saa
!     n    = nn
!     sa   = saa
!     incx = incxx
!     incy = incyy
!     if (n .le. 0) return
!     if (incx .eq. incy) if (incx - 1) 5,15,35
!   5 continue
!     ix = 1
!     iy = 1
!     if (incx .lt. 0) ix = (-n + 1)*incx + 1
!     if (incy .lt. 0) iy = (-n + 1)*incy + 1
!     do 10 i = 1,n
!        sx(ix) = sy(iy) + sa*sx(ix)
!        ix = ix + incx
!        iy = iy + incy
!  10 continue
!     return
!  15 do 20 i = 1,n
!        sx(i) = sy(i) + sa*sx(i)
!  20 continue
!     return
!  35 ns = n*incx
!     do 40 i = 1,ns,incx
!        sx(i) = sy(i) + sa*sx(i)
!  40 continue
!     return
!     end

*deck dbcg
      subroutine dbcg(n, b, x, nelt, ia, ja, a, isym, matvec, mttvec,
     $     msolve, mtsolv, itol, tol, itmax, iter, err, ierr, iunit, 
     $     r, z, p, rr, zz, pp, dz, rwork, iwork)
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym, itol, itmax
      integer iter, ierr, iunit, iwork(*)
      double precision b(n), x(n), a(nelt), tol, err, r(n), z(n), p(n)
      double precision rr(n), zz(n), pp(n), dz(n), rwork(*)
      external matvec, mttvec, msolve, mtsolv
      iter = 0
      ierr = 0
      if( n.lt.1 ) then
         ierr = 3
         return
      endif
      fuzz = d1mach(3)
      tolmin = 500.0*fuzz
      fuzz = fuzz*fuzz
      if( tol.lt.tolmin ) then
         tol = tolmin
         ierr = 4
      endif
      call matvec(n, x, r, nelt, ia, ja, a, isym)
      do 10 i = 1, n
         r(i)  = b(i) - r(i)
         rr(i) = r(i)
 10   continue
      call msolve(n, r, z, nelt, ia, ja, a, isym, rwork, iwork)
      call mtsolv(n, rr, zz, nelt, ia, ja, a, isym, rwork, iwork)
      if( isdbcg(n, b, x, nelt, ia, ja, a, isym, msolve, itol, tol,
     $     itmax, iter, err, ierr, iunit, r, z, p, rr, zz, pp,
     $     dz, rwork, iwork, ak, bk, bnrm, solnrm) .ne. 0 )
     $     go to 200
      if( ierr.ne.0 ) return
      do 100 k=1,itmax
         iter = k
         bknum = ddot(n, z, 1, rr, 1)
         if( abs(bknum).le.fuzz ) then
            ierr = 6
            return
         endif
         if(iter .eq. 1) then
            call dcopy(n, z, 1, p, 1)
            call dcopy(n, zz, 1, pp, 1)
         else
            bk = bknum/bkden
            do 20 i = 1, n
               p(i) = z(i) + bk*p(i)
               pp(i) = zz(i) + bk*pp(i)
 20         continue
         endif
         bkden = bknum
         call matvec(n, p, z, nelt, ia, ja, a, isym)
         akden = ddot(n, pp, 1, z, 1)
         ak = bknum/akden
         if( abs(akden).le.fuzz ) then
            ierr = 6
            return
         endif
         call daxpy(n, ak, p, 1, x, 1)
         call daxpy(n, -ak, z, 1, r, 1)
         call mttvec(n, pp, zz, nelt, ia, ja, a, isym)
         call daxpy(n, -ak, zz, 1, rr, 1)
         call msolve(n, r, z, nelt, ia, ja, a, isym, rwork, iwork)
         call mtsolv(n, rr, zz, nelt, ia, ja, a, isym, rwork, iwork)
         if( isdbcg(n, b, x, nelt, ia, ja, a, isym, msolve, itol, tol,
     $        itmax, iter, err, ierr, iunit, r, z, p, rr, zz,
     $        pp, dz, rwork, iwork, ak, bk, bnrm, solnrm) .ne. 0 )
     $        go to 200
 100  continue
      iter = itmax + 1
      ierr = 2
 200  return
      end

*deck dsdbcg
      subroutine dsdbcg(n, b, x, nelt, ia, ja, a, isym, itol, tol,
     $     itmax, iter, err, ierr, iunit, rwork, lenw, iwork, leniw )
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym, itol, itmax, iter
      integer ierr, lenw, iwork(leniw), leniw
      double precision b(n), x(n), a(n), tol, err, rwork(lenw)
      external dsmv, dsmtv, dsdi
      parameter (locrb=1, locib=11)
      ierr = 0
      if( n.lt.1 .or. nelt.lt.1 ) then
         ierr = 3
         return
      endif
      call ds2y( n, nelt, ia, ja, a, isym )
      lociw = locib
      locdin = locrb
      locr = locdin + n
      locz = locr + n
      locp = locz + n
      locrr = locp + n
      loczz = locrr + n
      locpp = loczz + n
      locdz = locpp + n
      locw = locdz + n
      call dchkw( 'dsdbcg', lociw, leniw, locw, lenw, ierr, iter, err )
      if( ierr.ne.0 ) return
      iwork(4) = locdin
      iwork(9) = lociw
      iwork(10) = locw
      call dsds(n, nelt, ia, ja, a, isym, rwork(locdin))
      call dbcg(n, b, x, nelt, ia, ja, a, isym, dsmv, dsmtv,
     $     dsdi, dsdi, itol, tol, itmax, iter, err, ierr, iunit,
     $     rwork(locr), rwork(locz), rwork(locp),
     $     rwork(locrr), rwork(loczz), rwork(locpp),
     $     rwork(locdz), rwork(1), iwork(1))
      return
      end

*deck dslubc
      subroutine dslubc(n, b, x, nelt, ia, ja, a, isym, itol, tol,
     $     itmax, iter, err, ierr, iunit, rwork, lenw, iwork, leniw )
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym, itol, itmax, iter
      integer ierr, iunit, lenw, iwork(leniw), leniw
      double precision b(n), x(n), a(nelt), tol, err, rwork(lenw)
      external dsmv, dsmtv, dslui, dsluti
      parameter (locrb=1, locib=11)
      ierr = 0
      if( n.lt.1 .or. nelt.lt.1 ) then
         ierr = 3
         return
      endif
      call ds2y( n, nelt, ia, ja, a, isym )
      nl = 0
      nu = 0
      do 20 icol = 1, n
         jbgn = ja(icol)+1
         jend = ja(icol+1)-1
         if( jbgn.le.jend ) then
            do 10 j = jbgn, jend
               if( ia(j).gt.icol ) then
                  nl = nl + 1
                  if( isym.ne.0 ) nu = nu + 1
               else
                  nu = nu + 1
               endif
 10         continue
         endif
 20   continue
      locil = locib
      locjl = locil + n+1
      lociu = locjl + nl
      locju = lociu + nu
      locnr = locju + n+1
      locnc = locnr + n
      lociw = locnc + n
      locl = locrb
      locdin = locl + nl
      locu = locdin + n
      locr = locu + nu
      locz = locr + n
      locp = locz + n
      locrr = locp + n
      loczz = locrr + n
      locpp = loczz + n
      locdz = locpp + n
      locw = locdz + n
      call dchkw( 'dslubc', lociw, leniw, locw, lenw, ierr, iter, err )
      if( ierr.ne.0 ) return
      iwork(1) = locil
      iwork(2) = locjl
      iwork(3) = lociu
      iwork(4) = locju
      iwork(5) = locl
      iwork(6) = locdin
      iwork(7) = locu
      iwork(9) = lociw
      iwork(10) = locw
      call dsilus( n, nelt, ia, ja, a, isym, nl, iwork(locil),
     $     iwork(locjl), rwork(locl), rwork(locdin), nu, iwork(lociu),
     $     iwork(locju), rwork(locu), iwork(locnr), iwork(locnc) )
      call dbcg(n, b, x, nelt, ia, ja, a, isym, dsmv, dsmtv,
     $     dslui, dsluti, itol, tol, itmax, iter, err, ierr, iunit,
     $     rwork(locr), rwork(locz), rwork(locp),
     $     rwork(locrr), rwork(loczz), rwork(locpp),
     $     rwork(locdz), rwork, iwork )
      return
      end

*deck isdbcg
      function isdbcg(n, b, x, nelt, ia, ja, a, isym, msolve, itol,
     $     tol, itmax, iter, err, ierr, iunit, r, z, p, rr, zz, pp, dz,
     $     rwork, iwork, ak, bk, bnrm, solnrm)
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym, itol, itmax
      integer iter, ierr, iunit, iwork(1)
      double precision b(n), x(n), a(nelt), tol, err, r(n), z(n), p(n)
      double precision rr(n), zz(n), pp(n), dz(n), rwork(*)
      double precision ak, bk, bnrm, solnrm
      parameter(maxn=441)
      common /solblk/ soln(maxn)
      external msolve
      isdbcg = 0
      if( itol.eq.1 ) then
         if(iter .eq. 0) bnrm = dnrm2(n, b, 1)
         err = dnrm2(n, r, 1)/bnrm
      else if( itol.eq.2 ) then
         if(iter .eq. 0) then
            call msolve(n, b, dz, nelt, ia, ja, a, isym, rwork, iwork)
            bnrm = dnrm2(n, dz, 1)
         endif
         err = dnrm2(n, z, 1)/bnrm
      else if( itol.eq.11 ) then
         if(iter .eq. 0) solnrm = dnrm2(n, soln, 1)
         do 10 i = 1, n
            dz(i) = x(i) - soln(i)
 10      continue
         err = dnrm2(n, dz, 1)/solnrm
      else
         err = 1.0e10
         ierr = 3
      endif
      if(iunit .ne. 0) then
         if( iter.eq.0 ) then
            write(iunit,1000) n, itol
         endif
         write(iunit,1010) iter, err, ak, bk
      endif
      if(err .le. tol) isdbcg = 1
      return
 1000 format(' preconditioned biconjugate gradient for n, itol = ',
     $     i5,i5,/' iter','   error estimate','            alpha',
     $     '             beta')
 1010 format(1x,i4,1x,e16.7,1x,e16.7,1x,e16.7)
      end

*deck dcg
      subroutine dcg(n, b, x, nelt, ia, ja, a, isym, matvec, msolve, 
     $     itol, tol, itmax, iter, err, ierr, iunit, r, z, p, dz,
     $     rwork, iwork )
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym, itol, itmax, iter
      integer iunit, ierr, iwork(*)
      double precision b(n), x(n), a(nelt), tol, err, r(n), z(n), p(n)
      double precision dz(n), rwork(*)
      external matvec, msolve
      iter = 0
      ierr = 0
      if( n.lt.1 ) then
         ierr = 3
         return
      endif
      tolmin = 500.0*d1mach(3)
      if( tol.lt.tolmin ) then
         tol = tolmin
         ierr = 4
      endif
      call matvec(n, x, r, nelt, ia, ja, a, isym)
      do 10 i = 1, n
         r(i) = b(i) - r(i)
 10   continue
      call msolve(n, r, z, nelt, ia, ja, a, isym, rwork, iwork)
      if( isdcg(n, b, x, nelt, ia, ja, a, isym, msolve, itol, tol,
     $     itmax, iter, err, ierr, iunit, r, z, p, dz,
     $     rwork, iwork, ak, bk, bnrm, solnrm) .ne. 0 ) go to 200
      if( ierr.ne.0 ) return
      do 100 k=1,itmax
         iter = k
         bknum = ddot(n, z, 1, r, 1)
         if( bknum.le.0.0d0 ) then
            ierr = 5
            return
         endif
         if(iter .eq. 1) then
            call dcopy(n, z, 1, p, 1)
         else
            bk = bknum/bkden
            do 20 i = 1, n
               p(i) = z(i) + bk*p(i)
 20         continue
         endif
         bkden = bknum
         call matvec(n, p, z, nelt, ia, ja, a, isym)
         akden = ddot(n, p, 1, z, 1)
         if( akden.le.0.0d0 ) then
            ierr = 6
            return
         endif
         ak = bknum/akden
         call daxpy(n, ak, p, 1, x, 1)
         call daxpy(n, -ak, z, 1, r, 1)
         call msolve(n, r, z, nelt, ia, ja, a, isym, rwork, iwork)
         if( isdcg(n, b, x, nelt, ia, ja, a, isym, msolve, itol, tol,
     $        itmax, iter, err, ierr, iunit, r, z, p, dz, rwork,
     $        iwork, ak, bk, bnrm, solnrm) .ne. 0 ) go to 200
 100  continue
      iter = itmax + 1
      ierr = 2
 200  return
      end

*deck dsdcg
      subroutine dsdcg(n, b, x, nelt, ia, ja, a, isym, itol, tol,
     $     itmax, iter, err, ierr, iunit, rwork, lenw, iwork, leniw )
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym, itol
      integer itmax, iter, ierr, iunit, lenw, iwork(leniw), leniw
      double precision b(n), x(n), a(nelt), tol, err, rwork(lenw)
      external dsmv, dsdi
      parameter (locrb=1, locib=11)
      ierr = 0
      if( n.lt.1 .or. nelt.lt.1 ) then
         ierr = 3
         return
      endif
      call ds2y( n, nelt, ia, ja, a, isym )
      lociw = locib
      locd = locrb
      locr = locd + n
      locz = locr + n
      locp = locz + n
      locdz = locp + n
      locw  = locdz + n
      call dchkw( 'dsdcg', lociw, leniw, locw, lenw, ierr, iter, err )
      if( ierr.ne.0 ) return
      iwork(4) = locd
      iwork(9) = lociw
      iwork(10) = locw
      call dsds(n, nelt, ia, ja, a, isym, rwork(locd))
      call dcg(n, b, x, nelt, ia, ja, a, isym, dsmv, dsdi, 
     $     itol, tol, itmax, iter, err, ierr, iunit, rwork(locr), 
     $     rwork(locz), rwork(locp), rwork(locdz), rwork, iwork)
      return
      end

*deck dsiccg
      subroutine dsiccg(n, b, x, nelt, ia, ja, a, isym, itol, tol,
     $     itmax, iter, err, ierr, iunit, rwork, lenw, iwork, leniw )
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym, itol
      integer itmax, iter, iunit, lenw, iwork(leniw), leniw
      double precision b(n), x(n), a(nelt), tol, err, rwork(lenw)
      external dsmv, dsllti
      parameter (locrb=1, locib=11)
      ierr = 0
      if( n.lt.1 .or. nelt.lt.1 ) then
         ierr = 3
         return
      endif
      call ds2y( n, nelt, ia, ja, a, isym )
      if( isym.eq.0 ) then
         nel = (nelt + n)/2
      else
         nel = nelt
      endif
      locjel = locib
      lociel = locjel + nel
      lociw = lociel + n + 1
      locel = locrb
      locdin = locel + nel
      locr = locdin + n
      locz = locr + n
      locp = locz + n
      locdz = locp + n
      locw = locdz + n
      call dchkw( 'dsiccg', lociw, leniw, locw, lenw, ierr, iter, err )
      if( ierr.ne.0 ) return
      iwork(1) = nel
      iwork(2) = locjel
      iwork(3) = lociel
      iwork(4) = locel
      iwork(5) = locdin
      iwork(9) = lociw
      iwork(10) = locw
      call dsics(n, nelt, ia, ja, a, isym, nel, iwork(lociel),
     $     iwork(locjel), rwork(locel), rwork(locdin),
     $     rwork(locr), ierr )
      if( ierr.ne.0 ) then
         call xerrwv('dsiccg: warning...ic factorization broke down '//
     $        'on step i1.  diagonal was set to unity and '//
     $        'factorization proceeded.', 113, 1, 1, 1, ierr, 0,
     $        0, 0.0, 0.0 )
         ierr = 7
      endif
      call dcg(n, b, x, nelt, ia, ja, a, isym, dsmv, dsllti, 
     $     itol, tol, itmax, iter, err, ierr, iunit, rwork(locr),
     $     rwork(locz), rwork(locp), rwork(locdz), rwork(1),
     $     iwork(1))
      return
      end

*deck isdcg
      function isdcg(n, b, x, nelt, ia, ja, a, isym, msolve, itol,
     $     tol, itmax, iter, err, ierr, iunit, r, z, p, dz, 
     $     rwork, iwork, ak, bk, bnrm, solnrm)
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym, itol, itmax
      integer iter, ierr, iunit, iwork(*)
      double precision b(n), x(n), a(nelt), tol, err, r(n)
      double precision z(n), p(n), dz(n), rwork(*)
      external msolve
      parameter(maxn=441)
      common /solblk/ soln(maxn)
      isdcg = 0
      if( itol.eq.1 ) then
         if(iter .eq. 0) bnrm = dnrm2(n, b, 1)
         err = dnrm2(n, r, 1)/bnrm
      else if( itol.eq.2 ) then
         if(iter .eq. 0) then
            call msolve(n, r, z, nelt, ia, ja, a, isym, rwork, iwork)
            bnrm = dnrm2(n, dz, 1)
         endif
         err = dnrm2(n, z, 1)/bnrm
      else if( itol.eq.11 ) then
         if(iter .eq. 0) solnrm = dnrm2(n, soln, 1)
         do 10 i = 1, n
            dz(i) = x(i) - soln(i)
 10      continue
         err = dnrm2(n, dz, 1)/solnrm
      else
         err = 1.0e10
         ierr = 3
      endif
      if(iunit .ne. 0) then
         if( iter.eq.0 ) then
            write(iunit,1000) n, itol
         endif
         write(iunit,1010) iter, err, ak, bk
      endif     
      if(err .le. tol) isdcg = 1
      return
 1000 format(' preconditioned conjugate gradient for ',
     $     'n, itol = ',i5, i5,
     $     /' iter','   error estimate','            alpha',
     $     '             beta')
 1010 format(1x,i4,1x,e16.7,1x,e16.7,1x,e16.7)
      end

*deck dcgn
      subroutine dcgn(n, b, x, nelt, ia, ja, a, isym, matvec, mttvec, 
     $     msolve, itol, tol, itmax, iter, err, ierr, iunit, r, z, p, 
     $     atp, atz, dz, atdz, rwork, iwork)
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym, itol, itmax, iter
      integer iunit, iwork(*)
      double precision b(n), x(n), a(n), r(n), z(n), p(n)
      double precision atp(n), atz(n), dz(n), atdz(n), rwork(*)
      external matvec, mttvec, msolve
      iter = 0
      ierr = 0
      if( n.lt.1 ) then
         ierr = 3
         return
      endif
      tolmin = 500.0*d1mach(3)
      if( tol.lt.tolmin ) then
         tol = tolmin
         ierr = 4
      endif
      call matvec(n, x, r, nelt, ia, ja, a, isym)
      do 10 i = 1, n
         r(i) = b(i) - r(i)
 10   continue
      call msolve(n, r, z, nelt, ia, ja, a, isym, rwork, iwork)
      call mttvec(n, z, atz, nelt, ia, ja, a, isym)
      if( isdcgn(n, b, x, nelt, ia, ja, a, isym, matvec, mttvec, msolve,
     $     itol, tol, itmax, iter, err, ierr, iunit, r, z, p, atp, atz,
     $     dz, atdz, rwork, iwork, ak, bk, bnrm, solnrm) .ne. 0 )
     $     go to 200
      if( ierr.ne.0 ) return
      do 100 k=1,itmax
         iter = k
         bknum = ddot(n, z, 1, r, 1)
         if( bknum.le.0.0d0 ) then
            ierr = 6
            return
         endif
         if(iter .eq. 1) then
            call dcopy(n, z, 1, p, 1)
         else
            bk = bknum/bkden
            do 20 i = 1, n
               p(i) = z(i) + bk*p(i)
 20         continue
         endif
         bkden = bknum
         if(iter .ne. 1) call daxpy(n, bk, atp, 1, atz, 1)
         call dcopy(n, atz, 1, atp, 1)
         akden = ddot(n, atp, 1, atp, 1)
         if( akden.le.0.0d0 ) then
            ierr = 6
            return
         endif
         ak = bknum/akden
         call daxpy(n, ak, atp, 1, x, 1)
         call matvec(n, atp, z, nelt, ia, ja, a, isym)
         call daxpy(n, -ak, z, 1, r, 1)
         call msolve(n, r, z, nelt, ia, ja, a, isym, rwork, iwork)
         call mttvec(n, z, atz, nelt, ia, ja, a, isym)
         if( isdcgn(n, b, x, nelt, ia, ja, a, isym, matvec, mttvec,
     $        msolve, itol, tol, itmax, iter, err, ierr, iunit, r, 
     $        z, p, atp, atz, dz, atdz, rwork, iwork, ak, bk, bnrm, 
     $        solnrm) .ne. 0) goto 200
 100  continue
      iter = itmax + 1
 200  return
      end

*deck dsdcgn
      subroutine dsdcgn(n, b, x, nelt, ia, ja, a, isym, itol, tol,
     $     itmax, iter, err, ierr, iunit, rwork, lenw, iwork, leniw )
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym, itol
      integer itmax, iter, ierr, iunit, lenw, iwork(leniw), leniw
      double precision b(n), x(n), a(nelt), tol, err, rwork(lenw)
      external dsmv, dsmtv, dsdi
      parameter (locrb=1, locib=11)
      ierr = 0
      if( n.lt.1 .or. nelt.lt.1 ) then
         ierr = 3
         return
      endif
      call ds2y( n, nelt, ia, ja, a, isym )
      lociw = locib
      locd = locrb
      locr = locd + n
      locz = locr + n
      locp = locz + n
      locatp = locp + n
      locatz = locatp + n
      locdz = locatz + n
      locatd = locdz + n
      locw = locatd + n
      call dchkw( 'dsdcgn', lociw, leniw, locw, lenw, ierr, iter, err )
      if( ierr.ne.0 ) return
      iwork(4) = locd
      iwork(9) = lociw
      iwork(10) = locw
      call dsd2s(n, nelt, ia, ja, a, isym, rwork(1))
      call dcgn( n, b, x, nelt, ia, ja, a, isym, dsmv, dsmtv, dsdi, 
     $     itol, tol, itmax, iter, err, ierr, iunit, rwork(locr), 
     $     rwork(locz), rwork(locp), rwork(locatp), rwork(locatz),
     $     rwork(locdz), rwork(locatd), rwork, iwork )
      if( iter.gt.itmax ) ierr = 2
      return
      end

*deck dslucn
      subroutine dslucn(n, b, x, nelt, ia, ja, a, isym, itol, tol,
     $     itmax, iter, err, ierr, iunit, rwork, lenw, iwork, leniw )
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym, itol, itmax, iter
      integer ierr, iunit, lenw, iwork(leniw), leniw
      double precision b(n), x(n), a(nelt), tol, err, rwork(lenw)
      parameter (locrb=1, locib=11)
      external dsmv, dsmtv, dsmmti
      ierr = 0
      if( n.lt.1 .or. nelt.lt.1 ) then
         ierr = 3
         return
      endif
      call ds2y( n, nelt, ia, ja, a, isym )
      nl = 0
      nu = 0
      do 20 icol = 1, n
         jbgn = ja(icol)+1
         jend = ja(icol+1)-1
         if( jbgn.le.jend ) then
            do 10 j = jbgn, jend
               if( ia(j).gt.icol ) then
                  nl = nl + 1
                  if( isym.ne.0 ) nu = nu + 1
               else
                  nu = nu + 1
               endif
 10         continue
         endif
 20   continue
      locil = locib
      locjl = locil + n+1
      lociu = locjl + nl
      locju = lociu + nu
      locnr = locju + n+1
      locnc = locnr + n
      lociw = locnc + n
      locl = locrb
      locdin = locl + nl
      locu = locdin + n
      locr = locu + nu
      locz = locr + n
      locp = locz + n
      locatp = locp + n
      locatz = locatp + n
      locdz = locatz + n
      locatd = locdz + n
      locw = locatd + n
      call dchkw( 'dslucn', lociw, leniw, locw, lenw, ierr, iter, err )
      if( ierr.ne.0 ) return
      iwork(1) = locil
      iwork(2) = locjl
      iwork(3) = lociu
      iwork(4) = locju
      iwork(5) = locl
      iwork(6) = locdin
      iwork(7) = locu
      iwork(9) = lociw
      iwork(10) = locw
      call dsilus( n, nelt, ia, ja, a, isym, nl, iwork(locil),
     $     iwork(locjl), rwork(locl), rwork(locdin), nu, iwork(lociu),
     $     iwork(locju), rwork(locu), iwork(locnr), iwork(locnc) )
      call dcgn(n, b, x, nelt, ia, ja, a, isym, dsmv, dsmtv, dsmmti, 
     $     itol, tol, itmax, iter, err, ierr, iunit, rwork(locr),
     $     rwork(locz), rwork(locp), rwork(locatp), rwork(locatz),
     $     rwork(locdz), rwork(locatd), rwork, iwork ) 
      if( iter.gt.itmax ) ierr = 2         
      return
      end

*deck isdcgn
      function isdcgn(n, b, x, nelt, ia, ja, a, isym, matvec, mttvec,
     $     msolve, itol, tol, itmax, iter, err, ierr, iunit, r, z, 
     $     p, atp, atz, dz, atdz, rwork, iwork, ak, bk, bnrm, solnrm)
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym, itol, itmax, iter
      integer iunit, iwork(*)
      double precision b(n), x(n), a(n), tol, err, r(n), z(n), p(n)
      double precision atp(n), atz(n), dz(n), atdz(n), rwork(*)
      double precision ak, bk, bnrm, solnrm
      external matvec, mttvec, msolve
      parameter(maxn=441)
      common /solblk/ soln(maxn)
      isdcgn = 0
      if( itol.eq.1 ) then
         if(iter .eq. 0) bnrm = dnrm2(n, b, 1)
         err = dnrm2(n, r, 1)/bnrm
      else if( itol.eq.2 ) then
         if(iter .eq. 0) then
            call msolve(n, b, dz, nelt, ia, ja, a, isym, rwork, iwork)
            call mttvec(n, dz, atdz, nelt, ia, ja, a, isym)
            bnrm = dnrm2(n, atdz, 1)
         endif
         err = dnrm2(n, atz, 1)/bnrm
      else if( itol.eq.11 ) then
         if(iter .eq. 0) solnrm = dnrm2(n, soln, 1)
         do 10 i = 1, n
            dz(i) = x(i) - soln(i)
 10      continue
         err = dnrm2(n, dz, 1)/solnrm
      else
         err = 1.0e10
         ierr = 3
      endif
      if( iunit.ne.0 ) then
         if( iter.eq.0 ) then
            write(iunit,1000) n, itol
         endif
         write(iunit,1010) iter, err, ak, bk
      endif
      if( err.le.tol ) isdcgn = 1
      return
 1000 format(' pcg applied to the normal equations for ',
     $     'n, itol = ',i5, i5,
     $     /' iter','   error estimate','            alpha',
     $     '             beta')
 1010 format(1x,i4,1x,e16.7,1x,e16.7,1x,e16.7)
      end

*deck dcgs
      subroutine dcgs(n, b, x, nelt, ia, ja, a, isym, matvec,
     $     msolve, itol, tol, itmax, iter, err, ierr, iunit, 
     $     r, r0, p, q, u, v1, v2, rwork, iwork)
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym, itol, itmax
      integer iter, ierr, iunit, iwork(*)
      double precision b(n), x(n), a(nelt), tol, err, r(n), r0(n), p(n)
      double precision q(n), u(n), v1(n), v2(n), rwork(*)
      external matvec, msolve
      iter = 0
      ierr = 0
      if( n.lt.1 ) then
         ierr = 3
         return
      endif
      tolmin = 500.0*d1mach(3)
      if( tol.lt.tolmin ) then
         tol = tolmin
         ierr = 4
      endif
      call matvec(n, x, r, nelt, ia, ja, a, isym)
      do 10 i = 1, n
         v1(i)  = r(i) - b(i)
 10   continue
      call msolve(n, v1, r, nelt, ia, ja, a, isym, rwork, iwork)
      if( isdcgs(n, b, x, nelt, ia, ja, a, isym, matvec, msolve, 
     $     itol, tol, itmax, iter, err, ierr, iunit, r, r0, p, q, 
     $     u, v1, v2, rwork, iwork, ak, bk, bnrm, solnrm) .ne. 0 )
     $     go to 200
      if( ierr.ne.0 ) return
      fuzz = d1mach(3)**2
      do 20 i = 1, n
         r0(i) = r(i)
 20   continue
      rhonm1 = 1.0
      do 100 k=1,itmax
         iter = k
         rhon = ddot(n, r0, 1, r, 1)
         if( abs(rhonm1).lt.fuzz ) goto 998
         bk = rhon/rhonm1
         if( iter.eq.1 ) then
            do 30 i = 1, n
               u(i) = r(i)
               p(i) = r(i)
 30         continue
         else
            do 40 i = 1, n
               u(i) = r(i) + bk*q(i)
               v1(i) = q(i) + bk*p(i)
 40         continue
            do 50 i = 1, n
               p(i) = u(i) + bk*v1(i)
 50         continue
         endif
         call matvec(n, p, v2, nelt, ia, ja, a, isym)
         call msolve(n, v2, v1, nelt, ia, ja, a, isym, rwork, iwork)
         sigma = ddot(n, r0, 1, v1, 1)
         if( abs(sigma).lt.fuzz ) goto 999
         ak = rhon/sigma
         akm = -ak
         do 60 i = 1, n
            q(i) = u(i) + akm*v1(i)
 60      continue
         do 70 i = 1, n
            v1(i) = u(i) + q(i)
 70      continue
         call daxpy( n, akm, v1, 1, x, 1 )
         call matvec(n, v1, v2, nelt, ia, ja, a, isym)
         call msolve(n, v2, v1, nelt, ia, ja, a, isym, rwork, iwork)
         call daxpy( n, akm, v1, 1, r, 1 )
         if( isdcgs(n, b, x, nelt, ia, ja, a, isym, matvec, msolve, 
     $        itol, tol, itmax, iter, err, ierr, iunit, r, r0, p, q, 
     $        u, v1, v2, rwork, iwork, ak, bk, bnrm, solnrm) .ne. 0 )
     $        go to 200
         rhonm1 = rhon
 100  continue
      iter = itmax + 1
      ierr = 2
 200  return
 998  ierr = 5
      return
 999  ierr = 6
      return
      end

*deck dsdcgs
      subroutine dsdcgs(n, b, x, nelt, ia, ja, a, isym, itol, tol,
     $     itmax, iter, err, ierr, iunit, rwork, lenw, iwork, leniw )
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym, itol, itmax, iter
      integer ierr, lenw, iwork(leniw), leniw
      double precision b(n), x(n), a(n), tol, err, rwork(lenw)
      external dsmv, dsdi
      parameter (locrb=1, locib=11)
      ierr = 0
      if( n.lt.1 .or. nelt.lt.1 ) then
         ierr = 3
         return
      endif
      call ds2y( n, nelt, ia, ja, a, isym )
      lociw = locib
      locdin = locrb
      locr  = locdin + n
      locr0 = locr + n
      locp  = locr0 + n
      locq  = locp + n
      locu  = locq + n
      locv1 = locu + n
      locv2 = locv1 + n
      locw  = locv2 + n
      call dchkw( 'dsdcgs', lociw, leniw, locw, lenw, ierr, iter, err )
      if( ierr.ne.0 ) return
      iwork(4) = locdin
      iwork(9) = lociw
      iwork(10) = locw
      call dsds(n, nelt, ia, ja, a, isym, rwork(locdin))
      call dcgs(n, b, x, nelt, ia, ja, a, isym, dsmv,
     $     dsdi, itol, tol, itmax, iter, err, ierr, iunit,
     $     rwork(locr), rwork(locr0), rwork(locp),
     $     rwork(locq), rwork(locu), rwork(locv1),
     $     rwork(locv2), rwork(1), iwork(1))
      return
      end

*deck dslucs
      subroutine dslucs(n, b, x, nelt, ia, ja, a, isym, itol, tol,
     $     itmax, iter, err, ierr, iunit, rwork, lenw, iwork, leniw )
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym, itol, itmax, iter
      integer ierr, iunit, lenw, iwork(leniw), leniw
      double precision b(n), x(n), a(nelt), tol, err, rwork(lenw)
      external dsmv, dslui
      parameter (locrb=1, locib=11)
      ierr = 0
      if( n.lt.1 .or. nelt.lt.1 ) then
         ierr = 3
         return
      endif
      call ds2y( n, nelt, ia, ja, a, isym )
      nl = 0
      nu = 0
      do 20 icol = 1, n
         jbgn = ja(icol)+1
         jend = ja(icol+1)-1
         if( jbgn.le.jend ) then
            do 10 j = jbgn, jend
               if( ia(j).gt.icol ) then
                  nl = nl + 1
                  if( isym.ne.0 ) nu = nu + 1
               else
                  nu = nu + 1
               endif
 10         continue
         endif
 20   continue
      locil = locib
      locjl = locil + n+1
      lociu = locjl + nl
      locju = lociu + nu
      locnr = locju + n+1
      locnc = locnr + n
      lociw = locnc + n
      locl   = locrb
      locdin = locl + nl
      locuu  = locdin + n
      locr   = locuu + nu
      locr0  = locr + n
      locp   = locr0 + n
      locq   = locp + n
      locu   = locq + n
      locv1  = locu + n
      locv2  = locv1 + n
      locw   = locv2 + n
      call dchkw( 'dslucs', lociw, leniw, locw, lenw, ierr, iter, err )
      if( ierr.ne.0 ) return
      iwork(1) = locil
      iwork(2) = locjl
      iwork(3) = lociu
      iwork(4) = locju
      iwork(5) = locl
      iwork(6) = locdin
      iwork(7) = locuu
      iwork(9) = lociw
      iwork(10) = locw
      call dsilus( n, nelt, ia, ja, a, isym, nl, iwork(locil),
     $     iwork(locjl), rwork(locl), rwork(locdin), nu, iwork(lociu),
     $     iwork(locju), rwork(locuu), iwork(locnr), iwork(locnc) )
      call dcgs(n, b, x, nelt, ia, ja, a, isym, dsmv,
     $     dslui, itol, tol, itmax, iter, err, ierr, iunit,
     $     rwork(locr), rwork(locr0), rwork(locp),
     $     rwork(locq), rwork(locu), rwork(locv1),
     $     rwork(locv2), rwork, iwork )
      return
      end

*deck isdcgs
      function isdcgs(n, b, x, nelt, ia, ja, a, isym, matvec, msolve, 
     $     itol, tol, itmax, iter, err, ierr, iunit, r, r0, p, q, u, 
     $     v1, v2, rwork, iwork, ak, bk, bnrm, solnrm)
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym, itol, itmax
      integer iter, ierr, iunit, iwork(1)
      double precision b(n), x(n), a(nelt), tol, err, r(n), r0(n), p(n)
      double precision q(n), u(n), v1(n), v2(n), rwork(1)
      double precision ak, bk, bnrm, solnrm
      parameter(maxn=441)
      common /solblk/ soln(maxn)
      external matvec, msolve
      isdcgs = 0
      if( itol.eq.1 ) then
         if(iter .eq. 0) bnrm = dnrm2(n, b, 1)
         call matvec(n, x, v2, nelt, ia, ja, a, isym )
         do 5 i = 1, n
            v2(i) = v2(i) - b(i)
 5       continue
         err = dnrm2(n, v2, 1)/bnrm
      else if( itol.eq.2 ) then
         if(iter .eq. 0) then
            call msolve(n, b, v2, nelt, ia, ja, a, isym, rwork, iwork)
            bnrm = dnrm2(n, v2, 1)
         endif
         err = dnrm2(n, r, 1)/bnrm
      else if( itol.eq.11 ) then
         if(iter .eq. 0) solnrm = dnrm2(n, soln, 1)
         do 10 i = 1, n
            v2(i) = x(i) - soln(i)
 10      continue
         err = dnrm2(n, v2, 1)/solnrm
      else
         err = 1.0e10
         ierr = 3
      endif
      if(iunit .ne. 0) then
         if( iter.eq.0 ) then
            write(iunit,1000) n, itol
         endif
         write(iunit,1010) iter, err, ak, bk
      endif
      if(err .le. tol) isdcgs = 1
      return
 1000 format(' preconditioned biconjugate gradient squared for ',
     $     'n, itol = ',i5, i5,
     $     /' iter','   error estimate','            alpha',
     $     '             beta')
 1010 format(1x,i4,1x,e16.7,1x,e16.7,1x,e16.7)
      end

*deck dgmres
      subroutine dgmres(n, b, x, nelt, ia, ja, a, isym, matvec, msolve,
     $     itol, tol, itmax, iter, err, ierr, iunit, sb, sx, 
     $     rgwk, lrgw, igwk, ligw, rwork, iwork )
      implicit double precision(a-h,o-z)
      integer  n, nelt, ia(nelt), ja(nelt), isym, itol, itmax, iter
      integer  ierr, iunit, lrgw, ligw, igwk(ligw)
      integer  iwork(*)
      double precision b(n), x(n), a(nelt), tol, err, sb(n), sx(n)
      double precision rgwk(lrgw), rwork(*)
      external matvec, msolve, d1mach
      integer jpre, kmp, maxl, nms, maxlp1, nmsl, nrsts, nrmax
      integer i, iflag, lr, ldl, lhes, lgmr, lq, lv, lw
      double precision bnrm, rhol, sum
      ierr = 0
      maxl = igwk(1)
      if (maxl .eq. 0) maxl = 10
      if (maxl .gt. n) maxl = n
      kmp = igwk(2)
      if (kmp .eq. 0) kmp = maxl
      if (kmp .gt. maxl) kmp = maxl
      jscal = igwk(3)
      jpre = igwk(4)
      if( itol.eq.1 .and. jpre.lt.0 ) goto 650
      if( itol.eq.2 .and. jpre.ge.0 ) goto 650
      nrmax = igwk(5)
      if( nrmax.eq.0 ) nrmax = 10
      if( nrmax.eq.-1 ) nrmax = 0
      if( tol.eq.0.0d0 ) tol = 500.0*d1mach(3)
      iter = 0
      nms = 0
      nrsts = 0
      maxlp1 = maxl + 1
      lv = 1
      lr = lv + n*maxlp1
      lhes = lr + n + 1
      lq = lhes + maxl*maxlp1
      ldl = lq + 2*maxl
      lw = ldl + n
      lxl = lw + n
      lz = lxl + n
      igwk(6) = lz + n - 1
      if( lz+n-1.gt.lrgw ) goto 640
      if (jpre .lt. 0) then
         call msolve(n, b, rgwk(lr), nelt, ia, ja, a, isym,
     $        rwork, iwork)
         nms = nms + 1
      else
         call dcopy(n, b, 1, rgwk(lr), 1)
      endif
      if( jscal.eq.2 .or. jscal.eq.3 ) then
         sum = 0.d0
         do 10 i = 1,n
            sum = sum + (rgwk(lr-1+i)*sb(i))**2
 10      continue
         bnrm = dsqrt(sum)
      else
         bnrm = dnrm2(n,rgwk(lr),1)
      endif
      call matvec(n, x, rgwk(lr), nelt, ia, ja, a, isym)
      do 50 i = 1,n
         rgwk(lr-1+i) = b(i) - rgwk(lr-1+i)
 50   continue
 100  continue
      if( nrsts.gt.nrmax ) goto 610
      if( nrsts.gt.0 ) then
         call dcopy(n, rgwk(ldl), 1, rgwk(lr), 1)
      endif
      call dpigmr(n, rgwk(lr), sb, sx, jscal, maxl, maxlp1, kmp,
     $       nrsts, jpre, matvec, msolve, nmsl, rgwk(lz), rgwk(lv),
     $       rgwk(lhes), rgwk(lq), lgmr, rwork, iwork, rgwk(lw),
     $       rgwk(ldl), rhol, nrmax, b, bnrm, x, rgwk(lxl), itol,
     $       tol, nelt, ia, ja, a, isym, iunit, iflag, err)
      iter = iter + lgmr
      nms = nms + nmsl
      lzm1 = lz - 1
      do 110 i = 1,n
         x(i) = x(i) + rgwk(lzm1+i)
 110  continue
      if( iflag.eq.0 ) goto 600
      if( iflag.eq.1 ) then
         nrsts = nrsts + 1
         goto 100
      endif
      if( iflag.eq.2 ) goto 620
 600  continue
      igwk(7) = nms
      rgwk(1) = rhol
      ierr = 0
      return
 610  continue
      igwk(7) = nms
      rgwk(1) = rhol
      ierr = 1
      return
 620  continue
      igwk(7) = nms
      rgwk(1) = rhol
      ierr = 2
      return
 640  continue
      err = tol
      ierr = -1
      return
 650  continue
      err = tol
      ierr = -2
      return
      end

*deck dsdgmr
      subroutine dsdgmr(n, b, x, nelt, ia, ja, a, isym, nsave,
     $     itol, tol, itmax, iter, err, ierr, iunit, rwork, lenw,
     $     iwork, leniw )
      implicit double precision(a-h,o-z)
      integer  n, nelt, ia(nelt), ja(nelt), isym, nsave, itol
      integer  itmax, iter, ierr, iunit, lenw, leniw, iwork(leniw)
      double precision b(n), x(n), a(nelt), tol, err, rwork(lenw)
      external dsmv, dsdi
      parameter (locrb=1, locib=11)
      ierr = 0
      err  = 0.0
      if( nsave.le.1 ) then
         ierr = 3
         return
      endif
      call ds2y( n, nelt, ia, ja, a, isym )
      locigw = locib
      lociw = locigw + 20
      locdin = locrb
      locrgw = locdin + n
      locw = locrgw + 1+n*(nsave+6)+nsave*(nsave+3)
      iwork(4) = locdin
      iwork(9) = lociw
      iwork(10) = locw
      call dchkw( 'dsdgmr', lociw, leniw, locw, lenw, ierr, iter, err )
      if( ierr.ne.0 ) return
      call dsds(n, nelt, ia, ja, a, isym, rwork(locdin))
      iwork(locigw  ) = nsave
      iwork(locigw+1) = nsave
      iwork(locigw+2) = 0
      iwork(locigw+3) = -1
      iwork(locigw+4) = itmax/nsave
      myitol = 0
      call dgmres( n, b, x, nelt, ia, ja, a, isym, dsmv, dsdi,
     $     myitol, tol, itmax, iter, err, ierr, iunit, rwork, rwork,
     $     rwork(locrgw), lenw-locrgw, iwork(locigw), 20,
     $     rwork, iwork )
      if( iter.gt.itmax ) ierr = 2
      return
      end

*deck dslugm
      subroutine dslugm(n, b, x, nelt, ia, ja, a, isym, nsave,
     $     itol, tol, itmax, iter, err, ierr, iunit, rwork, lenw,
     $     iwork, leniw )
      implicit double precision(a-h,o-z)
      integer  n, nelt, ia(nelt), ja(nelt), isym, nsave, itol
      integer  itmax, iter, ierr, iunit, lenw, leniw, iwork(leniw)
      double precision b(n), x(n), a(nelt), tol, err, rwork(lenw)
      external dsmv, dslui
      parameter (locrb=1, locib=11)
      ierr = 0
      err  = 0.0
      if( nsave.le.1 ) then
         ierr = 3
         return
      endif
      call ds2y( n, nelt, ia, ja, a, isym )
      nl = 0
      nu = 0
      do 20 icol = 1, n
         jbgn = ja(icol)+1
         jend = ja(icol+1)-1
         if( jbgn.le.jend ) then
            do 10 j = jbgn, jend
               if( ia(j).gt.icol ) then
                  nl = nl + 1
                  if( isym.ne.0 ) nu = nu + 1
               else
                  nu = nu + 1
               endif
 10         continue
         endif
 20   continue
      locigw = locib
      locil = locigw + 20
      locjl = locil + n+1
      lociu = locjl + nl
      locju = lociu + nu
      locnr = locju + n+1
      locnc = locnr + n
      lociw = locnc + n
      locl = locrb
      locdin = locl + nl
      locu = locdin + n
      locrgw = locu + nu
      locw = locrgw + 1+n*(nsave+6)+nsave*(nsave+3)
      call dchkw( 'dslugm', lociw, leniw, locw, lenw, ierr, iter, err )
      if( ierr.ne.0 ) return
      iwork(1) = locil
      iwork(2) = locjl
      iwork(3) = lociu
      iwork(4) = locju
      iwork(5) = locl
      iwork(6) = locdin
      iwork(7) = locu
      iwork(9) = lociw
      iwork(10) = locw
      call dsilus( n, nelt, ia, ja, a, isym, nl, iwork(locil),
     $     iwork(locjl), rwork(locl), rwork(locdin), nu, iwork(lociu),
     $     iwork(locju), rwork(locu), iwork(locnr), iwork(locnc) )
      iwork(locigw  ) = nsave
      iwork(locigw+1) = nsave
      iwork(locigw+2) = 0
      iwork(locigw+3) = -1
      iwork(locigw+4) = itmax/nsave
      myitol = 0
      call dgmres( n, b, x, nelt, ia, ja, a, isym, dsmv, dslui,
     $     myitol, tol, itmax, iter, err, ierr, iunit, rwork, rwork,
     $     rwork(locrgw), lenw-locrgw, iwork(locigw), 20,
     $     rwork, iwork )
      if( iter.gt.itmax ) ierr = 2
      return
      end

!     subroutine dhels(a, lda, n, q, b)
!     implicit double precision(a-h,o-z)
!     integer lda, n
!     double precision a(lda,1), b(1), q(1)
!     integer iq, k, kb, kp1
!     double precision c, s, t, t1, t2
!     do 20 k = 1, n
!        kp1 = k + 1
!        iq = 2*(k-1) + 1
!        c = q(iq)
!        s = q(iq+1)
!        t1 = b(k)
!        t2 = b(kp1)
!        b(k) = c*t1 - s*t2
!        b(kp1) = s*t1 + c*t2
!20   continue
!     do 40 kb = 1, n
!        k = n + 1 - kb
!        b(k) = b(k)/a(k,k)
!        t = -b(k)
!        call daxpy(k-1, t, a(1,k), 1, b(1), 1)
!40   continue
!     return
!     end

!     subroutine dheqr(a, lda, n, q, info, ijob)
!     implicit double precision(a-h,o-z)
!     integer lda, n, info, ijob
!     double precision a(lda,*), q(*)
!     integer i, iq, j, k, km1, kp1, nm1
!     double precision c, s, t, t1, t2
!     if (ijob .gt. 1) go to 70
!     info = 0
!     do 60 k = 1, n
!        km1 = k - 1
!        kp1 = k + 1
!        if (km1 .lt. 1) go to 20
!        do 10 j = 1, km1
!           i = 2*(j-1) + 1
!           t1 = a(j,k)
!           t2 = a(j+1,k)
!           c = q(i)
!           s = q(i+1)
!           a(j,k) = c*t1 - s*t2
!           a(j+1,k) = s*t1 + c*t2
!10      continue
!20      continue
!        iq = 2*km1 + 1
!        t1 = a(k,k)
!        t2 = a(kp1,k)
!        if( t2.eq.0.0d0 ) then
!           c = 1.0d0
!           s = 0.0d0
!        elseif( abs(t2).ge.abs(t1) ) then
!           t = t1/t2
!           s = -1.0d0/dsqrt(1.0d0+t*t)
!           c = -s*t
!        else
!           t = t2/t1
!           c = 1.0d0/dsqrt(1.0d0+t*t)
!           s = -c*t
!        endif
!        q(iq) = c
!        q(iq+1) = s
!        a(k,k) = c*t1 - s*t2
!        if( a(k,k).eq.0.0d0 ) info = k
!60   continue
!     return
!70   continue
!     nm1 = n - 1
!     do 100 k = 1,nm1
!        i = 2*(k-1) + 1
!        t1 = a(k,n)
!        t2 = a(k+1,n)
!        c = q(i)
!        s = q(i+1)
!        a(k,n) = c*t1 - s*t2
!        a(k+1,n) = s*t1 + c*t2
!100  continue
!     info = 0
!     t1 = a(n,n)
!     t2 = a(n+1,n)
!     if ( t2.eq.0.0d0 ) then
!        c = 1.0d0
!        s = 0.0d0
!     elseif( abs(t2).ge.abs(t1) ) then
!        t = t1/t2
!        s = -1.0d0/dsqrt(1.0d0+t*t)
!        c = -s*t
!     else
!        t = t2/t1
!        c = 1.0d0/dsqrt(1.0d0+t*t)
!        s = -c*t
!     endif
!     iq = 2*n - 1
!     q(iq) = c
!     q(iq+1) = s
!     a(n,n) = c*t1 - s*t2
!     if (a(n,n) .eq. 0.0d0) info = n
!     return
!     end

*deck dorth
      subroutine dorth(vnew, v, hes, n, ll, ldhes, kmp, snormw)
      implicit double precision(a-h,o-z)
      integer n, ll, ldhes, kmp
      double precision vnew, v, hes, snormw
      dimension vnew(1), v(n,1), hes(ldhes,1)
      integer i, i0
      double precision arg, sumdsq, tem, vnrm
      vnrm = dnrm2(n, vnew, 1)
      i0 = max0(1,ll-kmp+1)
      do 10 i = i0,ll
         hes(i,ll) = ddot(n, v(1,i), 1, vnew, 1)
         tem = -hes(i,ll)
         call daxpy(n, tem, v(1,i), 1, vnew, 1)
 10   continue
      snormw = dnrm2(n, vnew, 1)
      if (vnrm + 0.001d0*snormw .ne. vnrm) return
      sumdsq = 0.0d0
      do 30 i = i0,ll
         tem = -ddot(n, v(1,i), 1, vnew, 1)
         if (hes(i,ll) + 0.001d0*tem .eq. hes(i,ll)) go to 30
         hes(i,ll) = hes(i,ll) - tem
         call daxpy(n, tem, v(1,i), 1, vnew, 1)
         sumdsq = sumdsq + tem**2
 30   continue
      if (sumdsq .eq. 0.0d0) return
      arg = max(0.0d0,snormw**2 - sumdsq)
      snormw = dsqrt(arg)
      return
      end

*deck dpigmr
      subroutine dpigmr(n, r0, sr, sz, jscal, maxl, maxlp1, kmp, 
     $     nrsts, jpre, matvec, msolve, nmsl, z, v, hes, q, lgmr,
     $     rpar, ipar, wk, dl, rhol, nrmax, b, bnrm, x, xl,
     $     itol, tol, nelt, ia, ja, a, isym, iunit, iflag, err)
      implicit double precision(a-h,o-z)
      external matvec, msolve
      integer n,maxl,maxlp1,kmp,jpre,nmsl,lgmr,iflag,jscal,nrsts
      integer nrmax,itol,nelt,isym
      double precision rhol, bnrm, tol
      double precision r0(*), sr(*), sz(*), z(*), v(n,*)
      double precision hes(maxlp1,*), q(*), rpar(*), wk(*), dl(*)
      double precision a(nelt), b(*), x(*), xl(*)
      integer ipar(*), ia(nelt), ja(nelt)
      integer i, info, ip1, i2, j, k, ll, llp1
      double precision r0nrm,c,dlnrm,prod,rho,s,snormw,tem
      do 5 i = 1,n
         z(i) = 0.0d0
 5    continue
      iflag = 0
      lgmr = 0
      nmsl = 0
      itmax =(nrmax+1)*maxl
      if ((jpre .lt. 0) .and.(nrsts .eq. 0)) then
         call dcopy(n, r0, 1, wk, 1)
         call msolve(n, wk, r0, nelt, ia, ja, a, isym, rpar, ipar)
         nmsl = nmsl + 1
      endif
      if (((jscal.eq.2) .or.(jscal.eq.3)) .and.(nrsts.eq.0)) then
         do 10 i = 1,n
            v(i,1) = r0(i)*sr(i)
 10      continue
      else
         do 20 i = 1,n
            v(i,1) = r0(i)
 20      continue
      endif
      r0nrm = dnrm2(n, v, 1)
      iter = nrsts*maxl
      if (isdgmr(n, b, x, xl, nelt, ia, ja, a, isym, msolve,
     $    nmsl, itol, tol, itmax, iter, err, iunit, v(1,1), z, wk,
     $    rpar, ipar, r0nrm, bnrm, sr, sz, jscal,
     $    kmp, lgmr, maxl, maxlp1, v, q, snormw, prod, r0nrm,
     $    hes, jpre) .ne. 0) return
      tem = 1.0d0/r0nrm
      call dscal(n, tem, v(1,1), 1)
      do 50 j = 1,maxl
         do 40 i = 1,maxlp1
            hes(i,j) = 0.0d0
 40      continue
 50   continue
      prod = 1.0d0
      do 90 ll = 1,maxl
         lgmr = ll
        if ((jscal .eq. 1) .or.(jscal .eq. 3)) then
           do 60 i = 1,n
              wk(i) = v(i,ll)/sz(i)
 60        continue
        else
           call dcopy(n, v(1,ll), 1, wk, 1)
        endif
        if (jpre .gt. 0) then
           call msolve(n, wk, z, nelt, ia, ja, a, isym, rpar, ipar)
           nmsl = nmsl + 1
           call matvec(n, z, v(1,ll+1), nelt, ia, ja, a, isym)
        else
           call matvec(n, wk, v(1,ll+1), nelt, ia, ja, a, isym)
        endif
        if (jpre .lt. 0) then
           call dcopy(n, v(1,ll+1), 1, wk, 1)
           call msolve(n,wk,v(1,ll+1),nelt,ia,ja,a,isym,rpar,ipar)
           nmsl = nmsl + 1
        endif
        if ((jscal .eq. 2) .or.(jscal .eq. 3)) then
           do 65 i = 1,n
              v(i,ll+1) = v(i,ll+1)*sr(i)
 65        continue
        endif
        call dorth(v(1,ll+1), v, hes, n, ll, maxlp1, kmp, snormw)
        hes(ll+1,ll) = snormw
        call dheqr(hes, maxlp1, ll, q, info, ll)
        if (info .eq. ll) go to 120
        prod = prod*q(2*ll)
        rho = abs(prod*r0nrm)
        if ((ll.gt.kmp) .and.(kmp.lt.maxl)) then
           if (ll .eq. kmp+1) then
              call dcopy(n, v(1,1), 1, dl, 1)
              do 75 i = 1,kmp
                 ip1 = i + 1
                 i2 = i*2
                 s = q(i2)
                 c = q(i2-1)
                 do 70 k = 1,n
                    dl(k) = s*dl(k) + c*v(k,ip1)
 70              continue
 75           continue
           endif
           s = q(2*ll)
           c = q(2*ll-1)/snormw
           llp1 = ll + 1
           do 80 k = 1,n
              dl(k) = s*dl(k) + c*v(k,llp1)
 80        continue
           dlnrm = dnrm2(n, dl, 1)
           rho = rho*dlnrm
        endif
        rhol = rho
        iter = nrsts*maxl + lgmr
        if (isdgmr(n, b, x, xl, nelt, ia, ja, a, isym, msolve,
     $      nmsl, itol, tol, itmax, iter, err, iunit, dl, z, wk,
     $      rpar, ipar, rhol, bnrm, sr, sz, jscal,
     $      kmp, lgmr, maxl, maxlp1, v, q, snormw, prod, r0nrm,
     $      hes, jpre) .ne. 0) go to 200
        if (ll .eq. maxl) go to 100
        tem = 1.0d0/snormw
        call dscal(n, tem, v(1,ll+1), 1)
 90   continue
 100  continue
      if (rho .lt. r0nrm) go to 150
 120  continue
      iflag = 2
      do 130 i = 1,n
         z(i) = 0.d0
 130  continue
      return
 150  iflag = 1
      if (nrmax .gt. 0) then
         call drlcal(n, kmp, maxl, maxl, v, q, dl, snormw, prod,
     $        r0nrm)
      endif
 200  continue
      ll = lgmr
      llp1 = ll + 1
      do 210 k = 1,llp1
         r0(k) = 0.0d0
 210  continue
      r0(1) = r0nrm
      call dhels(hes, maxlp1, ll, q, r0)
      do 220 k = 1,n
         z(k) = 0.0d0
 220  continue
      do 230 i = 1,ll
         call daxpy(n, r0(i), v(1,i), 1, z, 1)
 230  continue
      if ((jscal .eq. 1) .or.(jscal .eq. 3)) then
         do 240 i = 1,n
            z(i) = z(i)/sz(i)
 240     continue
      endif
      if (jpre .gt. 0) then
         call dcopy(n, z, 1, wk, 1)
         call msolve(n, wk, z, nelt, ia, ja, a, isym, rpar, ipar)
         nmsl = nmsl + 1
      endif
      return
      end

*deck drlcal
      subroutine drlcal(n, kmp, ll, maxl, v, q, rl, snormw, prod,
     $     r0nrm)
      implicit double precision(a-h,o-z)
      integer n, kmp, ll, maxl
      double precision snormw
      double precision v(n,*), q(*), rl(n)
      integer i, ip1, i2, k
      if (kmp .eq. maxl) then
         call dcopy(n, v(1,1), 1, rl, 1)
         llm1 = ll - 1
         do 20 i = 1,llm1
            ip1 = i + 1
            i2 = i*2
            s = q(i2)
            c = q(i2-1)
            do 10 k = 1,n
               rl(k) = s*rl(k) + c*v(k,ip1)
 10         continue
 20      continue
         s = q(2*ll)
         c = q(2*ll-1)/snormw
         llp1 = ll + 1
         do 30 k = 1,n
            rl(k) = s*rl(k) + c*v(k,llp1)
 30      continue
      endif
      tem = r0nrm*prod
      call dscal(n, tem, rl, 1)
      return
      end

*deck dxlcal
      subroutine dxlcal(n, lgmr, x, xl, zl, hes, maxlp1, q, v, r0nrm,
     $     wk, sz, jscal, jpre, msolve, nmsl, rpar, ipar,
     $     nelt, ia, ja, a, isym)
      implicit double precision(a-h,o-z)
      external msolve
      integer n, lgmr, maxlp1, jscal, jpre, ipar(*), nmsl, nelt
      integer ia(nelt), ja(nelt), isym
      double precision r0nrm, x(n), xl(n), zl(n), hes(maxlp1,*)
      double precision q(*), v(n,*), wk(n), sz(*), rpar(*), a(nelt)
      integer i, k, ll, llp1
      ll = lgmr
      llp1 = ll + 1
      do 10 k = 1,llp1
         wk(k) = 0.0d0
 10   continue
      wk(1) = r0nrm
      call dhels(hes, maxlp1, ll, q, wk)
      do 20 k = 1,n
         zl(k) = 0.0d0
 20   continue
      do 30 i = 1,ll
         call daxpy(n, wk(i), v(1,i), 1, zl, 1)
 30   continue
      if ((jscal .eq. 1) .or.(jscal .eq. 3)) then
         do 40 k = 1,n
            zl(k) = zl(k)/sz(k)
 40      continue
      endif
      if (jpre .gt. 0) then
         call dcopy(n, zl, 1, wk, 1)
         call msolve(n, wk, zl, nelt, ia, ja, a, isym, rpar, ipar)
         nmsl = nmsl + 1
      endif
      do 50 k = 1,n
         xl(k) = x(k) + zl(k)
 50   continue
      return
      end

*deck isdgmr
      function isdgmr(n, b, x, xl, nelt, ia, ja, a, isym, msolve,
     $     nmsl, itol, tol, itmax, iter, err, iunit, r, z, dz,
     $     rwork, iwork, rnrm, bnrm, sb, sx, jscal,
     $     kmp, lgmr, maxl, maxlp1, v, q, snormw, prod, r0nrm,
     $     hes, jpre)
      implicit double precision(a-h,o-z)
      integer kmp, lgmr, maxl, maxlp1, jpre, nmsl
      double precision dxnrm, rnrm, r0nrm, snormw, solnrm, prod
      double precision b(*), x(*), ia(*), ja(*), a(*), r(*), z(*), dz(*)
      double precision rwork(*), iwork(*), sb(*), sx(*), q(*), v(n,*)
      double precision hes(maxlp1,maxl), xl(*)
      external msolve
      parameter(maxn=441)
      common /solblk/ soln(maxn)
      save solnrm
      isdgmr = 0
      if ( itol.eq.0 ) then
         err = rnrm/bnrm
      endif
      if ( (itol.gt.0) .and. (itol.le.3) ) then
         if ( lgmr.ne.0 ) call drlcal(n, kmp, lgmr, maxl, v, q, r,
     $                                snormw, prod, r0nrm)
         if ( itol.le.2 ) then
            err = dnrm2(n, r, 1)/bnrm
            if ( (kmp.lt.maxl) .and. (lgmr.ne.0) ) then
               tem = 1.0d0/(r0nrm*prod)
               call dscal(n, tem, r, 1)
            endif
         elseif ( itol.eq.3 ) then
            if ( jpre.gt.0 ) then
               call msolve(n, r, dz, nelt, ia, ja, a, isym, rwork,
     $              iwork)
               nmsl = nmsl + 1
            endif
            if ( (kmp.lt.maxl) .and. (lgmr.ne.0) ) then
               tem = 1.0d0/(r0nrm*prod)
               call dscal(n, tem, r, 1)
            endif
            fuzz = d1mach(1)
            ielmax = 1
            ratmax = abs(dz(1))/max(abs(x(1)),fuzz)
            do 25 i = 2, n
               rat = abs(dz(i))/max(abs(x(i)),fuzz)
               if( rat.gt.ratmax ) then
                  ielmax = i
                  ratmax = rat
               endif
 25         continue
            err = ratmax
            if( ratmax.le.tol ) isdgmr = 1
            if( iunit.gt.0 ) write(iunit,1020) iter, ielmax, ratmax
            return
         endif
      endif
      if ( itol.eq.11 ) then
         if ( (lgmr.ne.0) .and. (iter.gt.0) ) then
            call dxlcal(n, lgmr, x, xl, xl, hes, maxlp1, q, v, r0nrm,
     $           dz, sx, jscal, jpre, msolve, nmsl, rwork, iwork,
     $           nelt, ia, ja, a, isym)
         elseif ( iter.eq.0 ) then
            call dcopy(n, x, 1, xl, 1)
         else
            return
         endif
         if ((jscal .eq. 0) .or.(jscal .eq. 2)) then
            if ( iter.eq.0 ) solnrm = dnrm2(n, soln, 1)
            do 30 i = 1, n
               dz(i) = xl(i) - soln(i)
 30         continue
            err = dnrm2(n, dz, 1)/solnrm
         else
            if (iter .eq. 0) then
               solnrm = 0.d0
               do 40 i = 1,n
                  solnrm = solnrm + (sx(i)*soln(i))**2
 40            continue
               solnrm = dsqrt(solnrm)
            endif
            dxnrm = 0.d0
            do 50 i = 1,n
               dxnrm = dxnrm + (sx(i)*(xl(i)-soln(i)))**2
 50         continue
            dxnrm = dsqrt(dxnrm)
            err = dxnrm/solnrm
         endif
      endif
      if( iunit.ne.0 ) then
         if( iter.eq.0 ) then
            write(iunit,1000) n, itol, maxl, kmp
         endif
         write(iunit,1010) iter, rnrm/bnrm, err
      endif
      if ( err.le.tol ) isdgmr = 1
      return
 1000 format(' generalized minimum residual(',i3,i3,') for ',
     $     'n, itol = ',i5, i5,
     $     /' iter','   natral err est','   error estimate')
 1010 format(1x,i4,1x,e16.7,1x,e16.7)
 1020 format(1x,' iter = ',i5, ' ielmax = ',i5,
     $     ' |r(ielmax)/x(ielmax)| = ',e12.5)
      end

*deck dir
      subroutine dir(n, b, x, nelt, ia, ja, a, isym, matvec, msolve, 
     $     itol, tol, itmax, iter, err, ierr, iunit, r, z, dz,
     $     rwork, iwork)
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym
      integer itol, itmax, iter, ierr, iunit, iwork(*)
      double precision b(n), x(n), a(nelt), tol, err, r(n), z(n)
      double precision dz(n), rwork(*)
      external msolve, matvec, isdir
      iter = 0
      ierr = 0
      if( n.lt.1 ) then
         ierr = 3
         return
      endif
      tolmin = 500.0*d1mach(3)
      if( tol.lt.tolmin ) then
         tol = tolmin
         ierr = 4
      endif
      call matvec(n, x, r, nelt, ia, ja, a, isym)
      do 10 i = 1, n
         r(i) = b(i) - r(i)
 10   continue
      call msolve(n, r, z, nelt, ia, ja, a, isym, rwork, iwork)
      if( isdir(n, b, x, nelt, ia, ja, a, isym, msolve, itol, tol,
     $     itmax, iter, err, ierr, iunit, r, z, dz, rwork,
     $     iwork, bnrm, solnrm) .ne. 0 ) go to 200
      if( ierr.ne.0 ) return
      do 100 k=1,itmax
         iter = k
         do 20 i = 1, n
            x(i) = x(i) + z(i)
 20      continue
         call matvec(n, x, r, nelt, ia, ja, a, isym)
         do 30 i = 1, n
            r(i) = b(i) - r(i)
 30      continue
         call msolve(n, r, z, nelt, ia, ja, a, isym, rwork, iwork)
         if( isdir(n, b, x, nelt, ia, ja, a, isym, msolve, itol, tol,
     $        itmax, iter, err, ierr, iunit, r, z, dz, rwork,
     $        iwork, bnrm, solnrm) .ne. 0 ) go to 200
 100  continue
      iter = itmax + 1
      ierr = 2
 200  return
      end

*deck dsjac
      subroutine dsjac(n, b, x, nelt, ia, ja, a, isym, itol, tol, 
     $     itmax, iter, err, ierr, iunit, rwork, lenw, iwork, leniw )
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym, itol, itmax
      integer iter, iunit, lenw, iwork(leniw), leniw
      double precision b(n), x(n), a(nelt), rwork(lenw)
      external dsmv, dsdi
      parameter(locrb=1,locib=11)
      ierr = 0
      if( n.lt.1 .or. nelt.lt.1 ) then
         ierr = 3
         return
      endif
      lociw = locib
      locd = locrb
      locr = locd + n
      locz = locr + n
      locdz = locz + n
      locw = locdz + n
      call dchkw( 'dsjac', lociw, leniw, locw, lenw, ierr, iter, err )
      if( ierr.ne.0 ) return
      iwork(4) = locd
      iwork(9) = lociw
      iwork(10) = locw
      call ds2y(n, nelt, ia, ja, a, isym )
      call dsds(n, nelt, ia, ja, a, isym, rwork(locd))
      call dir(n, b, x, nelt, ia, ja, a, isym, dsmv, dsdi, itol, tol,
     $     itmax, iter, err, ierr, iunit, rwork(locr), rwork(locz), 
     $     rwork(locdz), rwork, iwork )
      return
      end

*deck dsgs
      subroutine dsgs(n, b, x, nelt, ia, ja, a, isym, itol, tol,
     $     itmax, iter, err, ierr, iunit, rwork, lenw, iwork, leniw )
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym, itol, itmax
      integer iter, iunit, iwork(10)
      double precision b(n), x(n), a(n), tol, err, rwork(1)
      external dsmv, dsli
      parameter(locrb=1,locib=11)
      if( n.lt.1 .or. nelt.lt.1 ) then
         ierr = 3
         return
      endif
      call ds2y( n, nelt, ia, ja, a, isym )
      if( isym.eq.0 ) then
         nel = 0
         do 20 icol = 1, n
            jbgn = ja(icol)
            jend = ja(icol+1)-1
            do 10 j = jbgn, jend
               if( ia(j).ge.icol ) nel = nel + 1
 10         continue
 20      continue
      else
         nel = ja(n+1)-1
      endif
      locjel = locib
      lociel = locjel + n+1
      lociw = lociel + nel
      locel = locrb
      locr = locel + nel
      locz = locr + n
      locdz = locz + n
      locw = locdz + n
      call dchkw( 'dsgs', lociw, leniw, locw, lenw, ierr, iter, err )
      if( ierr.ne.0 ) return
      iwork(1) = nel
      iwork(2) = lociel
      iwork(3) = locjel
      iwork(4) = locel
      iwork(9) = lociw
      iwork(10) = locw
      call ds2lt( n, nelt, ia, ja, a, isym, nel, iwork(lociel),
     $     iwork(locjel), rwork(locel) )
      call dir(n, b, x, nelt, ia, ja, a, isym, dsmv, dsli, 
     $     itol, tol, itmax, iter, err, ierr, iunit, rwork(locr),
     $     rwork(locz), rwork(locdz), rwork, iwork )
      iwork(9) = lociw+n+nelt
      iwork(10) = locw+nelt
      return
      end

*deck dsilur
      subroutine dsilur(n, b, x, nelt, ia, ja, a, isym, itol, tol,
     $     itmax, iter, err, ierr, iunit, rwork, lenw, iwork, leniw )
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym, itol, itmax, iter
      integer ierr, iunit, lenw, iwork(leniw), leniw
      double precision b(n), x(n), a(nelt), tol, err, rwork(lenw)
      parameter (locrb=1, locib=11)
      external dsmv, dslui
      ierr = 0
      if( n.lt.1 .or. nelt.lt.1 ) then
         ierr = 3
         return
      endif
      call ds2y( n, nelt, ia, ja, a, isym )
      nl = 0
      nu = 0
      do 20 icol = 1, n
         jbgn = ja(icol)+1
         jend = ja(icol+1)-1
         if( jbgn.le.jend ) then
            do 10 j = jbgn, jend
               if( ia(j).gt.icol ) then
                  nl = nl + 1
                  if( isym.ne.0 ) nu = nu + 1
               else
                  nu = nu + 1
               endif
 10         continue
         endif
 20   continue
      locil = locib
      locjl = locil + n+1
      lociu = locjl + nl
      locju = lociu + nu
      locnr = locju + n+1
      locnc = locnr + n
      lociw = locnc + n
      locl = locrb
      locdin = locl + nl
      locu = locdin + n
      locr = locu + nu
      locz = locr + n
      locdz = locz + n
      locw = locdz + n
      call dchkw( 'dsilur', lociw, leniw, locw, lenw, ierr, iter, err )
      if( ierr.ne.0 ) return
      iwork(1) = locil
      iwork(2) = locjl
      iwork(3) = lociu
      iwork(4) = locju
      iwork(5) = locl
      iwork(6) = locdin
      iwork(7) = locu
      iwork(9) = lociw
      iwork(10) = locw
      call dsilus( n, nelt, ia, ja, a, isym, nl, iwork(locil),
     $     iwork(locjl), rwork(locl), rwork(locdin), nu, iwork(lociu),
     $     iwork(locju), rwork(locu), iwork(locnr), iwork(locnc) )
      call dir(n, b, x, nelt, ia, ja, a, isym, dsmv, dslui, 
     $     itol, tol, itmax, iter, err, ierr, iunit, rwork(locr),
     $     rwork(locz), rwork(locdz), rwork, iwork)
      return
      end

*deck isdir
      function isdir(n, b, x, nelt, ia, ja, a, isym, msolve, itol, tol,
     $     itmax, iter, err, ierr, iunit, r, z, dz, rwork, iwork,
     $     bnrm, solnrm)
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym, itol, itmax, iter
      integer iunit, iwork(*)
      double precision b(n), x(n), a(nelt), r(n), z(n), dz(n), rwork(*)
      external msolve
      parameter(maxn=441)
      common /solblk/ soln(maxn)
      isdir = 0
      if( itol.eq.1 ) then
         if(iter .eq. 0) bnrm = dnrm2(n, b, 1)
         err = dnrm2(n, r, 1)/bnrm
      else if( itol.eq.2 ) then
         if(iter .eq. 0) then
            call msolve(n, b, dz, nelt, ia, ja, a, isym, rwork, iwork)
            bnrm = dnrm2(n, dz, 1)
         endif
         err = dnrm2(n, z, 1)/bnrm
      else if( itol.eq.11 ) then
         if( iter.eq.0 ) solnrm = dnrm2(n, soln, 1)
         do 10 i = 1, n
            dz(i) = x(i) - soln(i)
 10      continue
         err = dnrm2(n, dz, 1)/solnrm
      else
         err = 1.0e10
         ierr = 3
      endif
      if( iunit.ne.0 ) then
         write(iunit,1000) iter,err
      endif
      if( err.le.tol ) isdir = 1
      return
 1000 format(5x,'iter = ',i4,' error estimate = ',e16.7)
      end

*deck dlpdoc
      subroutine dlpdoc
      return
      end

      program dlapqc
      parameter(maxn=441, mxnelt=50000, maxiw=50000, maxrw=50000)
      implicit double precision(a-h,o-z)
      character*72     mesg
      double precision a(mxnelt), f(maxn), xiter(maxn), rwork(maxrw)
      integer          ia(mxnelt), ja(mxnelt), iwork(maxiw)
      common /solblk/ soln(maxn)
      istdi = i1mach(1)
      istdo = i1mach(2)
      nfail = 0
      read(istdi,990) kprint
  990 format(i1)
      call xsetun(lun)
      if( kprint.le.1 ) then
         call xsetf(0)
      else
         call xsetf(1)
      endif
      call xermax(1000)
      neltmx = mxnelt
      nmax   = maxn
      leniw  = maxiw
      lenw   = maxrw
      n      = nmax
      itmax  = n
      iout   = kprint
      factor = 1.2
      if( iout.lt.3 ) then
         iunit = 0
      else
         iunit = istdo
      endif
      tol = max(1.0d3*d1mach(3),1.0d-6)
      do 10 kase = 3, 3
         if(kase .eq. 1 .or. kase .eq. 2) itol = kase
         if(kase .eq. 3) itol = 11
         do 20 isym = 0, 1
            call drmgen( neltmx, factor, ierr, n, nelt, 
     $           isym, ia, ja, a, f, soln, rwork, iwork, iwork(n+1) )
            if( ierr.ne.0 ) then
               mesg = 'dlapqc -- fatal error (i1) generating '//
     $              '*random* matrix.'
               call xerrwv( mesg,len(mesg),ierr,2,1,ierr,0,
     $              0,0.0,0.0 )
            endif
            if( isym.eq.0 ) then
               dens = float(nelt)/float(n*n)
            else
               dens = float(2*nelt)/float(n*n)
            endif
            if( iout.ge.2 ) then
              write(istdo,1020) n, nelt, dens
              write(istdo,1030) tol
            endif
            call ds2y( n, nelt, ia, ja, a, isym )
            if( iout.ge.4 ) then
               write(istdo,1040) (k,ia(k),ja(k),a(k),k=1,nelt)
               call dcpplt( n, nelt, ia, ja, a, isym, istdo )
            endif
            if( iout.ge.3 ) then
              write(istdo,1000) 'dsjac ', itol, isym
            endif
            call dfill( n, xiter, 0.0d0 )
            call dsjac(n, f, xiter, nelt, ia, ja, a, isym,
     $           itol, tol, 2*itmax, iter, err, ierr, iunit,
     $           rwork, lenw, iwork, leniw )
            call duterr( 'dsjac ',ierr,iout,nfail,istdo,iter,err )
            if( iout.ge.3 ) then
              write(istdo,1000) 'dsgs  ',itol,isym
            endif
            call dfill( n, xiter, 0.0d0 )
            call dsgs(n, f, xiter, nelt, ia, ja, a, isym,
     $           itol, tol, itmax, iter, err, ierr, iunit,
     $           rwork, lenw, iwork, leniw )
            call duterr( 'dsgs  ',ierr,iout,nfail,istdo,iter,err )
            if( iout.ge.3 ) then
              write(istdo,1000) 'dsilur',itol,isym
            endif
            call dfill( n, xiter, 0.0d0 )
            call dsilur(n, f, xiter, nelt, ia, ja, a, isym,
     $           itol, tol, itmax, iter, err, ierr, iunit,
     $           rwork, lenw, iwork, leniw )
            call duterr( 'dsilur',ierr,iout,nfail,istdo,iter,err )
            if( isym.eq.1 ) then
               if( iout.ge.3 ) then
                  write(istdo,1000) 'dsdcg',itol,isym
               endif
               call dfill( n, xiter, 0.0d0 )
               call dsdcg(n, f, xiter, nelt, ia, ja, a, isym, 
     $              itol, tol, itmax, iter, err, ierr, iunit,
     $              rwork, lenw, iwork, leniw )
               call duterr( 'dsdcg ',ierr,iout,nfail,istdo,iter,err )
            endif
            if( isym.eq.1 ) then
               if( iout.ge.3 ) then
                  write(istdo,1000) 'dsiccg',itol,isym
               endif
               call dfill( n, xiter, 0.0d0 )
               call dsiccg(n, f, xiter, nelt, ia, ja, a, isym, 
     $              itol, tol, itmax, iter, err, ierr, iunit, rwork, 
     $              lenw, iwork, leniw )
               call duterr( 'dsiccg',ierr,iout,nfail,istdo,iter,err )
            endif
            if( iout.ge.3 ) then
               write(istdo,1000) 'dsdcgn',itol,isym
            endif
            call dfill( n, xiter, 0.0d0 )
            call dsdcgn(n, f, xiter, nelt, ia, ja, a, isym, itol,
     $           tol, itmax, iter, err, ierr, iunit, rwork, lenw,
     $           iwork, leniw )
            call duterr( 'dsdcgn',ierr,iout,nfail,istdo,iter,err )
            if( iout.ge.3 ) then 
               write(istdo,1000) 'dslucn',itol,isym
            endif
            call dfill( n, xiter, 0.0d0 )
            call dslucn(n, f, xiter, nelt, ia, ja, a, isym, itol,
     $           tol, itmax, iter, err, ierr, iunit, rwork, lenw,
     $           iwork, leniw )
            call duterr( 'dslucn',ierr,iout,nfail,istdo,iter,err )
            if( iout.ge.3 ) then
               write(istdo,1000) 'dsdbcg',itol,isym
            endif
            call dfill( n, xiter, 0.0d0 )
            call dsdbcg(n, f, xiter, nelt, ia, ja, a, isym, itol,
     $           tol, itmax, iter, err, ierr, iunit, rwork, lenw,
     $           iwork, leniw )
            call duterr( 'dsdbcg',ierr,iout,nfail,istdo,iter,err )
            if( iout.ge.3 ) then
               write(istdo,1000) 'dslubc',itol,isym
            endif
            call dfill( n, xiter, 0.0d0 )
            call dslubc(n, f, xiter, nelt, ia, ja, a, isym, 
     $           itol, tol, itmax, iter, err, ierr, iunit, 
     $           rwork, lenw, iwork, leniw )
            call duterr( 'dslubc',ierr,iout,nfail,istdo,iter,err )
            if( iout.ge.3 ) then
               write(istdo,1000) 'dsdcgs',itol,isym
            endif
            call dfill( n, xiter, 0.0d0 )
            call dsdcgs(n, f, xiter, nelt, ia, ja, a, isym, itol,
     $           tol, itmax, iter, err, ierr, iunit, rwork, lenw,
     $           iwork, leniw )
            call duterr( 'dsdcgs',ierr,iout,nfail,istdo,iter,err )
            if( iout.ge.3 ) then
               write(istdo,1000) 'dslucs',itol,isym
            endif
            call dfill( n, xiter, 0.0d0 )
            call dslucs(n, f, xiter, nelt, ia, ja, a, isym, 
     $           itol, tol, itmax, iter, err, ierr, iunit, 
     $           rwork, lenw, iwork, leniw )
            call duterr( 'dslucs',ierr,iout,nfail,istdo,iter,err )
            do 30 nsave = 0, 3
               if( iout.ge.3 ) then
                  write(istdo,1010) 'dsdomn',itol, isym, nsave
               endif
               call dfill( n, xiter, 0.0d0 )
               call dsdomn(n, f, xiter, nelt, ia, ja, a,
     $              isym, nsave, itol, tol, itmax, iter, err, ierr, 
     $              iunit, rwork, lenw, iwork, leniw )
               call duterr( 'dsdomn',ierr,iout,nfail,istdo,iter,err )
 30         continue
            do 40 nsave=0,3
               if( iout.ge.3 ) then
                  write(istdo,1010) 'dsluom',itol, isym, nsave
               endif
               call dfill( n, xiter, 0.0d0 )
               call dsluom(n, f, xiter, nelt, ia, ja, a,
     $              isym, nsave, itol, tol, itmax, iter, err, ierr, 
     $              iunit, rwork, lenw, iwork, leniw )
               call duterr( 'dsluom',ierr,iout,nfail,istdo,iter,err )
 40         continue
            do 50 nsave = 5, 12
               if( iout.ge.3 ) then
                  write(istdo,1010) 'dsdgmr',itol, isym, nsave
               endif
               call dfill( n, xiter, 0.0d0 )
               itolgm = 0
               call dsdgmr(n, f, xiter, nelt, ia, ja, a,
     $              isym, nsave, itolgm, tol, itmax, iter, err, ierr, 
     $              iunit, rwork, lenw, iwork, leniw )
               call duterr( 'dsdgmr',ierr,iout,nfail,istdo,iter,err )
 50         continue
            do 60 nsave = 5, 12
               if( iout.ge.3 ) then
                  write(istdo,1010) 'dslugm',itol, isym, nsave
               endif
               call dfill( n, xiter, 0.0d0 )
               call dslugm(n, f, xiter, nelt, ia, ja, a,
     $              isym, nsave, itol, tol, itmax, iter, err, ierr, 
     $              iunit, rwork, lenw, iwork, leniw )
               call duterr( 'dslugm',ierr,iout,nfail,istdo,iter,err )
 60         continue
 20      continue
 10   continue
      if( nfail.eq.0 ) then
         write(istdo,1050)
      else
         write(istdo,1060) nfail
      endif
      stop 'all done'
 1000 format(/1x,a6,' : itol = ',i2,'   isym = ',i1)
 1010 format(/1x,a6,' : itol = ',i2,'   isym = ',i1,' nsave = ',i2) 
 1020 format(/'                * random matrix of size',i5,'*'
     $     /'                ',
     $     'number of non-zeros & density = ', i5,e16.7)
 1030 format('                error tolerance = ',e16.7) 
 1040 format(/'  ***** slap column matrix *****'/
     $        ' indx   ia   ja     a'/(1x,i4,1x,i4,1x,i4,1x,e16.7))
 1050 format(//
     $     '*******************************************************'/
     $     '**** all slap double precision quick checks passed ****'/
     $     '****                 no errors                     ****'/
     $     '*******************************************************')
 1060 format(//
     $     '************************************************'/
     $     '**     ===>',i3,' failures detected <===      **'/
     $     '**     slap double precision quick checks     **'/
     $     '** set kprint = 3 for debug information and   **'/
     $     '** rerun the tests to determine the problem.  **'/
     $     '************************************************')
      end

*deck duterr
      subroutine duterr( method, ierr, iout, nfail, istdo, iter, err )
      implicit double precision(a-h,o-z)
      character*6 method
      integer ierr, iout, nfail, istdo, iter
      double precision err
      if( ierr.ne.0 ) nfail = nfail+1    
      if( iout.eq.1 .and. ierr.ne.0 ) then
         write(istdo,1000) method
      endif
      if( iout.eq.2 ) then
         if( ierr.eq.0 ) then
            write(istdo,1010) method
         else
            write(istdo,1020) method,ierr,iter,err
         endif
      endif
      if( iout.ge.3 ) then
         if( ierr.eq.0 ) then
            write(istdo,1030) method,ierr,iter,err
         else
            write(istdo,1020) method,ierr,iter,err
         endif
      endif
      return
 1000 format( 1x,a6,' : **** failure ****')
 1010 format( 1x,a6,' : **** passed  ****')
 1020 format(' **************** warning ***********************'/
     $       ' **** ',a6,' quick test failed: ierr = ',i5,' ****'/
     $       ' **************** warning ***********************'/
     $       ' iteration count = ',i3,' stop test = ',e12.6)
 1030 format(' ***************** passed ***********************'/
     $       ' **** ',a6,' quick test passed: ierr = ',i5,' ****'/
     $       ' ***************** passed ***********************'/
     $       ' iteration count = ',i3,' stop test = ',e12.6)
      end

*deck drmgen
      subroutine drmgen( neltmx, factor, ierr, n, nelt, isym, 
     $     ia, ja, a, f, soln, dsum, itmp, idiag )
      implicit double precision(a-h,o-z)
      integer neltmx, ierr, n, nelt, isym
      integer ia(neltmx), ja(neltmx)
      integer itmp(n), idiag(n)
      double precision factor, a(neltmx)
      double precision f(n), soln(n), dsum(n)
      real rand, dummy
      dummy = 16381.0
      iseed = rand( dummy )
      ierr = 0
      do 10 i = 1, n
         idiag(i) = 0
         dsum(i) = -1.0
 10   continue
      dummy = 0.0
      nelt = 0
      do 30 icol = 1, n
         nl = n+1-icol
         inum = (ifix( rand(dummy)*nl ) + 1)/3
         call dmpl( nl, inum, itmp )
         do 20 irow = 1, inum
            nelt = nelt + 1
            if( nelt.gt.neltmx ) then
               ierr = 1
               return
            endif
            ia(nelt) = n+1-itmp(irow)
            ja(nelt) = icol
            if( ia(nelt).eq.icol ) then
               idiag(icol) = nelt
            else
               a(nelt) = -rand(dummy)
               dsum(icol) = dsum(icol) + a(nelt)
               if( isym.eq.0 ) then
                  nelt = nelt + 1
                  if( nelt.gt.neltmx ) then
                     ierr = 1
                     return
                  endif
                  ia(nelt) = icol
                  ja(nelt) = ia(nelt-1)
                  a(nelt)  = a(nelt-1)*factor
                  dsum(ja(nelt)) = dsum(ja(nelt)) + a(nelt)
               else
                  dsum(ia(nelt)) = dsum(ia(nelt)) + a(nelt)
               endif
            endif
 20      continue
         if( idiag(icol).eq.0 ) then
            nelt = nelt + 1
            if( nelt.gt.neltmx ) then
               ierr = 1
               return
            endif
            idiag(icol) = nelt
            a(nelt) = 0.0d0
            ia(nelt) = icol
            ja(nelt) = icol
         endif
 30   continue
      do 40 i = 1, n
         a(idiag(i)) = -1.0001*dsum(i)
 40   continue
      do 50 i = 1, n
         soln(i) = rand(dummy)
         f(i) = 0.0d0
 50   continue
      do 60 k = 1, nelt
         f(ia(k)) = f(ia(k)) + a(k)*soln(ja(k))
         if( isym.ne.0 .and. ia(k).ne.ja(k) ) then
            f(ja(k)) = f(ja(k)) + a(k)*soln(ia(k))
         endif
 60   continue
      return
      end

*deck dmpl
      subroutine dmpl( n, m, indx )
      implicit double precision(a-h,o-z)
      real rand, dummy
      integer n, m, indx(m)
      dummy = 0.0
      if( n*m.lt.0 .or. m.gt.n ) return
      indx(1) = ifix( rand(dummy)*n ) + 1
      do 30 i = 2, m
 10      id = ifix( rand(dummy)*n ) + 1
         do 20 j = 1, i-1
            if( id.eq.indx(j) ) goto 10
 20      continue
         indx(i) = id
 30   continue
      return
      end

*deck dfill
      subroutine dfill (n,v,val)
      implicit double precision(a-h,o-z)
      integer n
      double precision v(*), val
      if (n .le. 0) return
      nr=mod(n,4)
      is=1
      goto(1,2,3,4), nr+1
    4   is=4
        v(1)=val
        v(2)=val
        v(3)=val
        goto 1
    3   is=3
        v(1)=val
        v(2)=val
        goto 1
    2   is=2
        v(1)=val
    1 do 10 i=is,n,4
        v(i)  =val
        v(i+1)=val
        v(i+2)=val
        v(i+3)=val
 10   continue
      return
      end

*deck dbhin
      subroutine dbhin( n, nelt, ia, ja, a, isym, soln, rhs,
     $     iunit, job )
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym, job
      double precision a(nelt), rhs(n), soln(n)
      character*80  title
      character*3   code
      character*16  pntfmt, rinfmt
      character*20  nvlfmt, rhsfmt
      integer nline, npls, nrils, nnvls, nrhsls, nrow, ncol, nind, nele
      read(iunit,9000) title
      read(iunit,9010) nline, npls, nrils, nnvls, nrhsls
      read(iunit,9020) code, nrow, ncol, nind, nele
      read(iunit,9030) pntfmt, rinfmt, nvlfmt, rhsfmt
      if( nrow.gt.n ) then
         n = nrow
         jobret = -1
         goto 999
      endif
      if( nind.gt.nelt ) then
         nelt = nind
         jobret = -2
         goto 999
      endif
      n    = nrow
      nelt = nind
      if( code.eq.'rua' ) then
         isym = 0
      else if( code.eq.'rsa' ) then
         isym = 1
      else
         jobret = -3
         goto 999
      endif
      read(iunit,pntfmt) (ja(i), i = 1, n+1)
      read(iunit,rinfmt) (ia(i), i = 1, nelt)
      jobret = 10
      if( nnvls.gt.0 ) then
         read(iunit,nvlfmt) (a(i),  i = 1, nelt)
         jobret = 0
      endif
      if( nrhsls.gt.0 .and. mod(job,2).eq.1 ) then
         read(5,rhsfmt) (rhs(i), i = 1, n)
         jobret = jobret + 1
      endif
      do 70 icol = 1, n
         ibgn = ja(icol)
         iend = ja(icol+1)-1
         do 30 i = ibgn, iend
            if( ia(i).eq.icol ) then
               itemp = ia(i)
               ia(i) = ia(ibgn)
               ia(ibgn) = itemp
               temp = a(i)
               a(i) = a(ibgn)
               a(ibgn) = temp
               goto 40
            endif
 30      continue
 40      ibgn = ibgn + 1
         if( ibgn.lt.iend ) then
            do 60 i = ibgn, iend
               do 50 j = i+1, iend
                  if( ia(i).gt.ia(j) ) then
                     itemp = ia(i)
                     ia(i) = ia(j)
                     ia(j) = itemp
                     temp = a(i)
                     a(i) = a(j)
                     a(j) = temp
                  endif
 50            continue
 60         continue
         endif
 70   continue
 999  job = jobret
      return
 9000 format( a80 )
 9010 format( 5i14 )
 9020 format( a3, 11x, 4i14 )
 9030 format( 2a16, 2a20 )
      end

*deck dchkw
      subroutine dchkw( name, lociw, leniw, locw, lenw,
     $     ierr, iter, err )
      implicit double precision(a-h,o-z)
      character*(*) name
      character*72 mesg
      integer lociw, leniw, locw, lenw, ierr, iter
      double precision err, d1mach
      external d1mach, xerrwv
      ierr = 0
      if( lociw.gt.leniw ) then
         ierr = 1
         iter = 0
         err = d1mach(2)
         mesg = name // ': integer work array too short. '//
     $        ' iwork needs i1: have allocated i2.'
         call xerrwv( mesg, len(mesg), 1, 1, 2, lociw, leniw,
     $        0, 0.0, 0.0 )
      endif
      if( locw.gt.lenw ) then
         ierr = 1
         iter = 0
         err = d1mach(2)
         mesg = name // ': double precision work array too short. '//
     $        ' rwork needs i1: have allocated i2.'
         call xerrwv( mesg, len(mesg), 1, 1, 2, locw, lenw,
     $        0, 0.0, 0.0 )
      endif
      return
      end

*deck qs2i1d
      subroutine qs2i1d( ia, ja, a, n, kflag )
      implicit double precision(a-h,o-z)
      dimension il(21),iu(21)
      integer   ia(n),ja(n),it,iit,jt,jjt
      double precision a(n), ta, tta
      nn = n
      if (nn.lt.1) then
         call xerror ( 'qs2i1d- the number of values to be sorted was no
     $t positive.',59,1,1)
         return
      endif
      if( n.eq.1 ) return
      kk = iabs(kflag)
      if ( kk.ne.1 ) then
         call xerror ( 'qs2i1d- the sort control parameter, k, was not 1
     $ or -1.',55,2,1)
         return
      endif
      if( kflag.lt.1 ) then
         do 20 i=1,nn
            ia(i) = -ia(i)
 20      continue
      endif
      m = 1
      i = 1
      j = nn
      r = .375
 210  if( r.le.0.5898437 ) then
         r = r + 3.90625e-2
      else
         r = r-.21875
      endif
 225  k = i
      ij = i + idint( dble(j-i)*r )
      it = ia(ij)
      jt = ja(ij)
      ta = a(ij)
      if( ia(i).gt.it ) then
         ia(ij) = ia(i)
         ia(i)  = it
         it     = ia(ij)
         ja(ij) = ja(i)
         ja(i)  = jt
         jt     = ja(ij)
         a(ij)  = a(i)
         a(i)   = ta
         ta     = a(ij)
      endif
      l=j
      if( ia(j).lt.it ) then
         ia(ij) = ia(j)
         ia(j)  = it
         it     = ia(ij)
         ja(ij) = ja(j)
         ja(j)  = jt
         jt     = ja(ij)
         a(ij)  = a(j)
         a(j)   = ta
         ta     = a(ij)
         if ( ia(i).gt.it ) then
            ia(ij) = ia(i)
            ia(i)  = it
            it     = ia(ij)
            ja(ij) = ja(i)
            ja(i)  = jt
            jt     = ja(ij)
            a(ij)  = a(i)
            a(i)   = ta
            ta     = a(ij)
         endif
      endif
  240 l=l-1
      if( ia(l).gt.it ) go to 240
  245 k=k+1
      if( ia(k).lt.it ) go to 245
      if( k.le.l ) then
         iit   = ia(l)
         ia(l) = ia(k)
         ia(k) = iit
         jjt   = ja(l)
         ja(l) = ja(k)
         ja(k) = jjt
         tta   = a(l)
         a(l)  = a(k)
         a(k)  = tta
         goto 240
      endif
      if( l-i.gt.j-k ) then
         il(m) = i
         iu(m) = l
         i = k
         m = m+1
      else
         il(m) = k
         iu(m) = j
         j = l
         m = m+1
      endif
      go to 260
  255 m = m-1
      if( m.eq.0 ) go to 300
      i = il(m)
      j = iu(m)
  260 if( j-i.ge.1 ) go to 225
      if( i.eq.j ) go to 255
      if( i.eq.1 ) go to 210
      i = i-1
  265 i = i+1
      if( i.eq.j ) go to 255
      it = ia(i+1)
      jt = ja(i+1)
      ta =  a(i+1)
      if( ia(i).le.it ) go to 265
      k=i
  270 ia(k+1) = ia(k)
      ja(k+1) = ja(k)
      a(k+1)  =  a(k)
      k = k-1
      if( it.lt.ia(k) ) go to 270
      ia(k+1) = it
      ja(k+1) = jt
      a(k+1)  = ta
      go to 265
  300 if( kflag.lt.1 ) then
         do 310 i=1,nn
            ia(i) = -ia(i)
 310     continue
      endif
      return
      end

*deck ds2y
      subroutine ds2y(n, nelt, ia, ja, a, isym )
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym
      double precision a(nelt)
      if( ja(n+1).eq.nelt+1 ) return
      call qs2i1d( ja, ia, a, nelt, 1 )
      ja(1) = 1
      do 20 icol = 1, n-1
         do 10 j = ja(icol)+1, nelt
            if( ja(j).ne.icol ) then
               ja(icol+1) = j
               goto 20
            endif
 10      continue
 20   continue
      ja(n+1) = nelt+1
      ja(n+2) = 0
      do 70 icol = 1, n
         ibgn = ja(icol)
         iend = ja(icol+1)-1
         do 30 i = ibgn, iend
            if( ia(i).eq.icol ) then
               itemp = ia(i)
               ia(i) = ia(ibgn)
               ia(ibgn) = itemp
               temp = a(i)
               a(i) = a(ibgn)
               a(ibgn) = temp
               goto 40
            endif
 30      continue
 40      ibgn = ibgn + 1
         if( ibgn.lt.iend ) then
            do 60 i = ibgn, iend
               do 50 j = i+1, iend
                  if( ia(i).gt.ia(j) ) then
                     itemp = ia(i)
                     ia(i) = ia(j)
                     ia(j) = itemp
                     temp = a(i)
                     a(i) = a(j)
                     a(j) = temp
                  endif
 50            continue
 60         continue
         endif
 70   continue
      return
      end

*deck dcpplt
      subroutine dcpplt( n, nelt, ia, ja, a, isym, iunit )
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym
      double precision a(nelt)
      character*225 chmat(225)
      nmax = min( 225, n)
      do 10 i = 1, nmax
         chmat(i)(1:nmax) = ' '
 10   continue
      do 30 icol = 1, nmax
         jbgn = ja(icol)
         jend = ja(icol+1)-1
         do 20 j = jbgn, jend
            irow = ia(j)
            if( irow.le.nmax ) then
               if( isym.ne.0 ) then
                  if( a(j).eq.0.0d0 ) then
                     chmat(irow)(icol:icol) = '0'
                  elseif( a(j).gt.0.0d0 ) then
                     chmat(irow)(icol:icol) = '#'
                  else
                     chmat(irow)(icol:icol) = '*'
                  endif
               endif
               if( irow.eq.icol ) then
                  if( a(j).eq.0.0d0 ) then
                     chmat(irow)(icol:icol) = '0'
                  elseif( a(j).gt.0.0d0 ) then
                     chmat(irow)(icol:icol) = 'd'
                  else
                     chmat(irow)(icol:icol) = 'n'
                  endif
               else
                  if( a(j).eq.0.0d0 ) then
                     chmat(irow)(icol:icol) = '0'
                  elseif( a(j).gt.0.0d0 ) then
                     chmat(irow)(icol:icol) = '#'
                  else
                     chmat(irow)(icol:icol) = '*'
                  endif
               endif
            endif
 20      continue
 30   continue
      write(iunit,1000) n, nelt, float(nelt)/float(n*n)
      write(iunit,1010) (mod(i,10),i=1,nmax)
      do 40 irow = 1, nmax
         write(iunit,1020) irow, chmat(irow)(1:nmax)
 40   continue
      return
 1000 format(/'**** picture of column slap matrix follows ****'/
     $     ' n, nelt and density = ',2i10,e16.7)
 1010 format(4x,255(i1))
 1020 format(1x,i3,a)
      end

*deck dtout
      subroutine dtout( n, nelt, ia, ja, a, isym, soln, rhs,
     $     iunit, job )
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym, job
      double precision a(nelt), rhs(n), soln(n)
      integer irhs, isoln, i
      irhs = 0
      isoln = 0
      if( job.eq.1 .or. job.eq.3 ) irhs = 1
      if( job.gt.1 ) isoln = 1
      write(iunit,1000) n, nelt, isym, irhs, isoln
      do 10 i = 1, nelt
         write(iunit,1010) ia(i), ja(i), a(i)
 10   continue
      if( irhs.eq.1 ) then
         write(iunit,1020) (rhs(i),i=1,n)
      endif
      if( isoln.eq.1 ) then
         write(iunit,1020) (soln(i),i=1,n)
      endif
      return
 1000 format(5i10)
 1010 format(1x,i5,1x,i5,1x,e16.7)
 1020 format(1x,e16.7)
      end

*deck dtin
      subroutine dtin( n, nelt, ia, ja, a, isym, soln, rhs,
     $     iunit, job )
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym, job
      double precision a(nelt), rhs(n), soln(n)
      integer irhs, isoln, i, neltmax
      neltmax = nelt
      read(iunit,1000) n, nelt, isym, irhs, isoln
      nelt = min( nelt, neltmax )
      do 10 i = 1, nelt
         read(iunit,1010) ia(i), ja(i), a(i)
 10   continue
      jobret = 0
      if( job.eq.1 .or. job.eq.3 ) then
         if( irhs.eq.1 ) then
            jobret = 1
            read(iunit,1020) (rhs(i),i=1,n)
         else
            do 20 i = 1, n
               rhs(i) = 0.0d0
 20         continue
         endif
      endif
      if( job.gt.1 ) then
         if( isoln.eq.1 ) then
            jobret = jobret + 2
            read(iunit,1020) (soln(i),i=1,n)
         else
            do 30 i = 1, n
               soln(i) = 0.0d0
 30         continue
         endif
      endif
      job = jobret
      return
 1000 format(5i10)
 1010 format(1x,i5,1x,i5,1x,e16.7)
 1020 format(1x,e16.7)
      end

*deck dsds
      subroutine dsds(n, nelt, ia, ja, a, isym, dinv)
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym
      double precision a(nelt), dinv(n)
 1    continue
      do 10 icol = 1, n
         dinv(icol) = 1.0d0/a(ja(icol))
 10   continue
      return
      end

*deck dsdscl
      subroutine dsdscl( n, nelt, ia, ja, a, isym, x, b, dinv, job,
     $     itol )
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym, job, itol
      double precision a(nelt), x(n), b(n), dinv(n)
      parameter(maxn=441)
      common /solblk/ soln(maxn)
      if( job.ne.0 ) then
         do 10 icol = 1, n
            dinv(icol) = 1.0d0/sqrt( a(ja(icol)) )
 10      continue
      else
         do 15 icol = 1, n
            dinv(icol) = 1.0d0/dinv(icol)
 15      continue
      endif
      do 30 icol = 1, n
         jbgn = ja(icol)
         jend = ja(icol+1)-1
         di = dinv(icol)
         do 20 j = jbgn, jend
            a(j) = dinv(ia(j))*a(j)*di
 20      continue
 30   continue
      do 40 icol = 1, n
         b(icol) = b(icol)*dinv(icol)
         x(icol) = x(icol)/dinv(icol)
 40   continue
      if( itol.eq.11 ) then
         do 50 icol = 1, n
            soln(icol) = soln(icol)/dinv(icol)
 50      continue
      endif
      return
      end

*deck dsd2s
      subroutine dsd2s(n, nelt, ia, ja, a, isym, dinv)
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym
      double precision a(nelt), dinv(n)
      do 10 i = 1, n
         dinv(i) = 0.
 10   continue
      do 40 i = 1, n
         kbgn = ja(i)
         kend = ja(i+1) - 1
         do 20 k = kbgn, kend
            dinv(ia(k)) = dinv(ia(k)) + a(k)**2
 20      continue
         if( isym.eq.1 ) then
            kbgn = kbgn + 1
            if( kbgn.le.kend ) then
               do 30 k = kbgn, kend
                  dinv(i) = dinv(i) + a(k)**2
 30            continue
            endif
         endif
 40   continue
      do 50 i=1,n
         dinv(i) = 1./dinv(i)
 50   continue
      return
      end

*deck ds2lt
      subroutine ds2lt( n, nelt, ia, ja, a, isym, nel, iel, jel, el )
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym 
      integer nel, iel(nel), jel(nel)
      double precision a(nelt), el(nelt)
      if( isym.eq.0 ) then
         nel = 0
         do 20 icol = 1, n
            jel(icol) = nel+1
            jbgn = ja(icol)
            jend = ja(icol+1)-1
            do 10 j = jbgn, jend
               if( ia(j).ge.icol ) then
                  nel = nel + 1
                  iel(nel) = ia(j)
                  el(nel)  = a(j)
               endif
 10         continue
 20      continue
         jel(n+1) = nel+1
      else
         nel = nelt
         do 30 i = 1, nelt
            iel(i) = ia(i)
            el(i) = a(i)
 30      continue
         do 40 i = 1, n+1
            jel(i) = ja(i)
 40      continue
      endif
      return
      end

*deck dsics
      subroutine dsics(n, nelt, ia, ja, a, isym, nel, iel, jel,
     $     el, d, r, iwarn )
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym
      integer nel, iel(nel), jel(nel)
      double precision a(nelt), el(nel), d(n), r(n)
      iwarn = 0
      nel = 1
      iel(1) = 1
      jel(1) = 1
      el(1) = 1.0d0
      d(1) = a(1)
      do 30 irow = 2, n
         nel = nel + 1
         iel(irow) = nel
         jel(nel) = irow
         el(nel) = 1.0d0
         d(irow) = a(ja(irow))
         if( isym.eq.0 ) then
            icbgn = ja(irow)
            icend = ja(irow+1)-1
         else
            icbgn = 1
            icend = irow-1
         endif
         do 20 ic = icbgn, icend
            if( isym.eq.0 ) then
               icol = ia(ic)
               if( icol.ge.irow ) goto 20
            else
               icol = ic
            endif
            jbgn = ja(icol)+1
            jend = ja(icol+1)-1
            if( jbgn.le.jend .and. ia(jend).ge.irow ) then
               do 10 j = jbgn, jend
                  if( ia(j).eq.irow ) then
                     nel = nel + 1
                     jel(nel) = icol
                     el(nel)  = a(j)
                     goto 20
                  endif
 10            continue
            endif
 20      continue
 30   continue
      iel(n+1) = nel+1
      do 60 irow = 2, n
         ibgn = iel(irow)+1
         iend = iel(irow+1)-1
         if( ibgn.lt.iend ) then
            do 50 i = ibgn, iend-1
               do 40 j = i+1, iend
                  if( jel(i).gt.jel(j) ) then
                     jeltmp = jel(j)
                     jel(j) = jel(i)
                     jel(i) = jeltmp
                     eltmp = el(j)
                     el(j) = el(i)
                     el(i) = eltmp
                  endif
 40            continue
 50         continue
         endif
 60   continue
      irbgn = ja(1)+1
      irend = ja(2)-1
      do 65 irr = irbgn, irend
         ir = ia(irr)
         i = iel(ir)+1
         el(i) = el(i)/d(1)
 65   continue
      do 110 irow = 2, n
         do 66 i = 1, irow-1
            r(i) = 0.0d0
 66      continue
         ibgn = iel(irow)+1
         iend = iel(irow+1)-1
         if( ibgn.le.iend ) then
            do 70 i = ibgn, iend
               r(jel(i)) = el(i)*d(jel(i))
               d(irow) = d(irow) - el(i)*r(jel(i))
 70         continue
            if( d(irow).le.0.0d0 ) then
               if( iwarn.eq.0 ) iwarn = irow
               d(irow) = 1.0d0
            endif
         endif
         irbgn = ja(irow)
         irend = ja(irow+1)-1
         do 100 irr = irbgn, irend
            ir = ia(irr)
            if( ir.le.irow ) goto 100
            ibgn = iel(ir)+1
            iend = iel(ir+1)-1
            if( jel(ibgn).gt.irow ) goto 100
            do 90 i = ibgn, iend
               if( jel(i).eq.irow ) then
                  icend = iend
 91               if( jel(icend).ge.irow ) then
                     icend = icend - 1
                     goto 91
                  endif
                  do 80 ic = ibgn, icend
                     el(i) = el(i) - el(ic)*r(jel(ic))
 80               continue
                  el(i) = el(i)/d(irow)
                  goto 100
               endif
 90         continue
            call xerrwv('dsics -- a and el data structure mismatch'//
     $           ' in row (i1)',53,1,2,1,irow,0,0,0.0,0.0)
 100     continue
 110  continue
      do 120 i =1, n
         d(i) = 1.0d0/d(i)
 120  continue
      return
      end

*deck dsilus
      subroutine dsilus(n, nelt, ia, ja, a, isym, nl, il, jl,
     $     l, dinv, nu, iu, ju, u, nrow, ncol)
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym, nl, il(nl), jl(nl)
      integer nu, iu(nu), ju(nu), nrow(n), ncol(n)
      double precision a(nelt), l(nl), dinv(n), u(nu)
      do 10 i=1,n
         nrow(i) = 0
         ncol(i) = 0
 10   continue
      do 30 icol = 1, n
         jbgn = ja(icol)+1
         jend = ja(icol+1)-1
         if( jbgn.le.jend ) then
            do 20 j = jbgn, jend
               if( ia(j).lt.icol ) then
                  ncol(icol) = ncol(icol) + 1
               else
                  nrow(ia(j)) = nrow(ia(j)) + 1
                  if( isym.ne.0 ) ncol(ia(j)) = ncol(ia(j)) + 1
               endif
 20         continue
         endif
 30   continue
      ju(1) = 1
      il(1) = 1
      do 40 icol = 1, n
         il(icol+1) = il(icol) + nrow(icol)
         ju(icol+1) = ju(icol) + ncol(icol)
         nrow(icol) = il(icol)
         ncol(icol) = ju(icol)
 40   continue
      do 60 icol = 1, n
         dinv(icol) = a(ja(icol))
         jbgn = ja(icol)+1
         jend = ja(icol+1)-1
         if( jbgn.le.jend ) then
            do 50 j = jbgn, jend
               irow = ia(j)
               if( irow.lt.icol ) then
                  iu(ncol(icol)) = irow
                  u(ncol(icol)) = a(j)
                  ncol(icol) = ncol(icol) + 1
               else
                  jl(nrow(irow)) = icol
                  l(nrow(irow)) = a(j)
                  nrow(irow) = nrow(irow) + 1
                  if( isym.ne.0 ) then
                     iu(ncol(irow)) = icol
                     u(ncol(irow)) = a(j)
                     ncol(irow) = ncol(irow) + 1
                  endif
               endif
 50         continue
         endif
 60   continue
      do 110 k = 2, n
         jbgn = ju(k)
         jend = ju(k+1)-1
         if( jbgn.lt.jend ) then
            do 80 j = jbgn, jend-1
               do 70 i = j+1, jend
                  if( iu(j).gt.iu(i) ) then
                     itemp = iu(j)
                     iu(j) = iu(i)
                     iu(i) = itemp
                     temp = u(j)
                     u(j) = u(i)
                     u(i) = temp
                  endif
 70            continue
 80         continue
         endif
         ibgn = il(k)
         iend = il(k+1)-1
         if( ibgn.lt.iend ) then
            do 100 i = ibgn, iend-1
               do 90 j = i+1, iend
                  if( jl(i).gt.jl(j) ) then
                     jtemp = ju(i)
                     ju(i) = ju(j)
                     ju(j) = jtemp
                     temp = l(i)
                     l(i) = l(j)
                     l(j) = temp
                  endif
 90            continue
 100        continue
         endif
 110  continue
      do 300 i=2,n
         indx1 = il(i)
         indx2 = il(i+1) - 1
         if(indx1 .gt. indx2) go to 200
         do 190 indx=indx1,indx2
            if(indx .eq. indx1) go to 180
            indxr1 = indx1
            indxr2 = indx - 1
            indxc1 = ju(jl(indx))
            indxc2 = ju(jl(indx)+1) - 1
            if(indxc1 .gt. indxc2) go to 180
 160        kr = jl(indxr1)
 170        kc = iu(indxc1)
            if(kr .gt. kc) then
               indxc1 = indxc1 + 1
               if(indxc1 .le. indxc2) go to 170
            elseif(kr .lt. kc) then
               indxr1 = indxr1 + 1
               if(indxr1 .le. indxr2) go to 160
            elseif(kr .eq. kc) then
               l(indx) = l(indx) - l(indxr1)*dinv(kc)*u(indxc1)
               indxr1 = indxr1 + 1
               indxc1 = indxc1 + 1
               if(indxr1 .le. indxr2 .and. indxc1 .le. indxc2) go to 160
            endif
 180        l(indx) = l(indx)/dinv(jl(indx))
 190     continue
 200     indx1 = ju(i)
         indx2 = ju(i+1) - 1
         if(indx1 .gt. indx2) go to 260
         do 250 indx=indx1,indx2
            if(indx .eq. indx1) go to 240
            indxc1 = indx1
            indxc2 = indx - 1
            indxr1 = il(iu(indx))
            indxr2 = il(iu(indx)+1) - 1
            if(indxr1 .gt. indxr2) go to 240
 210        kr = jl(indxr1)
 220        kc = iu(indxc1)
            if(kr .gt. kc) then
               indxc1 = indxc1 + 1
               if(indxc1 .le. indxc2) go to 220
            elseif(kr .lt. kc) then
               indxr1 = indxr1 + 1
               if(indxr1 .le. indxr2) go to 210
            elseif(kr .eq. kc) then
               u(indx) = u(indx) - l(indxr1)*dinv(kc)*u(indxc1)
               indxr1 = indxr1 + 1
               indxc1 = indxc1 + 1
               if(indxr1 .le. indxr2 .and. indxc1 .le. indxc2) go to 210
            endif
 240        u(indx) = u(indx)/dinv(iu(indx))
 250     continue
 260     indxr1 = il(i)
         indxr2 = il(i+1) - 1
         if(indxr1 .gt. indxr2) go to 300
         indxc1 = ju(i)
         indxc2 = ju(i+1) - 1
         if(indxc1 .gt. indxc2) go to 300
 270     kr = jl(indxr1)
 280     kc = iu(indxc1)
         if(kr .gt. kc) then
            indxc1 = indxc1 + 1
            if(indxc1 .le. indxc2) go to 280
         elseif(kr .lt. kc) then
            indxr1 = indxr1 + 1
            if(indxr1 .le. indxr2) go to 270
         elseif(kr .eq. kc) then
            dinv(i) = dinv(i) - l(indxr1)*dinv(kc)*u(indxc1)
            indxr1 = indxr1 + 1
            indxc1 = indxc1 + 1
            if(indxr1 .le. indxr2 .and. indxc1 .le. indxc2) go to 270
         endif
 300  continue
      do 430 i=1,n
         dinv(i) = 1./dinv(i)
 430  continue
      return
      end

*deck dsmv
      subroutine dsmv( n, x, y, nelt, ia, ja, a, isym )
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym
      double precision a(nelt), x(n), y(n)
      do 10 i = 1, n
         y(i) = 0.0d0
 10   continue
      do 30 icol = 1, n
         ibgn = ja(icol)
         iend = ja(icol+1)-1
         do 20 i = ibgn, iend
            y(ia(i)) = y(ia(i)) + a(i)*x(icol)
 20      continue
 30   continue
      if( isym.eq.1 ) then
         do 50 irow = 1, n
            jbgn = ja(irow)+1
            jend = ja(irow+1)-1
            if( jbgn.gt.jend ) goto 50
            do 40 j = jbgn, jend
               y(irow) = y(irow) + a(j)*x(ia(j))
 40         continue
 50      continue
      endif
      return
      end

*deck dsmtv
      subroutine dsmtv( n, x, y, nelt, ia, ja, a, isym )
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym
      double precision x(n), y(n), a(nelt)
      do 10 i = 1, n
         y(i) = 0.0d0
 10   continue
      do 30 irow = 1, n
         ibgn = ja(irow)
         iend = ja(irow+1)-1
         do 20 i = ibgn, iend
            y(irow) = y(irow) + a(i)*x(ia(i))
 20      continue
 30   continue
      if( isym.eq.1 ) then
         do 50 icol = 1, n
            jbgn = ja(icol)+1
            jend = ja(icol+1)-1
            if( jbgn.gt.jend ) goto 50
            do 40 j = jbgn, jend
               y(ia(j)) = y(ia(j)) + a(j)*x(icol)
 40         continue
 50      continue
      endif
      return
      end

*deck dsdi
      subroutine dsdi(n, b, x, nelt, ia, ja, a, isym, rwork, iwork)
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym, iwork(10)
      double precision b(n), x(n), a(nelt), rwork(1)
      locd = iwork(4) - 1
      do 10 i = 1, n
         x(i) = rwork(locd+i)*b(i)
 10   continue
      return
      end

*deck dsli
      subroutine dsli(n, b, x, nelt, ia, ja, a, isym, rwork, iwork )
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym, iwork(10)
      double precision b(n), x(n), a(nelt), rwork(1)
      nel = iwork(1)
      lociel = iwork(2)
      locjel = iwork(3)
      locel = iwork(4)
      call dsli2(n, b, x, nel, iwork(lociel), iwork(locjel),
     $     rwork(locel))
      return
      end

*deck dsli2
      subroutine dsli2(n, b, x, nel, iel, jel, el)
      implicit double precision(a-h,o-z)
      integer n, nel, iel(nel), jel(nel)
      double precision b(n), x(n), el(nel)
      do 10 i=1,n
         x(i) = b(i)
 10   continue
      do 30 icol = 1, n
         x(icol) = x(icol)/el(jel(icol))
         jbgn = jel(icol) + 1
         jend = jel(icol+1) - 1
         if( jbgn.le.jend ) then
            do 20 j = jbgn, jend
               x(iel(j)) = x(iel(j)) - el(j)*x(icol)
 20         continue
         endif
 30   continue
      return
      end

*deck dsllti
      subroutine dsllti(n, b, x, nelt, ia, ja, a, isym, rwork, iwork)
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym, iwork(1)
      double precision b(1), x(1), a(nelt), rwork(1)
      nel = iwork(1)
      lociel = iwork(3)
      locjel = iwork(2)
      locel  = iwork(4)
      locdin = iwork(5)
      call sllti2(n, b, x, nel, iwork(lociel), iwork(locjel),
     $     rwork(locel), rwork(locdin))
      return
      end

*deck sllti2
      subroutine sllti2(n, b, x, nel, iel, jel, el, dinv)
      implicit double precision(a-h,o-z)
      integer n, nel, iel(nel), jel(1)
      double precision b(n), x(n), el(nel), dinv(n)
      do 10 i=1,n
         x(i) = b(i)
 10   continue
      do 30 irow = 1, n
         ibgn = iel(irow) + 1
         iend = iel(irow+1) - 1
         if( ibgn.le.iend ) then
            do 20 i = ibgn, iend
               x(irow) = x(irow) - el(i)*x(jel(i))
 20         continue
         endif
 30   continue
      do 40 i=1,n
         x(i) = x(i)*dinv(i)
 40   continue
      do 60 irow = n, 2, -1
         ibgn = iel(irow) + 1
         iend = iel(irow+1) - 1
         if( ibgn.le.iend ) then
            do 50 i = ibgn, iend
               x(jel(i)) = x(jel(i)) - el(i)*x(irow)
 50         continue
         endif
 60   continue
      return
      end

*deck dslui
      subroutine dslui(n, b, x, nelt, ia, ja, a, isym, rwork, iwork)
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym, iwork(10)
      double precision b(n), x(n), a(nelt), rwork(1)
      locil = iwork(1)
      locjl = iwork(2)
      lociu = iwork(3)
      locju = iwork(4)
      locl = iwork(5)
      locdin = iwork(6)
      locu = iwork(7)
      call dslui2(n, b, x, iwork(locil), iwork(locjl), rwork(locl),
     $     rwork(locdin), iwork(lociu), iwork(locju), rwork(locu) )
      return
      end

*deck dslui2
      subroutine dslui2(n, b, x, il, jl, l, dinv, iu, ju, u )
      implicit double precision(a-h,o-z)
      integer n, il(1), jl(1), iu(1), ju(1)
      double precision b(n), x(n), l(1), dinv(n), u(1)
      do 10 i = 1, n
         x(i) = b(i)
 10   continue
      do 30 irow = 2, n
         jbgn = il(irow)
         jend = il(irow+1)-1
         if( jbgn.le.jend ) then
            do 20 j = jbgn, jend
               x(irow) = x(irow) - l(j)*x(jl(j))
 20         continue
         endif
 30   continue
      do 40 i=1,n
         x(i) = x(i)*dinv(i)
 40   continue
      do 60 icol = n, 2, -1
         jbgn = ju(icol)
         jend = ju(icol+1)-1
         if( jbgn.le.jend ) then
            do 50 j = jbgn, jend
               x(iu(j)) = x(iu(j)) - u(j)*x(icol)
 50         continue
         endif
 60   continue
      return
      end

*deck dsluti
      subroutine dsluti(n, b, x, nelt, ia, ja, a, isym, rwork, iwork)
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym, iwork(10)
      double precision b(n), x(n), a(n), rwork(1)
      locil = iwork(1)
      locjl = iwork(2)
      lociu = iwork(3)
      locju = iwork(4)
      locl = iwork(5)
      locdin = iwork(6)
      locu = iwork(7)
      call dslui4(n, b, x, iwork(locil), iwork(locjl), rwork(locl),
     $     rwork(locdin), iwork(lociu), iwork(locju), rwork(locu))
      return
      end

*deck dslui4
      subroutine dslui4(n, b, x, il, jl, l, dinv, iu, ju, u )
      implicit double precision(a-h,o-z)
      integer n, il(*), jl(*), iu(*), ju(*)
      double precision b(n), x(n), l(*), dinv(n), u(*)
      do 10 i=1,n
         x(i) = b(i)
 10   continue
      do 80 irow = 2, n
         jbgn = ju(irow)
         jend = ju(irow+1) - 1
         if( jbgn.le.jend ) then
            do 70 j = jbgn, jend
               x(irow) = x(irow) - u(j)*x(iu(j))
 70         continue
         endif
 80   continue
      do 90 i = 1, n
         x(i) = x(i)*dinv(i)
 90   continue
      do 110 icol = n, 2, -1
         jbgn = il(icol)
         jend = il(icol+1) - 1
         if( jbgn.le.jend ) then
            do 100 j = jbgn, jend
               x(jl(j)) = x(jl(j)) - l(j)*x(icol)
 100        continue
         endif
 110  continue
      return
      end

*deck dsmmti
      subroutine dsmmti(n, b, x, nelt, ia, ja, a, isym, rwork, iwork )
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym, iwork(10)
      double precision b(n), x(n), a(nelt), rwork(1)
      locil = iwork(1)
      locjl = iwork(2)
      lociu = iwork(3)
      locju = iwork(4)
      locl = iwork(5)
      locdin = iwork(6)
      locu = iwork(7)
      call dsmmi2(n, b, x, iwork(locil), iwork(locjl),
     $     rwork(locl), rwork(locdin), iwork(lociu),
     $     iwork(locju), rwork(locu))
      return
      end

*deck dsmmi2
      subroutine dsmmi2( n, b, x, il, jl, l, dinv, iu, ju, u )
      implicit double precision(a-h,o-z)
      integer n, il(1), jl(1), iu(1), ju(1)
      double precision b(n), x(n), l(1), dinv(n), u(n)
      do 10 i = 1, n
         x(i) = b(i)
 10   continue
      do 30 irow = 2, n
         jbgn = il(irow)
         jend = il(irow+1)-1
         if( jbgn.le.jend ) then
            do 20 j = jbgn, jend
               x(irow) = x(irow) - l(j)*x(jl(j))
 20         continue
         endif
 30   continue
      do 40 i=1,n
         x(i) = x(i)*dinv(i)
 40   continue
      do 60 icol = n, 2, -1
         jbgn = ju(icol)
         jend = ju(icol+1)-1
         if( jbgn.le.jend ) then
            do 50 j = jbgn, jend
               x(iu(j)) = x(iu(j)) - u(j)*x(icol)
 50         continue
         endif
 60   continue
      do 80 irow = 2, n
         jbgn = ju(irow)
         jend = ju(irow+1) - 1
         if( jbgn.le.jend ) then
            do 70 j = jbgn, jend
               x(irow) = x(irow) - u(j)*x(iu(j))
 70         continue
         endif
 80   continue
      do 90 i = 1, n
         x(i) = x(i)*dinv(i)
 90   continue
      do 110 icol = n, 2, -1
         jbgn = il(icol)
         jend = il(icol+1) - 1
         if( jbgn.le.jend ) then
            do 100 j = jbgn, jend
               x(jl(j)) = x(jl(j)) - l(j)*x(icol)
 100        continue
         endif
 110  continue
      return
      end

*deck domn
      subroutine domn( n, b, x, nelt, ia, ja, a, isym, matvec, msolve, 
     $     nsave, itol, tol, itmax, iter, err, ierr, iunit, r, z, p, 
     $     ap, emap, dz, csav, rwork, iwork )
      implicit double precision(a-h,o-z)
      integer  n, nelt, ia(nelt), ja(nelt), isym, nsave, itol, itmax
      integer  iter, ierr, iunit, iwork(*)
      double precision b(n), x(n), a(nelt), tol, err, r(n), z(n) 
      double precision p(n,0:nsave), ap(n,0:nsave), emap(n,0:nsave)
      double precision dz(n), csav(nsave), rwork(*)
      external matvec, msolve
      iter = 0
      ierr = 0
      if( n.lt.1 ) then
         ierr = 3
         return
      endif
      eps = d1mach(3)
      if( tol.lt.500.0*eps ) then
         tol = 500.0*eps
         ierr = 4
      endif
      fuzz = eps*eps
      call matvec(n, x, r, nelt, ia, ja, a, isym)
      do 10 i = 1, n
         r(i)  = b(i) - r(i)
 10   continue
      call msolve(n, r, z, nelt, ia, ja, a, isym, rwork, iwork)
      if( isdomn(n, b, x, nelt, ia, ja, a, isym, msolve, nsave,
     $     itol, tol, itmax, iter, err, ierr, iunit,
     $     r, z, p, ap, emap, dz, csav,
     $     rwork, iwork, ak, bnrm, solnrm) .ne. 0 ) go to 200
      if( ierr.ne.0 ) return
      do 100 k = 1, itmax
         iter = k
         ip = mod( iter-1, nsave+1 )
         call dcopy(n, z, 1, p(1,ip), 1)
         call matvec(n, p(1,ip), ap(1,ip), nelt, ia, ja, a, isym)
         call msolve(n, ap(1,ip), emap(1,ip), nelt, ia, ja, a, isym,
     $        rwork, iwork)
         if( nsave.eq.0 ) then
            akden = ddot(n, emap, 1, emap, 1)
         else
            if( iter.gt.1 ) then
               lmax = min( nsave, iter-1 )
               do 20 l = 1, lmax
                  ipo = mod(ip+(nsave+1-l),nsave+1)
                  bkl = ddot(n, emap(1,ip), 1, emap(1,ipo), 1)
                  bkl = bkl*csav(l)
                  call daxpy(n, -bkl,    p(1,ipo), 1,    p(1,ip), 1)
                  call daxpy(n, -bkl,   ap(1,ipo), 1,   ap(1,ip), 1)
                  call daxpy(n, -bkl, emap(1,ipo), 1, emap(1,ip), 1)
 20            continue
               if( nsave.gt.1 ) then
                  do 30 l = nsave-1, 1, -1
                     csav(l+1) = csav(l)
 30               continue
               endif
            endif
            akden = ddot(n, emap(1,ip), 1, emap(1,ip), 1)
            if( abs(akden).lt.eps*eps ) then
               ierr = 6
               return
            endif
            csav(1) = 1./akden
         endif
         aknum = ddot(n, z, 1, emap(1,ip), 1)
         ak = aknum/akden
         call daxpy(n,  ak,    p(1,ip), 1, x, 1)
         call daxpy(n, -ak,   ap(1,ip), 1, r, 1)
         call daxpy(n, -ak, emap(1,ip), 1, z, 1)
         if( isdomn(n, b, x, nelt, ia, ja, a, isym, msolve, nsave,
     $        itol, tol, itmax, iter, err, ierr, iunit,
     $        r, z, p, ap, emap, dz, csav,
     $        rwork, iwork, ak, bnrm, solnrm) .ne. 0 ) go to 200
 100  continue
      iter = itmax + 1
      ierr = 2
 200  return
      end

*deck dsdomn
      subroutine dsdomn(n, b, x, nelt, ia, ja, a, isym, nsave,
     $     itol, tol, itmax, iter, err, ierr, iunit,
     $     rwork, lenw, iwork, leniw )
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym, nsave, itol, itmax
      integer iter, ierr, iunit, lenw, iwork(leniw), leniw
      double precision b(n), x(n), a(n), tol, err, rwork(lenw)
      external dsmv, dsdi
      parameter (locrb=1, locib=11)
      ierr = 0
      if( n.lt.1 .or. nelt.lt.1 ) then
         ierr = 3
         return
      endif
      call ds2y( n, nelt, ia, ja, a, isym )
      lociw = locib
      locdin = locrb
      locr = locdin + n
      locz = locr + n
      locp = locz + n
      locap = locp + n*(nsave+1)
      locema = locap + n*(nsave+1)
      locdz = locema + n*(nsave+1)
      loccsa = locdz + n
      locw = loccsa + nsave
      call dchkw( 'dsdomn', lociw, leniw, locw, lenw, ierr, iter, err )
      if( ierr.ne.0 ) return
      iwork(4) = locdin
      iwork(9) = lociw
      iwork(10) = locw
      call dsds(n, nelt, ia, ja, a, isym, rwork(locdin))
      call domn(n, b, x, nelt, ia, ja, a, isym, dsmv, 
     $     dsdi, nsave, itol, tol, itmax, iter, err, ierr, iunit,
     $     rwork(locr), rwork(locz), rwork(locp), rwork(locap),
     $     rwork(locema), rwork(locdz), rwork(loccsa),
     $     rwork, iwork )
      return
      end

*deck dsluom
      subroutine dsluom(n, b, x, nelt, ia, ja, a, isym, nsave,
     $     itol, tol, itmax, iter, err, ierr, iunit,
     $     rwork, lenw, iwork, leniw )
      implicit double precision(a-h,o-z)
      integer n, nelt, ia(nelt), ja(nelt), isym, nsave, itol, itmax
      integer iter, ierr, iunit, lenw, iwork(leniw), leniw
      double precision b(n), x(n), a(n), rwork(lenw)
      external dsmv, dslui
      parameter (locrb=1, locib=11)
      ierr = 0
      if( n.lt.1 .or. nelt.lt.1 ) then
         ierr = 3
         return
      endif
      call ds2y( n, nelt, ia, ja, a, isym )
      nl = 0
      nu = 0
      do 20 icol = 1, n
         jbgn = ja(icol)+1
         jend = ja(icol+1)-1
         if( jbgn.le.jend ) then
            do 10 j = jbgn, jend
               if( ia(j).gt.icol ) then
                  nl = nl + 1
                  if( isym.ne.0 ) nu = nu + 1
               else
                  nu = nu + 1
               endif
 10         continue
         endif
 20   continue
      locil = locib
      locjl = locil + n+1
      lociu = locjl + nl
      locju = lociu + nu
      locnr = locju + n+1
      locnc = locnr + n
      lociw = locnc + n
      locl   = locrb
      locdin = locl + nl
      locu   = locdin + n
      locr   = locu + nu
      locz   = locr + n
      locp   = locz + n
      locap  = locp + n*(nsave+1)
      locema = locap + n*(nsave+1)
      locdz  = locema + n*(nsave+1)
      loccsa = locdz + n
      locw   = loccsa + nsave
      call dchkw( 'dsluom', lociw, leniw, locw, lenw, ierr, iter, err )
      if( ierr.ne.0 ) return
      iwork(1) = locil
      iwork(2) = locjl
      iwork(3) = lociu
      iwork(4) = locju
      iwork(5) = locl
      iwork(6) = locdin
      iwork(7) = locu
      iwork(9) = lociw
      iwork(10) = locw
      call dsilus( n, nelt, ia, ja, a, isym, nl, iwork(locil),
     $     iwork(locjl), rwork(locl), rwork(locdin), nu, iwork(lociu),
     $     iwork(locju), rwork(locu), iwork(locnr), iwork(locnc) )
      call domn(n, b, x, nelt, ia, ja, a, isym, dsmv,
     $     dslui, nsave, itol, tol, itmax, iter, err, ierr, iunit,
     $     rwork(locr), rwork(locz), rwork(locp), rwork(locap),
     $     rwork(locema), rwork(locdz), rwork(loccsa),
     $     rwork, iwork )
      return
      end

*deck isdomn
      function isdomn(n, b, x, nelt, ia, ja, a, isym, msolve, nsave,
     $     itol, tol, itmax, iter, err, ierr, iunit,
     $     r, z, p, ap, emap, dz, csav,
     $     rwork, iwork, ak, bnrm, solnrm)
      implicit double precision(a-h,o-z)
      integer  n, nelt, ia(nelt), ja(nelt), isym, nsave, itol, itmax
      integer  iter, iunit, iwork(*)
      double precision b(n), x(n), a(nelt), tol, err, r(n), z(n)
      double precision p(n,0:nsave), ap(n,0:nsave), emap(n,0:nsave)
      double precision dz(n), csav(nsave), rwork(*)
      external msolve
      parameter(maxn=441)
      common /solblk/ soln(maxn)
      isdomn = 0
      if( itol.eq.1 ) then
         if(iter .eq. 0) bnrm = dnrm2(n, b, 1)
         err = dnrm2(n, r, 1)/bnrm
      else if( itol.eq.2 ) then
         if(iter .eq. 0) then
            call msolve(n, b, dz, nelt, ia, ja, a, isym, rwork, iwork)
            bnrm = dnrm2(n, dz, 1)
         endif
         err = dnrm2(n, z, 1)/bnrm
      else if( itol.eq.11 ) then
         if(iter .eq. 0) solnrm = dnrm2(n, soln, 1)
         do 10 i = 1, n
            dz(i) = x(i) - soln(i)
 10      continue
         err = dnrm2(n, dz, 1)/solnrm
      else
         err = 1.0e10
         ierr = 3
      endif
      if(iunit .ne. 0) then
         if( iter.eq.0 ) then
            write(iunit,1000) nsave, n, itol
         endif
         write(iunit,1010) iter, err, ak
      endif
      if(err .le. tol) isdomn = 1
      return
 1000 format(' preconditioned orthomin(',i3,') for ',
     $     'n, itol = ',i5, i5,
     $     /' iter','   error estimate','            alpha')
 1010 format(1x,i4,1x,e16.7,1x,e16.7)
      end

! *deck xerabt
!      subroutine xerabt(messg,nmessg)
!      dimension messg(nmessg)
!      call exit(1)
!      end

*deck xerctl
      subroutine xerctl(messg1,nmessg,nerr,level,kontrl)
      character*20 messg1
      return
      end

*deck xerprt
      subroutine xerprt(messg,nmessg)
      integer lun(5)
      character*(*) messg
      call xgetua(lun,nunit)
      lenmes = len(messg)
      do 20 kunit=1,nunit
         iunit = lun(kunit)
         if (iunit.eq.0) iunit = i1mach(4)
         do 10 ichar=1,lenmes,72
            last = min0(ichar+71 , lenmes)
            write (iunit,'(1x,a)') messg(ichar:last)
   10    continue
   20 continue
      return
      end

*deck xerror
      subroutine xerror(messg,nmessg,nerr,level)
      character*(*) messg
      call xerrwv(messg,nmessg,nerr,level,0,0,0,0,0.,0.)
      return
      end

*deck xerrwv
      subroutine xerrwv(messg,nmessg,nerr,level,ni,i1,i2,nr,r1,r2)
      character*(*) messg
      character*20 lfirst
      character*37 morf
      dimension lun(5)
      lkntrl = j4save(2,0,.false.)
      maxmes = j4save(4,0,.false.)
      if ((nmessg.gt.0).and.(nerr.ne.0).and.
     1    (level.ge.(-1)).and.(level.le.2)) go to 10
         if (lkntrl.gt.0) call xerprt('fatal error in...',17)
         call xerprt('xerror -- invalid input',23)
         if (lkntrl.gt.0) call xerprt('job abort due to fatal error.',
     1  29)
         if (lkntrl.gt.0) call xersav(' ',0,0,0,kdummy)
         call xerabt('xerror -- invalid input',23)
         return
   10 continue
      junk = j4save(1,nerr,.true.)
      call xersav(messg,nmessg,nerr,level,kount)
      lfirst = messg
      lmessg = nmessg
      lerr = nerr
      llevel = level
      call xerctl(lfirst,lmessg,lerr,llevel,lkntrl)
      lmessg = nmessg
      lerr = nerr
      llevel = level
      lkntrl = max0(-2,min0(2,lkntrl))
      mkntrl = iabs(lkntrl)
      if ((llevel.lt.2).and.(lkntrl.eq.0)) go to 100
      if (((llevel.eq.(-1)).and.(kount.gt.min0(1,maxmes)))
     1.or.((llevel.eq.0)   .and.(kount.gt.maxmes))
     2.or.((llevel.eq.1)   .and.(kount.gt.maxmes).and.(mkntrl.eq.1))
     3.or.((llevel.eq.2)   .and.(kount.gt.max0(1,maxmes)))) go to 100
         if (lkntrl.le.0) go to 20
            call xerprt(' ',1)
            if (llevel.eq.(-1)) call xerprt
     1('warning message...this message will only be printed once.',57)
            if (llevel.eq.0) call xerprt('warning in...',13)
            if (llevel.eq.1) call xerprt
     1      ('recoverable error in...',23)
            if (llevel.eq.2) call xerprt('fatal error in...',17)
   20    continue
         call xerprt(messg,lmessg)
         call xgetua(lun,nunit)
         isizei = log10(float(i1mach(9))) + 1.0
         isizef = log10(float(i1mach(10))**i1mach(11)) + 1.0
         do 50 kunit=1,nunit
            iunit = lun(kunit)
            if (iunit.eq.0) iunit = i1mach(4)
            do 22 i=1,min(ni,2)
               write (morf,21) i,isizei
   21          format ('(11x,21hin above message, i',i1,'=,i',i2,')   ')
               if (i.eq.1) write (iunit,morf) i1
               if (i.eq.2) write (iunit,morf) i2
   22       continue
            do 24 i=1,min(nr,2)
               write (morf,23) i,isizef+10,isizef
   23          format ('(11x,21hin above message, r',i1,'=,e',
     1         i2,'.',i2,')')
               if (i.eq.1) write (iunit,morf) r1
               if (i.eq.2) write (iunit,morf) r2
   24       continue
            if (lkntrl.le.0) go to 40
               write (iunit,30) lerr
   30          format (15h error number =,i10)
   40       continue
   50    continue
  100 continue
      ifatal = 0
      if ((llevel.eq.2).or.((llevel.eq.1).and.(mkntrl.eq.2)))
     1ifatal = 1
      if (ifatal.le.0) return
      if ((lkntrl.le.0).or.(kount.gt.max0(1,maxmes))) go to 120
         if (llevel.eq.1) call xerprt
     1   ('job abort due to unrecovered error.',35)
         if (llevel.eq.2) call xerprt
     1   ('job abort due to fatal error.',29)
         call xersav(' ',-1,0,0,kdummy)
  120 continue
      if ((llevel.eq.2).and.(kount.gt.max0(1,maxmes))) lmessg = 0
      call xerabt(messg,lmessg)
      return
      end

*deck xersav
      subroutine xersav(messg,nmessg,nerr,level,icount)
      integer lun(5)
      character*(*) messg
      character*20 mestab(10),mes
      dimension nertab(10),levtab(10),kount(10)
      save mestab,nertab,levtab,kount,kountx
      data kount(1),kount(2),kount(3),kount(4),kount(5),
     1     kount(6),kount(7),kount(8),kount(9),kount(10)
     2     /0,0,0,0,0,0,0,0,0,0/
      data kountx/0/
      if (nmessg.gt.0) go to 80
         if (kount(1).eq.0) return
         call xgetua(lun,nunit)
         do 60 kunit=1,nunit
            iunit = lun(kunit)
            if (iunit.eq.0) iunit = i1mach(4)
            write (iunit,10)
   10       format (32h0          error message summary/
     1      51h message start             nerr     level     count)
            do 20 i=1,10
               if (kount(i).eq.0) go to 30
               write (iunit,15) mestab(i),nertab(i),levtab(i),kount(i)
   15          format (1x,a20,3i10)
   20       continue
   30       continue
            if (kountx.ne.0) write (iunit,40) kountx
   40       format (41h0other errors not individually tabulated=,i10)
            write (iunit,50)
   50       format (1x)
   60    continue
         if (nmessg.lt.0) return
         do 70 i=1,10
   70       kount(i) = 0
         kountx = 0
         return
   80 continue
      mes = messg
      do 90 i=1,10
         ii = i
         if (kount(i).eq.0) go to 110
         if (mes.ne.mestab(i)) go to 90
         if (nerr.ne.nertab(i)) go to 90
         if (level.ne.levtab(i)) go to 90
         go to 100
   90 continue
         kountx = kountx+1
         icount = 1
         return
  100    kount(ii) = kount(ii) + 1
         icount = kount(ii)
         return
  110    mestab(ii) = mes
         nertab(ii) = nerr
         levtab(ii) = level
         kount(ii)  = 1
         icount = 1
         return
      end

!     subroutine xgetua(iunita,n)
!     dimension iunita(5)
!     n = j4save(5,0,.false.)
!     do 30 i=1,n
!        index = i+4
!        if (i.eq.1) index = 3
!        iunita(i) = j4save(index,0,.false.)
!  30 continue
!     return
!     end

!     function j4save(iwhich,ivalue,iset)
!     logical iset
!     integer iparam(9)
!     save iparam
!     data iparam(1),iparam(2),iparam(3),iparam(4)/0,2,0,10/
!     data iparam(5)/1/
!     data iparam(6),iparam(7),iparam(8),iparam(9)/0,0,0,0/
!     j4save = iparam(iwhich)
!     if (iset) iparam(iwhich) = ivalue
!     return
!     end

!     subroutine xerdmp
!     call xersav(' ',0,0,0,kount)
!     return
!     end

!     subroutine xgetun(iunit)
!     iunit = j4save(3,0,.false.)
!     return
!     end

!     subroutine xsetua(iunita,n)
!     dimension iunita(5)
!     if ((n.ge.1).and.(n.le.5)) go to 10
!        call xerrwv('xsetua -- invalid value of n (i1).',34,1,2,
!    1  1,n,0,0,0.,0.)
!        return
!  10 continue
!     do 20 i=1,n
!        index = i+4
!        if (i.eq.1) index = 3
!        junk = j4save(index,iunita(i),.true.)
!  20 continue
!     junk = j4save(5,n,.true.)
!     return
!     end

!     subroutine xsetun(iunit)
!     junk = j4save(3,iunit,.true.)
!     junk = j4save(5,1,.true.)
!     return
!     end

      function rand(r)
      save ia1, ia0, ia1ma0, ic, ix1, ix0
      data ia1, ia0, ia1ma0 /1536, 1029, 507/
      data ic /1731/
      data ix1, ix0 /0, 0/
      if (r.lt.0.) go to 10
      if (r.gt.0.) go to 20
      iy0 = ia0*ix0
      iy1 = ia1*ix1 + ia1ma0*(ix0-ix1) + iy0
      iy0 = iy0 + ic
      ix0 = mod (iy0, 2048)
      iy1 = iy1 + (iy0-ix0)/2048
      ix1 = mod (iy1, 2048)
 10   rand = ix1*2048 + ix0
      rand = rand / 4194304.
      return
 20   ix1 = amod(r,1.)*4194304. + 0.5
      ix0 = mod (ix1, 2048)
      ix1 = (ix1-ix0)/2048
      go to 10
      end
//ft05f001 dd *
3
/*

#pragma -xO
      implicit none
      parameter (n = 1000)
      parameter (lda = n + 1)
      integer k, lda, i, info, in, ipvt(n)
      real*8 a(lda, n), b(n), cray, eps, epslon
      real*8 norma, normx, ops, resid, residn, t1, t2, time(6), total, x(n)
      write (*, '(a)') 'linpack_bench_d'
      write (*, '(a)') '  the linpack benchmark.'
      write (*, '(a)') '  language: fortran77'
      write (*, '(a)') '  datatype: real real*8'
      write (*, '(a, i8)') '  matrix order n =               ', n
      write (*, '(a, i8)') '  leading matrix dimension lda = ', lda
      cray = .056
      ops = (2.0d0*dfloat(n)**3)/3.0d0 + 2.0d0*dfloat(n)**2
      do k =1, 10
         call matgen(a, lda, n, b, norma)
         call cputim (t1)
         call dgefa(a, lda, n, ipvt, info)
         call cputim (t2)
         time(1) = t2 - t1
         call cputim (t1)
         call dgesl(a, lda, n, ipvt, b, 0)
         call cputim (t2)
         time(2) = t2 - t1
         total = time(1) + time(2)
         do i = 1, n
            x(i) = b(i)
         end do
         call matgen(a, lda, n, b, norma)
         do i = 1, n
            b(i) = -b(i)
         end do
         call dmxpy(n, b, n, lda, x, a)
         resid = 0.0
         normx = 0.0
         do i = 1, n
            resid = dmax1(resid, dabs(b(i)))
            normx = dmax1(normx, dabs(x(i)))
         end do
         eps = epslon(1.0d0)
         residn = resid/(n*norma*normx*eps)
         write(6, 40)
   40    format('     norm. resid resid machep', 
     $          '         x(1)          x(n)')
         write(6, 50) residn, resid, eps, x(1), x(n)
   50    format(5(1pe16.8))
         write(6, 70)
   70    format(6x, 'factor', 5x, 'solve', 6x, 'total', 5x, 'mflops', 7x, 'unit', 
     $         6x, 'ratio')
         time(3) = total
         time(4) = ops/(1.0d6*total)
         time(5) = 2.0d0/time(4)
         time(6) = total/cray
         write(6, 110) (time(i), i=1, 6)
  110    format(6(1pe11.3))
      end do
      end

      subroutine matgen(a, lda, n, b, norma)
      integer lda, n, init(4), i, j
      real*8 a(lda, 1), b(1), norma, random_value
      init(1) = 1
      init(2) = 2
      init(3) = 3
      init(4) = 1325
      norma = 0.0
      do 30 j = 1, n
         do 20 i = 1, n
            a(i, j) = random_value(init) - .5
            norma = dmax1(dabs(a(i, j)), norma)
   20    continue
   30 continue
      do 35 i = 1, n
          b(i) = 0.0
   35 continue
      do 50 j = 1, n
         do 40 i = 1, n
            b(i) = b(i) + a(i, j)
   40    continue
   50 continue
      return
      end

      subroutine dgefa(a, lda, n, ipvt, info)
      integer lda, n, ipvt(1), info
      real*8 a(lda, 1)
      real*8 t
      integer idamax, j, k, kp1, l, nm1
      info = 0
      nm1 = n - 1
      if (nm1 .lt. 1) go to 70
      do 60 k = 1, nm1
         kp1 = k + 1
         l = idamax(n-k+1, a(k, k), 1) + k - 1
         ipvt(k) = l
         if (a(l, k) .eq. 0.0d0) go to 40
            if (l .eq. k) go to 10
               t = a(l, k)
               a(l, k) = a(k, k)
               a(k, k) = t
   10       continue
            t = -1.0d0/a(k, k)
            call dscal(n-k, t, a(k+1, k), 1)
            do 30 j = kp1, n
               t = a(l, j)
               if (l .eq. k) go to 20
                  a(l, j) = a(k, j)
                  a(k, j) = t
   20          continue
               call daxpy(n-k, t, a(k+1, k), 1, a(k+1, j), 1)
   30       continue
         go to 50
   40    continue
            info = k
   50    continue
   60 continue
   70 continue
      ipvt(n) = n
      if (a(n, n) .eq. 0.0d0) info = n
      return
      end

      subroutine dgesl(a, lda, n, ipvt, b, job)
      integer lda, n, ipvt(1), job
      real*8 a(lda, 1), b(1)
      real*8 ddot, t
      integer k, kb, l, nm1
      nm1 = n - 1
      if (job .ne. 0) go to 50
         if (nm1 .lt. 1) go to 30
         do 20 k = 1, nm1
            l = ipvt(k)
            t = b(l)
            if (l .eq. k) go to 10
               b(l) = b(k)
               b(k) = t
   10       continue
            call daxpy(n-k, t, a(k+1, k), 1, b(k+1), 1)
   20    continue
   30    continue
         do 40 kb = 1, n
            k = n + 1 - kb
            b(k) = b(k)/a(k, k)
            t = -b(k)
            call daxpy(k-1, t, a(1, k), 1, b(1), 1)
   40    continue
      go to 100
   50 continue
         do 60 k = 1, n
            t = ddot(k-1, a(1, k), 1, b(1), 1)
            b(k) = (b(k) - t)/a(k, k)
   60    continue
         if (nm1 .lt. 1) go to 90
         do 80 kb = 1, nm1
            k = n - kb
            b(k) = b(k) + ddot(n-k, a(k+1, k), 1, b(k+1), 1)
            l = ipvt(k)
            if (l .eq. k) go to 70
               t = b(l)
               b(l) = b(k)
               b(k) = t
   70       continue
   80    continue
   90    continue
  100 continue
      return
      end

      subroutine daxpy(n, da, dx, incx, dy, incy)
      real*8 dx(1), dy(1), da
      integer i, incx, incy, ix, iy, m, mp1, n
      if(n.le.0)return
      if (da .eq. 0.0d0) return
      if(incx.eq.1.and.incy.eq.1)go to 20
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1, n
        dy(iy) = dy(iy) + da*dx(ix)
        ix = ix + incx
        iy = iy + incy
   10 continue
      return
   20 m = mod(n, 4)
      if(m .eq. 0) go to 40
      do 30 i = 1, m
        dy(i) = dy(i) + da*dx(i)
   30 continue
      if(n .lt. 4) return
   40 mp1 = m + 1
      do 50 i = mp1, n, 4
        dy(i) = dy(i) + da*dx(i)
        dy(i + 1) = dy(i + 1) + da*dx(i + 1)
        dy(i + 2) = dy(i + 2) + da*dx(i + 2)
        dy(i + 3) = dy(i + 3) + da*dx(i + 3)
   50 continue
      return
      end

      real*8 function ddot(n, dx, incx, dy, incy)
      real*8 dx(1), dy(1), dtemp
      integer i, incx, incy, ix, iy, m, mp1, n
      ddot = 0.0d0
      dtemp = 0.0d0
      if(n.le.0)return
      if(incx.eq.1.and.incy.eq.1)go to 20
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1, n
        dtemp = dtemp + dx(ix)*dy(iy)
        ix = ix + incx
        iy = iy + incy
   10 continue
      ddot = dtemp
      return
   20 m = mod(n, 5)
      if(m .eq. 0) go to 40
      do 30 i = 1, m
        dtemp = dtemp + dx(i)*dy(i)
   30 continue
      if(n .lt. 5) go to 60
   40 mp1 = m + 1
      do 50 i = mp1, n, 5
        dtemp = dtemp + dx(i)*dy(i) + dx(i + 1)*dy(i + 1) +
     *   dx(i + 2)*dy(i + 2) + dx(i + 3)*dy(i + 3) + dx(i + 4)*dy(i + 4)
   50 continue
   60 ddot = dtemp
      return
      end

      subroutine dscal(n, da, dx, incx)
      real*8 da, dx(1)
      integer i, incx, m, mp1, n, nincx
      if(n.le.0)return
      if(incx.eq.1)go to 20
      nincx = n*incx
      do 10 i = 1, nincx, incx
        dx(i) = da*dx(i)
   10 continue
      return
   20 m = mod(n, 5)
      if(m .eq. 0) go to 40
      do 30 i = 1, m
        dx(i) = da*dx(i)
   30 continue
      if(n .lt. 5) return
   40 mp1 = m + 1
      do 50 i = mp1, n, 5
        dx(i) = da*dx(i)
        dx(i + 1) = da*dx(i + 1)
        dx(i + 2) = da*dx(i + 2)
        dx(i + 3) = da*dx(i + 3)
        dx(i + 4) = da*dx(i + 4)
   50 continue
      return
      end

      integer function idamax(n, dx, incx)
      real*8 dx(1), dmax
      integer i, incx, ix, n
      idamax = 0
      if(n .lt. 1) return
      idamax = 1
      if(n.eq.1)return
      if(incx.eq.1)go to 20
      ix = 1
      dmax = dabs(dx(1))
      ix = ix + incx
      do 10 i = 2, n
         if(dabs(dx(ix)).le.dmax) go to 5
         idamax = i
         dmax = dabs(dx(ix))
    5    ix = ix + incx
   10 continue
      return
   20 dmax = dabs(dx(1))
      do 30 i = 2, n
         if(dabs(dx(i)).le.dmax) go to 30
         idamax = i
         dmax = dabs(dx(i))
   30 continue
      return
      end

      real*8 function epslon (x)
      real*8 x
      real*8 a, b, c, eps
      a = 4.0d0/3.0d0
   10 b = a - 1.0d0
      c = b + b + b
      eps = dabs(c-1.0d0)
      if (eps .eq. 0.0d0) go to 10
      epslon = eps*dabs(x)
      return
      end

      subroutine mm (a, lda, n1, n3, b, ldb, n2, c, ldc)
      real*8 a(lda, *), b(ldb, *), c(ldc, *)
      do 20 j = 1, n3
         do 10 i = 1, n1
            a(i, j) = 0.0
   10    continue
         call dmxpy (n2, a(1, j), n1, ldb, c(1, j), b)
   20 continue
      return
      end

      subroutine dmxpy (n1, y, n2, ldm, x, m)
      real*8 y(*), x(*), m(ldm, *)
      j = mod(n2, 2)
      if (j .ge. 1) then
         do 10 i = 1, n1
            y(i) = (y(i)) + x(j)*m(i, j)
   10    continue
      endif
      j = mod(n2, 4)
      if (j .ge. 2) then
         do 20 i = 1, n1
            y(i) = ((y(i))
     $             + x(j-1)*m(i, j-1)) + x(j)*m(i, j)
   20    continue
      endif
      j = mod(n2, 8)
      if (j .ge. 4) then
         do 30 i = 1, n1
            y(i) = ((((y(i))
     $             + x(j-3)*m(i, j-3)) + x(j-2)*m(i, j-2))
     $             + x(j-1)*m(i, j-1)) + x(j)  *m(i, j)
   30    continue
      endif
      j = mod(n2, 16)
      if (j .ge. 8) then
         do 40 i = 1, n1
            y(i) = ((((((((y(i))
     $             + x(j-7)*m(i, j-7)) + x(j-6)*m(i, j-6))
     $             + x(j-5)*m(i, j-5)) + x(j-4)*m(i, j-4))
     $             + x(j-3)*m(i, j-3)) + x(j-2)*m(i, j-2))
     $             + x(j-1)*m(i, j-1)) + x(j)  *m(i, j)
   40    continue
      endif
      jmin = j+16
      do 60 j = jmin, n2, 16
         do 50 i = 1, n1
            y(i) = ((((((((((((((((y(i))
     $             + x(j-15)*m(i, j-15)) + x(j-14)*m(i, j-14))
     $             + x(j-13)*m(i, j-13)) + x(j-12)*m(i, j-12))
     $             + x(j-11)*m(i, j-11)) + x(j-10)*m(i, j-10))
     $             + x(j- 9)*m(i, j- 9)) + x(j- 8)*m(i, j- 8))
     $             + x(j- 7)*m(i, j- 7)) + x(j- 6)*m(i, j- 6))
     $             + x(j- 5)*m(i, j- 5)) + x(j- 4)*m(i, j- 4))
     $             + x(j- 3)*m(i, j- 3)) + x(j- 2)*m(i, j- 2))
     $             + x(j- 1)*m(i, j- 1)) + x(j)   *m(i, j)
   50    continue
   60 continue
      return
      end

      real*8 function random_value(iseed)
      integer iseed(4)
      integer m1, m2, m3, m4
      parameter (m1 = 494, m2 = 322, m3 = 2508, m4 = 2549)
      real*8 one
      parameter (one = 1.0d+0)
      integer ipw2
      real*8 r
      parameter (ipw2 = 4096, r = one / ipw2)
      integer it1, it2, it3, it4
      intrinsic dble, mod
      it4 = iseed(4)*m4
      it3 = it4 / ipw2
      it4 = it4 - ipw2*it3
      it3 = it3 + iseed(3)*m4 + iseed(4)*m3
      it2 = it3 / ipw2
      it3 = it3 - ipw2*it2
      it2 = it2 + iseed(2)*m4 + iseed(3)*m3 + iseed(4)*m2
      it1 = it2 / ipw2
      it2 = it2 - ipw2*it1
      it1 = it1 + iseed(1)*m4 + iseed(2)*m3 + iseed(3)*m2 +
     $      iseed(4)*m1
      it1 = mod(it1, ipw2)
      iseed(1) = it1
      iseed(2) = it2
      iseed(3) = it3
      iseed(4) = it4
      random_value = r*(dble(it1)+r*(dble(it2)+r*(dble(it3)
     &  +r*(dble(it4)))))
      return
      end

! @section Synopsis
!
! FORTRAN IV library functions for VIF.
!
! @author J. Marcel van der Veer
!
! @section copyright
!
! This file is part of VIF - vintage fortran compiler.
! Copyright 2020-2025 J. Marcel van der Veer <algol68g@xs4all.nl>.
!
! @section license
!
! This program is free software; you can redistribute it and/or modify it 
! under the terms of the gnu general public license as published by the 
! free software foundation; either version 3 of the license, or 
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful, but 
! without any warranty; without even the implied warranty of merchantability 
! or fitness for a particular purpose. See the GNU general public license for 
! more details. You should have received a copy of the GNU general public 
! license along with this program. If not, see <http://www.gnu.org/licenses/>.
!
      SUBROUTINE slite (i)
! SLITE (Sense LIghTEs) sets indicators.
      COMMON /slites/ ilites(36)
      IF (i .eq. 0) THEN
        DO j = 1, 36
          ilites(j) = 2
        END DO
      ELSE IF (i .le. 36) then
        ilites(i) = 1
      END IF 
      END

      SUBROUTINE slitet (i, j)
! SLITET tests indicators set by SLITE.
      COMMON /slites/ ilites(36)
      IF (i .ge. 1 .and. i .le. 36) THEN
        j = ilites(i)
        ilites(i) = 2
      END IF
      END

#pragma -z
      program main

c*********************************************************************72
c
cc fftpack5.1_test() tests fftpack5.1().
c
c  Licensing:
c
c    This code is distributed under the MIT license. 
c
c  Modified:
c
c    29 March 2011
c
c  Author:
c
c    John Burkardt
c
      implicit none

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'fftpack5.1_test():'
      write ( *, '(a)' ) '  FORTRAN77 version'
      write ( *, '(a)' ) '  Test fftpack5.1().'

      call test01 ( )
      call test02 ( )
      call test03 ( )
      call test04 ( )
      call test05 ( )
      call test06 ( )
      call test07 ( )
      call test08 ( )
      call test09 ( )
      call test10 ( )
      call test11 ( )
      call test12 ( )
      call test13 ( )
      call test14 ( )
c
c  Terminate.
c
      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'fftpack5.1_test():'
      write ( *, '(a)' ) '  Normal end of execution.'
      write ( *, '(a)' ) ' '

      stop
      end
      subroutine test01 ( )

c*********************************************************************72
c
cc TEST01 tests CFFT1B, CFFT1F and CFFT1I.
c
c  Licensing:
c
c    This code is distributed under the MIT license. 
c
c  Modified:
c
c    29 March 2011
c
c  Author:
c
c    John Burkardt
c
      implicit none

      integer n
      parameter ( n = 4096 )

      integer lenwrk
      parameter ( lenwrk = 2 * n )

      integer lensav
      parameter ( lensav = 
     &  2 * n + int ( log ( real ( n ) ) / log ( 2.0E+00 ) ) + 4 )

      complex c(n)
      integer ier
      integer inc
      integer lenc
      integer seed
      real work(lenwrk)
      real wsave(lensav)

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'TEST01'
      write ( *, '(a)' ) '  For complex fast Fourier transforms, 1D,'
      write ( *, '(a)' ) '  CFFT1I initializes the transform,'
      write ( *, '(a)' ) '  CFFT1F does a forward transform;'
      write ( *, '(a)' ) '  CFFT1B does a backward transform.'
      write ( *, '(a)' ) ' '
      write ( *, '(a,i4)' ) '  The number of data items is N = ', n
      write ( *, '(a,i8)' ) '  Workspace size LENSAV = ', lensav
c
c  Set the data values.
c
      seed = 1973

      call c4vec_uniform_01 ( n, seed, c )

      call c4vec_print_part ( n, c, 10, '  The original data:' )
c
c  Initialize the WSAVE array.
c
      call dcfft1i ( n, wsave, lensav, ier )
c
c  Compute the FFT coefficients.
c
      inc = 1
      lenc = n

      call dcfft1f ( n, inc, c, lenc, wsave, lensav, work, lenwrk, ier )

      call c4vec_print_part ( n, c, 10, '  The FFT coefficients:' )
c
c  Compute inverse FFT of coefficients.  Should get back the
c  original data.
c
      call dcfft1b ( n, inc, c, lenc, wsave, lensav, work, lenwrk, ier )

      call c4vec_print_part ( n, c, 10, '  The retrieved data:' )

      return
      end
      subroutine test02 ( )

c*********************************************************************72
c
cc TEST02 tests CFFT2B, CFFT2F and CFFT2I.
c
c  Licensing:
c
c    This code is distributed under the MIT license. 
c
c  Modified:
c
c    29 March 2011
c
c  Author:
c
c    John Burkardt
c
      implicit none

      integer l
      integer m

      parameter ( l = 32 )
      parameter ( m = 64 )

      integer lenwrk
      parameter ( lenwrk = 2 * l * m )

      integer lensav
      parameter ( lensav = 
     &    2 * l + int ( log ( real ( l ) ) / log ( 2.0E+00 ) ) 
     &  + 2 * m + int ( log ( real ( m ) ) / log ( 2.0E+00 ) ) 
     &  + 8 )

      complex c(l,m)
      integer ier
      integer ldim
      integer seed
      real work(lenwrk)
      real wsave(lensav)

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'TEST02'
      write ( *, '(a)' ) '  For complex fast Fourier transforms, 2D,'
      write ( *, '(a)' ) '  CFFT2I initializes the transform,'
      write ( *, '(a)' ) '  CFFT2F does a forward transform;'
      write ( *, '(a)' ) '  CFFT2B does a backward transform.'
      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) '  The data is stored in an L by M array, with'
      write ( *, '(a,i4)' ) '  L = ', l
      write ( *, '(a,i4)' ) '  M = ', m
      write ( *, '(a,i8)' ) '  Workspace size LENSAV = ', lensav
c
c  Set the data values.
c
      seed = 1973

      call c4mat_uniform_01 ( l, m, seed, c )

      call c4mat_print_some ( l, m, c, 1, 1, 5, 5, 
     &  '  Part of the original data:' )
c
c  Initialize the WSAVE array.
c
      call dcfft2i ( l, m, wsave, lensav, ier )
c
c  Compute the FFT coefficients.
c
      ldim = l

      call dcfft2f ( ldim, l, m, c, wsave, lensav, work, lenwrk, ier )

      call c4mat_print_some ( l, m, c, 1, 1, 5, 5, 
     &  '  Part of the FFT coefficients:' )
c
c  Compute inverse FFT of coefficients.  Should get back the
c  original data.
c
      call dcfft2b ( ldim, l, m, c, wsave, lensav, work, lenwrk, ier )

      call c4mat_print_some ( l, m, c, 1, 1, 5, 5, 
     &  '  Part of the retrieved data:' )

      return
      end
      subroutine test03 ( )

c*********************************************************************72
c
cc TEST03 tests CFFTMB, CFFTMF and CFFTMI.
c
c  Licensing:
c
c    This code is distributed under the MIT license. 
c
c  Modified:
c
c    29 March 2011
c
c  Author:
c
c    John Burkardt
c
      implicit none

      integer n
      integer lot

      parameter ( n = 32 )
      parameter ( lot = 6 )

      integer lenc
      integer lenwrk

      parameter ( lenc = n * lot )
      parameter ( lenwrk = 2 * lot * n )

      integer lensav
      parameter ( lensav = 
     &  2 * n + int ( log ( real ( n ) ) / log ( 2.0E+00 ) ) + 4 )

      complex c(lenc)
      integer ier
      integer inc
      integer jump
      integer seed
      real work(lenwrk)
      real wsave(lensav)

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'TEST03'
      write ( *, '(a)' ) '  For complex fast Fourier transforms,'
      write ( *, '(a)' ) '  1D, multiple'
      write ( *, '(a)' ) '  CFFTMI initializes the transform,'
      write ( *, '(a)' ) '  CFFTMF does a forward transform;'
      write ( *, '(a)' ) '  CFFTMB does a backward transform.'
      write ( *, '(a)' ) ' '
      write ( *, '(a,i4)' ) '  The number of sequences is LOT = ', lot
      write ( *, '(a,i4)' ) '  The length of each sequence is N = ', n
      write ( *, '(a,i8)' ) '  Workspace size LENSAV = ', lensav
c
c  Set the data values.
c
      seed = 1973

      call c4mat_uniform_01 ( n, lot, seed, c )

      call c4mat_print_some ( n, lot, c, 1, 1, 5, 5, 
     &  '  Part of the original data:' )
c
c  Initialize the WSAVE array.
c
      call dcfftmi ( n, wsave, lensav, ier )
c
c  Compute the FFT coefficients.
c
      jump = n
      inc = 1

      call dcfftmf ( lot, jump, n, inc, c, lenc, wsave, lensav, 
     &  work, lenwrk, ier )

      call c4mat_print_some ( n, lot, c, 1, 1, 5, 5, 
     &  '  Part of the FFT coefficients:' )
c
c  Compute inverse FFT of coefficients.  Should get back the
c  original data.
c
      call dcfftmb ( lot, jump, n, inc, c, lenc, wsave, lensav, 
     &  work, lenwrk, ier )

      call c4mat_print_some ( n, lot, c, 1, 1, 5, 5, 
     &  '  Part of the retrieved data:' )

      return
      end
      subroutine test04 ( )

c*********************************************************************72
c
cc TEST04 tests COSQ1B, COSQ1F and COSQ1I.
c
c  Licensing:
c
c    This code is distributed under the MIT license. 
c
c  Modified:
c
c    29 March 2011
c
c  Author:
c
c    John Burkardt
c
      implicit none

      integer n
      parameter ( n = 4096 )

      integer lenwrk
      parameter ( lenwrk = n )

      integer lensav
      parameter ( lensav = 
     &  2 * n + int ( log ( real ( n ) ) / log ( 2.0E+00 ) ) + 4 )

      integer ier
      integer inc
      integer lenr
      real r(n)
      integer seed
      real work(lenwrk)
      real wsave(lensav)

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'TEST04'
      write ( *, '(a)' ) '  For real fast cosine transforms, 1D,'
      write ( *, '(a)' ) '  COSQ1I initializes the transform,'
      write ( *, '(a)' ) '  COSQ1F does a forward transform;'
      write ( *, '(a)' ) '  COSQ1B does a backward transform.'
      write ( *, '(a)' ) ' '
      write ( *, '(a,i4)' ) '  The number of data items is N = ', n
      write ( *, '(a,i8)' ) '  Workspace size LENSAV = ', lensav
c
c  Set the data values.
c
      seed = 1973

      call r4vec_uniform_01 ( n, seed, r )

      call r4vec_print_part ( n, r, 10, '  The original data:' )
c
c  Initialize the WSAVE array.
c
      call dcosq1i ( n, wsave, lensav, ier )
c
c  Compute the FFT coefficients.
c
      inc = 1
      lenr = n

      call dcosq1f ( n, inc, r, lenr, wsave, lensav, work, 
     &  lenwrk, ier )

      call r4vec_print_part ( n, r, 10, '  The FFT coefficients:' )
c
c  Compute inverse FFT of coefficients.  Should get back the
c  original data.
c
      call dcosq1b ( n, inc, r, lenr, wsave, lensav, work, lenwrk, ier )

      call r4vec_print_part ( n, r, 10, '  The retrieved data:' )

      return
      end
      subroutine test05 ( )

c*********************************************************************72
c
cc TEST05 tests COSQMB, COSQMF and COSQMI.
c
c  Licensing:
c
c    This code is distributed under the MIT license. 
c
c  Modified:
c
c    29 March 2011
c
c  Author:
c
c    John Burkardt
c
      implicit none

      integer n
      integer lot

      parameter ( n = 32 )
      parameter ( lot = 6 )

      integer lenr
      parameter ( lenr = n * lot )

      integer lenwrk
      parameter ( lenwrk = lot * n )

      integer lensav
      parameter ( lensav = 
     &  2 * n + int ( log ( real ( n ) ) / log ( 2.0E+00 ) ) + 4 )

      integer ier
      integer inc
      integer jump
      real r(lenr)
      integer seed
      real work(lenwrk)
      real wsave(lensav)

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'TEST05'
      write ( *, '(a)' ) '  For real fast cosine transforms, '
      write ( *, '(a)' ) '  1D, multiple'
      write ( *, '(a)' ) '  COSQMI initializes the transform,'
      write ( *, '(a)' ) '  COSQMF does a forward transform;'
      write ( *, '(a)' ) '  COSQMB does a backward transform.'
      write ( *, '(a)' ) ' '
      write ( *, '(a,i4)' ) '  The number of sequences is LOT = ', lot
      write ( *, '(a,i4)' ) '  The length of each sequence is N = ', n
      write ( *, '(a,i8)' ) '  Workspace size LENSAV = ', lensav
c
c  Set the data values.
c
      seed = 1973

      call r4mat_uniform_01 ( n, lot, seed, r )

      call r4mat_print_some ( n, lot, r, 1, 1, 5, 5, 
     &  '  Part of the original data:' )
c
c  Initialize the WSAVE array.
c
      call dcosqmi ( n, wsave, lensav, ier )
c
c  Compute the FFT coefficients.
c
      jump = n
      inc = 1

      call dcosqmf ( lot, jump, n, inc, r, lenr, wsave, lensav, 
     &  work, lenwrk, ier )

      call r4mat_print_some ( n, lot, r, 1, 1, 5, 5, 
     &  '  Part of the FFT coefficients:' )
c
c  Compute inverse FFT of coefficients.  Should get back the
c  original data.
c
      call dcosqmb ( lot, jump, n, inc, r, lenr, wsave, lensav, 
     &  work, lenwrk, ier )

      call r4mat_print_some ( n, lot, r, 1, 1, 5, 5, 
     &  '  Part of the retrieved data:' )

      return
      end
      subroutine test06 ( )

c*********************************************************************72
c
cc TEST06 tests COST1B, COST1F and COST1I.
c
c  Licensing:
c
c    This code is distributed under the MIT license. 
c
c  Modified:
c
c    29 March 2011
c
c  Author:
c
c    John Burkardt
c
      implicit none

      integer n
      parameter ( n = 4096 )

      integer lenwrk
      parameter ( lenwrk = n - 1 )

      integer lensav
      parameter ( lensav = 
     &  2 * n + int ( log ( real ( n ) ) / log ( 2.0E+00 ) ) + 4 )

      integer ier
      integer inc
      integer lenr
      real r(n)
      integer seed
      real work(lenwrk)
      real wsave(lensav)

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'TEST06'
      write ( *, '(a)' ) '  For real fast cosine transforms, 1D,'
      write ( *, '(a)' ) '  COST1I initializes the transform,'
      write ( *, '(a)' ) '  COST1F does a forward transform;'
      write ( *, '(a)' ) '  COST1B does a backward transform.'
      write ( *, '(a)' ) ' '
      write ( *, '(a,i4)' ) '  The number of data items is N = ', n
      write ( *, '(a,i8)' ) '  Workspace size LENSAV = ', lensav
c
c  Set the data values.
c
      seed = 1973

      call r4vec_uniform_01 ( n, seed, r )

      call r4vec_print_part ( n, r, 10, '  The original data:' )
c
c  Initialize the WSAVE array.
c
      call dcost1i ( n, wsave, lensav, ier )
c
c  Compute the FFT coefficients.
c
      inc = 1
      lenr = n

      call dcost1f ( n, inc, r, lenr, wsave, lensav, work, lenwrk, ier )

      call r4vec_print_part ( n, r, 10, '  The FFT coefficients:' )
c
c  Compute inverse FFT of coefficients.  Should get back the
c  original data.
c
      call dcost1b ( n, inc, r, lenr, wsave, lensav, work, lenwrk, ier )

      call r4vec_print_part ( n, r, 10, '  The retrieved data:' )

      return
      end
      subroutine test07 ( )

c*********************************************************************72
c
cc TEST07 tests COSTMB, COSTMF and COSTMI.
c
c  Licensing:
c
c    This code is distributed under the MIT license. 
c
c  Modified:
c
c    29 March 2011
c
c  Author:
c
c    John Burkardt
c
      implicit none

      integer n
      integer lot

      parameter ( n = 32 )
      parameter ( lot = 6 )

      integer lenr
      parameter ( lenr = n * lot )

      integer lenwrk
      parameter ( lenwrk = lot * ( n + 1 ) )

      integer lensav
      parameter ( lensav = 
     &  2 * n + int ( log ( real ( n ) ) / log ( 2.0E+00 ) ) + 4 )

      integer ier
      integer inc
      integer jump
      real r(lenr)
      integer seed
      real work(lenwrk)
      real wsave(lensav)

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'TEST07'
      write ( *, '(a)' ) '  For real fast cosine transforms, '
      write ( *, '(a)' ) '  1D, multiple'
      write ( *, '(a)' ) '  COSTMI initializes the transform,'
      write ( *, '(a)' ) '  COSTMF does a forward transform;'
      write ( *, '(a)' ) '  COSTMB does a backward transform.'
      write ( *, '(a)' ) ' '
      write ( *, '(a,i4)' ) '  The number of sequences is LOT = ', lot
      write ( *, '(a,i4)' ) '  The length of each sequence is N = ', n
      write ( *, '(a,i8)' ) '  Workspace size LENSAV = ', lensav
c
c  Set the data values.
c
      seed = 1973

      call r4mat_uniform_01 ( n, lot, seed, r )

      call r4mat_print_some ( n, lot, r, 1, 1, 5, 5, 
     &  '  Part of the original data:' )
c
c  Initialize the WSAVE array.
c
      call dcostmi ( n, wsave, lensav, ier )
c
c  Compute the FFT coefficients.
c
      jump = n
      inc = 1

      call dcostmf ( lot, jump, n, inc, r, lenr, wsave, lensav, 
     &  work, lenwrk, ier )

      call r4mat_print_some ( n, lot, r, 1, 1, 5, 5, 
     &  '  Part of the FFT coefficients:' )
c
c  Compute inverse FFT of coefficients.  Should get back the
c  original data.
c
      call dcostmb ( lot, jump, n, inc, r, lenr, wsave, lensav, 
     &  work, lenwrk, ier )

      call r4mat_print_some ( n, lot, r, 1, 1, 5, 5, 
     &  '  Part of the retrieved data:' )

      return
      end
      subroutine test08 ( )

c*********************************************************************72
c
cc TEST08 tests RFFT1B, RFFT1F and RFFT1I.
c
c  Licensing:
c
c    This code is distributed under the MIT license. 
c
c  Modified:
c
c    29 March 2011
c
c  Author:
c
c    John Burkardt
c
      implicit none

      integer n
      parameter ( n = 4096 )

      integer lenwrk
      parameter ( lenwrk = 2 * n )

      integer lensav
      parameter ( lensav = 
     &  n + int ( log ( real ( n ) ) / log ( 2.0E+00 ) ) + 4 )

      integer ier
      integer inc
      integer lenr
      real r(n)
      integer seed
      real work(lenwrk)
      real wsave(lensav)

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'TEST08'
      write ( *, '(a)' ) '  For real fast Fourier transforms, 1D,'
      write ( *, '(a)' ) '  RFFT1I initializes the transform,'
      write ( *, '(a)' ) '  RFFT1F does a forward transform;'
      write ( *, '(a)' ) '  RFFT1B does a backward transform.'
      write ( *, '(a)' ) ' '
      write ( *, '(a,i4)' ) '  The number of data items is N = ', n
      write ( *, '(a,i8)' ) '  Workspace size LENSAV = ', lensav
c
c  Set the data values.
c
      seed = 1973

      call r4vec_uniform_01 ( n, seed, r )

      call r4vec_print_part ( n, r, 10, '  The original data:' )
c
c  Initialize the WSAVE array.
c
      call drfft1i ( n, wsave, lensav, ier )
c
c  Compute the FFT coefficients.
c
      inc = 1
      lenr = n

      call drfft1f ( n, inc, r, lenr, wsave, lensav, work, lenwrk, ier )

      call r4vec_print_part ( n, r, 10, '  The FFT coefficients:' )
c
c  Compute inverse FFT of coefficients.  Should get back the
c  original data.
c
      call drfft1b ( n, inc, r, lenr, wsave, lensav, work, lenwrk, ier )

      call r4vec_print_part ( n, r, 10, '  The retrieved data:' )

      return
      end
      subroutine test09 ( )

c*********************************************************************72
c
cc TEST09 tests RFFT2B, RFFT2F and RFFT2I.
c
c  Licensing:
c
c    This code is distributed under the MIT license. 
c
c  Modified:
c
c    29 March 2011
c
c  Author:
c
c    John Burkardt
c
      implicit none

      integer l
      integer m
      parameter ( l = 32 )
      parameter ( m = 64 )

      integer ldim
      parameter ( ldim = 2 * ( l / 2 + 1 ) )

      integer lenwrk
      parameter ( lenwrk = 2 * ldim * m )

      integer lensav
      parameter ( lensav = 
     &        l + int ( log ( real ( l ) ) / log ( 2.0E+00 ) ) + 4
     &  + 2 * m + int ( log ( real ( m ) ) / log ( 2.0E+00 ) ) + 4
     &  +     m + int ( log ( real ( m ) ) / log ( 2.0E+00 ) ) + 4 )


      integer ier
      real r(ldim,m)
      integer seed
      real work(lenwrk)
      real wsave(lensav)

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'TEST09'
      write ( *, '(a)' ) '  For real fast Fourier transforms, 2D,'
      write ( *, '(a)' ) '  RFFT2I initializes the transform,'
      write ( *, '(a)' ) '  RFFT2F does a forward transform;'
      write ( *, '(a)' ) '  RFFT2B does a backward transform.'
      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) '  The L by M data is stored in an '
      write ( *, '(a)' ) '  LDIM by M array, with'
      write ( *, '(a,i4)' ) '  L = ', l
      write ( *, '(a,i4)' ) '  LDIM = ', ldim
      write ( *, '(a,i4)' ) '  M = ', m
      write ( *, '(a,i8)' ) '  Workspace size LENSAV = ', lensav
c
c  Set the data values.
c
      seed = 1973

      call r4mat_uniform_01 ( ldim, m, seed, r )

      call r4mat_print_some ( ldim, m, r, 1, 1, 5, 5, 
     &  '  Part of the original data:' )
c
c  Initialize the WSAVE array.
c
      call drfft2i ( l, m, wsave, lensav, ier )
c
c  Compute the FFT coefficients.
c
      call drfft2f ( ldim, l, m, r, wsave, lensav, work, lenwrk, ier )

      call r4mat_print_some ( ldim, m, r, 1, 1, 5, 5, 
     &  '  Part of the FFT coefficients:' )
c
c  Compute inverse FFT of coefficients.  Should get back the
c  original data.
c
      call drfft2b ( ldim, l, m, r, wsave, lensav, work, lenwrk, ier )

      call r4mat_print_some ( ldim, m, r, 1, 1, 5, 5, 
     &  '  Part of the retrieved data:' )

      return
      end
      subroutine test10 ( )

c*********************************************************************72
c
cc TEST10 tests RFFTMB, RFFTMF and RFFTMI.
c
c  Licensing:
c
c    This code is distributed under the MIT license. 
c
c  Modified:
c
c    29 March 2011
c
c  Author:
c
c    John Burkardt
c
      implicit none

      integer n
      integer lot

      parameter ( n = 32 )
      parameter ( lot = 6 )

      integer lenr
      parameter ( lenr = n * lot )

      integer lenwrk
      parameter ( lenwrk = lot * n )

      integer lensav
      parameter ( lensav =
     &  n + int ( log ( real ( n ) ) / log ( 2.0E+00 ) ) + 4 )

      integer ier
      integer inc
      integer jump
      real r(lenr)
      integer seed
      real work(lenwrk)
      real wsave(lensav)

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'TEST10'
      write ( *, '(a)' ) '  For real fast Fourier transforms, '
      write ( *, '(a)' ) '  1D, multiple'
      write ( *, '(a)' ) '  RFFTMI initializes the transform,'
      write ( *, '(a)' ) '  RFFTMF does a forward transform;'
      write ( *, '(a)' ) '  RFFTMB does a backward transform.'
      write ( *, '(a)' ) ' '
      write ( *, '(a,i4)' ) '  The number of sequences is LOT = ', lot
      write ( *, '(a,i4)' ) '  The length of each sequence is N = ', n
      write ( *, '(a,i8)' ) '  Workspace size LENSAV = ', lensav
c
c  Set the data values.
c
      seed = 1973

      call r4mat_uniform_01 ( n, lot, seed, r )

      call r4mat_print_some ( n, lot, r, 1, 1, 5, 5, 
     &  '  Part of the original data:' )
c
c  Initialize the WSAVE array.
c
      call drfftmi ( n, wsave, lensav, ier )
c
c  Compute the FFT coefficients.
c
      jump = n
      inc = 1

      call drfftmf ( lot, jump, n, inc, r, lenr, wsave, lensav, 
     &  work, lenwrk, ier )

      call r4mat_print_some ( n, lot, r, 1, 1, 5, 5, 
     &  '  Part of the FFT coefficients:' )
c
c  Compute inverse FFT of coefficients.  Should get back the
c  original data.
c
      call drfftmb ( lot, jump, n, inc, r, lenr, wsave, lensav, 
     &  work, lenwrk, ier )

      call r4mat_print_some ( n, lot, r, 1, 1, 5, 5, 
     &  '  Part of the retrieved data:' )

      return
      end
      subroutine test11 ( )

c*********************************************************************72
c
cc TEST11 tests SINQ1B, SINQ1F and SINQ1I.
c
c  Licensing:
c
c    This code is distributed under the MIT license. 
c
c  Modified:
c
c    29 March 2011
c
c  Author:
c
c    John Burkardt
c
      implicit none

      integer n
      parameter ( n = 4096 )

      integer lenwrk
      parameter ( lenwrk = n )

      integer lensav
      parameter ( lensav = 
     &  2 * n + int ( log ( real ( n ) ) / log ( 2.0E+00 ) ) + 4 )

      integer ier
      integer inc
      integer lenr
      real r(n)
      integer seed
      real work(lenwrk)
      real wsave(lensav)

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'TEST11'
      write ( *, '(a)' ) '  For real fast sine transforms, 1D,'
      write ( *, '(a)' ) '  SINQ1I initializes the transform,'
      write ( *, '(a)' ) '  SINQ1F does a forward transform;'
      write ( *, '(a)' ) '  SINQ1B does a backward transform.'
      write ( *, '(a)' ) ' '
      write ( *, '(a,i4)' ) '  The number of data items is N = ', n
      write ( *, '(a,i8)' ) '  Workspace size LENSAV = ', lensav
c
c  Set the data values.
c
      seed = 1973

      call r4vec_uniform_01 ( n, seed, r )

      call r4vec_print_part ( n, r, 10, '  The original data:' )
c
c  Initialize the WSAVE array.
c
      call dsinq1i ( n, wsave, lensav, ier )
c
c  Compute the FFT coefficients.
c
      inc = 1
      lenr = n

      call dsinq1f ( n, inc, r, lenr, wsave, lensav, work, 
     &  lenwrk, ier )

      call r4vec_print_part ( n, r, 10, '  The FFT coefficients:' )
c
c  Compute inverse FFT of coefficients.  Should get back the
c  original data.
c
      call dsinq1b ( n, inc, r, lenr, wsave, lensav, work, lenwrk, ier )

      call r4vec_print_part ( n, r, 10, '  The retrieved data:' )

      return
      end
      subroutine test12 ( )

c*********************************************************************72
c
cc TEST12 tests SINQMB, SINQMF and SINQMI.
c
c  Licensing:
c
c    This code is distributed under the MIT license. 
c
c  Modified:
c
c    29 March 2011
c
c  Author:
c
c    John Burkardt
c
      implicit none

      integer n
      integer lot

      parameter ( n = 32 )
      parameter ( lot = 6 )

      integer lenr
      parameter ( lenr = n * lot )

      integer lenwrk
      parameter ( lenwrk = lot * n )

      integer lensav
      parameter ( lensav = 
     &  2 * n + int ( log ( real ( n ) ) / log ( 2.0E+00 ) ) + 4 )

      integer ier
      integer inc
      integer jump
      real r(lenr)
      integer seed
      real work(lenwrk)
      real wsave(lensav)

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'TEST12'
      write ( *, '(a)' ) '  For real fast sine transforms, 1D, multiple'
      write ( *, '(a)' ) '  SINQMI initializes the transform,'
      write ( *, '(a)' ) '  SINQMF does a forward transform;'
      write ( *, '(a)' ) '  SINQMB does a backward transform.'
      write ( *, '(a)' ) ' '
      write ( *, '(a,i4)' ) '  The number of sequences is LOT = ', lot
      write ( *, '(a,i4)' ) '  The length of each sequence is N = ', n
      write ( *, '(a,i8)' ) '  Workspace size LENSAV = ', lensav
c
c  Set the data values.
c
      seed = 1973

      call r4mat_uniform_01 ( n, lot, seed, r )

      call r4mat_print_some ( n, lot, r, 1, 1, 5, 5, 
     &  '  Part of the original data:' )
c
c  Initialize the WSAVE array.
c
      call dsinqmi ( n, wsave, lensav, ier )
c
c  Compute the FFT coefficients.
c
      jump = n
      inc = 1

      call dsinqmf ( lot, jump, n, inc, r, lenr, wsave, lensav, 
     &  work, lenwrk, ier )

      call r4mat_print_some ( n, lot, r, 1, 1, 5, 5, 
     &  '  Part of the FFT coefficients:' )
c
c  Compute inverse FFT of coefficients.  Should get back the
c  original data.
c
      call dsinqmb ( lot, jump, n, inc, r, lenr, wsave, lensav, 
     &  work, lenwrk, ier )

      call r4mat_print_some ( n, lot, r, 1, 1, 5, 5, 
     &  '  Part of the retrieved data:' )

      return
      end
      subroutine test13 ( )

c*********************************************************************72
c
cc TEST13 tests SINT1B, SINT1F and SINT1I.
c
c  Licensing:
c
c    This code is distributed under the MIT license. 
c
c  Modified:
c
c    29 March 2011
c
c  Author:
c
c    John Burkardt
c
      implicit none

      integer n
      parameter ( n = 4096 )

      integer lenwrk
      parameter ( lenwrk = 2 * ( n + 1 ) )

      integer lensav
      parameter ( lensav = 
     &  n / 2 + n + int ( log ( real ( n ) ) / log ( 2.0E+00 ) ) + 4 )

      integer ier
      integer inc
      integer lenr
      real r(n)
      integer seed
      real work(lenwrk)
      real wsave(lensav)

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'TEST13'
      write ( *, '(a)' ) '  For real fast sine transforms, 1D,'
      write ( *, '(a)' ) '  SINT1I initializes the transform,'
      write ( *, '(a)' ) '  SINT1F does a forward transform;'
      write ( *, '(a)' ) '  SINT1B does a backward transform.'
      write ( *, '(a)' ) ' '
      write ( *, '(a,i4)' ) '  The number of data items is N = ', n
      write ( *, '(a,i8)' ) '  Workspace size LENSAV = ', lensav
c
c  Set the data values.
c
      seed = 1973

      call r4vec_uniform_01 ( n, seed, r )

      call r4vec_print_part ( n, r, 10, '  The original data:' )
c
c  Initialize the WSAVE array.
c
      call dsint1i ( n, wsave, lensav, ier )
c
c  Compute the FFT coefficients.
c
      inc = 1
      lenr = n

      call dsint1f ( n, inc, r, lenr, wsave, lensav, work, 
     &  lenwrk, ier )

      call r4vec_print_part ( n, r, 10, '  The FFT coefficients:' )
c
c  Compute inverse FFT of coefficients.  Should get back the
c  original data.
c
      call dsint1b ( n, inc, r, lenr, wsave, lensav, work, lenwrk, ier )

      call r4vec_print_part ( n, r, 10, '  The retrieved data:' )

      return
      end
      subroutine test14 ( )

c*********************************************************************72
c
cc TEST14 tests SINTMB, SINTMF and SINTMI.
c
c  Licensing:
c
c    This code is distributed under the MIT license. 
c
c  Modified:
c
c    29 March 2011
c
c  Author:
c
c    John Burkardt
c
      implicit none

      integer n
      integer lot

      parameter ( n = 32 )
      parameter ( lot = 6 )

      integer lenr
      parameter ( lenr = n * lot )

      integer lenwrk
      parameter ( lenwrk = lot * 2 * ( n + 2 ) )

      integer lensav
      parameter ( lensav = 
     &  n / 2 + n + int ( log ( real ( n ) ) / log( 2.0 ) ) + 4 )

      integer ier
      integer inc
      integer jump
      real r(lenr)
      integer seed
      real work(lenwrk)
      real wsave(lensav)

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'TEST14'
      write ( *, '(a)' ) '  For real fast sine transforms, 1D, multiple'
      write ( *, '(a)' ) '  SINTMI initializes the transform,'
      write ( *, '(a)' ) '  SINTMF does a forward transform;'
      write ( *, '(a)' ) '  SINTMB does a backward transform.'
      write ( *, '(a)' ) ' '
      write ( *, '(a,i4)' ) '  The number of sequences is LOT = ', lot
      write ( *, '(a,i4)' ) '  The length of each sequence is N = ', n
      write ( *, '(a,i8)' ) '  Workspace size LENSAV = ', lensav
c
c  Set the data values.
c
      seed = 1973

      call r4mat_uniform_01 ( n, lot, seed, r )

      call r4mat_print_some ( n, lot, r, 1, 1, 5, 5, 
     &  '  Part of the original data:' )
c
c  Initialize the WSAVE array.
c
      call dsintmi ( n, wsave, lensav, ier )
c
c  Compute the FFT coefficients.
c
      jump = n
      inc = 1

      call dsintmf ( lot, jump, n, inc, r, lenr, wsave, lensav, 
     &  work, lenwrk, ier )

      call r4mat_print_some ( n, lot, r, 1, 1, 5, 5, 
     &  '  Part of the FFT coefficients:' )
c 
c  Compute inverse FFT of coefficients.  Should get back the
c  original data.
c
      call dsintmb ( lot, jump, n, inc, r, lenr, wsave, lensav, 
     &  work, lenwrk, ier )

      call r4mat_print_some ( n, lot, r, 1, 1, 5, 5, 
     &  '  Part of the retrieved data:' )

      return
      end
      subroutine c4mat_print ( m, n, a, title )

c*********************************************************************72
c
cc C4MAT_PRINT prints a C4MAT.
c
c  Licensing:
c
c    This code is distributed under the MIT license. 
c
c  Modified:
c
c    23 March 2005
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Input, integer M, N, the number of rows and columns in the matrix.
c
c    Input, complex A(M,N), the matrix.
c
c    Input, character*(*) TITLE, a title.
c
      implicit none

      integer m
      integer n

      complex a(m,n)
      character*(*) title

      call c4mat_print_some ( m, n, a, 1, 1, m, n, title )

      return
      end
      subroutine c4mat_print_some ( m, n, a, ilo, jlo, ihi, jhi, title )

c*********************************************************************72
c
cc C4MAT_PRINT_SOME prints some of a C4MAT.
c
c  Licensing:
c
c    This code is distributed under the MIT license. 
c
c  Modified:
c
c    23 March 2005
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Input, integer M, N, the number of rows and columns in the matrix.
c
c    Input, complex A(M,N), the matrix.
c
c    Input, integer ILO, JLO, IHI, JHI, the first row and
c    column, and the last row and column to be printed.
c
c    Input, character*(*) TITLE, a title.
c
      implicit none

      integer incx
      parameter ( incx = 4 )
      integer m
      integer n

      complex a(m,n)
      character*20 ctemp(incx)
      integer i
      integer i2hi
      integer i2lo
      integer ihi
      integer ilo
      integer inc
      integer j
      integer j2
      integer j2hi
      integer j2lo
      integer jhi
      integer jlo
      character*(*) title
      complex zero

      zero = cmplx ( 0.0E+00, 0.0E+00 )

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) title
c
c  Print the columns of the matrix, in strips of INCX.
c
      do j2lo = jlo, jhi, incx

        j2hi = j2lo + incx - 1
        j2hi = min ( j2hi, n )
        j2hi = min ( j2hi, jhi )

        inc = j2hi + 1 - j2lo

        write ( *, '(a)' ) ' '

        do j = j2lo, j2hi
          j2 = j + 1 - j2lo
          write ( ctemp(j2), '(i10,10x)' ) j
        end do

        write ( *, '(a,4a20)' ) '  Col: ', ( ctemp(j2), j2 = 1, inc )
        write ( *, '(a)' ) '  Row'
        write ( *, '(a)' ) '  ---'
c
c  Determine the range of the rows in this strip.
c
        i2lo = max ( ilo, 1 )
        i2hi = min ( ihi, m )

        do i = i2lo, i2hi
c
c  Print out (up to) INCX entries in row I, that lie in the current strip.
c
          do j2 = 1, inc

            j = j2lo - 1 + j2

            if ( a(i,j) == zero ) then
              ctemp(j2) = '    0.0'
            else if ( imag ( a(i,j) ) == 0.0E+00 ) then
              write ( ctemp(j2), '(g10.3,10x)' ) real ( a(i,j) )
            else
              write ( ctemp(j2), '(2g10.3)' ) a(i,j)
            end if

          end do

          write ( *, '(i5,1x,4a20)' ) i, ( ctemp(j2), j2 = 1, inc )

        end do

      end do

      return
      end
      subroutine c4mat_uniform_01 ( m, n, seed, c )

c*********************************************************************72
c
cc C4MAT_UNIFORM_01 returns a unit pseudorandom C4MAT.
c
c  Discussion:
c
c    The angles should be uniformly distributed between 0 and 2 * PI,
c    the square roots of the radius uniformly distributed between 0 and 1.
c
c    This results in a uniform distribution of values in the unit circle.
c
c  Licensing:
c
c    This code is distributed under the MIT license. 
c
c  Modified:
c
c    15 March 2005
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Input, integer M, N, the number of rows and columns in the matrix.
c
c    Input/output, integer SEED, the "seed" value, which should NOT be 0.
c    On output, SEED has been updated.
c
c    Output, complex C(M,N), the pseudorandom complex matrix.
c
      implicit none

      integer m
      integer n

      complex c(m,n)
      integer i
      integer j
      real r
      integer k
      real pi
      parameter ( pi = 3.1415926E+00 )
      integer seed
      real theta

      do j = 1, n
        do i = 1, m

          k = seed / 127773

          seed = 16807 * ( seed - k * 127773 ) - k * 2836

          if ( seed < 0 ) then
            seed = seed + 2147483647
          end if

          r = sqrt ( real ( dble ( seed ) * 4.656612875D-10 ) )

          k = seed / 127773

          seed = 16807 * ( seed - k * 127773 ) - k * 2836

          if ( seed < 0 ) then
            seed = seed + 2147483647
          end if

          theta = 2.0E+00 * pi * real ( dble ( seed ) 
     &      * 4.656612875D-10 )

          c(i,j) = r * cmplx ( cos ( theta ), sin ( theta ) )

        end do

      end do

      return
      end
      subroutine c4vec_print_part ( n, a, max_print, title )

c*********************************************************************72
c
cc C4VEC_PRINT_PART prints "part" of a C4VEC.
c
c  Discussion:
c
c    The user specifies MAX_PRINT, the maximum number of lines to print.
c
c    If N, the size of the vector, is no more than MAX_PRINT, then
c    the entire vector is printed, one entry per line.
c
c    Otherwise, if possible, the first MAX_PRINT-2 entries are printed,
c    followed by a line of periods suggesting an omission,
c    and the last entry.
c
c  Licensing:
c
c    This code is distributed under the MIT license.
c
c  Modified:
c
c    22 June 2010
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Input, integer N, the number of entries of the vector.
c
c    Input, complex A(N), the vector to be printed.
c
c    Input, integer MAX_PRINT, the maximum number of lines
c    to print.
c
c    Input, character * ( * ) TITLE, a title.
c
      implicit none

      integer n

      complex a(n)
      integer i
      integer max_print
      character * ( * )  title

      if ( max_print .le. 0 ) then
        return
      end if

      if ( n .le. 0 ) then
        return
      end if

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) trim ( title )
      write ( *, '(a)' ) ' '

      if ( n .le. max_print ) then

        do i = 1, n
          write ( *, '(2x,i8,a,1x,g14.6,2x,g14.6)' ) i, ':', a(i)
        end do

      else if ( 3 .le. max_print ) then

        do i = 1, max_print - 2
          write ( *, '(2x,i8,a,1x,g14.6,2x,g14.6)' ) i, ':', a(i)
        end do
        write ( *, '(a)' ) '  ........  ..............  ..............'
        i = n
        write ( *, '(2x,i8,a,1x,g14.6,2x,g14.6)' ) i, ':', a(i)

      else

        do i = 1, max_print - 1
          write ( *, '(2x,i8,a,1x,g14.6,2x,g14.6)' ) i, ':', a(i)
        end do
        i = max_print
        write ( *, '(2x,i8,a,1x,g14.6,2x,g14.6,2x,a)' ) i, ':', a(i), 
     &    '...more entries...'

      end if

      return
      end
      subroutine c4vec_uniform_01 ( n, seed, c )

c*********************************************************************72
c
cc C4VEC_UNIFORM_01 returns a unit pseudorandom C4VEC.
c
c  Discussion:
c
c    The angles should be uniformly distributed between 0 and 2 * PI,
c    the square roots of the radius uniformly distributed between 0 and 1.
c
c    This results in a uniform distribution of values in the unit circle.
c
c  Licensing:
c
c    This code is distributed under the MIT license. 
c
c  Modified:
c
c    15 March 2005
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Input, integer N, the number of values to compute.
c
c    Input/output, integer SEED, the "seed" value, which should NOT be 0.
c    On output, SEED has been updated.
c
c    Output, complex C(N), the pseudorandom complex vector.
c
      implicit none

      integer n

      complex c(n)
      integer i
      real r
      integer k
      real pi
      parameter ( pi = 3.1415926E+00 )
      integer seed
      real theta

      do i = 1, n

        k = seed / 127773

        seed = 16807 * ( seed - k * 127773 ) - k * 2836

        if ( seed < 0 ) then
          seed = seed + 2147483647
        end if

        r = sqrt ( real ( dble ( seed ) * 4.656612875D-10 ) )

        k = seed / 127773

        seed = 16807 * ( seed - k * 127773 ) - k * 2836

        if ( seed < 0 ) then
          seed = seed + 2147483647
        end if

        theta = 2.0E+00 * pi * real ( dble ( seed ) * 4.656612875D-10 )

        c(i) = r * cmplx ( cos ( theta ), sin ( theta ) )

      end do

      return
      end
      subroutine r4mat_print_some ( m, n, a, ilo, jlo, ihi, jhi, 
     &  title )

c*********************************************************************72
c
cc R4MAT_PRINT_SOME prints some of an R4MAT.
c
c  Licensing:
c
c    This code is distributed under the MIT license. 
c
c  Modified:
c
c    12 September 2004
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Input, integer M, N, the number of rows and columns.
c
c    Input, real A(M,N), an M by N matrix to be printed.
c
c    Input, integer ILO, JLO, the first row and column to print.
c
c    Input, integer IHI, JHI, the last row and column to print.
c
c    Input, character*(*) TITLE, a title.
c
      implicit none

      integer incx
      parameter ( incx = 5 )

      integer m
      integer n

      real a(m,n)
      character*14 ctemp(incx)
      integer i
      integer i2hi
      integer i2lo
      integer ihi
      integer ilo
      integer inc
      integer j
      integer j2
      integer j2hi
      integer j2lo
      integer jhi
      integer jlo
      character*(*) title

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) trim ( title )

      do j2lo = max ( jlo, 1 ), min ( jhi, n ), incx

        j2hi = j2lo + incx - 1
        j2hi = min ( j2hi, n )
        j2hi = min ( j2hi, jhi )

        inc = j2hi + 1 - j2lo

        write ( *, '(a)' ) ' '

        do j = j2lo, j2hi
          j2 = j + 1 - j2lo
          write ( ctemp(j2), '(i7,7x)') j
        end do

        write ( *, '(''  Col   '',5a14)' ) ( ctemp(j), j = 1, inc )
        write ( *, '(a)' ) '  Row'
        write ( *, '(a)' ) ' '

        i2lo = max ( ilo, 1 )
        i2hi = min ( ihi, m )

        do i = i2lo, i2hi

          do j2 = 1, inc

            j = j2lo - 1 + j2

            if ( a(i,j) == real ( int ( a(i,j) ) ) ) then
              write ( ctemp(j2), '(f8.0,6x)' ) a(i,j)
            else
              write ( ctemp(j2), '(g14.6)' ) a(i,j)
            end if

          end do

          write ( *, '(i5,1x,5a14)' ) i, ( ctemp(j), j = 1, inc )

        end do

      end do

      return
      end
      subroutine r4mat_uniform_01 ( m, n, seed, r )

c*********************************************************************72
c
cc R4MAT_UNIFORM_01 returns a unit pseudorandom R4MAT.
c
c  Licensing:
c
c    This code is distributed under the MIT license. 
c
c  Modified:
c
c    26 March 2005
c
c  Author:
c
c    John Burkardt
c
c  Reference:
c
c    Paul Bratley, Bennett Fox, L E Schrage,
c    A Guide to Simulation,
c    Springer Verlag, pages 201-202, 1983.
c
c    Bennett Fox,
c    Algorithm 647:
c    Implementation and Relative Efficiency of Quasirandom
c    Sequence Generators,
c    ACM Transactions on Mathematical Software,
c    Volume 12, Number 4, pages 362-376, 1986.
c
c    P A Lewis, A S Goodman, J M Miller,
c    A Pseudo-Random Number Generator for the System/360,
c    IBM Systems Journal,
c    Volume 8, pages 136-143, 1969.
c
c  Parameters:
c
c    Input, integer M, N, the number of rows and columns in the array.
c
c    Input/output, integer SEED, the "seed" value, which should NOT be 0.
c    On output, SEED has been updated.
c
c    Output, real R(M,N), the array of pseudorandom values.
c
      implicit none

      integer m
      integer n

      integer i
      integer j
      integer k
      integer seed
      real r(m,n)

      do j = 1, n

        do i = 1, m

          k = seed / 127773

          seed = 16807 * ( seed - k * 127773 ) - k * 2836

          if ( seed < 0 ) then
            seed = seed + 2147483647
          end if

          r(i,j) = real ( seed ) * 4.656612875E-10

        end do
      end do

      return
      end
      subroutine r4vec_print_part ( n, a, max_print, title )

c*********************************************************************72
c
cc R4VEC_PRINT_PART prints "part" of an R4VEC.
c
c  Discussion:
c
c    The user specifies MAX_PRINT, the maximum number of lines to print.
c
c    If N, the size of the vector, is no more than MAX_PRINT, then
c    the entire vector is printed, one entry per line.
c
c    Otherwise, if possible, the first MAX_PRINT-2 entries are printed,
c    followed by a line of periods suggesting an omission,
c    and the last entry.
c
c  Licensing:
c
c    This code is distributed under the MIT license.
c
c  Modified:
c
c    22 June 2010
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Input, integer N, the number of entries of the vector.
c
c    Input, real A(N), the vector to be printed.
c
c    Input, integer MAX_PRINT, the maximum number of lines to print.
c
c    Input, character*(*) TITLE, a title.
c
      implicit none

      integer n

      real a(n)
      integer i
      integer max_print
      character*(*) title

      if ( max_print .le. 0 ) then
        return
      end if

      if ( n .le. 0 ) then
        return
      end if

      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) trim ( title )
      write ( *, '(a)' ) ' '

      if ( n .le. max_print ) then

        do i = 1, n
          write ( *, '(2x,i8,a,1x,g14.6)' ) i, ':', a(i)
        end do

      else if ( 3 .le. max_print ) then

        do i = 1, max_print - 2
          write ( *, '(2x,i8,a,1x,g14.6)' ) i, ':', a(i)
        end do

        write ( *, '(a)' ) '  ........  ..............'
        i = n

        write ( *, '(2x,i8,a,1x,g14.6)' ) i, ':', a(i)

      else

        do i = 1, max_print - 1
          write ( *, '(2x,i8,a,1x,g14.6)' ) i, ':', a(i)
        end do

        i = max_print

        write ( *, '(2x,i8,a,1x,g14.6,a)' )
     &    i, ':', a(i), '...more entries...'

      end if

      return
      end
      subroutine r4vec_uniform_01 ( n, seed, r )

c*********************************************************************72
c
cc R4VEC_UNIFORM_01 returns a unit pseudorandom R4VEC.
c
c  Licensing:
c
c    This code is distributed under the MIT license. 
c
c  Modified:
c
c    22 March 2005
c
c  Author:
c
c    John Burkardt
c
c  Reference:
c
c    Paul Bratley, Bennett Fox, L E Schrage,
c    A Guide to Simulation,
c    Springer Verlag, pages 201-202, 1983.
c
c    Bennett Fox,
c    Algorithm 647:
c    Implementation and Relative Efficiency of Quasirandom
c    Sequence Generators,
c    ACM Transactions on Mathematical Software,
c    Volume 12, Number 4, pages 362-376, 1986.
c
c    P A Lewis, A S Goodman, J M Miller,
c    A Pseudo-Random Number Generator for the System/360,
c    IBM Systems Journal,
c    Volume 8, pages 136-143, 1969.
c
c  Parameters:
c
c    Input, integer N, the number of entries in the vector.
c
c    Input/output, integer SEED, the "seed" value, which should NOT be 0.
c    On output, SEED has been updated.
c
c    Output, real R(N), the vector of pseudorandom values.
c
      implicit none

      integer n

      integer i
      integer k
      integer seed
      real r(n)

      do i = 1, n

        k = seed / 127773

        seed = 16807 * ( seed - k * 127773 ) - k * 2836

        if ( seed < 0 ) then
          seed = seed + 2147483647
        end if

        r(i) = real ( seed ) * 4.656612875E-10

      end do

      return
      end

#pragma -xO
c   date: fri, 24 jun 88 11:16:54 pdt
c   from: david bailey <dbailey@ew11.nas.nasa.gov>
      program nasker
c
c   nas kernel benchmark program
c   12/17/84      david h bailey
c
      character*8 pn(8)
      real er(8), fp(8), tm(8), rt(8)
      data pn/'mxm', 'cfft2d', 'cholsky', 'btrix', 'gmtry', 'emit',
     $ 'vpenta', 'total'/
c
      call cputim(-1.0d0)
c
      write (6, 1)
1     format (/16x, 'the nas kernel benchmark program'//)
c
      call mxmtst (er(1), fp(1), tm(1))
      call ffttst (er(2), fp(2), tm(2))
      call chotst (er(3), fp(3), tm(3))
      call btrtst (er(4), fp(4), tm(4))
      call gmttst (er(5), fp(5), tm(5))
      call emitst (er(6), fp(6), tm(6))
      call vpetst (er(7), fp(7), tm(7))
c
      te = 0.
      tf = 0.
      tt = 0.
      do 100 i = 1, 7
        te = te + er(i)
        tf = tf + fp(i)
        tt = tt + tm(i)
        rt(i) = 1e-6 * fp(i) / tm(i)
100   continue
      er(8) = te
      fp(8) = tf
      tm(8) = tt
      rt(8) = 1e-6 * tf / tt
c
      write (6, 2)  (pn(i), er(i), fp(i), tm(i), rt(i), i = 1, 8)
2     format (' program', 8x, 'error', 10x, 'fp ops', 7x, 'seconds',
     $  6x, 'mflops'// 7(1x, a8, 1p, 2e15.4, 0p, f12.4, f12.2/)/
     $  1x, a8, 1p, 2e15.4, 0p, f12.4, f12.2//)
c
      stop
      end
c
      function cptime ()
c
c   returns the cpu time since the last call to cptime.
c   this subprogram may be changed as needed for a particular computer
c   system without penalty, provided it performs this function.
c
c     data tx/0./
c     t = second ()
c     cptime = t - tx
c     tx = t
      real*8 a
      call cputim(a)
      cptime = a
      return
      end
c
      subroutine copy (n, a, b)
c
c   array copy routine
c
      real a(n), b(n)
      do 100 i = 1, n
        b(i) = a(i)
100   continue
      return
      end
c
      subroutine mxmtst (er, fp, tm)
c
c   floating-point matrix multiply test
c
      parameter (l=256, m=128, n=64, f7=78125., t30=1073741824.)
      common /arrays2/ a(l,m), s1, b(m,n), s2, c(l,n)
      data it/100/, ans/35.2026179738722/
c
c   initialization
c
c   the arrays a and b are filled with pseudo-random  (0., 1.)  data
c   using a random number generator based on the recursion
c           x(n+1) = 5**7 * x(n)  (mod 2**30)
c   this recursion will generate 2**28 (approx. 268 million) numbers
c   before repeating.  for this scheme to work properly, the hardware
c   multiply operation must be correct to 47 bits of precision.
c   this same scheme is used to initialize data arrays for all tests.
c
      t = f7 / t30
      do 100 j = 1, m
        do 100 i = 1, l
          t = mod (f7 * t, 1.)
          a(i,j) = t
100   continue
      do 110 j = 1, n
        do 110 i = 1, m
          t = mod (f7 * t, 1.)
          b(i,j) = t
110   continue
      tm = cptime ()
c
c   timing test
c
      do 120 ii = 1, it
        call mxm (a, b, c, l, m, n)
120   continue
c
      tm = cptime ()
      er = abs ((c(19,19) - ans) / ans)
      fp = 2. * it * l * m * n
c
      return
      end
c
      subroutine mxm (a, b, c, l, m, n)
      dimension a(l,m), b(m,n), c(l,n)
c
c   4-way unrolled matrix multiply routine for vector computers.
c   m must be a multiple of 4.  contiguous data assumed.
c   d h bailey  11/15/84
c
      do 100 k = 1, n
        do 100 i = 1, l
          c(i,k) = 0.
100     continue
      do 110 j = 1, m, 4
        do 110 k = 1, n
          do 110 i = 1, l
            c(i,k) = c(i,k) + a(i,j) * b(j,k)
     $             + a(i,j+1) * b(j+1,k) + a(i,j+2) * b(j+2,k)
     $             + a(i,j+3) * b(j+3,k)
110   continue
c
      return
      end
c
      subroutine ffttst (er, fp, tm)
c
c   2-d fft test program
c
      parameter (m=128, n=256, m1=128, f7=78125., t30=1073741824.)
      complex x, y, ct
      common /arrays3/ x(m1,n), w1(m), w2(n), ip(2*n)
      data it/100/, ans/0.894799941219277/
c
c   initialize
c
      amn = m * n
      rmn = 1. / amn
      t2 = f7 / t30
      do 100 j = 1, n
        do 100 i = 1, m
          t1 = mod (f7 * t2, 1.)
          t2 = mod (f7 * t1, 1.)
          x(i,j) = cmplx (t1, t2)
100   continue
      call cfft2d1 (0, m, m1, n, x, w1, ip)
      call cfft2d2 (0, m, m1, n, x, w2, ip)
      tm = cptime ()
c
c   test iterations
c
      do 120 k = 1, it
        do 110 j = 1, n
          do 110 i = 1, m
            x(i,j) = rmn * x(i,j)
110     continue
c
        call cfft2d1 (1, m, m1, n, x, w1, ip)
        call cfft2d2 (1, m, m1, n, x, w2, ip)
        call cfft2d2 (-1, m, m1, n, x, w2, ip)
        call cfft2d1 (-1, m, m1, n, x, w1, ip)
120   continue
c
      tm = cptime ()
      er = abs ((real(x(19,19)) - ans) / ans)
      fp = it * amn * (2.  +  10. * log (amn)/log (2.))
c
      return
      end
c
      subroutine cfft2d1 (is, m, m1, n, x, w, ip)
c
c   performs complex radix 2 ffts on the first dimension of the 2-d array x
c   d h bailey  11/15/84
c
      complex x(m1,n), w(m), ct, cx
      integer ip(2,m)
      data pi/3.141592653589793/
c
c   if  is = 0  then initialize only
c
      m2 = m / 2
      if (is .eq. 0)  then
        do 100 i = 1, m2
          t = 2. * pi * (i-1) / m
          w(i) = cmplx (cos (t), sin (t))
100     continue
        return
      endif
c
c   perform forward or backward ffts according to  is = 1 or -1
c
      do 110 i = 1, m
        ip(1,i) = i
110   continue
      l = 1
      i1 = 1
c
120   i2 = 3 - i1
      do 130 j = l, m2, l
        cx = w(j-l+1)
        if (is .lt. 0)  cx = conjg (cx)
        do 130 i = j-l+1, j
          ii = ip(i1,i)
          ip(i2,i+j-l) = ii
          im = ip(i1,i+m2)
          ip(i2,i+j) = im
          do 130 k = 1, n
            ct = x(ii,k) - x(im,k)
            x(ii,k) = x(ii,k) + x(im,k)
            x(im,k) = ct * cx
130   continue
      l = 2 * l
      i1 = i2
      if (l .le. m2)  goto 120
c
      do 150 i = 1, m
        ii = ip(i1,i)
        if (ii .gt. i)  then
          do 140 k = 1, n
            ct = x(i,k)
            x(i,k) = x(ii,k)
            x(ii,k) = ct
140       continue
        endif
150   continue
c
      return
      end
c
      subroutine cfft2d2 (is, m, m1, n, x, w, ip)
c
c   performs complex radix 2 ffts on the second dimension of the 2-d array x
c   d h bailey  11/15/84
c
      complex x(m1,n), w(n), ct, cx
      integer ip(2,n)
      data pi/3.141592653589793/
c
c   if  is = 0  then initialize only
c
      n2 = n / 2
      if (is .eq. 0)  then
        do 100 i = 1, n2
          t = 2. * pi * (i-1) / n
          w(i) = cmplx (cos (t), sin (t))
100     continue
        return
      endif
c
c   peform forward or backward ffts according to  is = 1 or -1
c
      do 110 i = 1, n
        ip(1,i) = i
110   continue
      l = 1
      i1 = 1
c
120   i2 = 3 - i1
      do 130 j = l, n2, l
        cx = w(j-l+1)
        if (is .lt. 0)  cx = conjg (cx)
        do 130 i = j-l+1, j
          ii = ip(i1,i)
          ip(i2,i+j-l) = ii
          im = ip(i1,i+n2)
          ip(i2,i+j) = im
          do 130 k = 1, m
            ct = x(k,ii) - x(k,im)
            x(k,ii) = x(k,ii) + x(k,im)
            x(k,im) = ct * cx
130   continue
      l = 2 * l
      i1 = i2
      if (l .le. n2)  goto 120
c
      do 150 i = 1, n
        ii = ip(i1,i)
        if (ii .gt. i)  then
          do 140 k = 1, m
            ct = x(k,i)
            x(k,i) = x(k,ii)
            x(k,ii) = ct
140       continue
        endif
150   continue
c
      return
      end
c
      subroutine chotst (er, fp, tm)
c
c   cholsky test program
c
      parameter (ida=250, nmat=250, m=4, n=40, nrhs=3, f7=78125.,
     $ t30=1073741824.)
      common /arrays4/ a(0:ida, -m:0, 0:n), b(0:nrhs, 0:nmat, 0:n),
     $   ax(0:ida, -m:0, 0:n), bx(0:nrhs, 0:nmat, 0:n)
      data  it/200/, ans/5177.88531774562/
c
c   initialize
c
      la = (ida+1) * (m+1) * (n+1)
      lb = (nrhs+1) * (nmat+1) * (n+1)
      t = f7 / t30
      do 100 k = 0, n
        do 100 j = -m, 0
          do 100 i = 0, ida
            t = mod (f7 * t, 1.)
            ax(i,j,k) = t
100     continue
      do 110 k = 0, n
        do 110 j = 0, nmat
          do 110 i = 0, nrhs
            t = mod (f7 * t, 1.)
            bx(i,j,k) = t
110   continue
      tm = cptime ()
c
c   begin timing test
c
      do 120 j = 1, it
        call copy (la, ax, a)
        call copy (lb, bx, b)
        call cholsky (ida, nmat, m, n, a, nrhs, ida, b)
120   continue
c
      tm = cptime ()
      er = abs ((b(1,19,19) - ans) / ans)
      fp = it * (nmat + 1) * 4403.
c
      return
      end
c
      subroutine cholsky (ida, nmat, m, n, a, nrhs, idb, b)
c
c   cholesky decomposition/substitution subroutine.
c
c   11/28/84  d h bailey  modified for nas kernel test
c
      real a(0:ida, -m:0, 0:n), b(0:nrhs, 0:idb, 0:n), epss(0:256)
      data eps/1e-13/
c
c  cholesky decomposition
c
      do 1 j = 0, n
        i0 = max ( -m, -j )
c
c  off diagonal elements
c
        do 2 i = i0, -1
          do 3 jj = i0 - i, -1
            do 3 l = 0, nmat
3             a(l,i,j) = a(l,i,j) - a(l,jj,i+j) * a(l,i+jj,j)
          do 2 l = 0, nmat
2           a(l,i,j) = a(l,i,j) * a(l,0,i+j)
c
c  store inverse of diagonal elements
c
        do 4 l = 0, nmat
4         epss(l) = eps * a(l,0,j)
        do 5 jj = i0, -1
          do 5 l = 0, nmat
5           a(l,0,j) = a(l,0,j) - a(l,jj,j) ** 2
        do 1 l = 0, nmat
1         a(l,0,j) = 1. / sqrt ( abs (epss(l) + a(l,0,j)) )
c
c  solution
c
      do 6 i = 0, nrhs
        do 7 k = 0, n
          do 8 l = 0, nmat
8           b(i,l,k) = b(i,l,k) * a(l,0,k)
          do 7 jj = 1, min (m, n-k)
            do 7 l = 0, nmat
7             b(i,l,k+jj) = b(i,l,k+jj) -  a(l,-jj,k+jj) * b(i,l,k)
c
        do 6 k = n, 0, -1
          do 9 l = 0, nmat
9           b(i,l,k) = b(i,l,k) * a(l,0,k)
          do 6 jj = 1, min (m, k)
            do 6 l = 0, nmat
6             b(i,l,k-jj) = b(i,l,k-jj) - a(l,-jj,k) * b(i,l,k)
c
      return
      end
c
      subroutine btrtst (er, fp, tm)
c
c   btrix test program
c
      parameter (jd=30, kd=30, ld=30, md=30, f7=78125., t30=1073741824.)
      common /arrays5/ s(jd,kd,ld,5), a(5,5,md,md), b(5,5,md,md),
     $     c(5,5,md,md), sx(jd,kd,ld,5), bx(5,5,md,md)
      data js/2/, je/29/, ls/2/, le/29/, it/20/, ans/-0.286282658663962/
c
c   initialization
c
      nb = 25 * md * md
      ns = jd * kd * ld * 5
      t = f7 / t30
      do 100 l = 1, md
        do 100 k = 1, md
          do 100 j = 1, 5
            do 100 i = 1, 5
              t = mod (f7 * t, 1.)
              a(i,j,k,l) = t
              t = mod (f7 * t, 1.)
              bx(i,j,k,l) = t
              t = mod (f7 * t, 1.)
              c(i,j,k,l) = t
100   continue
      do 110 l = 1, 5
        do 110 k = 1, ld
          do 110 j = 1, kd
            do 110 i = 1, jd
              t = mod (f7 * t, 1.)
              sx(i,j,k,l) = t
110   continue
      tm = cptime ()
c
c   timing test
c
      do 120 ii = 1, it
        call copy (ns, sx, s)
        do 120 k = 1, kd
          call copy (nb, bx, b)
          call btrix (js, je, ls, le, k)
120   continue
c
      tm = cptime ()
      er = abs ((s(19,19,19,1) - ans) / ans)
      fp = it * md * (le - 1) * 19165.
c
      return
      end
c
      subroutine btrix (js, je, ls, le, k)
c
c     vectorized block tri-diagonal solver in the j direction
c          for k = constant planes
c
c   11/15/84  d h bailey  modified for nas kernel test
c
      parameter (jd=30, kd=30, ld=30, md=30)
      common /arrays5/ s(jd,kd,ld,5), a(5,5,md,md), b(5,5,md,md),
     $     c(5,5,md,md)
c
      dimension    u12(md), u13(md), u14(md), u15(md), u23(md),
     $             u24(md), u25(md), u34(md), u35(md), u45(md)
c
      real         l11(md), l21(md), l31(md), l41(md), l51(md),
     $             l22(md), l32(md), l42(md), l52(md), l33(md),
     $             l43(md), l53(md), l44(md), l54(md), l55(md)
c
c     part 1.  forward block sweep
c
c
      do 100 j   = js,je
c
c**********   step 1.  construct l(i) in b    **************************
c
      if(j.eq.js) go to 4
      do 3 m = 1,5
        do 3 n = 1,5
          do 3 l = ls,le
            b(m,n,j,l) = b(m,n,j,l) - a(m,1,j,l)*b(1,n,j-1,l)
     $           - a(m,2,j,l)*b(2,n,j-1,l) - a(m,3,j,l)*b(3,n,j-1,l)
     $           - a(m,4,j,l)*b(4,n,j-1,l) - a(m,5,j,l)*b(5,n,j-1,l)
    3 continue
c
    4 continue
c
c**********    step 2.  conpute l inverse    ***************************
c
c
c        a.  decompose l(i) into l and u
c
      do 20 l = ls,le
        l11(l)  = 1. / b(1,1,j,l)
        u12(l)  = b(1,2,j,l)*l11(l)
        u13(l)  = b(1,3,j,l)*l11(l)
        u14(l)  = b(1,4,j,l)*l11(l)
        u15(l)  = b(1,5,j,l)*l11(l)
        l21(l)  = b(2,1,j,l)
        l22(l)  = 1. / (b(2,2,j,l) - l21(l)*u12(l))
        u23(l)  = (b(2,3,j,l) - l21(l)*u13(l)) * l22(l)
        u24(l)  = (b(2,4,j,l) - l21(l)*u14(l)) * l22(l)
        u25(l)  = (b(2,5,j,l) - l21(l)*u15(l)) * l22(l)
        l31(l)  = b(3,1,j,l)
        l32(l)  = b(3,2,j,l) - l31(l)*u12(l)
        l33(l)  = 1. / (b(3,3,j,l) - l31(l)*u13(l) - l32(l)*u23(l))
        u34(l)  = (b(3,4,j,l) - l31(l)*u14(l) - l32(l)*u24(l)) * l33(l)
        u35(l)  = (b(3,5,j,l) - l31(l)*u15(l) - l32(l)*u25(l)) * l33(l)
   20 continue
c
      do 25 l = ls,le
        l41(l)  = b(4,1,j,l)
        l42(l)  = b(4,2,j,l) - l41(l)*u12(l)
        l43(l)  = b(4,3,j,l) - l41(l)*u13(l) - l42(l)*u23(l)
        l44(l)  = 1. / (b(4,4,j,l) - l41(l)*u14(l) - l42(l)*u24(l)
     $      - l43(l)*u34(l))
        u45(l)  = (b(4,5,j,l) - l41(l)*u15(l) - l42(l)*u25(l)
     $      - l43(l)*u35(l)) * l44(l)
        l51(l)  = b(5,1,j,l)
        l52(l)  = b(5,2,j,l) - l51(l)*u12(l)
        l53(l)  = b(5,3,j,l) - l51(l)*u13(l) - l52(l)*u23(l)
        l54(l)  = b(5,4,j,l) - l51(l)*u14(l) - l52(l)*u24(l)
     $      - l53(l)*u34(l)
        l55(l)  = 1. / (b(5,5,j,l) - l51(l)*u15(l) - l52(l)*u25(l)
     $      - l53(l)*u35(l) - l54(l)*u45(l))
   25 continue
c
c**********    step 3.  solve for intermediate vector    ***************
c
c         a.  construct rhs
c
      if(j.eq.js) go to 34
      do 33 m = 1,5
        do 33 l = ls,le
          s(j,k,l,m) = s(j,k,l,m) - a(m,1,j,l)*s(j-1,k,l,1)
     $         - a(m,2,j,l)*s(j-1,k,l,2) - a(m,3,j,l)*s(j-1,k,l,3)
     $         - a(m,4,j,l)*s(j-1,k,l,4) - a(m,5,j,l)*s(j-1,k,l,5)
   33 continue
c
c         b. intermediate vector
c
   34 continue
c
c         fwd substitution
c
      do 35 l = ls,le
        d1 = s(j,k,l,1)*l11(l)
        d2 = (s(j,k,l,2) - l21(l)*d1) * l22(l)
        d3 = (s(j,k,l,3) - l31(l)*d1 - l32(l)*d2) * l33(l)
        d4 = (s(j,k,l,4) - l41(l)*d1 - l42(l)*d2 - l43(l)*d3) * l44(l)
        d5 = (s(j,k,l,5) - l51(l)*d1 - l52(l)*d2 - l53(l)*d3
     $       - l54(l)*d4) * l55(l)
c
c         bwd substitution
c
        s(j,k,l,5)  = d5
        s(j,k,l,4)  = d4 - u45(l)*d5
        s(j,k,l,3)  = d3 - u34(l)*s(j,k,l,4) - u35(l)*d5
        s(j,k,l,2)  = d2 - u23(l)*s(j,k,l,3) - u24(l)*s(j,k,l,4)
     $       - u25(l)*d5
        s(j,k,l,1)  = d1 - u12(l)*s(j,k,l,2) - u13(l)*s(j,k,l,3)
     $       - u14(l)*s(j,k,l,4) - u15(l)*d5
   35 continue
c
c**********    step 4.  construct u(i) = l(i)**(-1)*c(i+1)    **********
c**********             by columns and store in b            **********
c
      if(j.eq.je) go to 100
      do 40 n = 1,5
        do 40 l = ls,le
c
c         fwd substitution
c
          c1 = c(1,n,j,l)*l11(l)
          c2 = (c(2,n,j,l) - l21(l)*c1) * l22(l)
          c3 = (c(3,n,j,l) - l31(l)*c1 - l32(l)*c2) * l33(l)
          c4 = (c(4,n,j,l) - l41(l)*c1 - l42(l)*c2 - l43(l)*c3)
     $          * l44(l)
          c5 = (c(5,n,j,l) - l51(l)*c1 - l52(l)*c2 - l53(l)*c3
     $          - l54(l)*c4) * l55(l)
c
c         bwd substitution
c
          b(5,n,j,l)  = c5
          b(4,n,j,l)  = c4 - u45(l)*c5
          b(3,n,j,l)  = c3 - u34(l)*b(4,n,j,l) - u35(l)*c5
          b(2,n,j,l)  = c2 - u23(l)*b(3,n,j,l) - u24(l)*b(4,n,j,l)
     $         - u25(l)*c5
          b(1,n,j,l)  = c1 - u12(l)*b(2,n,j,l) - u13(l)*b(3,n,j,l)
     $         - u14(l)*b(4,n,j,l) - u15(l)*c5
   40 continue
c
c
  100 continue
c
c     part 2.  backward block sweep
c
      jem1 = je - 1
c
      do 200 j = jem1,js,-1
        do 200 m = 1,5
          do 200 l = ls,le
            s(j,k,l,m) = s(j,k,l,m) - b(m,1,j,l)*s(j+1,k,l,1)
     $           - b(m,2,j,l)*s(j+1,k,l,2) - b(m,3,j,l)*s(j+1,k,l,3)
     $           - b(m,4,j,l)*s(j+1,k,l,4) - b(m,5,j,l)*s(j+1,k,l,5)
  200 continue
c
      return
      end
c
      subroutine gmttst (er, fp, tm)
c
      parameter (nw=100, nb=5, f7=78125., t30=1073741824.)
      complex wall, zcr, proj, zi, z1, zz
      common /arrays6/ nwall(nb), wall(nw,nb), rmatrx(nw*nb,nw*nb),
     $ zcr(nw,nb), proj(nw,nb), xxmax(nb)
      data it/2/, ans/-2.57754233214174/
c
c   initialization
c
      lw = 2 * nw * nb
      t2 = f7 / t30
      do 100 j = 1, nb
        nwall(j) = nw
100   continue
      do 110 j = 1, nb
        do 110 i = 1, nw
          t1 = mod (f7 * t2, 1.)
          t2 = mod (f7 * t1, 1.)
          wall(i,j) = cmplx (t1, t2)
110   continue
      tm = cptime ()
c
c   timing test
c
      do 120 i = 1, it
        call gmtry
120   continue
c
      tm = cptime ()
      er = abs ((rmatrx(19,19) - ans) / ans)
      fp = it * (120. * (nb*nw) ** 2  +  0.666 * (nb*nw) ** 3)
c
      return
      end
c
      subroutine gmtry
c
c  compute solid-related arrays,  gauss eliminate the matrix of wall
c  influence coefficients.
c
c    11/30/84  d h bailey    revised code for nas kernel test
c
      parameter (nw=100, nb=5)
      complex wall, zcr, proj, zi, z1, zz
      common /arrays6/ nwall(nb), wall(nw,nb), rmatrx(nw*nb,nw*nb),
     $ zcr(nw,nb), proj(nw,nb), xxmax(nb)
c
      data  arcl /5./, pi /3.141592653589793/, period/3./
c
c  compute arclength.
c
      matdim = 0
      arcl = 0.
      ymin = 1.e+50
      ymax = -1.e+50
      pidp = pi / period
c
      do 9 l = 1, nb
        matdim = matdim + nwall(l)
        do 9 k = 1,nwall(l)
          arcl = arcl + abs(wall(k,l) - wall(1+mod(k,nwall(l)), l))
9     continue
c
c  compute core radius.
c
      r0 = arcl / (matdim*2.)
      sigma = r0 / 2.
c
c  define creation points.
c
      do 6 l = 1,nb
        do 5 k = 1,nwall(l)
          zz = wall(1+mod(k+nwall(l)-2,nwall(l)), l)
     &         - wall(1+mod(k,nwall(l)), l)
          zcr(k,l) = wall(k,l) + cmplx(0., r0/abs(zz)) * zz
5       continue
c
c  check that wall and creation points are not crossed due to
c  too sharp a concave kink or an error in defining the body.
c  also find highest,  lowest and right-most point.
c
        xxmax(l) = real(zcr(1,l))
        ls = 0
        do 6 k = 1,nwall(l)
          ymin = min (ymin, aimag(zcr(k,l)))
          ymax = max (ymax, aimag(zcr(k,l)))
          xxmax(l) = max (xxmax(l), real(zcr(k,l)))
          kp = 1 + mod(k, nwall(l))
          if (real((zcr(kp,l) - zcr(k,l)) *
     &        conjg(wall(kp,l) - wall(k,l))).gt.0.) then
            ls = l
            ks = k
          endif
6     continue
c
c       if (ls .ne. 0) then
c         write (6, 102) ls, ks
c102      format(" on body number ", i3, " you have too sharp a",
c     &      " kink near point ", i4)
c         stop
c       endif
c
c  the "main period" will be between ylimit and ylimit + period.
c
      ylimit = (ymin - period + ymax)/2
c
c  project creation points into main period. this is technical.
c
      do 1 l = 1,nb
        do 1 k = 1,nwall(l)
          proj(k,l) = zcr(k,l) - cmplx(0., period*
     &           (int(5. + (aimag(zcr(k,l)) - ylimit) / period) - 5.))
1     continue
c
c   compute matrix.
c
      sig2 = (2. * pidp * sigma) ** 2
      i0 = 0
      do 2 l1 = 1,nb
        j0 = 0
        do 4 l2 = 1,nb
          kron = 0
          if (l1 .eq. l2) kron = 1
          do 3 j = 1,nwall(l2)
            rmatrx(i0+1,j0+j) = kron
            z1 = exp ((wall(1,l1) - zcr(j,l2)) * pidp)
            z1 = z1 - 1. / z1
            dum = sig2 + real(z1)**2 + aimag(z1)**2
            do 3 i = 2,nwall(l1)
              zi = exp ((wall(i,l1) - zcr(j,l2)) * pidp)
              zz = zi - 1. / zi
              rmatrx(i0+i,j0+j) = -0.25 / pi * log (dum /
     &              (sig2 + real(zz) ** 2 + aimag(zz) ** 2))
3         continue
          j0 = j0 + nwall(l2)
4       continue
        i0 = i0 + nwall(l1)
2     continue
c
c  gauss elimination
c
      do 8 i = 1, matdim
        rmatrx(i,i) = 1. / rmatrx(i,i)
        do 8 j = i+1, matdim
          rmatrx(j,i) = rmatrx(j,i) * rmatrx(i,i)
          do 8 k = i+1, matdim
            rmatrx(j,k) = rmatrx(j,k) - rmatrx(j,i) * rmatrx(i,k)
8     continue
c
      return
      end
c
      subroutine emitst (er, fp, tm)
c
c   emit test subroutine
c
      parameter (nw=100, nb=5, nv=1000, nvm=1500, f7=78125.,
     $ t30=1073741824.)
      complex z, wall, zcr, refpt,  expwkl, expmwk, force,
     & uupstr, dum3, expz, expmz
      common /arrays6/ nwall(nb), wall(nw,nb), rmatrx(nw*nb,nw*nb),
     $ zcr(nw,nb), z(nvm), gamma(nvm), refpt(nb), rhs(nw*nb),
     $ force(nb), rmom(nb), cp(nw,nb), dpds(nw,nb), expz(nvm),
     $ expmz(nvm), psi(nw), ps(nvm)
      data it/10/, ans/6.0088546832072/
c
      t2 = f7 / t30
      do 100 j = 1, nb
        nwall(j) = nw
        refpt(j) = 0.
        force(j) = 0.
        rmom(j) = 0.
        do 100 i = 1, nw
          t1 = mod (f7 * t2, 1.)
          t2 = mod (f7 * t1, 1.)
          wall(i,j) = cmplx (t1, t2)
          t1 = mod (f7 * t2, 1.)
          t2 = mod (f7 * t1, 1.)
          zcr(i,j) = cmplx (t1, t2)
          dpds(i,j) = 0.
100   continue
      do 110 j = 1, nw*nb
        rmatrx(j,j) = 1.
        do 110 i = 1, j-1
          t2 = mod (f7 * t2, 1.)
          rmatrx(i,j) = .001 * t2
          rmatrx(j,i) = .001 * t2
110   continue
      do 120 i = 1, nvm
        t1 = mod (f7 * t2, 1.)
        t2 = mod (f7 * t1, 1.)
        z(i) = cmplx (t1, t2)
        t2 = mod (f7 * t2, 1.)
        gamma(i) = t2
120   continue
      tm = cptime ()
c
c   timing test
c
      do 130 i = 1, it
        call emit
130   continue
c
      tm = cptime ()
      er = abs ((rhs(19) - ans) / ans)
      fp = it * (56.*nv + nb*nw * (97. + 44.*nv + 2.*nb*nw))
c
      return
      end
c
      subroutine emit
c
c  emit new vortices to satisfy boundary condition.
c  finish computing pressure, forces, etc.
c
c   11/28/84  d h bailey  modified for nas kernel test
c
      parameter (nw=100, nb=5, nvm=1500)
      complex z, wall, zcr, refpt,  expwkl, expmwk, force,
     & uupstr, dum3, expz, expmz, zz
      common /arrays6/ nwall(nb), wall(nw,nb), rmatrx(nw*nb,nw*nb),
     $ zcr(nw,nb), z(nvm), gamma(nvm), refpt(nb), rhs(nw*nb),
     $ force(nb), rmom(nb), cp(nw,nb), dpds(nw,nb), expz(nvm),
     $ expmz(nvm), psi(nw), ps(nvm)
c
      data  period/3./, sig2/3./, u0/4./, matdim/500/, delt/1./,
     $  chord/5./, pi/3.141592653589793/, uupstr/(3., 4.)/
c
c  store exp(z(i)) and exp(-z(i)) to reduce work in inner loop 4.
c
      nv = 1000
      pidp = pi / period
c
      do 2 i = 1, nv
        expz(i) = exp (z(i) * pidp)
        expmz(i) = 1. / expz(i)
2     continue
c
      i0 = 0
      cupst = real(uupstr) ** 2 + aimag(uupstr) ** 2
c
      do 5 l = 1, nb
        do 6 k = 1, nwall(l)
          expwkl = exp (wall(k,l) * pidp)
          expmwk = 1. / expwkl
          sps = 0.
          do 4 i = 1, nv
            dum3 = expz(i) * expmwk - expwkl * expmz(i)
            ps(i) = gamma(i) * log (real(dum3) ** 2 +
     &              aimag(dum3) ** 2 + sig2)
            sps = sps + ps(i)
4         continue
          psi(k) = aimag(wall(k,l) * conjg (uupstr + cmplx (0., u0)))
     &             - sps * 0.25 / pi
6       continue
c
c  compute right-hand side.
c
        do 8 k = 1, nwall(l)
          rhs(i0+k) = psi(k) - psi(1)
8       continue
        i0 = i0 + nwall(l)
5     continue
c
c  solve system
c
      do 10 i = 1, matdim
        do 10 j = i+1, matdim
          rhs(j) = rhs(j) - rmatrx(j,i) * rhs(i)
10    continue
      do 11 i = matdim, 1, -1
        rhs(i) = rmatrx(i,i) * rhs(i)
        do 11 j = 1, i-1
          rhs(j) = rhs(j) - rmatrx(j,i) * rhs(i)
11    continue
c
c  create new vortices.
c
      nolld = nv
      i0 = 0
      do 7 l = 1, nb
        do 3 k = 1, nwall(l)
c
c  put the new vortex at the end of the array.
c
          nv = nv+1
          z(nv) = zcr(k,l)
          gamma(nv) = rhs(i0+k)
c
c  record the gain of linear and angular momentum
c
          force(l) = force(l) + gamma(nv) * z(nv)
          rmom(l) = rmom(l) + gamma(nv) * (real (z(nv) - refpt(l)) ** 2
     &              + aimag (z(nv) - refpt(l)) ** 2)
          dpds(k,l) = dpds(k,l) - gamma(nv)
3       continue
c
c  filter and integrate pressure gradient to get pressure
c
        cp(1,l) = 0.
        cpm = -1e50
        do 9 k = 2, nwall(l)
          cp(k,l) = cp(k-1,l) + (3. * (dpds(k,l) + dpds(k-1,l))
     &              + dpds(1+mod(k,nwall(l)), l)
     &              + dpds(1+mod(k+nwall(l)-3, nwall(l)), l))
     &              / (4. * delt * cupst)
          cpm = max (cpm, cp(k,l))
9       continue
c
c  normalize pressure
c
        do 12 k = 1, nwall(l)
          cp(k,l) = cp(k,l) - cpm
12      continue
c
c  finish computing force and moment,  as time rate of change of linear
c  and angular momentum
c
        force(l) = force(l) * cmplx (0., 2. / (delt * chord * cupst))
        rmom(l) = rmom(l) * 2. / (delt * chord ** 2 * cupst)
c
        i0=i0+nwall(l)
7     continue
c
      return
      end

      subroutine vpetst (er, fp, tm)
c
c   vpenta test program
c
      parameter (nja=128, njb=128, jl=1, ju=128, kl=1, ku=128,
     $ f7=78125., t30=1073741824.)
      common /arrays7/ a(nja,njb), b(nja,njb), c(nja,njb), d(nja,njb),
     $ e(nja,njb), f(nja,njb,3), x(nja,njb), y(nja,njb), fx(nja,njb,3)
      data it/400/, ans/-0.354649411858726/
c
      lf = nja * njb * 3
      t = f7 / t30
      do 100 j = kl, ku
        do 100 i = jl, ju
          t = mod (f7 * t, 1.)
          a(i,j) = t
          t = mod (f7 * t, 1.)
          b(i,j) = t
          t = mod (f7 * t, 1.)
          c(i,j) = t
          t = mod (f7 * t, 1.)
          d(i,j) = t
          t = mod (f7 * t, 1.)
          e(i,j) = t
          do 100 k = 1, 3
            t = mod (f7 * t, 1.)
            fx(i,j,k) = t
100   continue
      tm = cptime ()
c
c   timing test
c
      do 110 i = 1, it
        call copy (lf, fx, f)
        call vpenta
110   continue
c
      tm = cptime ()
      er = abs ((f(19,19,1) - ans) / ans)
      fp = it * ku * (40. * ku - 53.)
c
      return
      end
c
      subroutine vpenta
c
c    routine to invert 3 pentadiagonals simultaneously
c
c   12/05/84  d h bailey   modified for nas kernel test
c
      parameter (nja=128, njb=128, jl=1, ju=128, kl=1, ku=128)
      common /arrays7/ a(nja,njb), b(nja,njb), c(nja,njb), d(nja,njb),
     $ e(nja,njb), f(nja,njb,3), x(nja,njb), y(nja,njb), fx(nja,njb,3)
c
c	! start forward generation process and sweep
c
      j = jl
      do 1 k = kl,ku
        rld = c(j,k)
        rldi = 1./rld
        f(j,k,1) = f(j,k,1)*rldi
        f(j,k,2) = f(j,k,2)*rldi
        f(j,k,3) = f(j,k,3)*rldi
        x(j,k) = d(j,k)*rldi
        y(j,k) = e(j,k)*rldi
1     continue
c
      j = jl+1
      do 2 k = kl,ku
        rld1 = b(j,k)
        rld = c(j,k) - rld1*x(j-1,k)
        rldi = 1./rld
        f(j,k,1) = (f(j,k,1) - rld1*f(j-1,k,1))*rldi
        f(j,k,2) = (f(j,k,2) - rld1*f(j-1,k,2))*rldi
        f(j,k,3) = (f(j,k,3) - rld1*f(j-1,k,3))*rldi
        x(j,k) = (d(j,k) - rld1*y(j-1,k))*rldi
        y(j,k) = e(j,k)*rldi
2     continue
c
      do 3 j = jl+2,ju-2
        do 11 k = kl,ku
          rld2 = a(j,k)
          rld1 = b(j,k) - rld2*x(j-2,k)
          rld = c(j,k) - (rld2*y(j-2,k) + rld1*x(j-1,k))
          rldi = 1./rld
          f(j,k,1) = (f(j,k,1) - rld2*f(j-2,k,1) - rld1*f(j-1,k,1))*rldi
          f(j,k,2) = (f(j,k,2) - rld2*f(j-2,k,2) - rld1*f(j-1,k,2))*rldi
          f(j,k,3) = (f(j,k,3) - rld2*f(j-2,k,3) - rld1*f(j-1,k,3))*rldi
          x(j,k) = (d(j,k) - rld1*y(j-1,k))*rldi
          y(j,k) = e(j,k)*rldi
11      continue
3     continue
c
      j = ju-1
      do 12 k = kl,ku
        rld2 = a(j,k)
        rld1 = b(j,k) - rld2*x(j-2,k)
        rld = c(j,k) - (rld2*y(j-2,k) + rld1*x(j-1,k))
        rldi = 1./rld
        f(j,k,1) = (f(j,k,1) - rld2*f(j-2,k,1) - rld1*f(j-1,k,1))*rldi
        f(j,k,2) = (f(j,k,2) - rld2*f(j-2,k,2) - rld1*f(j-1,k,2))*rldi
        f(j,k,3) = (f(j,k,3) - rld2*f(j-2,k,3) - rld1*f(j-1,k,3))*rldi
        x(j,k) = (d(j,k) - rld1*y(j-1,k))*rldi
12    continue
c
      j = ju
      do 13 k = kl,ku
        rld2 = a(j,k)
        rld1 = b(j,k) - rld2*x(j-2,k)
        rld = c(j,k) - (rld2*y(j-2,k) + rld1*x(j-1,k))
        rldi = 1./rld
        f(j,k,1) = (f(j,k,1) - rld2*f(j-2,k,1) - rld1*f(j-1,k,1))*rldi
        f(j,k,2) = (f(j,k,2) - rld2*f(j-2,k,2) - rld1*f(j-1,k,2))*rldi
        f(j,k,3) = (f(j,k,3) - rld2*f(j-2,k,3) - rld1*f(j-1,k,3))*rldi
13    continue
c
c        !  back sweep solution
c
      do 14 k = kl,ku
        f(ju,k,1) = f(ju,k,1)
        f(ju,k,2) = f(ju,k,2)
        f(ju,k,3) = f(ju,k,3)
        f(ju-1,k,1) = f(ju-1,k,1) - x(ju-1,k)*f(ju,k,1)
        f(ju-1,k,2) = f(ju-1,k,2) - x(ju-1,k)*f(ju,k,2)
        f(ju-1,k,3) = f(ju-1,k,3) - x(ju-1,k)*f(ju,k,3)
14    continue
c
      do 4 j = 2,ju-jl
        jx = ju-j
        do 15 k = kl,ku
          f(jx,k,1) = f(jx,k,1) - x(jx,k)*f(jx+1,k,1) -
     *                y(jx,k)*f(jx+2,k,1)
          f(jx,k,2) = f(jx,k,2) - x(jx,k)*f(jx+1,k,2) -
     *                y(jx,k)*f(jx+2,k,2)
          f(jx,k,3) = f(jx,k,3) - x(jx,k)*f(jx+1,k,3) -
     *                y(jx,k)*f(jx+2,k,3)
15      continue
4     continue
c
      return
      end

#pragma -xO
C Source: netlib.org/slatec
C SLATEC code is in the public domain.

*DECK TESTI
            program testi
C***BEGIN PROLOGUE  TESTI
C***PURPOSE  Driver for testing SLATEC subprogram
C                  fullerton intrinsics.
C***LIBRARY   FNLIB
C***CATEGORY  Z
C***TYPE            all (testi-a)
C***KEYWORDS  FULLERTON INTRINSIC FUNCTIONS, QUICK CHECK DRIVER
C***AUTHOR  SLATEC Common Mathematical Library Committee
C***DESCRIPTION
C
C *Usage:
C     One input data record is required
C               read (unit=lin, fmt='(i1)') kprint
C
C *Arguments:
C     KPRINT = 0  Quick checks - No printing.
C                       driver       - short pass or fail message printed.
C                    1  quick checks - no message printed for passed tests,
C                                      short message printed for failed tests.
C                       driver       - short pass or fail message printed.
C                    2  quick checks - print short message for passed tests,
C                                      fuller information for failed tests.
C                       driver       - pass or fail message printed.
C                    3  quick checks - print complete quick check results.
C                       driver       - pass or fail message printed.
C
C *Description:
C     Driver for testing SLATEC subprogram
C
C***REFERENCES  Fong, Kirby W., Jefferson, Thomas H., Suyehiro,
C                       tokihiko, walton, lee, guidelines to the slatec common
C                       mathematical library, march 21, 1989.
C***ROUTINES CALLED  I1MACH, QCINTC, QCINTD, QCINTS, XERMAX, XSETF,
C                          xsetun
C***REVISION HISTORY  (YYMMDD)
C   900709  DATE WRITTEN
C***END PROLOGUE  TESTI
C     .. Local Scalars ..
            integer ipass, kprint, lin, lun, nfail
C     .. External Functions ..
            integer i1mach
            external i1mach
C     .. External Subroutines ..
            external qcintc, qcintd, qcints, xermax, xsetf, xsetun
C***FIRST EXECUTABLE STATEMENT  TESTI
            lun = i1mach(2)
C     LIN = I1MACH(1)
            lin = 2
            nfail = 0
C
C     Read KPRINT parameter
C
            read (lin, '(i1)') kprint
            call xsetun (lun)
            call xermax (1000)
            if (kprint .le. 1) then
               call xsetf (0)
            else
               kprint = 2
               call xsetf (1)
            endif
C
C     Test single precision Fullerton intrinsics.
C
            call qcints (lun, kprint, ipass)
            if (ipass .eq. 0) nfail = nfail + 1
C
C     Test double precision Fullerton intrinsics.
C
            call qcintd (lun, kprint, ipass)
            if (ipass .eq. 0) nfail = nfail + 1
C
C     Test complex Fullerton intrinsics.
C
            call qcintc (lun, kprint, ipass)
            if (ipass .eq. 0) nfail = nfail + 1
C
C     Write PASS or FAIL message
C
            if (nfail .eq. 0) then
               write (unit=lun, fmt=9000)
            else
               write (unit=lun, fmt=9010) nfail
            endif
            stop
 9000 FORMAT (/' --------------TESTI PASSED ALL TESTS----------------')
 9010 FORMAT (/' ************* WARNING -- ', I5,
     1              ' test(s) failed in program testi *************')
            end
*DECK QCINTC
            subroutine qcintc (lun, kprint, ipass)
C***BEGIN PROLOGUE  QCINTC
C***PURPOSE  Quick check for the complex Fullerton elementary
C                  intrinsic functions.
C***LIBRARY   FNLIB
C***CATEGORY  C
C***TYPE            complex (qcints-s, qcintd-d, qcintc-c)
C***KEYWORDS  QUICK CHECK
C***AUTHOR  Boland, W. Robert, (LANL)
C                 rivera, shawn m., (lanl)
C***DESCRIPTION
C
C   This subroutine does a quick check for the complex
C   Fullerton elementary intrinsic functions.
C
C   Parameter list-
C
C   LUN            input integer value to designate the external device unit
C                  for message output
C   KPRINT   input INTEGER value to specify amount of printing to be
C                  done by quick check
C   IPASS    output INTEGER value indicating whether tests passed or
C                  failed
C
C***ROUTINES CALLED  CABS, CCOS, CEXP, CLOG, CSIN, CSQRT, R1MACH, SQRT
C***REVISION HISTORY  (YYMMDD)
C   900717  DATE WRITTEN
C***END PROLOGUE  QCINTC
C     .. Scalar Arguments ..
            integer ipass, kprint, lun
C     .. Local Scalars ..
            real errtol
            integer i
C     .. Local Arrays ..
            complex c(20), w(20)
C     .. External Functions ..
            complex ccos, cexp, clog, csin, csqrt
            real cabs, r1mach, sqrt
C     EXTERNAL CCOS, CEXP, CLOG, CSIN, CSQRT, CABS, R1MACH, SQRT
C     .. Intrinsic Functions ..
            intrinsic cmplx
C
C     Complex values through different calculations are stored in C(*)
C
C     .. Data statements ..
            data c( 1) /(  1.0000000000000, 0.0000000000000) /
            data c( 2) /(  89.00280929194, .0078649202825041) /
            data c( 3) /(  30.00001041666, .024999991319455) /
            data c( 4) /(  6324555.320337, .0000001897366596101) /
            data c( 5) /( -0.8414709848079, 0.0000000000000) /
            data c( 6) /(  27.23982534694, 1.930412376268) /
            data c( 7) /(  0.000000000000000, 1.175201193644) /
            data c( 8) /(  1.127805246806, 1.868618519183) /
            data c( 9) /(  0.5403023058681, 0.0000000000000) /
            data c(10) /(  23.96522893293, 13.0834832507) /
            data c(11) /(  1.543080634815, 0.00000000000000) /
            data c(12) /(  2.064433656761, -1.020830949598) /
            data c(13) /( -2.929427471521, -3.391753471626) /
            data c(14) /( -0.7373937155412, 0.6754631805511) /
            data c(15) /(  .1699671429002, .9854497299884) /
            data c(16) /(  0.7055457557766, 9.949196994152) /
            data c(17) /(  3.738352258649, 0.3119690755436) /
            data c(18) /(  4.605747852161, .033986907746255) /
            data c(19) /(  2.313710397461, 0.1488899476095) /
            data c(20) /(  6.907755278982, 0.00000000000000) /
C
C***FIRST EXECUTABLE STATEMENT  QCINTC
C
            if (kprint .ge. 2) write (unit=lun, fmt=9000)
C
C     Exercise routines in Category C2.
C
            w( 1) = csqrt(cmplx(1.0, 0.0))
            w( 2) = csqrt(cmplx(7921.5, 1.4))
            w( 3) = csqrt(cmplx(900.0, 1.5))
            w( 4) = csqrt(cmplx(0.4e+14, 2.4))
C
C     Exercise routines in Category C4A.
C
            w( 5) = csin(cmplx(-1.0, 0.0))
            w( 6) = csin(cmplx(1.5, 4.0))
            w( 7) = csin(cmplx(0.0, 1.0))
            w( 8) = csin(cmplx(0.5, 1.5))
            w( 9) = ccos(cmplx(-1.0, 0.0))
            w(10) = ccos(cmplx(-0.5, 4.0))
            w(11) = ccos(cmplx(0.0, 1.0))
            w(12) = ccos(cmplx(0.5, 1.5))
C
C     Exercise routines in Category C4B.
C
            w(13) = cexp(cmplx(1.5, 4.0))
            w(14) = cexp(cmplx(0.0, 2.4))
            w(15) = cexp(cmplx(0.0, 1.4))
            w(16) = cexp(cmplx(2.3, 1.5))
            w(17) = clog(cmplx(40.0, 12.9))
            w(18) = clog(cmplx(100.0, 3.4))
            w(19) = clog(cmplx(10.0, 1.5))
            w(20) = clog(cmplx(1000.0, 0.0))
C
C     Check for possible errors.
C
            ipass = 1
            errtol = sqrt(r1mach(4))
            do 10 i = 1,20
              if (cabs(c(i)-w(i)) .ge. errtol*cabs(c(i))+errtol) then
                ipass = 0
                if (kprint .ge. 2) write (unit=lun, fmt=9020) i, w(i), c(i)
              endif
   10 CONTINUE
            if (ipass.ne.0 .and. kprint.ge.2) write (unit=lun, fmt=9010)
            return
 9000 FORMAT (// ' Test of complex Fullerton intrinsic routines')
 9010 FORMAT (' Complex Fullerton intrinsic function routines o.k.')
 9020 FORMAT (' For I  = ', I3, '  test fails with  ', /
     +              ' computed result = (', 1p, e22.14, ', ', e22.14,'  ) '/
     +              ' and true result = (', e22.14, ', ', e22.14, '  )')
            end
*DECK QCINTD
            subroutine qcintd (lun, kprint, ipass)
C***BEGIN PROLOGUE  QCINTD
C***PURPOSE  Quick check for the double precision Fullerton
C                  elementary intrinsic functions.
C***LIBRARY   FNLIB
C***CATEGORY  C
C***TYPE            double precision (qcints-s, qcintd-d, qcintc-c)
C***KEYWORDS  QUICK CHECK
C***AUTHOR  Boland, W. Robert, (LANL)
C                 rivera, shawn m., (lanl)
C***DESCRIPTION
C
C   This subroutine does a quick check for the double precision
C   Fullerton intrinsic functions.
C
C   Parameter list-
C
C   LUN            input integer value to designate the external device unit
C                  for message output
C   KPRINT   input INTEGER value to specify amount of printing to be
C                  done by quick check
C   IPASS    output INTEGER value indicating whether tests passed or
C                  failed
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D1MACH, DACOS, DASIN, DATAN, DATAN2, DCOS, DCOSH,
C                          dexp, dint, dlog, dlog10, dsin, dsinh, dsqrt, dtan,
C                          dtanh
C***REVISION HISTORY  (YYMMDD)
C   900717  DATE WRITTEN
C***END PROLOGUE  QCINTD
C     .. Scalar Arguments ..
            integer ipass, kprint, lun
C     .. Local Scalars ..
            double precision errtol
            integer i
C     .. Local Arrays ..
            double precision v(60), y(60)
C     .. External Functions ..
            double precision d1mach, dacos, dasin, datan, datan2, dcos, dcosh,
     +                       dexp, dint, dlog, dlog10, dsin, dsinh, dsqrt,
     +                       dtan, dtanh
C     EXTERNAL D1MACH, DACOS, DASIN, DATAN, DATAN2, DCOS, DCOSH, DEXP,
C    +                       dint, dlog, dlog10, dsin, dsinh, dsqrt, dtan,
C    +                       dtanh
C     .. Intrinsic Functions ..
            intrinsic abs
C
C     Correct values through different calculations are stored in V(*)
C
C     .. Data statements ..
            data v( 1) /  10.0d0 /
            data v( 2) /  79.0d0 /
            data v( 3) /  900.0d0 /
            data v( 4) /  4.0d0 /
            data v( 5) /  1.0d0 /
            data v( 6) /  89.0d0 /
            data v( 7) /  30.0d0 /
            data v( 8) /  6.32455532033675866399778708d06 /
            data v( 9) /  3.1415926535897932846264338d0 /
            data v(10) /  2.09439510239319549230842892d0 /
            data v(11) /  1.57079632679489661923132169d0 /
            data v(12) /  1.04719755119659774615421446d0 /
            data v(13) / -1.57079632679489661923132169d0 /
            data v(14) / -0.52359877559829887307710723d0 /
            data v(15) /  0.0d0 /
            data v(16) /  0.52359877559829887307710723d0 /
            data v(17) /  -0.785398163397448309615660845d0 /
            data v(18) / -0.463647609000806116214256231d0 /
            data v(19) /  0.0d0 /
            data v(20) /  0.463647609000806116214256231d0 /
            data v(21) / -0.58800260354756755124561108d0 /
            data v(22) / -0.463647609000806116214256231d0 /
            data v(23) /  2.034443935795702707025611744029d0 /
            data v(24) /  2.158798930342464394982471276307d0 /
            data v(25) /  0.540302305868139717400936607d0 /
            data v(26) /  0.877582561890372716116281582d0 /
            data v(27) /  1.0d0 /
            data v(28) /  0. 877582561890372716116281582d0 /
            data v(29) / -0.841470984807896506652502321d0 /
            data v(30) / -0.479425538604203000273287935d0 /
            data v(31) /  0.0d0 /
            data v(32) /  0.479425538604203000273287935d0 /
            data v(33) /  -1.55740772465490223050697485d0 /
            data v(34) / -0.546302489843790513255179465d0 /
            data v(35) /  0.0d0 /
            data v(36) /  0.546302489843790513255179465d0 /
            data v(37) /  2.30258509299404568401799145d0 /
            data v(38) /  2.99573227355399099343522357d0 /
            data v(39) /  3.40119738166215537541323669d0 /
            data v(40) /  3.68887945411393630285245569d0 /
            data v(41) /  1.0d0 /
            data v(42) /  1.30102999566398119521373889d0 /
            data v(43) /  1.4771212547196624372950279d0 /
            data v(44) /  1.60205999132796239042747778d0 /
            data v(45) /  1.00000100530050531421637777d0 /
            data v(46) /  0.999843012323855043126609044d0 /
            data v(47) /  1.00003876575137232151808428d0 /
            data v(48) /  0.992002154326025434343372944d0 /
            data v(49) /  1.54308063481524377847790562d0 /
            data v(50) /  1.12762596520638078522622516d0 /
            data v(51) /  1.0d0 /
            data v(52) /  1.12762596520638078522622516d0 /
            data v(53) / -1.175201193643801456882381851d0 /
            data v(54) / -0.521095305493747361622425626d0 /
            data v(55) /  0.0d0 /
            data v(56) /  0.521095305493747361622425626d0 /
            data v(57) / -0.761594155955764888119458282d0 /
            data v(58) / -0.462117157260009758502318483d0 /
            data v(59) /  0.0d0 /
            data v(60) /  0.462117157260009758592318483d0 /
C
C***FIRST EXECUTABLE STATEMENT  QCINTD
C
            if (kprint .ge. 2) write (unit=lun, fmt=9000)
C
C     Exercise routines in Category C1.
C
            y( 1) = dint(10.465890d0)
            y( 2) = dint(79.32178d0)
            y( 3) = dint(900.0d0)
            y( 4) = dint(4.0d0)
C
C     Exercise routines in Category C2.
C
            y( 5) = dsqrt(1.0d0)
            y( 6) = dsqrt(7921.0d0)
            y( 7) = dsqrt(900.0d0)
            y( 8) = dsqrt(4000d+10)
C
C     Exercise routines in Category C4A.
C
            y( 9) = dacos(-1.0d0)
            y(10) = dacos(-0.5d0)
            y(11) = dacos(0.0d0)
            y(12) = dacos(0.5d0)
            y(13) = dasin(-1.0d0)
            y(14) = dasin(-0.5d0)
            y(15) = dasin(0.0d0)
            y(16) = dasin(0.5d0)
            y(17) = datan(-1.0d0)
            y(18) = datan(-0.5d0)
            y(19) = datan(0.0d0)
            y(20) = datan(0.5d0)
            y(21) = datan2(-1.0d0,1.5d0)
            y(22) = datan2(-0.5d0,1.0d0)
            y(23) = datan2(1.0d0,-0.5d0)
            y(24) = datan2(1.5d0,-1.0d0)
            y(25) = dcos(-1.0d0)
            y(26) = dcos(-0.5d0)
            y(27) = dcos(0.0d0)
            y(28) = dcos(0.5d0)
            y(29) = dsin(-1.0d0)
            y(30) = dsin(-0.5d0)
            y(31) = dsin(0.0d0)
            y(32) = dsin(0.5d0)
            y(33) = dtan(-1.0d0)
            y(34) = dtan(-0.5d0)
            y(35) = dtan(0.0d0)
            y(36) = dtan(0.5d0)
C
C     Exercise routines in Category C4B.
C
            y(37) = dlog(10.0d0)
            y(38) = dlog(20.0d0)
            y(39) = dlog(30.0d0)
            y(40) = dlog(40.0d0)
            y(41) = dlog10(10.0d0)
            y(42) = dlog10(20.0d0)
            y(43) = dlog10(30.0d0)
            y(44) = dlog10(40.0d0)
            y(45) = dexp(1.0053d-06)
            y(46) = dexp(-1.57d-04)
            y(47) = dexp(3.8765d-05)
            y(48) = dexp(-8.03d-03)
C
C     Exercise routines in Category C4C.
C
            y(49) = dcosh(-1.0d0)
            y(50) = dcosh(-0.5d0)
            y(51) = dcosh(0.0d0)
            y(52) = dcosh(0.5d0)
            y(53) = dsinh(-1.0d0)
            y(54) = dsinh(-0.5d0)
            y(55) = dsinh(0.0d0)
            y(56) = dsinh(0.5d0)
            y(57) = dtanh(-1.0d0)
            y(58) = dtanh(-0.5d0)
            y(59) = dtanh(0.0d0)
            y(60) = dtanh(0.5d0)
C
C     Check for possible errors.
C
            ipass = 1
            errtol = dsqrt(d1mach(4))
            do 10 i = 1,60
              if (abs(v(i)-y(i)) .ge. errtol*abs(v(i))+errtol) then
                ipass = 0
                if (kprint .ge. 2) write (unit=lun, fmt=9020) i, y(i), v(i)
              endif
   10 CONTINUE
            if (ipass.ne.0 .and. kprint.ge.2) write (unit=lun, fmt=9010)
            return
 9000 FORMAT (// ' Test of double precision Fullerton intrinsic ',
     +              'routines')
 9010 FORMAT (' Double precision Fullerton intrinsic function ',
     +              'routines o.k.')
 9020 FORMAT (' For I  = ', I3, '  test fails with ', /
     +              ' computed result = ', 1p, e38.30, /
     +              ' and true result = ', e38.30)
            end
*DECK QCINTS
            subroutine qcints (lun, kprint, ipass)
C***BEGIN PROLOGUE  QCINTS
C***PURPOSE  Quick check for the single precision Fullerton
C                  elementary intrinsic functions.
C***LIBRARY   FNLIB
C***CATEGORY  C
C***TYPE            single precision (qcints-s, qcintd-d, qctinc-c)
C***KEYWORDS  QUICK CHECK
C***AUTHOR  Boland, W. Robert, (LANL)
C                 rivera, shawn m., (lanl)
C***DESCRIPTION
C
C   This subroutine does a quick check for the single precision
C   Fullerton intrinsic functions.
C
C   Parameter list-
C
C   LUN            input integer value to designate the external device unit
C                  for message output
C   KPRINT   input INTEGER value to specify amount of printing to be
C                  done by quick check
C   IPASS    output INTEGER value indicating whether tests passed or
C                  failed
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  ACOS, ALOG, ALOG10, ASIN, ATAN, ATAN2, CABS, COS,
C                          cosh, exp, r1mach, sin, sinh, sqrt, tan, tanh
C***REVISION HISTORY  (YYMMDD)
C   900711  DATE WRITTEN
C***END PROLOGUE  QCINTS
C     .. Scalar Arguments ..
            integer ipass, kprint, lun
C     .. Local Scalars ..
            real errtol
            integer i
C     .. Local Arrays ..
            real v(60), y(60)
C     .. External Functions ..
            real acos, alog, alog10, asin, atan, atan2, cabs, cos, cosh, exp,
     +     R1MACH, SIN, SINH, SQRT, TAN, TANH
C     EXTERNAL ACOS, ALOG, ALOG10, ASIN, ATAN, ATAN2, CABS, COS, COSH,
C    +               exp, r1mach, sin, sinh, sqrt, tan, tanh
C     .. Intrinsic Functions ..
            intrinsic abs, cmplx
C
C     Correct values through different calculations are stored in V(*)
C
C     .. Data statements ..
            data v( 1) /  1.0 /
            data v( 2) /  89.0 /
            data v( 3) /  30.0 /
            data v( 4) /  6.324555320337e+06 /
            data v( 5) /  10.55327437339 /
            data v( 6) /  79.32157587945 /
            data v( 7) /  901.0429556913 /
            data v( 8) /  4.00000e+13 /
            data v( 9) /  3.14159265359 /
            data v(10) /  2.094395102393 /
            data v(11) /  1.570796326795 /
            data v(12) /  1.047197551197 /
            data v(13) / -1.570796326795 /
            data v(14) / -0.5235987755983 /
            data v(15) /  0.0 /
            data v(16) /  0.5235987755983 /
            data v(17) / -0.7853981633974 /
            data v(18) / -0.4636476090008 /
            data v(19) /  0.0 /
            data v(20) /  0.4636476090008 /
            data v(21) / -0.5880026035475 /
            data v(22) / -0.4636476090008 /
            data v(23) /  2.0344438552856 /
            data v(24) /  2.158798930342 /
            data v(25) /  0.5403023058681 /
            data v(26) /  0.8775825618903 /
            data v(27) /  1.0 /
            data v(28) /  0.8775825618903 /
            data v(29) / -0.8414709848079 /
            data v(30) / -0.4794255386042 /
            data v(31) /  0.0 /
            data v(32) /  0.4794255386042 /
            data v(33) / -1.557407724655 /
            data v(34) / -0.5463024898437 /
            data v(35) /  0.0 /
            data v(36) /  0.5463024898437 /
            data v(37) /  2.302585092994 /
            data v(38) /  2.995732273554 /
            data v(39) /  3.401197381662 /
            data v(40) /  3.688879454114 /
            data v(41) /  1.0 /
            data v(42) /  1.301029995664 /
            data v(43) /  1.47712125472 /
            data v(44) /  1.602059991328 /
            data v(45) /  1.000001005301 /
            data v(46) /  0.9998430123238 /
            data v(47) /  1.000038765751 /
            data v(48) /  0.992002154326 /
            data v(49) /  1.543080634815 /
            data v(50) /  1.127625965206 /
            data v(51) /  1.0 /
            data v(52) /  1.127625965206 /
            data v(53) / -1.175201193644 /
            data v(54) / -0.5210953054937 /
            data v(55) /  0.0 /
            data v(56) /  0.5210953054937 /
            data v(57) / -0.7615941559557 /
            data v(58) / -0.46211715726 /
            data v(59) /  0.0 /
            data v(60) /  0.46211715726 /
C
C***FIRST EXECUTABLE STATEMENT  QCINTS
C
            if (kprint .ge. 2) write (unit=lun, fmt=9000)
C
C     Exercise routines in Category C2.
C
            y( 1) = sqrt(1.0)
            y( 2) = sqrt(7921.0)
            y( 3) = sqrt(900.0)
            y( 4) = sqrt(4.00000e+13)
C
C     Exercise routines in Category C4.
C
            y( 5) = cabs(cmplx(10.46,1.4))
            y( 6) = cabs(cmplx(79.32,0.5))
            y( 7) = cabs(cmplx(900.999,8.9))
            y( 8) = cabs(cmplx(4.00000e+13,1.5))
C
C     Exercise routines in Category C4A.
C
            y( 9) = acos(-1.0)
            y(10) = acos(-0.5)
            y(11) = acos(0.0)
            y(12) = acos(0.5)
            y(13) = asin(-1.0)
            y(14) = asin(-0.5)
            y(15) = asin(0.0)
            y(16) = asin(0.5)
            y(17) = atan(-1.0)
            y(18) = atan(-0.5)
            y(19) = atan(0.0)
            y(20) = atan(0.5)
            y(21) = atan2(-1.0,1.5)
            y(22) = atan2(-0.5,1.0)
            y(23) = atan2(1.0,-0.5)
            y(24) = atan2(1.5,-1.0)
            y(25) = cos(-1.0)
            y(26) = cos(-0.5)
            y(27) = cos(0.0)
            y(28) = cos(0.5)
            y(29) = sin(-1.0)
            y(30) = sin(-0.5)
            y(31) = sin(0.0)
            y(32) = sin(0.5)
            y(33) = tan(-1.0)
            y(34) = tan(-0.5)
            y(35) = tan(0.0)
            y(36) = tan(0.5)
C
C     Exercise routines in Category C4B.
C
            y(37) = alog(10.0)
            y(38) = alog(20.0)
            y(39) = alog(30.0)
            y(40) = alog(40.0)
            y(41) = alog10(10.0)
            y(42) = alog10(20.0)
            y(43) = alog10(30.0)
            y(44) = alog10(40.0)
            y(45) = exp(1.0053e-06)
            y(46) = exp(-1.57000e-04)
            y(47) = exp(3.87650e-05)
            y(48) = exp(-8.03000e-03)
C
C     Exercise routines in Category C4C.
C
            y(49) = cosh(-1.0)
            y(50) = cosh(-0.5)
            y(51) = cosh(0.0)
            y(52) = cosh(0.5)
            y(53) = sinh(-1.00000)
            y(54) = sinh(-0.50000)
            y(55) = sinh(0.000000)
            y(56) = sinh(0.500000)
            y(57) = tanh(-1.00000)
            y(58) = tanh(-0.50000)
            y(59) = tanh(0.000000)
            y(60) = tanh(0.500000)
C
C     Check for possible errors.
C
            ipass = 1
            errtol = sqrt(r1mach(4))
            do 10 i = 1,60
              if (abs(v(i)-y(i)) .ge. errtol*abs(v(i))+errtol) then
                ipass = 0
                if (kprint .ge. 2) write (unit=lun, fmt=9020) i, y(i), v(i)
              endif
   10 CONTINUE
            if (ipass.ne.0 .and. kprint.ge.2) write (unit=lun, fmt=9010)
            return
 9000 FORMAT (// ' Test of single precision Fullerton intrinsic ',
     +              'routines')
 9010 FORMAT (' Single precision Fullerton intrinsic function ',
     +              'routines o.k.')
 9020 FORMAT (' For I  = ', I3, '  test fails with ', /
     +              ' computed result = ', 1p, e22.14, /
     +              ' and true result = ', e22.14)
            end
//ft02f001 dd *
2
/*

#pragma -xO
! @file zeroin.f
! From demo
! Adapted for VIF beta-0.9.45
! Tuesday 30 July 2024
!
      program zeroes
      implicit real*8 (a - h, o - z)
      external zeroin, x2
      intrinsic dcos
      tol = 10 * d1mach (4)
      x = zeroin (1.d0, 2.d0, dcos, tol, ierr)
      write (*, *) ierr, ' ', x
      x = zeroin (-2.d0, -1.d0, dcos, tol, ierr)
      write (*, *) ierr, ' ', x
      x = zeroin (1.d0, 2.d0, x2, tol, ierr)
      write (*, *) ierr, ' ', x
      x = zeroin (-1.d0, 0.d0, x2, tol, ierr)
      write (*, *) ierr, ' ', x
      end

      real*8 function x2 (x)
      implicit double precision (a-h, o-z)
      x2 = x ** 2 - 2
      return
      end

#pragma -xO
      intrinsic qsin, xsin, qasin, xasin, qexp, xexp
      print *, 'Test sin'
      call test(qsin, xsin)
      print *, 'Test asin'
      call test(qasin, xasin)
      print *, 'Test exp'
      call test(qexp, xexp)
      end

      subroutine test (fun16, fun32)
      parameter (n = 25000)
      real drand48*8, x, x16*16, x32*32, f1*16, f2*16, fun16*16, fun32*32
      do i = 1, n
         x = drand48()
         x16 = x
         x32 = x
         f1 = fun16(x16)
         f2 = fun32(x32)
         if (abs(f1 - f2) > 1e-9) then
            write (*, *) f1, f2
         endif
      end do
      end

! @section Synopsis
!
! Machine Learning subprograms for VIF. Needs LAPACK.
!
! @author J. Marcel van der Veer
!
! @section copyright
!
! This file is part of VIF - vintage fortran compiler.
! Copyright 2020-2025 J. Marcel van der Veer <algol68g@xs4all.nl>.
!
! @section license
!
! This program is free software; you can redistribute it and/or modify it 
! under the terms of the gnu general public license as published by the 
! free software foundation; either version 3 of the license, or 
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful, but 
! without any warranty; without even the implied warranty of merchantability 
! or fitness for a particular purpose. See the GNU general public license for 
! more details. You should have received a copy of the GNU general public 
! license along with this program. If not, see <http://www.gnu.org/licenses/>.
!
      SUBROUTINE ml colmean(a, m, n)
      IMPLICIT none
      INTEGER i, j, m, n
      REAL*8 a(m, n), mean
      REAL*16 sum
      DO i = 1, n
        sum = 0.0q0
        DO j = 1, m
          sum = sum + a(j, i)
        END DO
        mean = dble (sum / m)
        DO j = 1, m
          a(j, i) = a(j, i) - mean
        END DO
      END DO
      END
!
      SUBROUTINE ml ols(a, m, n, x, y, a inv, u, vt, s, tol)
! Solve 'A' 'x' = 'y' by computing the pseudo-inverse of 'A'.
! 'A' is a 'm'x'n' matrix which is overwritten.
! 'Ainv' will contain the 'n'x'm' pseudo-inverse.
! 'U' will contain U, and 'VT' will contain V^T.
! 'S' will contain reciprocal singular values.
! 'Tol' is the threshold ratio relative to the largest singular value.
! 'Info' is a status indicator. Zero on exit is good.
      IMPLICIT none
      INTEGER i, info, j, k, lmax, lwork, m, n
! Work dimension should be at least 8 * min(m, n)
      REAL*8 a(m, n), x(m), y(m), u(m, m), vt(n, n), s(n), a inv(n, m), tol
! Solve A x = b.
      CALL ml pinv (a, m, n, a inv, u, vt, s, tol)
      CALL dgemv ('n', n, m, 1.0d0, a inv, n, y, 1, 0.0d0, x, 1)
      RETURN
      END
!
      SUBROUTINE ml pinv(a, m, n, a inv, u, vt, s, tol)
! Compute pseudo-inverse of 'A'.
! 'A' is a 'm'x'n' matrix which is overwritten.
! 'Ainv' will contain the 'n'x'm' pseudo-inverse.
! 'U' will contain U, and 'VT' will contain V^T.
! 'S' will contain reciprocal singular values.
! 'Tol' is the threshold ratio relative to the largest singular value.
! 'Info' is a status indicator. Zero on exit is good.
      IMPLICIT none
      REAL*8 work
      INTEGER iwork, lwmax
      parameter (lwmax = 100000)
      common /work/ work(lwmax), iwork(lwmax)
      INTEGER i, info, j, k, lmax, lwork, m, n
! Work dimension should be at least 8 * min(m, n)
      REAL*8 a(m, n), u(m, m), vt(n, n), s(n), a inv(n, m)
      REAL*8 s1, tol
      REAL*16 sum
! find optimal workspace.
      lwork = -1
      CALL dgesdd('a', m, n, a, m, s, u, m, vt, n, work, lwork, iwork, info)
      lwork = min(lwmax, int(work(1)))
! compute svd.
      CALL dgesdd('a', m, n, a, m, s, u, m, vt, n, work, lwork, iwork, info)
      IF (info > 0) THEN
         write (*, *) 'failed to converge'
      END IF
! compute pseudo inverse V * S^+ * U^T
! blas has no routines for multiplying diagonal matrices.
      s1 = s(1)
      DO i = 1, n
        IF (s(i) > tol * s1) THEN
          s(i) = 1.0d0 / s(i)
        ELSE
          s(i) = 0.0d0
        END IF
      END DO
      DO i = 1, n
        DO j = 1, m
          sum = 0
          DO k = 1, m
            sum = sum + vt(k, i) * s(k) * u (j, k)
          END DO
          a inv(i, j) = dble (sum)
        END DO
      END DO
      END

      SUBROUTINE ml testsignal(a, m, n, y)
! make a dummy test signal.
      IMPLICIT none
      INTEGER j, k, l, m, n
      REAL*8 a(m, n), y(n), x, pi
      CALL pi8(pi)
      DO j = 1, m
      y(j) = j
        DO k = 1, n
          a(j, k) = j * sin ((k - 0.5) / n * pi)
        END DO
      END DO
      RETURN
      END

      SUBROUTINE ml svddd(a, m, n, u, vt, s, iwork)
!
! compute the SVD of rectangular matrix using a divide and conquer algorithm.
! the svd reads
!
! a = u * sigma * vt
!
! where sigma is an m x n matrix which is zero except for its min(m, n)
! diagonal elements, u is an m x m orthogonal matrix and vt (v transposed)
! is an n x n orthogonal matrix.
!
! the diagonal elements of sigma are the real non - negative singular values
! of a- negative, in descending order.
! the first min(m, n) columns of u and v are the left and right singular vectors of a.
!
! left singular vectors are stored columnwise, right singular vectors are stored rowwise.
! note that the routine returns vt, not v.
!
! iwork dimension should be at least 8 * min(m, n)
!
      IMPLICIT none
      REAL*8 work
      INTEGER iwork, lwmax
      parameter (lwmax = 100000)
      common /work/ work(lwmax), iwork(lwmax)
      INTEGER info, lda, ldu, ldvt, lwork, m, n
! work dimension should be at least 8 * min(m, n)
      REAL*8 a(m, n), u(m, m), vt(n, n), s(n)
      lda = m
      ldu = m
      ldvt = n
! find optimal workspace.
      lwork = -1
      CALL dgesdd('a', m, n, a, lda, s, u, ldu, vt, ldvt, work, lwork, iwork, info)
      lwork = min(lwmax, int(work(1)))
! compute svd.
      CALL dgesdd('a', m, n, a, lda, s, u, ldu, vt, ldvt, work, lwork, iwork, info)
      IF (info > 0) THEN
        write (*, *) 'failed to converge'
      END IF
      END

      SUBROUTINE ml wmatrow(a, l, n, m)
      IMPLICIT none
      INTEGER k, l, m, n
      REAL*8 a(n, m)
! Print row n of a having width m.
      IF (m <= 6) THEN
        write (*, *) (sngl(a(l, k))i, ' ', k = 1, m)
      ELSE
        write (*, *) (sngl(a(l, k)), k = 1, 3) , ' ... ', (sngl(a(l, k)), k = m - 2, m)
      END IF
      END

      SUBROUTINE ml wmatrix(caption, a, n, m)
      IMPLICIT none
      INTEGER k, m, n
! ML Write MATRIX.
      REAL*8 a(n, m)
      character*(*) caption
      write (*, *) caption, ': ', n, 'x', m, ' matrix'
      IF (n <= 20) THEN
        DO k = 1, n
          CALL ml wmatrow(a, k, n, m)
        END DO
      ELSE
        DO k = 1, 10
          CALL ml wmatrow(a, k, n, m)
        END DO
        write (*, *) ' ... '
        DO k = n - 10, n
          CALL ml wmatrow(a, k, n, m)
        END DO
      END IF
      END

      SUBROUTINE ml wcolvec(caption, v, n)
! ML Write COLumn VECtor.
      CALL ml wmatrix(caption, v, 1, n)
      END

      SUBROUTINE mlwrowvec(caption, v, m)
! ML Write ROW VECtor.
      CALL ml wmatrix(caption, v, m, 1)
      END

! @section Synopsis
!
! Box-Behnken design related subprograms.
!
! @author J. Marcel van der Veer
!
! @section copyright
!
! This file is part of VIF - vintage fortran compiler.
! Copyright 2020-2025 J. Marcel van der Veer <algol68g@xs4all.nl>.
!
! @section license
!
! This program is free software; you can redistribute it and/or modify it 
! under the terms of the gnu general public license as published by the 
! free software foundation; either version 3 of the license, or 
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful, but 
! without any warranty; without even the implied warranty of merchantability 
! or fitness for a particular purpose. See the GNU general public license for 
! more details. You should have received a copy of the GNU general public 
! license along with this program. If not, see <http://www.gnu.org/licenses/>.
!
      SUBROUTINE box_behnken (dim_num, x_num, range, x)

c  box_behnken() returns a Box-Behnken design for the given number of factors.
c
c  Licensing:
c
c    This code is distributed under the MIT license.
c
c  Modified:
c
c    26 October 2008
c
c  Author:
c
c    John Burkardt
c
c  Reference:
c
c    George Box, Donald Behnken, 
c    Some new three level designs for the study of quantitative variables, 
c    Technometrics, 
c    Volume 2, pages 455-475, 1960.
c
c  Parameters:
c
c    Input, integer DIM_NUM, the spatial dimension.
c
c    Input, integer X_NUM, the number of elements of the design.
c    X_NUM should be equal to DIM_NUM * 2**(DIM_NUM-1) + 1.
c
c    Input, double precision RANGE(DIM_NUM, 2), the minimum and maximum
c    value for each component.
c
c    Output, double precision X(DIM_NUM, X_NUM), the elements of the design.
c
      IMPLICIT none

      INTEGER dim_num, x_num, i, i2, j, last_low
      DOUBLE PRECISION range(dim_num, 2), x(dim_num, x_num)
c
c  Ensure that the range is legal.
c
      DO i = 1, dim_num
        IF (range(i, 2) .le. range(i, 1)) THEN
          CALL xerabt ('BOX_BEHNKEN range error', 1)
        END IF
      END DO
c
c  The first point is the center.
c
      j = 1

      DO i = 1, dim_num
        x(i, j) = (range(i, 1) + range(i, 2)) / 2.0d+00
      END DO
c
c  For subsequent elements, one entry is fixed at the middle of the range.
c  The others are set to either extreme.
c
      DO i = 1, dim_num

        j = j + 1

        DO i2 = 1, dim_num
          x(i2, j) = range(i2, 1)
        END DO
        x(i, j) = (range(i, 1) + range(i, 2)) / 2.0d+00
c
c  The next element is made by finding the last low value, making it
c  high, and all subsequent high values low.
c
    1 CONTINUE

      last_low = -1

      DO i2 = 1, dim_num
        IF (x(i2, j) .eq. range(i2, 1)) THEN
          last_low = i2
        END IF
      END DO

      IF (last_low .eq. -1) THEN
        GO TO 2
      END IF

      j = j + 1
      DO i2 = 1, dim_num
        x(i2, j) = x(i2, j-1)
      END DO
      x(last_low, j) = range(last_low, 2)

      DO i2 = last_low + 1, dim_num
        IF (x(i2, j) .eq. range(i2, 2)) THEN
          x(i2, j) = range(i2, 1)
        END IF
      END DO 

      GO TO 1

    2 CONTINUE

      END DO

      RETURN
      END

      SUBROUTINE box_behnken_size (dim_num, x_num)

c  box_behnken_size returns the size of a Box-Behnken design.
c
c  Licensing:
c
c    This code is distributed under the MIT license.
c
c  Modified:
c
c    26 October 2008
c
c  Author:
c
c    John Burkardt
c
c  Reference:
c
c    George Box, Donald Behnken, 
c    Some new three level designs for the study of quantitative variables, 
c    Technometrics, 
c    Volume 2, pages 455-475, 1960.
c
c  Parameters:
c
c    Input, integer DIM_NUM, the spatial dimension.
c
c    Output, integer X_NUM, the number of elements of the design.
c    X_NUM will be equal to DIM_NUM * 2**(DIM_NUM-1) + 1.
c
      IMPLICIT none

      INTEGER dim_num, x_num

      IF (1 .le. dim_num) THEN
        x_num = 1 + dim_num * 2 ** (dim_num - 1)
      ELSE
        x_num = -1
      END IF

      RETURN
      END

#pragma -xO
c
c Note that this ancient code gives wrong results when aggressive 
c optimization is specified - tested this with several compilers.
c
c
c     solution of the matrix equation ax + xb = c.
c     source: netlib.org/linalg
c
c     this is a sample main program which solves randomly generated
c     problems.
c
c     a is reduced to schur form and b to upper-hessenberg form.
c     the resulting block-schur system of equations is
c     solved and the solution transformed back to that of the
c     original equation.
c
c     april 9, 1978.  written by stephen nash
c
c
      real xx(10),yy(10),zz(10)
      real*8 d1mach
      real*8 eps,ort(10),a(10,10),b(10,10),c(10,10),v(10,10)
     *      ,aa(10,10),bb(10,10),tt(10,10),dabs,t(10,10),dmax,work(5310)
c      data eps/z3410000000000000/
c
c     within the main program, a,b and c are stored normally.
c     at the end of the computation c holds the solution x. the array
c     work is used for temporary storage within the subroutines.
c     v is used to store the transformation matrix for a.
c     the transformation matrix for b is stored in ort and b.
c     c and x are m * n matrices. a is m * m, b is n * n.
c
      integer ipr(200)
      eps = d1mach(4)
      write(*,*) eps
      ndim = 10
      mdim = 10
      mode = 1
      iseed = 14365725
      maxiij = 2
      do 90 iijj = 1,maxiij
c
c     n and m are randomly generated in the range u10,50e.
c     afterwards, the matrices a,b, and x (stored in t) are
c     also generated randomly with entries in the interval u0,1).
c     iseed is a seed for the random number generator.
c     if iijj=1 we are generating a new problem.  when
c     iijj=2, the right hand side is changed, but the
c     coefficient matrices are left unchanged.
c
      call randk(iseed,xx(1),0)
      call randk(iseed,xx(2),0)
      m = 10
      n = 5
      if (iijj .eq. 2) mode = 2
      nm = max0(n,m)
      write(6,10) m,n
10    format('-solution of',i3,' by',i3,' matrix equation')
      do 20 i = 1,nm
         do 15 k = 1,nm
            call randk(iseed,xx(k),0)
            call randk(iseed,yy(k),0)
            call randk(iseed,zz(k),0)
15       continue
         do 20 j = 1,nm
            if (iijj .eq. 2) go to 17
            a(i,j) = xx(j)
            b(i,j) = yy(j)
            aa(i,j) = a(i,j)
            bb(i,j) = b(i,j)
17          t(i,j) = zz(j)
20    continue
      do 30 i = 1,nm
      do 30 j = 1,nm
         tt(i,j) = t(i,j)
30    continue
c
c     generate c from a, b, and x
c
      call slvchk(aa,bb,t,c,ndim,n,mdim,m)
c
c     now solve the matrix equation
c
      call axxbc(mode,ndim,n,mdim,m,a,v,b,c,ort,work,ipr,eps,ierr)
      if (ierr.ne.0) go to 60
c
c     check the size of the error.
c
      dmax = 0.d0
      do 40 i = 1,m
      do 40 j = 1,n
         if (dmax.lt.dabs(c(i,j)-tt(i,j))) dmax = dabs(c(i,j)-tt(i,j))
40    continue
      write(6,50) dmax
50    format(' maximal error = ', d14.6)
      go to 90
60    write(6,70)
70    format('0singular system of equations')
90    continue
      stop
      end
c
c
c
c
c
      subroutine randk (iy, yfl, index)
c
c     this is a uniform random number generator written by g. e.
c  forsythe in spring 1969, following d. knuth, the art of computer
c  programming, vol. 2, pp. 155-156.  it is much superior to randu,
c  the random number generator found in ibm's scientific subroutine
c  package.
c
c     before the first call of randk, iy should be set outside randk
c  to an arbitrary integer value.  (in watfor this is essential.)
c  for program checkout, the initial value of iy should be a fixed
c  integer.  for random numbers different on every run (and hence
c  not reproducible), declare integer clock1 and then initialize
c  iy to clock1(4).
c
c     if randk is called with an integer index = 1, then the output
c  value of iy is a pseudorandom integer uniformly distributed in the
c  range 0 <= iy < 2**31.
c
c     if randk is called with index = 0, then not only is iy produced,
c  but also (at some extra cost in time) a floating number yfl, uni-
c  formly distributed in the interval 0.0 <= yfl < 1.0.
c
      iy = iy*314159269 + 453806245
4     if (iy .ge. 0) go to 6
c
c  caution:  the statement label 4 is essential in order to prevent
c  certain compilers (e.g., fortran h with opt 0) from performing
c  unwanted "optimizations."  it should not be removed.
c
5        iy = iy + 2147483647 + 1
c        statement 5 adds 2**31 to negative values of iy
c
6     if (index) 7, 7, 8
c
7        yfl = iy
         yfl = yfl*.4656613e-9
c
8     return
      end
c
c
c
c
c
      subroutine slvchk(a,b,x,c,ndim,n,mdim,m)
c
      integer i,j,k,m,mdim,n,ndim
      real*8 a(mdim,m),b(ndim,n),x(mdim,n),c(mdim,n)
c
c     this subroutine forms ax + xb in order to check the solution
c     to the problem.  the result is stored in the matrix c.
c     parameters:
c     a,b,x - input matrices
c     c     - output matrix
c     ndim  - declared row dimension of the matrix b
c     n     - actual row dimension of b and column dimension
c             of b, c, and x
c     mdim  - declared row dimension of the matrices a, x, and c
c     m     - actual column dimesion of a and row dimension of
c             a, x, and c.
c
      do 10 i = 1,m
         do 10 j = 1,n
            c(i,j) = 0.d0
            do 10 k = 1,m
               c(i,j) = c(i,j) + a(i,k) * x(k,j)
10    continue
      do 20 i = 1,m
         do 20 j = 1,n
            do 20 k = 1,n
               c(i,j) = c(i,j) + x(i,k) * b(k,j)
20    continue
      return
      end
c
c------------------------------------------------------------------------
c
      subroutine axxbc(mode,ndim,n,mdim,m,a,v,b,c,ort,d,ipr,eps,ierr)
c
      integer i,ierr,ind,ipr(1),j,m,mdim,mode,n,ndim
      real*8 a(mdim,m),b(ndim,n),v(ndim,n),
     *     c(mdim,n),ort(1),eps,reps,d(1)
c
c     this routine solves the matrix equation ax + xb = c where
c
c        a - m * m matrix
c        x - m * n matrix
c        b - n * n matrix
c        c - m * n matrix.
c
c     the parameters for this subroutine are:
c
c     mode - indicates whether a new matrix equation is being solved,
c            or that just the right hand side has been changed.
c            mode=1 implies that the equation is new
c            mode=2 implies that only the right hand side is new
c     ndim - declared row dimension of the matrix b
c     n    - row dimension of b; column dimension of b and c
c     mdim - declared row dimension of a, c, and v
c     m    - row dimension of a, c, and v; column dimension of a and v
c     a    - m * m matrix (double precision)
c     b    - n * n matrix (double precision)
c     v    - n * n matrix (double precision) used to store the matrix
c            which transforms b(t) to upper schur form
c     c    - m * n matrix which holds c on input and x on output
c     ort  - double precision vector used by subroutine rg
c            of length at least max(n,m)
c     d    - double precision vector for internal use of length
c            at least 2m**2 + 7m
c     ipr  - integer vector for internal use of length at least 4n
c     eps  - error tolerance. eps should equal the smallest number
c            which satisfies fl(1 + eps) > 1.
c     ierr - integer variable used to set error codes.
c            ierr=0 => proper return.
c            ierr=j => j-th eigenvalue of b has not been determined
c                      after 30 qr iterations.
c            ierr=-j => a singular matrix was encountered when
c                       solving for the j-th column of x.
c
c     method:
c
c     first of all, b(transpose) is formed and is used instead of
c     b throughout the program. (in the following discussion, b(t) is
c     used to represent b(transpose)).
c     b(t) is transformed to real upper schur form and a to upper
c     hessenberg form using orthogonal transformations.
c     the right hand side c is multiplied by these transformation
c     matrices and the solution of this transformed system is
c     computed.  this solution is then multiplied by the trans-
c     formation matrices in order to obtain the solution to the
c     original problem.
c
c     note:
c
c     in order to get optimal efficiency from this routine, n should
c     be <= m.  if this is not true for your problem, transpose the
c     equation and solve the resulting problem.
c
c     -------------------------------------------------------------
c
c     form b(transpose) for internal use
c
      if (mode .eq. 2) go to 7
      do 5 i = 1,n
         do 5 j = i,n
            d(1) = b(i,j)
            b(i,j) = b(j,i)
            b(j,i) = d(1)
5     continue
c
c     a and b(t) will be transformed into the appropriate forms using
c     modifications of eispack routines (modified by s. nash).
c
c     warning:  do not change the order of the next two statements
c
      call rg(ndim,n,b,1,v,ort,eps,ierr)
      call rg(mdim,m,a,0,a,ort,eps,ierr)
c
c     now, transform the right hand side.
c
7     call transf(a,ort,1,c,v,0,m,n,mdim,ndim,d)
c
c     now solve the system of equations (block back substitution)
c     the system is block upper hessenberg with upper hessenberg
c     matrices on the diagonal (a + b(i,i) * i) and multiples of
c     the identity off the diagonal.
c     tests are made to see whether a single or a double block
c     must be handled at the current stage and appropriate
c     subroutines are called.
c
c     set relative error tolerance
c
      reps = eps*n*n*m*m
      ind = n - 1
      if (ind.eq.0) go to 40
10    if (dabs(b(ind + 1,ind)).le.reps)  go to 20
      call n2solv(a,b,c,d,ndim,n,mdim,m,ind,ipr,reps,ierr)
      if (ierr.ne.0) return
      go to 30
20    call nsolve(a,b,c,d,ndim,n,mdim,m,ind,ipr,reps,ierr)
      if (ierr.ne.0) return
30    if (ind.gt.0) go to 10
40    if (ind.eq.0) call nsolve(a,b,c,d,ndim,n,mdim,m,ind,ipr,reps,ierr)
c
c     the solution of the transformed system of equations
c     has now been obtained.  it is transformed back into
c     the solution of the original system of equations.
c
      call transf(a,ort,0,c,v,1,m,n,mdim,ndim,d)
      return
      end
c
c
c
c
c
      subroutine rg(ndim,n,a,matz,z,ort,eps,ierr)
c
      integer n,ndim,ierr,matz
      real*8 a(ndim,n),z(ndim,n),ort(n),eps
c
c     this subroutine reduces a to either upper-hessenberg
c     or schur form depending on whether matz is zero or not.
c     the routines used are from eispack except that hqr2 has
c     been modified so as not to compute the eigenvectors of
c     a and only reduces a to schur form. orthogonal transformations
c     are used throughout.
c     parameters:
c     ndim - declared row dimension of the matrix a
c     n    - actual dimension of the matrix a
c     a    - matrix to be transformed (on input) and transformed
c            matrix (on output)
c     matz - integer variable; matz = 0 => transform a to upper-
c            hessenberg form; otherwise compute the schur form of a
c     z    - stores the transformation matrix if a is transformed to
c          - schur form (if matz=0, z can be the same as a).
c     ort  - vector used for internal storage; if matz=0, ort holds
c            information about the transformation matrix
c     eps  - error tolerance, as in subroutine axxbc.
c     ierr - error code; see routine axxbc for details
c
      ierr=0
      call orthes(ndim,n,a,ort)
      if (matz.eq.0) return
      call ortran(ndim,n,a,ort,z)
      call hqr2(ndim,n,a,z,eps,ierr)
10    return
      end
c
c
c
c
c
      subroutine orthes(ndim,n,a,ort)
c
      integer i,j,m,n,ii,jj,la,mp,ndim,kp1
      real*8 a(ndim,n),ort(n)
      real*8 f,g,h,scale
      real*8 dsqrt,dabs,dsign
c
c     this subroutine is a translation of the algol procedure orthes,
c     num. math. 12, 349-368(1968) by martin and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 339-358(1971).
c
c     given a real general matrix, this subroutine
c     reduces a submatrix situated in rows and columns
c     1 through n to upper hessenberg form by
c     orthogonal similarity transformations.
c
c     on input:
c
c        ndim must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement;
c
c        n is the order of the matrix;
c
c        a contains the input matrix.
c
c     on output:
c
c        a contains the hessenberg matrix.  information about
c          the orthogonal transformations used in the reduction
c          is stored in the remaining triangle under the
c          hessenberg matrix;
c
c        ort contains further information about the transformations.
c          only elements 1 through n are used.
c
c     questions and comments should be directed to b. s. garbow,
c     applied mathematics division, argonne national laboratory
c
c     -----------------------------------------------------------------
c
      la = n - 1
      kp1 = 2
      if (la .lt. kp1) go to 200
c
      do 180 m = kp1, la
         h = 0.0d0
         ort(m) = 0.0d0
         scale = 0.0d0
c
c     scale column (algol tol then not needed)
c
         do 90 i = m, n
90       scale = scale + dabs(a(i,m-1))
c
         if (scale .eq. 0.0d0) go to 180
         mp = m + n
c
c        for i=n step -1 until m do --
c
         do 100 ii = m, n
            i = mp - ii
            ort(i) = a(i,m-1) / scale
            h = h + ort(i) * ort(i)
100      continue
c
         g = -dsign(dsqrt(h),ort(m))
         h = h - ort(m) * g
         ort(m) = ort(m) - g
c
c        form (i-(u*ut)/h) * a
c
         do 130 j = m, n
            f = 0.0d0
c
c           for i=n step -1 until m do --
c
            do 110 ii = m, n
               i = mp - ii
               f = f + ort(i) * a(i,j)
110         continue
c
            f = f / h
c
            do 120 i = m, n
120         a(i,j) = a(i,j) - f * ort(i)
c
130      continue
c
c        form (i-(u*ut)/h)*a*(i-(u*ut)/h)
c
         do 160 i = 1, n
            f = 0.0d0
c
c           for j=n step -1 until m do --
c
            do 140 jj = m, n
               j = mp - jj
               f = f + ort(j) * a(i,j)
140         continue
c
            f = f / h
c
            do 150 j = m, n
150         a(i,j) = a(i,j) - f * ort(j)
c
160      continue
c
         ort(m) = scale * ort(m)
         a(m,m-1) = scale * g
180   continue
200   return
      end
c
c
c
c
c
      subroutine ortran(ndim,n,a,ort,z)
c
      integer i,j,n,kl,mm,mp,ndim,mp1
      real*8 a(ndim,n),ort(n),z(ndim,n)
      real*8 g
c
c     this subroutine is a translation of the algol procedure ortrans,
c     num. math. 16, 181-204(1970) by peters and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 372-395(1971).
c
c     this subroutine accumulates the orthogonal similarity
c     transformations used in the reduction of a real general
c     matrix to upper hessenberg form by  orthes.
c
c     on input:
c
c        ndim must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement;
c
c        n is the order of the matrix;
c
c        a contains information about the orthogonal trans-
c          formations used in the reduction by  orthes
c          in its strict lower triangle;
c
c        ort contains further information about the trans-
c          formations used in the reduction by  orthes.
c          only elements 1 through n are used.
c
c     on output:
c
c        z contains the transformation matrix produced in the
c          reduction by  orthes;
c
c        ort has been altered.
c
c     questions and comments should be directed to b. s. garbow,
c     applied mathematics division, argonne national laboratory
c
c     -----------------------------------------------------------
c
c     initialize z to identity matrix
c
      do 80 i = 1, n
c
         do 60 j = 1, n
60       z(i,j) = 0.0d0
c
         z(i,i) = 1.0d0
80    continue
c
      kl = n - 2
      if (kl .lt. 1) go to 200
c
c     for mp=n-1 step -1 until 2 do --
c
      do 140 mm = 1, kl
         mp = n - mm
         if (a(mp,mp-1) .eq. 0.0d0) go to 140
         mp1 = mp + 1
c
         do 100 i = mp1, n
100      ort(i) = a(i,mp-1)
c
         do 130 j = mp, n
            g = 0.0d0
c
            do 110 i = mp, n
110         g = g + ort(i) * z(i,j)
c
c           divisor below is negative of h formed in orthes.
c           double division avoids possible underflow
c
            g = (g / ort(mp)) / a(mp,mp-1)
c
            do 120 i = mp, n
120         z(i,j) = z(i,j) + g * ort(i)
c
130      continue
c
140   continue
c
200   return
      end
c
c
c
c
c
      subroutine hqr2(ndim,n,h,z,eps,ierr)
c
      integer i,j,k,l,m,n,en,ii,jj,ll,mm,na,ndim,nn,
     x        its,mp2,enm2,ierr
      real*8 h(ndim,n),z(ndim,n)
      real*8 p,q,r,s,t,w,x,y,ra,sa,vi,vr,zz,norm,eps
      real*8 dsqrt,dabs,dsign
      integer min0
      logical notlas
c
c     this subroutine is a translation of the algol procedure hqr2,
c     num. math. 16, 181-204(1970) by peters and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 372-395(1971).
c     it has been further modified by stephen nash so that it only
c     computes the schur form of the upper-hessenberg matrix h.
c
c     on input:
c
c        ndim must be set to the row dimension of two - dimensional
c          array parameters as declared in the calling program
c          dimension statement;
c
c        n is the order of the matrix;
c
c        h contains the upper hessenberg matrix;
c
c        z contains the transformation matrix produced by ortran
c          after the reduction by orthes.
c
c     on output:
c
c        h has been destroyed;
c
c        z contains the transformation matrix.
c
c        ierr is set to
c          zero       for normal return,
c          j          if the j-th eigenvalue has not been
c                     determined after 30 iterations.
c
c     -----------------------------------------------------------------
c
c     eps is a machine dependent parameter specifying
c     the relative precision of floating point arithmetic.
c
      ierr = 0
      norm = 0.0d0
      k = 1
c
c     compute matrix norm
c
      do 50 i = 1, n
c
         do 40 j = k, n
40       norm = norm + dabs(h(i,j))
c
         k = i
50    continue
c
      en = n
      t = 0.0d0
c
c     search for next eigenvalues
c
60    if (en .lt. 1) go to 340
      its = 0
      na = en - 1
      enm2 = na - 1
c
c     look for single small sub-diagonal element
c     for l=en step -1 until 1 do --
c
70    do 80 ll = 1, en
         l = en + 1 - ll
         if (l .eq. 1) go to 100
         s = dabs(h(l-1,l-1)) + dabs(h(l,l))
         if (s .eq. 0.0d0) s = norm
         if (dabs(h(l,l-1)) .le. eps * s) go to 100
80    continue
c
c     form shift
c
100   x = h(en,en)
      if (l .eq. en) go to 270
      y = h(na,na)
      w = h(en,na) * h(na,en)
      if (l .eq. na) go to 280
      if (its .eq. 30) go to 1000
      if (its .ne. 10 .and. its .ne. 20) go to 130
c
c     form exceptional shift
c
      t = t + x
c
      do 120 i = 1, en
120   h(i,i) = h(i,i) - x
c
      s = dabs(h(en,na)) + dabs(h(na,enm2))
      x = 0.75d0 * s
      y = x
      w = -0.4375d0 * s * s
130   its = its + 1
c
c     look for two consecutive small
c     sub-diagonal elements.
c     for m=en-2 step -1 until l do --
c
      do 140 mm = l, enm2
         m = enm2 + l - mm
         zz = h(m,m)
         r = x - zz
         s = y - zz
         p = (r * s - w) / h(m+1,m) + h(m,m+1)
         q = h(m+1,m+1) - zz - r - s
         r = h(m+2,m+1)
         s = dabs(p) + dabs(q) + dabs(r)
         p = p / s
         q = q / s
         r = r / s
         if (m .eq. l) go to 150
         if (dabs(h(m,m-1)) * (dabs(q) + dabs(r)) .le. eps * dabs(p)
     x    * (dabs(h(m-1,m-1)) + dabs(zz) + dabs(h(m+1,m+1)))) go to 150
140   continue
c
150   mp2 = m + 2
c
      do 160 i = mp2, en
         h(i,i-2) = 0.0d0
         if (i .eq. mp2) go to 160
         h(i,i-3) = 0.0d0
160   continue
c
c     double qr step involving rows l to en and
c     columns m to en
c
      do 260 k = m, na
         notlas = k .ne. na
         if (k .eq. m) go to 170
         p = h(k,k-1)
         q = h(k+1,k-1)
         r = 0.0d0
         if (notlas) r = h(k+2,k-1)
         x = dabs(p) + dabs(q) + dabs(r)
         if (x .eq. 0.0d0) go to 260
         p = p / x
         q = q / x
         r = r / x
170      s = dsign(dsqrt(p*p+q*q+r*r),p)
         if (k .eq. m) go to 180
         h(k,k-1) = -s * x
         go to 190
180      if (l .ne. m) h(k,k-1) = -h(k,k-1)
190      p = p + s
         x = p / s
         y = q / s
         zz = r / s
         q = q / p
         r = r / p
c
c        row modification
c
         do 210 j = k, n
            p = h(k,j) + q * h(k+1,j)
            if (.not. notlas) go to 200
            p = p + r * h(k+2,j)
            h(k+2,j) = h(k+2,j) - p * zz
200         h(k+1,j) = h(k+1,j) - p * y
            h(k,j) = h(k,j) - p * x
210      continue
c
         j = min0(en,k+3)
c
c        column modification
c
         do 230 i = 1, j
            p = x * h(i,k) + y * h(i,k+1)
            if (.not. notlas) go to 220
            p = p + zz * h(i,k+2)
            h(i,k+2) = h(i,k+2) - p * r
220         h(i,k+1) = h(i,k+1) - p * q
            h(i,k) = h(i,k) - p
230      continue
c
c        accumulate transformations
c
         do 250 i = 1, n
            p = x * z(i,k) + y * z(i,k+1)
            if (.not. notlas) go to 240
            p = p + zz * z(i,k+2)
            z(i,k+2) = z(i,k+2) - p * r
240         z(i,k+1) = z(i,k+1) - p * q
            z(i,k) = z(i,k) - p
250      continue
c
260   continue
c
      go to 70
c
c     one root found
c
270   h(en,en) = x + t
      en = na
      go to 60
c
c     two roots found
c
280   p = (y - x) / 2.0d0
      q = p * p + w
      zz = dsqrt(dabs(q))
      h(en,en) = x + t
      x = h(en,en)
      h(na,na) = y + t
      if (q .lt. 0.0d0) go to 320
c
c     real pair
c
      zz = p + dsign(zz,p)
      x = h(en,na)
      s = dabs(x) + dabs(zz)
      p = x / s
      q = zz / s
      r = dsqrt(p*p+q*q)
      p = p / r
      q = q / r
c
c     row modification
c
      do 290 j = na, n
         zz = h(na,j)
         h(na,j) = q * zz + p * h(en,j)
         h(en,j) = q * h(en,j) - p * zz
290   continue
c
c     column modification
c
      do 300 i = 1, en
         zz = h(i,na)
         h(i,na) = q * zz + p * h(i,en)
         h(i,en) = q * h(i,en) - p * zz
300   continue
c
c     accumulate transformations
c
      do 310 i = 1, n
         zz = z(i,na)
         z(i,na) = q * zz + p * z(i,en)
         z(i,en) = q * z(i,en) - p * zz
310   continue
c
      go to 330
c
c     complex pair
c
320   continue
330   en = enm2
      go to 60
c
c     all roots found.  backsubstitute to find
c     vectors of upper triangular form
c
1000  ierr = en
340   return
      end
c
c
c
c
c
      subroutine transf(a,ort,it1,c,v,it2,m,n,mdim,ndim,d)
c
      integer i,it1,it2,j,k,k1,k2,kk,m,mdim,n,n2
      real*8 v(ndim,n),c(mdim,n),a(mdim,m),ort(m),d(1),g
c
c     subroutine to form c(new) = u * c * v.  the integer variables
c     it1 and it2 indicate whether u(transpose) or v(transpose)
c     are required instead of u or v.
c     if itx = 0 then the actual matrix is used, if itx = 1, then
c     its transpose is used.
c     in order to save storage, the matrix u (the transformation
c     matrix for the matrix a) is stored in the lower part of a
c     and in the vector ort in coded form. (see subroutine orthes)
c     the parameters for this subroutine are as for the subroutine
c     axxbc except that here ort takes the place of ort.
c
c     --------------------------------------------------------------
c
c     form u * c and store in c (as in subroutine ortran)
c
      m2 = m - 2
c
c     check for small matrix
c
      if (m2.le.0) go to 45
      do 40 kk = 1,m2
         k = m2 - kk + 1
         if (it1.eq.1) k = kk
         k1 = k + 1
         if (a(k1,k).eq.0.d0) go to 40
         d(k1) = ort(k1)
         k2 = k + 2
         do 10 i = k2,m
            d(i) = a(i,k)
10       continue
         do 30 j = 1,n
            g = 0.d0
            do 20 i = k1,m
               g = g + d(i) * c(i,j)
20          continue
            g = g / ort(k1) / a(k1,k)
            do 30 i = k1,m
            c(i,j) = c(i,j) + g * d(i)
30       continue
40    continue
c
c     form c(new) = (u * c) * v
c
45    do 60 i = 1,m
         do 50 j = 1,n
            d(j) = 0.d0
            do 50 k = 1,n
               if (it2.eq.0) d(j) = d(j) + c(i,k) * v(k,j)
               if (it2.eq.1) d(j) = d(j) + c(i,k) * v(j,k)
50          continue
            do 60 j = 1,n
               c(i,j) = d(j)
60    continue
      return
      end
c
c
c
c
c
      subroutine nsolve(a,b,c,d,ndim,n,mdim,m,ind,ipr,reps,ierr)
c
      integer i,i1,ierr,ind,ipr(1),irow1,j,m,m1,mdim,n,ndim,mfin
      real*8 a(mdim,m),b(ndim,n),c(mdim,n),d(1),reps
c
c     this subroutine sets up and solves (with the help of
c     the subroutine hesolv) a single system of equations
c
c      ( a + b(ind+1,ind+1) * i )(x(ind+1)) = (c(ind+1))
c
c     (x(i),c(i) - column i of the matrices x and c)
c     and stores the result in the appropriate row of the
c     matrix c.  the upper-hessenberg matrix is stored in the
c     vector d in order to save storage (entries below the sub-
c     diagonal are ignored).
c     the right hand side is also stored in the vector d in order
c     to reduce the number of vectors used in the subroutines.
c     the parameters are as in the subroutine axxbc.
c
c     ----------------------------------------------------------
c
c     perform block back-substitution if necessary
c
      if (ind.lt.n - 1) call backsb(c,b,ind,n,m,mdim,ndim)
c
c     set up the system of equations
c
      mfin = (m * (m + 1)) / 2 + m
      do 20 i = 1,m
c
c        find index of beginning of row i within the vector d
c
         m1 = irow1(i,m)
         i1 = i - 1
         if (i.eq.1) i1 = 1
         do 10 j = i1,m
            d(m1+j-i1+1) = a(i,j)
10       continue
         j = 2
         if (i.eq.1) j = 1
         d(m1+j) = d(m1+j) + b(ind+1,ind+1)
c
c        store the right hand side
c
         d(mfin+i) = c(i,ind+1)
20    continue
c
c     solve the system of equations and store the result in c.
c
      call hesolv(d,ipr,m,reps,ierr)
      if (ierr.ne.0) go to 40
      do 30 i = 1,m
         c(i,ind+1) = d(ipr(i))
30    continue
      ind = ind - 1
      return
40    ierr = -ind - 1
      return
      end
c
c
c
c
c
      subroutine hesolv(d,ipr,m,reps,ierr)
c
      integer i,i1,i2,ierr,ipr(1),irow1,j,j1,k,n,n1,mfin
      real*8 d(1),dabs,mult,reps
c
c     this subroutine solves an upper-hessenberg system of equations
c     which is stored in packed form in the vector d.  the method used
c     is gaussian elimination with partial pivoting.  the parameters
c     in the subroutine are:
c     d      -  matrix of coefficients, right hand side (on input),
c               and solution (on output)
c     ipr    -  integer vector which records interchanges
c     m      -  size of system
c     reps   -  error tolerance
c     ierr   -  error code (ierr=0 => normal return)
c                          (ierr=-1 => singular matrix)
c
c     ----------------------------------------------------------------
c
c     initialize interchange vectors and parameters.
c
      ierr = 0
      mfin = (m * (m + 1)) / 2 + m
      do 10 i = 1,m
         ipr(m+i) = irow1(i,m)
         ipr(i) = i + mfin
10    continue
      m1 = m - 1
c
c     reduce the matrix to upper triangular form
c
      if (m.eq.1) go to 35
      do 30 i = 1,m1
         if (dabs(d(ipr(m+i)+1)).gt.dabs(d(ipr(m+i+1)+1))) go to 20
c
c        interchange rows if necessary
c
         k = ipr(m+i)
         ipr(m+i) = ipr(m+i+1)
         ipr(m+i+1) = k
         k = ipr(i)
         ipr(i) = ipr(i+1)
         ipr(i+1) = k
c
c        check for computationally singular matrix
c
20       if (dabs(d(ipr(m+i)+1)).lt.reps) go to 60
         ipr(m+i+1) = ipr(m+i+1) + 1
c
c        eliminate subdiagonal element of a
c
         mult = d(ipr(m+i+1)) / d(ipr(m+i)+1)
         d(ipr(i+1)) = d(ipr(i+1)) - mult * d(ipr(i))
         i1 = i + 1
         do 30 j = i1,m
            d(ipr(m+i+1)+j-i) = d(ipr(m+i+1)+j-i) -
     *                            mult*d(ipr(m+i)+j+1-i)
30    continue
35    if (dabs(d(ipr(m+m)+1)).lt.reps) go to 60
c
c     perform back - substitution
c
      d(ipr(m)) = d(ipr(m)) / d(ipr(m+m)+1)
      if (m1.eq.0) return
      do 50 i1 = 1,m1
         i = m - i1
         i2 = i + 1
         mult = 0.d0
         do 40 j1 = i2,m
            j = j1 - i2 + 2
            mult = mult + d(ipr(j1)) * d(ipr(m+i)+j)
40       continue
         d(ipr(i)) = (d(ipr(i)) - mult) / d(ipr(m+i)+1)
50    continue
      return
60    ierr = -1
      return
      end
c
c
c
c
      subroutine backsb(c,b,ind,n,m,mdim,ndim)
c
      integer i,ind,ind1,ind2,j,m,mdim,n,ndim
      real*8 b(ndim,n),c(mdim,n)
c
c     block back - substitution for one 'row'.
c     parameters are as in subroutine axxbc.
c
      ind1 = ind + 1
      ind2 = ind + 2
      do 10 i = ind2,n
         do 10 j = 1,m
            c(j,ind1) = c(j,ind1) - b(ind1,i) * c(j,i)
10    continue
      return
      end
c
c
c
c
c
      integer function irow1(i,m)
c
      integer i,m
c
c     this function computes the index (for the vector d) one before
c     the beginning of row i in the m*m matrix.
c
      irow1 = (i-1) * m - (i-2) * (i-3) / 2
      if (i.eq.1) irow1 = 0
      return
      end
c
c
c
c
c
      subroutine n2solv(a,b,c,d,ndim,n,mdim,m,ind,ipr,reps,ierr)
c
      integer i,i1,ierr,ind,ipr(1),irow2,j,j1,j2,k,lrow2,m,m1,
     *   mdim,n,ndim,mfin
      real*8 a(mdim,m),b(ndim,n),c(mdim,n),d(1),reps
c
c     this subroutine sets up a double system of equations.
c     it solves (using subroutine h2solv) the set of equations
c
c     ( a+b(ind,ind)*i        b(ind,ind+1) )( x(ind) )   ( c(ind) )
c     (                                    )(        ) = (        )
c     ( b(ind+1,ind)*i  a+b(ind+1,ind+1)*i )(x(ind+1))   (c(ind+1))
c
c     by interchanging rows and columns (to insure that there are
c     zeroes below the sub-sub-diagonal) and then using gaussian
c     elimination.  in order to take advantage of the number of
c     zeroes in this matrix, the matrix is stored in the vector
c     d in packed form. (entries below the sub-sub-diagonal are
c     ignored) the right hand side and solution are also stored in d.
c     the parameters are as in the subroutine axxbc.
c
c     ------------------------------------------------------------
c
c     perform block back-substitution if necessary
c
      if (ind.lt.n-1) call backs2(c,b,ind,n,m,mdim,ndim)
c
c     set up the system of equations for h2solv
c
      m2 = 2 * m
      mfin = (m2 * (m2 + 1)) / 2 + 4 * m
      do 20 i = 1,m
c
c        find beginning and length of row 2i-1 in the vector d.
c
         m1 = irow2(2*i-1,m)
         k = lrow2(2*i-1,m)
         i1 = i - 1
         if (i.eq.1) i1 = 1
         do 10 j = i1,m
            j1 = 2 * (j - i1 + 1)
            j2 = 1
            if (m1.eq.0) j2 = 0
            d(m1+j1-1) = a(i,j)
            d(m1+j1) = 0.d0
            d(m1+k+j1-j2) = a(i,j)
            d(m1+k+j1-1-j2) = 0.d0
10       continue
         j1 = 3
         if (i.eq.1) j1 = 1
         d(j1+m1) = d(j1+m1) + b(ind,ind)
         d(j1+m1+1) = d(j1+m1+1) + b(ind,ind+1)
         if (i.ne.1) j1 = 2
         d(j1+m1+k) = d(j1+m1+k) + b(ind+1,ind)
         d(j1+m1+k+1) = d(j1+m1+k+1) + b(ind+1,ind+1)
c
c        store right hand side
c
         d(2*i+mfin) = c(i,ind+1)
         d(2*i-1+mfin) = c(i,ind)
20    continue
c
c     solve the system of equations and store the result back in c
c
      call h2solv(d,ipr,m,reps,ierr)
      if (ierr.ne.0) go to 40
      do 30 i = 1,m
         c(i,ind) = d(ipr(2*i-1))
         c(i,ind+1) = d(ipr(2*i))
30    continue
      ind = ind - 2
      return
40    ierr = -ind - 1
      return
      end
c
c
c
c
c
      subroutine h2solv(d,ipr,m,reps,ierr)
c
      integer i,i1,i2,ierr,ipr(1),irow2,j,j1,k,k1,l,n,n2,n21,mfin
      real*8 reps,d(1),max,dabs
c
c     this subroutine solves a system of 2m * 2m equations
c     where the matrix has zeroes below the sub - sub - diagonal
c     and where the matrix is stored as a vector in packed form.
c     the method used is gaussian elimination.
c     parameters:
c     d      -  matrix of coefficients, right hand side (on input),
c               and solution (on output).
c     ipr    -  vector used to record row permutations
c     m      -  size of system
c     reps   -  error tolerance
c     ierr   -  error code (ierr=0 => normal return)
c                          (ierr=-1 => singular matrix)
c
c     --------------------------------------------------------------
c
c     initialize pivot vectors and size parameters.
c
      ierr = 0
      m2 = 2 * m
      mfin = (m2 * (m2 + 1)) / 2 + 4 * m
      do 10 i = 1,m2
         ipr(m2+i) = irow2(i,m)
         ipr(i) = i + mfin
10    continue
      m21 = m2 - 1
c
c     transform matrix to triangular form
c
      do 40 i = 1,m21
         i1 = 2
         if (i.eq.m21) i1 = 1
         l = 0
c
c        interchange rows if necessary
c
         max = dabs(d(ipr(m2+i) + 1))
         do 20 j = 1,i1
            if (dabs(d(ipr(m2+j+i) + 1)).le.max) go to 20
            max = dabs(d(ipr(m2+j+i) + 1))
            l = j
20       continue
c
c        check for computationally singular matrix
c
         if (max.le.reps) go to 80
         if (l.eq.0) go to 30
         k = ipr(m2+i)
         ipr(m2+i) = ipr(m2+l+i)
         ipr(m2+l+i) = k
         k = ipr(i)
         ipr(i) = ipr(i+l)
         ipr(i+l) = k
30       continue
c
c        adjust pointers to beginnings of rows
c
         ipr(m2+i+1) = ipr(m2+i+1) + 1
         if (i.ne.m21) ipr(m2+i+2) = ipr(m2+i+2) + 1
         ip1 = i + 1
c
c        eliminate subdiagonal elements in the matrix
c
         do 40 j = 1,i1
            max = d(ipr(m2+i+j)) / d(ipr(m2+i)+1)
            d(ipr(i+j)) = d(ipr(i+j)) - max * d(ipr(i))
            do 40 k1 = ip1,m2
               k = k1 - i
               d(ipr(m2+i+j)+k) = d(ipr(m2+i+j)+k) -
     *                                    max * d(ipr(m2+i)+1+k)
40    continue
      if (dabs(d(ipr(m2+m2)+1)).le.reps) go to 80
c
c     perform back substitution
c
      d(ipr(m2)) = d(ipr(m2)) / d(ipr(m2+m2)+1)
      do 60 i1 = 1,m21
         i = m2 - i1
         i2 = i + 1
         max = 0.d0
         do 50 j1 = i2,m2
            j = j1 - i2 + 2
            max = max + d(ipr(j1)) * d(ipr(m2+i)+j)
50       continue
         d(ipr(i)) = (d(ipr(i)) - max) / d(ipr(m2+i)+1)
60    continue
70    return
80    ierr = -1
      go to 70
      end
c
c
c
c
c
      subroutine backs2(c,b,ind,n,m,mdim,ndim)
c
      integer i,ind,ind1,ind2,j,m,mdim,n,ndim
      real*8 b(ndim,n),c(mdim,n)
c
c     block back - substitution for two 'rows'.
c     parameters are as in subroutine axxbc.
c
      ind1 = ind + 1
      ind2 = ind + 2
      do 10 i = ind2,n
         do 10 j = 1,m
            c(j,ind1) = c(j,ind1) - b(ind1,i) * c(j,i)
            c(j,ind) = c(j,ind) - b(ind,i) * c(j,i)
10    continue
      return
      end
c
c
c
c
c
      integer function irow2(i,m)
c
      integer i,k,m
c
c     this function finds the index (for the vector d) one
c     before the beginning of row i in the 2n*2n matrix.
c
      irow2 = 2 * (i - 1) * m
      k = (i - 4) * (i - 3) / 2
      if (i.le.2) k = 0
      irow2 = irow2 - k
      return
      end
c
c
c
c
c
      integer function lrow2(i,m)
c
      integer i,k,m
c
c     this function finds the length of row i in the
c     double matrix (when it is stored in packed form in the
c     vector d)
c
      k = i - 3
      if (i.le.2) k = 0
      lrow2 = 2 * m - k
      if (i.le.2) lrow2 = 2 * m
      return
      end

! @section Synopsis
!
! Doomsday algorithm giving the day of the week for a date.
!
! @author J. Marcel van der Veer
!
! @section copyright
!
! This file is part of VIF - vintage fortran compiler.
! Copyright 2020-2025 J. Marcel van der Veer <algol68g@xs4all.nl>.
!
! @section license
!
! This program is free software; you can redistribute it and/or modify it 
! under the terms of the gnu general public license as published by the 
! free software foundation; either version 3 of the license, or 
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful, but 
! without any warranty; without even the implied warranty of merchantability 
! or fitness for a particular purpose. See the GNU general public license for 
! more details. You should have received a copy of the GNU general public 
! license along with this program. If not, see <http://www.gnu.org/licenses/>.
!
      SUBROUTINE doomsday_gregorian (y, m, d, w)

c  DOOMSDAY_GREGORIAN(): weekday given any date in Gregorian calendar.
c
c  Discussion:
c
c    This procedure does not include any procedure to switch to the Julian
c    calendar for dates early enough that that calendar was used instead.
c
c  Licensing:
c
c    This code is distributed under the MIT license.
c
c  Modified:
c
c    28 May 2012
c
c  Author:
c
c    John Burkardt
c
c  Reference:
c
c    John Conway,
c    Tomorrow is the Day After Doomsday,
c    Eureka,
c    Volume 36, October 1973, pages 28-31.
c
c  Parameters:
c
c    Input, integer Y, M, D, the year, month and day of the date.
c    Note that the year must be positive.
c
c    Output, integer W, the weekday of the date.
c
      IMPLICIT none

      INTEGER anchor(4)
      INTEGER c
      INTEGER d
      INTEGER drd
      INTEGER drdr
      INTEGER i4_wrap
      INTEGER l
      INTEGER m
      INTEGER mdoom(12)
      INTEGER w
      INTEGER y
      INTEGER ydoom
      LOGICAL year_is_leap_gregorian
      INTEGER yy
      INTEGER yy12d
      INTEGER yy12r
      INTEGER yy12r4d

      SAVE anchor
      SAVE mdoom

      DATA anchor / 1, 6, 4, 3 /
      DATA mdoom / 3, 28, 0, 4, 9, 6, 11, 8, 5, 10, 7, 12 /
c
c  Refuse to handle Y <= 0.
c
      IF (y .le. 0) THEN
        write (*, '(a)') ' '
        write (*, '(a)') 'DOOMSDAY_GREGORIAN - Fatal error!'
        write (*, '(a)') '  Y <= 0.'
        STOP
      END IF
c
c  Determine the century C.
c
      c = y / 100
c
c  Determine the last two digits of the year, YY
c
      yy = mod (y, 100)
c
c  Divide the last two digits of the year by 12.
c
      yy12d = yy / 12
      yy12r = mod (yy, 12) 
      yy12r4d = yy12r / 4
      drd = yy12d + yy12r + yy12r4d

      drdr = mod (drd, 7)
      ydoom = anchor(mod (c-1, 4) + 1) + drdr
      ydoom = i4_wrap (ydoom, 1, 7)
c
c  If M = 1 or 2, and Y is a leap year, add 1.
c
      IF ((m .eq. 1 .or. m .eq. 2) .and. 
     &  year_is_leap_gregorian (y)) THEN
        l = 1
      ELSE
        l = 0
      END IF

      w = ydoom + (d -  mdoom(m) - l)
      w = i4_wrap (w, 1, 7)


      RETURN
      END

      FUNCTION i4_modp (i, j)

cc I4_MODP returns the nonnegative remainder of integer division.
c
c  Discussion:
c
c    If
c      NREM = I4_MODP (I, J)
c      NMULT = (I - NREM) / J
c    then
c      I = J * NMULT + NREM
c    where NREM is always nonnegative.
c
c    The MOD function computes a result with the same sign as the
c    quantity being divided.  Thus, suppose you had an angle A,
c    and you wanted to ensure that it was between 0 and 360.
c    Then mod(A,360) would do, if A was positive, but if A
c    was negative, your result would be between -360 and 0.
c
c    On the other hand, I4_MODP(A,360) is between 0 and 360, always.
c
c  Example:
c
c        I     J     MOD I4_MODP    Factorization
c
c      107    50       7       7    107 =  2 *  50 + 7
c      107   -50       7       7    107 = -2 * -50 + 7
c     -107    50      -7      43   -107 = -3 *  50 + 43
c     -107   -50      -7      43   -107 =  3 * -50 + 43
c
c  Licensing:
c
c    This code is distributed under the MIT license.
c
c  Modified:
c
c    30 December 2006
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Input, integer I, the number to be divided.
c
c    Input, integer J, the number that divides I.
c
c    Output, integer I4_MODP, the nonnegative remainder when I is
c    divided by J.
c
      IMPLICIT none

      INTEGER i
      INTEGER i4_modp
      INTEGER j
      INTEGER value

      IF (j .eq. 0) THEN
        CALL xerabt ('i4_modp: illegal divisor', 1)
      END IF

      value = mod (i, j)

      IF (value .lt. 0) THEN
        value = value + abs (j)
      END IF

      i4_modp = value

      RETURN
      END

      FUNCTION i4_wrap (ival, ilo, ihi)

c  I4_WRAP forces an I4 to lie between given limits by wrapping.
c
c  Example:
c
c    ILO = 4, IHI = 8
c
c    I  Value
c
c    -2     8
c    -1     4
c     0     5
c     1     6
c     2     7
c     3     8
c     4     4
c     5     5
c     6     6
c     7     7
c     8     8
c     9     4
c    10     5
c    11     6
c    12     7
c    13     8
c    14     4
c
c  Licensing:
c
c    This code is distributed under the MIT license.
c
c  Modified:
c
c    31 December 2006
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Input, integer IVAL, an integer value.
c
c    Input, integer ILO, IHI, the desired bounds for the integer value.
c
c    Output, integer I4_WRAP, a "wrapped" version of IVAL.
c
      IMPLICIT none

      INTEGER i4_modp
      INTEGER i4_wrap
      INTEGER ihi
      INTEGER ilo
      INTEGER ival
      INTEGER jhi
      INTEGER jlo
      INTEGER value
      INTEGER wide

      jlo = min (ilo, ihi)
      jhi = max (ilo, ihi)

      wide = jhi - jlo + 1

      IF (wide .eq. 1) THEN
        value = jlo
      ELSE
        value = jlo + i4_modp (ival - jlo, wide)
      END IF

      i4_wrap = value

      RETURN
      END

      SUBROUTINE weekday_to_name_common (w, s)

c  WEEKDAY_TO_NAME_COMMON returns the name of a Common weekday.
c
c  Licensing:
c
c    This code is distributed under the MIT license.
c
c  Modified:
c
c    28 August 1999
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Input, integer W, the weekday index.
c
c    Output, character * (*) S, the weekday name.
c
      IMPLICIT none

      CHARACTER * 9 name(7)
      CHARACTER * (*) s
      INTEGER w
      INTEGER w2

      SAVE name

      DATA name /
     &  'Sunday   ', 'Monday   ', 'Tuesday  ', 'Wednesday',
     &  'Thursday ', 'Friday   ', 'Saturday ' /
c
c  Make a local copy of the weekday number.
c
      w2 = w
c
c  Return the weekday name.
c
      s = name (w2)

      RETURN
      END

      SUBROUTINE weekday_values (n_data, y, m, d, w)

c  WEEKDAY_VALUES returns the day of the week for various dates.
c
c  Discussion:
c
c    The CE or Common Era calendar is used, under the
c    hybrid Julian/Gregorian Calendar, with a transition from Julian
c    to Gregorian.  The day after 04 October 1582 was 15 October 1582.
c
c    The year before 1 AD or CE is 1 BC or BCE.  In this data set,
c    years BC/BCE are indicated by a negative year value.
c
c  Licensing:
c
c    This code is distributed under the MIT license.
c
c  Modified:
c
c    26 May 2012
c
c  Author:
c
c    John Burkardt
c
c  Reference:
c
c    Edward Reingold, Nachum Dershowitz,
c    Calendrical Calculations: The Millennium Edition,
c    Cambridge University Press, 2001,
c    ISBN: 0 521 77752 6
c    LC: CE12.R45.
c
c  Parameters:
c
c    Input/output, integer N_DATA.  The user sets N_DATA to 0
c    before the first call.  On each call, the routine increments N_DATA by 1,
c    and returns the corresponding data; when there is no more data, the
c    output value of N_DATA will be 0 again.
c
c    Output, integer Y, M, D, the Common Era date.
c
c    Output, integer W, the day of the week.  Sunday = 1.
c
      IMPLICIT none

      INTEGER n_max
      PARAMETER (n_max = 34)

      INTEGER d
      INTEGER d_vec(n_max)
      INTEGER m
      INTEGER m_vec(n_max)
      INTEGER n_data
      INTEGER w
      INTEGER w_vec(n_max)
      INTEGER y
      INTEGER y_vec(n_max)

      SAVE d_vec
      SAVE m_vec
      SAVE w_vec
      SAVE y_vec

      DATA d_vec /
     &  30,
     &   8,
     &  26,
     &   3,
     &   7,
     &  18,
     &   7,
     &  19,
     &  14,
     &  18,
     &  16,
     &   3,
     &  26,
     &  20,
     &   4,
     &  25,
     &  31,
     &   9,
     &  24,
     &  10,
     &  30,
     &  24,
     &  19,
     &   2,
     &  27,
     &  19,
     &  25,
     &  29,
     &  19,
     &   7,
     &  17,
     &  25,
     &  10,
     &  18 /
      DATA m_vec /
     &   7,
     &  12,
     &   9,
     &  10,
     &   1,
     &   5,
     &  11,
     &   4,
     &  10,
     &   5,
     &   3,
     &   3,
     &   3,
     &   4,
     &   6,
     &   1,
     &   3,
     &   9,
     &   2,
     &   6,
     &   6,
     &   7,
     &   6,
     &   8,
     &   3,
     &   4,
     &   8,
     &   9,
     &   4,
     &  10,
     &   3,
     &   2,
     &  11,
     &   7 /
      DATA w_vec /
     &  1,
     &  4,
     &  4,
     &  1,
     &  4,
     &  2,
     &  7,
     &  1,
     &  7,
     &  1,
     &  6,
     &  7,
     &  6,
     &  1,
     &  1,
     &  4,
     &  7,
     &  7,
     &  7,
     &  4,
     &  1,
     &  6,
     &  1,
     &  2,
     &  4,
     &  1,
     &  1,
     &  2,
     &  2,
     &  5,
     &  3,
     &  1,
     &  4,
     &  1 /
      DATA y_vec /
     &  - 587,
     &  - 169,
     &     70,
     &    135,
     &    470,
     &    576,
     &    694,
     &   1013,
     &   1066,
     &   1096,
     &   1190,
     &   1240,
     &   1288,
     &   1298,
     &   1391,
     &   1436,
     &   1492,
     &   1553,
     &   1560,
     &   1648,
     &   1680,
     &   1716,
     &   1768,
     &   1819,
     &   1839,
     &   1903,
     &   1929,
     &   1941,
     &   1943,
     &   1943,
     &   1992,
     &   1996,
     &   2038,
     &   2094 /

      IF (n_data .lt. 0) THEN
        n_data = 0
      END IF

      n_data = n_data + 1

      IF (n_max .lt. n_data) THEN
        n_data = 0
        y = 0
        m = 0
        d = 0
        w = 0
      ELSE
        y = y_vec(n_data)
        m = m_vec(n_data)
        d = d_vec(n_data)
        w = w_vec(n_data)
      END IF

      RETURN
      END

      FUNCTION year_is_leap_gregorian (y)

c  YEAR_IS_LEAP_GREGORIAN returns TRUE if the Gregorian year was a leap year.
c
c  Licensing:
c
c    This code is distributed under the MIT license.
c
c  Modified:
c
c    21 May 2000
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Input, integer Y, the year to be checked.
c
c    Output, logical YEAR_IS_LEAP_GREGORIAN, TRUE if the year was a leap year,
c    FALSE otherwise.
c
      IMPLICIT none

      INTEGER y
      LOGICAL year_is_leap_gregorian

      IF (y .le. 0) THEN
        CALL xerabt ('year_is_leap_gregorian: invalid year', 1)
      END IF

      IF (mod (y, 400) .eq. 0) THEN
        year_is_leap_gregorian = .true.
      ELSE IF (mod (y, 100) .eq. 0) then
        year_is_leap_gregorian = .false.
      ELSE IF (mod (y, 4) .eq. 0) then
        year_is_leap_gregorian = .true.
      ELSE
        year_is_leap_gregorian = .false.
      END IF

      RETURN
      END

#pragma -xO
      function bisect (xx, nb, ner, l)
c
c BISECT approximates the W function using bisection.
c
c  Discussion:
c
c    The parameter TOL, which determines the accuracy of the bisection
c    method, is calculated using NBITS (assuming the final bit is lost
c    due to rounding error).
c
c    N0 is the maximum number of iterations used in the bisection
c    method.
c
c    For XX close to 0 for Wp, the exponential approximation is used.
c    The approximation is exact to O(XX^8) so, depending on the value
c    of NBITS, the range of application of this formula varies. Outside
c    this range, the usual bisection method is used.
c
c  Licensing:
c
c    This code is distributed under the MIT license.
c
c  Modified:
c
c    13 June 2014
c
c  Author:
c
c    Original FORTRAN77 version by Andrew Barry, S. J. Barry, 
c    Patricia Culligan-Hensley.
c    This version by John Burkardt.
c
c  Reference:
c
c    Andrew Barry, S. J. Barry, Patricia Culligan-Hensley,
c    Algorithm 743: WAPR - A Fortran routine for calculating real 
c    values of the W-function,
c    ACM Transactions on Mathematical Software,
c    Volume 21, Number 2, June 1995, pages 172-181.
c
c  Parameters:
c
c    Input, double precision XX, the argument.
c
c    Input, integer NB, indicates the branch of the W function.
c    0, the upper branch;
c    nonzero, the lower branch.
c
c    Output, integer NER, the error flag.
c    0, success;
c    1, the routine did not converge.  Perhaps reduce NBITS and try again.
c
c    Input, integer L, the offset indicator.
c    1, XX represents the offset of the argument from -exp(-1).
c    not 1, XX is the actual argument.
c
c    Output, double precision BISECT, the value of W(X), as determined
c    by bisection.
c
      implicit none
      double precision bisect
      double precision crude
      double precision d
      double precision f
      double precision fd
      integer i
      integer l
      integer n0
      parameter (n0 = 500)
      integer nb
      integer nbits
      integer ner
      double precision r
      double precision test
      double precision tol
      double precision u
      double precision x
      double precision xx
      save nbits
      data nbits / 0 /
      bisect = 0.0D+00
      ner = 0
      if (nbits == 0) then
        call nbits_compute (nbits)
      end if
      if (l .eq. 1) then
        x = xx - dexp (-1.0D+00)
      else
        x = xx
      end if
      if (nb .eq. 0) then
        test = 1.0D+00 / (2.0D+00 ** nbits) ** (1.0D+00 / 7.0D+00)
        if (dabs (x) .lt. test) then
          bisect = x 
     &      * dexp (- x
     &      * dexp (- x 
     &      * dexp (- x 
     &      * dexp (- x
     &      * dexp (- x
     &      * dexp (- x))))))
          return
        else
          u = crude (x, nb) + 1.0D-03
          tol = dabs (u) / 2.0D+00 ** nbits
          d = max (u - 2.0D-03, -1.0D+00)
          do i = 1, n0
            r = 0.5D+00 * (u - d)
            bisect = d + r
c
c  Find root using w*exp(w)-x to avoid ln(0) error.
c
            if (x .lt. dexp (1.0D+00)) then
              f = bisect * dexp (bisect) - x
              fd = d * dexp (d) - x
c
c  Find root using ln(w/x)+w to avoid overflow error.
c
            else
              f = dlog (bisect / x) + bisect
              fd = dlog (d / x) + d
            end if
            if (f .eq. 0.0D+00) then
              return
            end if
            if (dabs (r) .le. tol) then
              return
            end if
            if (0.0D+00 .lt. fd * f) then
              d = bisect
            else
              u = bisect
            end if
          end do
        end if
      else
        d = crude (x, nb) - 1.0D-03
        u = min (d + 2.0D-03, -1.0D+00)
        tol = dabs (u) / 2.0D+00 ** nbits
        do i = 1, n0
          r = 0.5D+00 * (u - d)
          bisect = d + r
          f = bisect * dexp (bisect) - x
          if (f .eq. 0.0D+00) then
            return
          end if
          if (dabs (r) .le. tol) then
            return
          end if
          fd = d * dexp (d) - x
          if (0.0D+00 .lt. fd * f) then
            d = bisect
          else
            u = bisect
          end if
        end do
      end if
c
c  The iteration did not converge.
c
      ner = 1
      return
      end

      function crude (xx, nb)
c
c CRUDE returns a crude approximation for the W function.
c
c  Licensing:
c
c    This code is distributed under the MIT license.
c
c  Modified:
c
c    12 June 2014
c
c  Author:
c
c    Original FORTRAN77 version by Andrew Barry, S. J. Barry, 
c    Patricia Culligan-Hensley.
c    This version by John Burkardt.
c
c  Reference:
c
c    Andrew Barry, S. J. Barry, Patricia Culligan-Hensley,
c    Algorithm 743: WAPR - A Fortran routine for calculating real 
c    values of the W-function,
c    ACM Transactions on Mathematical Software,
c    Volume 21, Number 2, June 1995, pages 172-181.
c
c  Parameters:
c
c    Input, double precision XX, the argument.
c
c    Input, integer NB, indicates the desired branch of the W function.
c    * 0, the upper branch;
c    * nonzero, the lower branch.
c
c    Output, double precision CRUDE, the crude approximation to W at XX.
c
      implicit none
      double precision an2
      double precision c13
      double precision crude
      double precision em
      double precision em2
      double precision em9
      double precision eta
      integer init
      integer nb
      double precision reta
      double precision s2
      double precision s21
      double precision s22
      double precision s23
      double precision t
      double precision ts
      double precision xx
      double precision zl
      save c13
      save em
      save em2
      save em9
      save init
      save s2
      save s21
      save s22
      save s23
      data init / 0 /
      crude = 0.0D+00
c
c  Various mathematical constants.
c
      if (init .eq. 0) then
        init = 1
        em = - dexp (-1.0D+00)
        em9 = - dexp (-9.0D+00)
        c13 = 1.0D+00 / 3.0D+00
        em2 = 2.0D+00 / em
        s2 = dsqrt (2.0D+00)
        s21 = 2.0D+00 * s2 - 3.0D+00
        s22 = 4.0D+00 - 3.0D+00 * s2
        s23 = s2 - 2.0D+00
      end if
c
c  Crude Wp.
c
      if (nb .eq. 0) then
        if (xx .le. 20.0D+00) then
          reta = s2 * dsqrt (1.0D+00 - xx / em)
          an2 = 4.612634277343749D+00 * dsqrt (dsqrt (reta +
     &      1.09556884765625D+00))
          crude = reta / (1.0D+00 + reta / (3.0D+00 
     &      + (s21 * an2 + s22) * reta / (s23 * (an2 + reta)))) 
     &      - 1.0D+00
        else
          zl = dlog (xx)
          crude = dlog (xx / dlog (xx 
     &      / zl ** dexp (-1.124491989777808D+00 /
     &      (0.4225028202459761D+00 + zl))))
        end if
      else
c
c  Crude Wm.
c
        if (xx .le. em9) then
          zl = dlog (-xx)
          t = -1.0D+00 - zl
          ts = dsqrt (t)
          crude = zl - (2.0D+00 * ts) / (s2 + (c13 - t 
     &      / (270.0D+00 + ts * 127.0471381349219D+00)) * ts)
        else
          zl = dlog (-xx)
          eta = 2.0D+00 - em2 * xx
          crude = dlog (xx / dlog (- xx / ((1.0D+00
     &      - 0.5043921323068457D+00 * (zl + 1.0D+00)) 
     &      * (dsqrt (eta) + eta / 3.0D+00) + 1.0D+00)))
         end if
      end if
      return
      end

      subroutine nbits_compute (nbits)
c
c NBITS_COMPUTE computes the mantissa length minus one.
c
c  Discussion:
c
c    NBITS is the number of bits (less 1) in the mantissa of the
c    floating point number number representation of your machine.
c    It is used to determine the level of accuracy to which the W
c    function should be calculated.
c
c    Most machines use a 24-bit matissa for single precision and
c    53-56 bits for double precision. The IEEE standard is 53
c    bits. The Fujitsu VP2200 uses 56 bits. Long word length
c    machines vary, e.g., the Cray X/MP has a 48-bit mantissa for
c    single precision.
c
c  Licensing:
c
c    This code is distributed under the MIT license.
c
c  Modified:
c
c    12 June 2014
c
c  Author:
c
c    Original FORTRAN77 version by Andrew Barry, S. J. Barry, 
c    Patricia Culligan-Hensley.
c    This version by John Burkardt.
c
c  Reference:
c
c    Andrew Barry, S. J. Barry, Patricia Culligan-Hensley,
c    Algorithm 743: WAPR - A Fortran routine for calculating real 
c    values of the W-function,
c    ACM Transactions on Mathematical Software,
c    Volume 21, Number 2, June 1995, pages 172-181.
c
c  Parameters:
c
c    Output, integer NBITS, the mantissa length, in bits, minus one.
c
      implicit none
      double precision b
      integer nbits
      double precision v
      nbits = 0
      b = 1.0D+00
10    continue
        b = b / 2.0D+00
        v = b + 1.0D+00
        if (v .eq. 1.0D+00) then
          go to 20
        end if
        nbits = nbits + 1
      go to 10
20    continue
      return
      end

      function fwapr (x, nb, nerror, l)
c
c WAPR approximates the W function.
c
c  Discussion:
c
c    The call will fail if the input value X is out of range.
c    The range requirement for the upper branch is:
c      -exp(-1) <= X.
c    The range requirement for the lower branch is:
c      -exp(-1) < X < 0.
c
c  Licensing:
c
c    This code is distributed under the MIT license.
c
c  Modified:
c
c    13 June 2014
c
c  Author:
c
c    Original FORTRAN77 version by Andrew Barry, S. J. Barry, 
c    Patricia Culligan-Hensley.
c    This version by John Burkardt.
c
c  Reference:
c
c    Andrew Barry, S. J. Barry, Patricia Culligan-Hensley,
c    Algorithm 743: WAPR - A Fortran routine for calculating real 
c    values of the W-function,
c    ACM Transactions on Mathematical Software,
c    Volume 21, Number 2, June 1995, pages 172-181.
c
c  Parameters:
c
c    Input, double precision X, the argument.
c
c    Input, integer NB, indicates the desired branch of the W function.
c    * 0, the upper branch;
c    * nonzero, the lower branch.
c
c    Output, integer NERROR, the error flag.
c    * 0, successful call.
c    * 1, failure, the input X is out of range.
c
c    Input, integer L, indicates the interpretation of X.
c    * 1, X is actually the offset from -(exp-1), so compute W(X-exp(-1)).
c    * not 1, X is the argument; compute W(X);
c
c    Output, double precision WAPR, the approximate value of W(X).
c
      implicit none
      double precision an2
      double precision an3
      double precision an4
      double precision an5
      double precision an6
      double precision c13
      double precision c23
      double precision d12
      double precision delx
      double precision em
      double precision em2
      double precision em9
      double precision eta
      integer i
      integer init
      integer l
      integer nb
      integer nbits
      integer nerror
      integer niter
      double precision reta
      double precision s2
      double precision s21
      double precision s22
      double precision s23
      double precision t
      double precision tb
      double precision tb2
      double precision temp
      double precision temp2
      double precision ts
      double precision fwapr
      double precision x
      double precision x0
      double precision x1
      double precision xx
      double precision zl
      double precision zn
      save an3
      save an4
      save an5
      save an6
      save c13
      save c23
      save d12
      save em
      save em2
      save em9
      save init
      save nbits
      save niter
      save s2
      save s21
      save s22
      save s23
      save tb
      save tb2
      save x0
      save x1
      data init / 0 /
      data niter / 1 /
      fwapr = 0.0D+00
      nerror = 0
      if (init .eq. 0) then
        init = 1
        call nbits_compute (nbits)
        if (56 .le. nbits) then
          niter = 2
        end if
c
c  Various mathematical constants.
c
        em = -dexp (-1.0D+00)
        em9 = -dexp (-9.0D+00)
        c13 = 1.0D+00 / 3.0D+00
        c23 = 2.0D+00 * c13
        em2 = 2.0D+00 / em
        d12 = -em2
        tb = 0.5D+00 ** nbits
        tb2 = dsqrt (tb)
        x0 = tb ** (1.0D+00 / 6.0D+00) * 0.5D+00
        x1 = (1.0D+00 - 17.0D+00 * tb ** (2.0D+00 / 7.0D+00)) * em
        an3 = 8.0D+00 / 3.0D+00
        an4 = 135.0D+00 / 83.0D+00
        an5 = 166.0D+00 / 39.0D+00
        an6 = 3167.0D+00 / 3549.0D+00
        s2 = dsqrt (2.0D+00)
        s21 = 2.0D+00 * s2 - 3.0D+00
        s22 = 4.0D+00 - 3.0D+00 * s2
        s23 = s2 - 2.0D+00
      end if
      if (l .eq. 1) then
        delx = x
        if (delx .lt. 0.0D+00) then
          nerror = 1
          write (*, '(a)') ''
          write (*, '(a)') 'WAPR - Fatal error!'
          write (*, '(a)') '  The offset X is negative.'
          write (*, '(a)') '  It must be nonnegative.'
          stop 1
        end if
        xx = x + em
      else
        if (x .lt. em) then
          nerror = 1
          return
        else if (x .eq. em) then
          fwapr = -1.0D+00
          return
        end if
        xx = x
        delx = xx - em
      end if
      if (nb .eq. 0) then
c
c  Calculations for Wp.
c
        if (dabs (xx) .le. x0) then
          fwapr = xx / (1.0D+00 + xx / (1.0D+00 + xx 
     &      / (2.0D+00 + xx / (0.6D+00 + 0.34D+00 * xx))))
          return
        else if (xx .le. x1) then
          reta = dsqrt (d12 * delx)
          fwapr = reta / (1.0D+00 + reta / (3.0D+00 + reta / (reta
     &      / (an4 + reta / (reta * an6 + an5)) + an3))) 
     &      - 1.0D+00
          return
        else if (xx .le. 20.0D+00) then
          reta = s2 * dsqrt (1.0D+00 - xx / em)
          an2 = 4.612634277343749D+00 * dsqrt (dsqrt (reta +
     &      1.09556884765625D+00))
          fwapr = reta / (1.0D+00 + reta / (3.0D+00 + (s21 * an2 
     &      + s22) * reta / (s23 * (an2 + reta)))) - 1.0D+00
        else
          zl = dlog (xx)
          fwapr = dlog (xx / dlog (xx 
     &      / zl ** dexp (-1.124491989777808D+00 /
     &      (0.4225028202459761D+00 + zl))))
        end if
c
c  Calculations for Wm.
c
      else
        if (0.0D+00 .le. xx) then
          nerror = 1
          return
        else if (xx .le. x1) then
          reta = dsqrt (d12 * delx)
          fwapr = reta / (reta / (3.0D+00 + reta / (reta / (an4 
     &      + reta / (reta * an6 - an5)) - an3)) - 1.0D+00) 
     &      - 1.0D+00
          return
        else if (xx .le. em9) then
          zl = dlog (-xx)
          t = -1.0D+00 - zl
          ts = dsqrt (t)
          fwapr = zl - (2.0D+00 * ts) / (s2 + (c13 - t 
     &      / (270.0D+00 + ts * 127.0471381349219D+00)) * ts)
        else
          zl = dlog (-xx)
          eta = 2.0D+00 - em2 * xx
          fwapr = dlog (xx / dlog (-xx / ((1.0D+00 
     &      - 0.5043921323068457D+00 * (zl + 1.0D+00)) 
     &      * (dsqrt (eta) + eta / 3.0D+00) + 1.0D+00)))
        end if
      end if
      do i = 1, niter
        zn = dlog (xx / fwapr) - fwapr
        temp = 1.0D+00 + fwapr
        temp2 = temp + c23 * zn
        temp2 = 2.0D+00 * temp * temp2
        fwapr = fwapr * (1.0D+00 + (zn / temp) * (temp2 - zn) 
     &    / (temp2 - 2.0D+00 * zn))
      end do
      return
      end

      program twapr
      implicit real*8 (a-h, o-z)
      parameter (n = 10000000)
      devmax = -1
      xu = -1
      do i = 1, n
      call rand48(j, k, rnd)
      x = exp (1.0d0 + 2 * rnd)
      y = wapr (x, 0, nerr, 0)
      z = fwapr (x, 0, nerr, 0)
      if (dabs(z - y) > devmax) then
        xu = x
        devmax = dabs(z - y)
      endif
      enddo
      write (*, *) n, ' upper branch trials, max dev = ', devmax, ' at x = ', xu
      devmax = -1
      xl = -1 
      do i = 1, n
      call rand48(j, k, rnd)
      x = exp (-1.0d0) * rnd
      y = wapr (x, 0, nerr, 1)
      z = fwapr (x, 0, nerr, 1)
      if (dabs(z - y) > devmax) then
        xl = x
        devmax = dabs(z - y)
      endif
      enddo
      write (*, *) n, ' lower branch trials, max dev = ', devmax, ' at x = ', xl
      end

#pragma -xO
      program a
      implicit real*8 (a-h, o-z)
      write (*, *) wapr (0.0d0, 0, nerr, 0)
      write (*, *) wapr (-dexp (-1.0d0), 0, nerr, 0)
      write (*, *) wapr (dexp (1.0d0), 0, nerr, 0)
      write (*, *) wapr (dexp (1.0d0 + dexp (1.0d0)), 0, nerr, 0)
      write (*, *) wapr (32 * dlog(2), 0, nerr, 0)
      end

! @section Synopsis
!
! Auxiliary math functions for VIF.
!
! @author J. Marcel van der Veer
!
! @section copyright
!
! This file is part of VIF - vintage fortran compiler.
! Copyright 2020-2025 J. Marcel van der Veer <algol68g@xs4all.nl>.
!
! @section license
!
! This program is free software; you can redistribute it and/or modify it 
! under the terms of the gnu general public license as published by the 
! free software foundation; either version 3 of the license, or 
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful, but 
! without any warranty; without even the implied warranty of merchantability 
! or fitness for a particular purpose. See the GNU general public license for 
! more details. You should have received a copy of the GNU general public 
! license along with this program. If not, see <http://www.gnu.org/licenses/>.
!

      SUBROUTINE rand48(ix,iy,yfl)
!
! Generates random numbers between 0 and 1 (SUN version).
!
!       ix - initial seed
!       iy - new seed value
!       yfl - random number double precision
!
! Adapted from CASCADE: netlib.org/ieeecs/cascade
! The CASCADE library is in the public domain.
!
      DOUBLE PRECISION yfl, drand48
      INTEGER ix, iy, iseed
      LOGICAL first
      DATA    first /.true./
      SAVE    first, iseed
!
!     if this is the first call, initialize topmost 32 bits of the seed
!
      IF (first .or. iseed .ne. ix) THEN
        CALL srand48 (ix)
        first = .false.
      END IF
!
!     Use SUN-supplied function drand48
!
      iy = ix
      iseed = ix
      yfl = drand48()
!
      RETURN
      END

      SUBROUTINE gauss(ix,x)
! The routine gauss generates a random number from a gaussian 
! distribution, with a mean of zero and a standard deviation of one.
!
!       VAX/VMS version
!
!       Variables:
!
!       ix - initial seed integer; gauss updates it with a new seed value
!
!       x - the output gaussian variable
!
! Adapted from CASCADE: netlib.org/ieeecs/cascade
! The CASCADE library is in the public domain.
!
      DOUBLE PRECISION x, y, sum
      sum = 0d0
      DO 1 i = 1, 5
         CALL rand48(ix,iy,y)
         ix = iy
         sum = sum + y
    1 CONTINUE
      x = 6d0 * (sum / 5d0) - 3d0
      RETURN
      END

      REAL*8 function zero in (ax, bx, f, tol, ierr)
      IMPLICIT REAL*8 (a - h, o - z)
!
! Compute a zero of the function f(x) in the interval [ax, bx].
!
! It is assumed that f(ax) and f(bx) have opposite signs.
! Zeroin returns a zero in the given interval ax, bx to within a
! tolerance 4 * macheps * abs(x) + tol, where macheps
! is the relative machine precision.
!
! Adapted from zeroin.f from netlib.org/fmm.
! That function is a slightly modified translation of the ALGOL 60
! procedure zero given in
!
!  Richard Brent, Algorithms for Minimization without Derivatives, 
!  Prentice - Hall, inc. (1973).
!
! Parameters:
!
! ax  left endpoint of initial interval
! bx  right endpoint of initial interval
! f   function subprogram which evaluates f(x) for any x in the interval ax, bx
! tol desired length of the interval of uncertainty of the final result (>= 0.0d0)
!
! Result:
!
! Approximation of a zero of f in the interval ax, bx
! ierr = 0 'zero in' found a root
! ierr = 1 'zero in' did not find a root
!
! Compare to SLATEC routines DFZERO and FZERO.
!

! Initialization.
      eps = d1mach(3)
      a = ax
      b = bx
      fa = f(a)
      fb = f(b)
! Begin.
    1 c = a
      fc = fa
      d = b - a
      e = d
    2 IF (dabs(fc) < dabs(fb)) THEN
        a = b
        b = c
        c = a
        fa = fb
        fb = fc
        fc = fa
      END IF
! Convergence check.
      tol1 = 2.0d0 * eps * dabs(b) + 0.5d0 * tol
      xm = .5d0 * (c - b)
      IF (dabs(xm) <= tol1 | fb == 0.0d0) GO TO 5
! Is bisection necessary?
      IF (dabs(e) < tol1 | dabs(fa) <= dabs(fb)) GO TO 3
! Is quadratic interpolation possible?
      IF (a == c) THEN
! Linear interpolation.
        s = fb / fa
        p = 2.0d0 * xm * s
        q = 1.0d0 - s
      ELSE
! Inverse quadratic interpolation.
        q = fa / fc
        r = fb / fc
        s = fb / fa
        p = s * (2.0d0 * xm * q * (q - r) - (b - a) * (r - 1.0d0))
        q = (q - 1.0d0) * (r - 1.0d0) * (s - 1.0d0)
      END IF
! Adjust signs.
      IF (p > 0.0d0) q = -q
      p = dabs(p)
! Is interpolation acceptable?
      IF ((2.0d0 * p) >= (3.0d0 * xm * q - dabs(tol1 * q))) GO TO 3
      IF (p >= dabs(0.5d0 * e * q)) GO TO 3
      e = d
      d = p / q
      GO TO 4
! Bisection.
    3 d = xm
      e = d
! Complete step.
    4 a = b
      fa = fb
      IF (dabs(d) > tol1) b = b + d
      IF (dabs(d) <= tol1) b = b + dsign(tol1, xm)
      fb = f(b)
      IF ((fb * (fc / dabs(fc))) > 0.0d0) GO TO 1
      GO TO 2
! Done.
    5 zero in = b
      IF (dabs (fb) <= tol) THEN
        ierr = 0
      ELSE
        ierr = 1
      END IF
      RETURN
      END

! @section Synopsis
!
! Statistical functions for VIF.
!
! @author J. Marcel van der Veer
!
! @section copyright
!
! This file is part of VIF - vintage fortran compiler.
! Copyright 2020-2025 J. Marcel van der Veer <algol68g@xs4all.nl>.
!
! @section license
!
! This program is free software; you can redistribute it and/or modify it 
! under the terms of the gnu general public license as published by the 
! free software foundation; either version 3 of the license, or 
! (at your option) any later version.
!
! This program is distributed in the hope that it will be useful, but 
! without any warranty; without even the implied warranty of merchantability 
! or fitness for a particular purpose. See the GNU general public license for 
! more details. You should have received a copy of the GNU general public 
! license along with this program. If not, see <http://www.gnu.org/licenses/>.
!

      REAL*8 FUNCTION dlnorm (x, upper)
!
! DLNORM computes the cumulative density of the standard normal distribution.
!
! Modified:
!
!   28 March 1999
!
! Author:
!
!   David Hill
!   Modifications by John Burkardt
!
! Reference:
!
!   David Hill,
!   Algorithm AS 66:
!   The Normal Integral,
!   Applied Statistics,
!   Volume 22, Number 3, 1973, pages 424-427.
!
! Parameters:
!
!   Input, real*8 X, is one endpoint of the semi-infinite interval
!   over which the integration takes place.
!
!   Input, logical UPPER, determines whether the upper or lower
!   interval is to be integrated:
!   .TRUE.  => integrate from X to + Infinity;
!   .FALSE. => integrate from - Infinity to X.
!
!   Output, real*8 ALNORM, the integral of the standard normal
!   distribution over the desired interval.
!
      IMPLICIT none

      REAL*8 a1
      PARAMETER (a1 = 5.75885480458d+00)
      REAL*8 a2
      PARAMETER (a2 = 2.62433121679d+00)
      REAL*8 a3
      PARAMETER (a3 = 5.92885724438d+00)
      REAL*8 b1
      PARAMETER (b1 = -29.8213557807d+00)
      REAL*8 b2
      PARAMETER (b2 = 48.6959930692d+00)
      REAL*8 c1
      PARAMETER (c1 = -0.000000038052d+00)
      REAL*8 c2
      PARAMETER (c2 = 0.000398064794d+00)
      REAL*8 c3
      PARAMETER (c3 = -0.151679116635d+00)
      REAL*8 c4
      PARAMETER (c4 = 4.8385912808d+00)
      REAL*8 c5
      PARAMETER (c5 = 0.742380924027d+00)
      REAL*8 c6
      PARAMETER (c6 = 3.99019417011d+00)
      REAL*8 con
      PARAMETER (con = 1.28d+00)
      REAL*8 d1
      PARAMETER (d1 = 1.00000615302d+00)
      REAL*8 d2
      PARAMETER (d2 = 1.98615381364d+00)
      REAL*8 d3
      PARAMETER (d3 = 5.29330324926d+00)
      REAL*8 d4
      PARAMETER (d4 = -15.1508972451d+00)
      REAL*8 d5
      PARAMETER (d5 = 30.789933034d+00)
      REAL*8 ltone
      PARAMETER (ltone = 7.0d+00)
      REAL*8 p
      PARAMETER (p = 0.398942280444d+00)
      REAL*8 q
      PARAMETER (q = 0.39990348504d+00)
      REAL*8 r
      PARAMETER (r = 0.398942280385d+00)
      LOGICAL up
      LOGICAL upper
      REAL*8 utzero
      PARAMETER (utzero = 18.66d+00)
      REAL*8 x
      REAL*8 y
      REAL*8 z

      up = upper
      z = x

      IF (z .lt. 0.0d+00) THEN
        up = .not. up
        z = - z
      END IF

      IF (ltone .lt. z .and. 
     &  ((.not. up) .or. utzero .lt. z)) THEN

        IF (up) THEN
          dlnorm = 0.0d+00
        ELSE
          dlnorm = 1.0d+00
        END IF

        RETURN

      END IF

      y = 0.5d+00 * z * z

      IF (z .le. con) THEN

        dlnorm = 0.5d+00 - z * (p - q * y
     &    / (y + a1 + b1 
     &    / (y + a2 + b2 
     &    / (y + a3))))

      ELSE

        dlnorm = r * dexp (- y)
     &    / (z + c1 + d1
     &    / (z + c2 + d2
     &    / (z + c3 + d3
     &    / (z + c4 + d4
     &    / (z + c5 + d5
     &    / (z + c6))))))

      END IF

      IF (.not. up) THEN
        dlnorm = 1.0d+00 - dlnorm
      END IF

      RETURN
      END

      REAL*8 FUNCTION prncst (st, idf, d, ifault)

!
! PRNCST computes the lower tail of noncentral T distribution.
!
! Modified:
!
!   06 January 2008
!
! Author:
!
!   BE Cooper
!   Modifications by John Burkardt
!
! Reference:
!
!   BE Cooper,
!   Algorithm AS 5: 
!   The Integral of the Non-Central T-Distribution,
!   Applied Statistics,
!   Volume 17, Number 2, 1968, page 193.
!
! Parameters:
!
!   Input, real*8 ST, the argument.
!
!   Input, integer IDF, the number of degrees of freedom.
!
!   Input, real*8 D, the noncentrality parameter.
!
!   Output, integer IFAULT, error flag.
!   0, no error occurred.
!   nonzero, an error occurred.
!
!   Output, real*8 PRNCST, the value of the lower tail of
!   the noncentral T distribution.
!
! Local Parameters:
!
!   Local, real*8 G1, 1.0 / sqrt(2.0 * pi)
!
!   Local, real*8 G2, 1.0 / (2.0 * pi)
!
!   Local, real*8 G3, sqrt(2.0 * pi)
!
      IMPLICIT none

      REAL*8 a
      REAL*8 ak
      REAL*8 dlnorm
      REAL*8 b
      REAL*8 d
      REAL*8 da
      REAL*8 drb
      REAL*8 emin
      PARAMETER (emin = 12.5d+00)
      REAL*8 f
      REAL*8 fk
      REAL*8 fkm1
      REAL*8 fmkm1
      REAL*8 fmkm2
      REAL*8 g1
      PARAMETER (g1 = 0.3989422804d+00)
      REAL*8 g2
      PARAMETER (g2 = 0.1591549431d+00)
      REAL*8 g3
      PARAMETER (g3 = 2.5066282746d+00)
      INTEGER idf
      INTEGER ifault
      INTEGER ioe
      INTEGER k
      REAL*8 rb
      REAL*8 st
      REAL*8 sum
      REAL*8 tfn

      f = dble (idf)
!
! For very large IDF, use the normal approximation.
!
      IF (100 .lt. idf) THEN

        ifault = 1

        a = dsqrt (0.5d+00 * f) 
     &  * dexp (dlngam (0.5d+00 * (f - 1.0d+00))
     &  - dlngam (0.5d+00 * f)) * d

        prncst = dlnorm ((st - a) / dsqrt (f * (1.0d+00 + d * d)
     &  / (f - 2.0d+00) - a * a), .false.)

        RETURN
      END IF

      ifault = 0
      ioe = mod (idf, 2)
      a = st / dsqrt (f)
      b = f / (f + st * st)
      rb = dsqrt (b)
      da = d * a
      drb = d * rb

      IF (idf .eq. 1) THEN
        prncst = dlnorm (drb, .true.) + 2.0d+00 * tfn (drb, a)
        RETURN
      END IF

      sum = 0.0d+00

      IF (dabs (drb) .lt. emin) THEN
        fmkm2 = a * rb * dexp (- 0.5d+00 * drb * drb)
     &  * dlnorm (a * drb, .false.) * g1
      ELSE
        fmkm2 = 0.0d+00
      END IF

      fmkm1 = b * da * fmkm2

      IF (dabs (d)  .lt. emin) THEN
        fmkm1 = fmkm1 + b * a * g2 * dexp (- 0.5d+00 * d * d)
      END IF

      IF (ioe .eq. 0) THEN
        sum = fmkm2
      ELSE
        sum = fmkm1
      END IF

      ak = 1.0d+00
      fk = 2.0d+00

      DO k = 2, idf - 2, 2

        fkm1 = fk - 1.0d+00
        fmkm2 = b * (da * ak * fmkm1 + fmkm2) * fkm1 / fk
        ak = 1.0d+00 / (ak * fkm1)
        fmkm1 = b * (da * ak * fmkm2 + fmkm1) * fk / (fk + 1.0d+00)

        IF (ioe .eq. 0) THEN
          sum = sum + fmkm2
        ELSE
          sum = sum + fmkm1
        END IF

        ak = 1.0d+00 / (ak * fk)
        fk = fk + 2.0d+00

      END DO

      IF (ioe .eq. 0) THEN
        prncst = dlnorm (d, .true.) + sum * g3
      ELSE
        prncst = dlnorm (drb, .true.) 
     &  + 2.0d+00 * (sum + tfn (drb, a))
      END IF

      RETURN
      END

      SUBROUTINE student_noncentral_cdf_values (n_data, df, lambda, 
     &  x, fx)

!
! STUDENT_NONCENTRAL_CDF_VALUES returns values of the noncentral Student CDF.
!
! Discussion:
!
!   In Mathematica, the function can be evaluated by:
!
!     Needs["Statistics`ContinuousDistributions`"]
!     dist = NoncentralStudentTDistribution [ df, lambda ]
!     CDF [ dist, x ]
!
!   Mathematica seems to have some difficulty computing this function
!   to the desired number of digits.
!
! Modified:
!
!   25 March 2007
!
! Author:
!
!   John Burkardt
!
! Reference:
!
!   Milton Abramowitz, Irene Stegun,
!   Handbook of Mathematical Functions,
!   National Bureau of Standards, 1964,
!   ISBN: 0-486-61272-4,
!   LC: QA47.A34.
!
!   Stephen Wolfram,
!   The Mathematica Book,
!   Fourth Edition,
!   Cambridge University Press, 1999,
!   ISBN: 0-521-64314-7,
!   LC: QA76.95.W65.
!
! Parameters:
!
!   Input/output, integer N_DATA.  The user sets N_DATA to 0 before the
!   first call.  On each call, the routine increments N_DATA by 1, and
!   returns the corresponding data; when there is no more data, the
!   output value of N_DATA will be 0 again.
!
!   Output, integer DF, real*8 LAMBDA, the parameters of the
!   function.
!
!   Output, real*8 X, the argument of the function.
!
!   Output, real*8 FX, the value of the function.
!
      IMPLICIT none

      INTEGER n_max
      PARAMETER (n_max = 30)

      INTEGER df
      INTEGER df_vec(n_max) 
      REAL*8 fx
      REAL*8 fx_vec(n_max) 
      REAL*8 lambda
      REAL*8 lambda_vec(n_max) 
      INTEGER n_data
      REAL*8 x
      REAL*8 x_vec(n_max) 

      SAVE df_vec
      SAVE fx_vec
      SAVE lambda_vec
      SAVE x_vec

      DATA df_vec /
     &   1,  2,  3, 
     &   1,  2,  3, 
     &   1,  2,  3, 
     &   1,  2,  3, 
     &   1,  2,  3, 
     &  15, 20, 25, 
     &   1,  2,  3, 
     &  10, 10, 10, 
     &  10, 10, 10, 
     &  10, 10, 10 /
      DATA fx_vec /
     &  0.8975836176504333d+00, 
     &  0.9522670169d+00, 
     &  0.9711655571887813d+00, 
     &  0.8231218864d+00, 
     &  0.9049021510d+00, 
     &  0.9363471834d+00, 
     &  0.7301025986d+00, 
     &  0.8335594263d+00, 
     &  0.8774010255d+00, 
     &  0.5248571617d+00, 
     &  0.6293856597d+00, 
     &  0.6800271741d+00, 
     &  0.20590131975d+00, 
     &  0.2112148916d+00, 
     &  0.2074730718d+00, 
     &  0.9981130072d+00, 
     &  0.9994873850d+00, 
     &  0.9998391562d+00, 
     &  0.168610566972d+00, 
     &  0.16967950985d+00, 
     &  0.1701041003d+00, 
     &  0.9247683363d+00, 
     &  0.7483139269d+00, 
     &  0.4659802096d+00, 
     &  0.9761872541d+00, 
     &  0.8979689357d+00, 
     &  0.7181904627d+00, 
     &  0.9923658945d+00, 
     &  0.9610341649d+00, 
     &  0.8688007350d+00 /
      DATA lambda_vec /
     &  0.0d+00, 
     &  0.0d+00, 
     &  0.0d+00, 
     &  0.5d+00, 
     &  0.5d+00, 
     &  0.5d+00, 
     &  1.0d+00, 
     &  1.0d+00, 
     &  1.0d+00, 
     &  2.0d+00, 
     &  2.0d+00, 
     &  2.0d+00, 
     &  4.0d+00, 
     &  4.0d+00, 
     &  4.0d+00, 
     &  7.0d+00, 
     &  7.0d+00, 
     &  7.0d+00, 
     &  1.0d+00, 
     &  1.0d+00, 
     &  1.0d+00, 
     &  2.0d+00, 
     &  3.0d+00, 
     &  4.0d+00, 
     &  2.0d+00, 
     &  3.0d+00, 
     &  4.0d+00, 
     &  2.0d+00, 
     &  3.0d+00, 
     &  4.0d+00 /
      DATA x_vec /
     &   3.00d+00, 
     &   3.00d+00, 
     &   3.00d+00, 
     &   3.00d+00, 
     &   3.00d+00, 
     &   3.00d+00, 
     &   3.00d+00, 
     &   3.00d+00, 
     &   3.00d+00, 
     &   3.00d+00, 
     &   3.00d+00, 
     &   3.00d+00, 
     &   3.00d+00, 
     &   3.00d+00, 
     &   3.00d+00, 
     &  15.00d+00, 
     &  15.00d+00, 
     &  15.00d+00, 
     &   0.05d+00, 
     &   0.05d+00, 
     &   0.05d+00, 
     &   4.00d+00, 
     &   4.00d+00, 
     &   4.00d+00, 
     &   5.00d+00, 
     &   5.00d+00, 
     &   5.00d+00, 
     &   6.00d+00, 
     &   6.00d+00, 
     &   6.00d+00 /

      IF (n_data .lt. 0) THEN
        n_data = 0
      END IF

      n_data = n_data + 1

      IF (n_max .lt. n_data) THEN
        n_data = 0
        df = 0
        lambda = 0.0d+00
        x = 0.0d+00
        fx = 0.0d+00
      ELSE
        df = df_vec(n_data)
        lambda = lambda_vec(n_data)
        x = x_vec(n_data)
        fx = fx_vec(n_data)
      END IF

      RETURN
      END

      REAL*8 FUNCTION tfn (x, fx)
!
! TFN calculates the T-function of Owen.
!
! Modified:
!
!   06 January 2008
!
! Author:
!
!   JC Young, Christoph Minder
!   Modifications by John Burkardt
!
! Reference:
!
!   MA Porter, DJ Winstanley,
!   Remark AS R30:
!   A Remark on Algorithm AS76:
!   An Integral Useful in Calculating Noncentral T and Bivariate
!   Normal Probabilities,
!   Applied Statistics,
!   Volume 28, Number 1, 1979, page 113.
!
!   JC Young, Christoph Minder,
!   Algorithm AS 76: 
!   An Algorithm Useful in Calculating Non-Central T and 
!   Bivariate Normal Distributions,
!   Applied Statistics,
!   Volume 23, Number 3, 1974, pages 455-457.
!
! Parameters:
!
!   Input, real*8 X, FX, the parameters of the function.
!
!   Output, real*8 TFN, the value of the T-function.
!
      IMPLICIT none

      INTEGER ng
      PARAMETER (ng = 5)

      REAL*8 fx
      REAL*8 fxs
      INTEGER i
      REAL*8 r(ng)
      REAL*8 r1
      REAL*8 r2
      REAL*8 rt
      REAL*8 tp
      PARAMETER (tp = 0.159155d+00)
      REAL*8 tv1
      PARAMETER (tv1 = 1.0d-35)
      REAL*8 tv2
      PARAMETER (tv2 = 15.0d+00)
      REAL*8 tv3
      PARAMETER (tv3 = 15.0d+00)
      REAL*8 tv4
      PARAMETER (tv4 = 1.0d-05)
      REAL*8 u(ng)
      REAL*8 x
      REAL*8 x1
      REAL*8 x2
      REAL*8 xs

      DATA u / 
     &  0.0744372d+00, 
     &  0.2166977d+00, 
     &  0.3397048d+00, 
     &  0.4325317d+00, 
     &  0.4869533d+00 /

      DATA r /
     &  0.1477621d+00, 
     &  0.1346334d+00, 
     &  0.1095432d+00, 
     &  0.0747257d+00, 
     &  0.0333357d+00 /
!
! Test for X near zero.
!
      IF (dabs (x) .lt. tv1) THEN
        tfn = tp * atan (fx)
        RETURN
      END IF
!
! Test for large values of abs(X).
!
      IF (tv2 .lt. dabs (x)) THEN
        tfn = 0.0d+00
        RETURN
      END IF
!
! Test for FX near zero.
!
      IF (dabs (fx) .lt. tv1) THEN
        tfn = 0.0d+00
        RETURN
      END IF
!
! Test whether abs (FX) is so large that it must be truncated.
!
      xs = - 0.5d+00 * x * x
      x2 = fx
      fxs = fx * fx

      IF (dlog (1.0d+00 + fxs) - xs * fxs .lt. tv3) THEN
        GO TO 2 
      END IF
!
! Computation of truncation point by Newton iteration.
!
      x1 = 0.5d+00 * fx
      fxs = 0.25d+00 * fxs

    1 CONTINUE

        rt = fxs + 1.0d+00

        x2 = x1 + (xs * fxs + tv3 - dlog (rt)) 
     &  / (2.0d+00 * x1 * (1.0d+00 / rt - xs))

        fxs = x2 * x2

        IF (dabs (x2 - x1) .lt. tv4) THEN
          GO TO 2
        END IF

        x1 = x2

      GO TO 1
!
! Gaussian quadrature.
!
    2 CONTINUE

      rt = 0.0d+00

      DO i = 1, ng

        r1 = 1.0d+00 + fxs * (0.5d+00 + u(i))**2
        r2 = 1.0d+00 + fxs * (0.5d+00 - u(i))**2

        rt = rt + r(i) * (dexp (xs * r1) / r1 
     &  + dexp (xs * r2) / r2)

      END DO

      tfn = rt * x2 * tp

      RETURN
      END

#pragma -xO
      program random
      parameter (n = 10000000)
      real*8 rnd, sum
      sum = 0
      do i = 1, n
      call rand48 (j, k, rnd)
      sum = sum + rnd
      end do
      write (*, *) sum / n
      end
